/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.DecimalType;

import com.tinkerforge.BrickDC;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickDCWrapper extends DeviceWrapper implements StandardFlashHost{
    BrickDC dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickDC.DEVICE_DISPLAY_NAME, "brickdc", BrickDC.DEVICE_IDENTIFIER, BrickDCWrapper.class, BrickDCActions.class, "2.3.5", false);

    public BrickDCWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickDC(uid, ipcon);
    }

    
	public final static int DRIVE_MODE_DRIVE_BRAKE = 0;
	public final static int DRIVE_MODE_DRIVE_COAST = 1;
	public final static int COMMUNICATION_METHOD_NONE = 0;
	public final static int COMMUNICATION_METHOD_USB = 1;
	public final static int COMMUNICATION_METHOD_SPI_STACK = 2;
	public final static int COMMUNICATION_METHOD_CHIBI = 3;
	public final static int COMMUNICATION_METHOD_RS485 = 4;
	public final static int COMMUNICATION_METHOD_WIFI = 5;
	public final static int COMMUNICATION_METHOD_ETHERNET = 6;
	public final static int COMMUNICATION_METHOD_WIFI_V2 = 7;


    public void setVelocity(int velocity) throws TinkerforgeException {
    this.dev.setVelocity(velocity);
}

public int getVelocity() throws TinkerforgeException {
    return this.dev.getVelocity();
}

public int getCurrentVelocity() throws TinkerforgeException {
    return this.dev.getCurrentVelocity();
}

public void setAcceleration(int acceleration) throws TinkerforgeException {
    this.dev.setAcceleration(acceleration);
}

public int getAcceleration() throws TinkerforgeException {
    return this.dev.getAcceleration();
}

public void setPWMFrequency(int frequency) throws TinkerforgeException {
    this.dev.setPWMFrequency(frequency);
}

public int getPWMFrequency() throws TinkerforgeException {
    return this.dev.getPWMFrequency();
}

public void fullBrake() throws TinkerforgeException {
    this.dev.fullBrake();
}

public int getStackInputVoltage() throws TinkerforgeException {
    return this.dev.getStackInputVoltage();
}

public int getExternalInputVoltage() throws TinkerforgeException {
    return this.dev.getExternalInputVoltage();
}

public int getCurrentConsumption() throws TinkerforgeException {
    return this.dev.getCurrentConsumption();
}

public void enable() throws TinkerforgeException {
    this.dev.enable();
}

public void disable() throws TinkerforgeException {
    this.dev.disable();
}

public boolean isEnabled() throws TinkerforgeException {
    return this.dev.isEnabled();
}

public void setMinimumVoltage(int voltage) throws TinkerforgeException {
    this.dev.setMinimumVoltage(voltage);
}

public int getMinimumVoltage() throws TinkerforgeException {
    return this.dev.getMinimumVoltage();
}

public void setDriveMode(int mode) throws TinkerforgeException {
    this.dev.setDriveMode(mode);
}

public int getDriveMode() throws TinkerforgeException {
    return this.dev.getDriveMode();
}

public void setCurrentVelocityPeriod(int period) throws TinkerforgeException {
    this.dev.setCurrentVelocityPeriod(period);
}

public int getCurrentVelocityPeriod() throws TinkerforgeException {
    return this.dev.getCurrentVelocityPeriod();
}

public void setSPITFPBaudrateConfig(boolean enableDynamicBaudrate, long minimumDynamicBaudrate) throws TinkerforgeException {
    this.dev.setSPITFPBaudrateConfig(enableDynamicBaudrate, minimumDynamicBaudrate);
}

public BrickDC.SPITFPBaudrateConfig getSPITFPBaudrateConfig() throws TinkerforgeException {
    return this.dev.getSPITFPBaudrateConfig();
}

public long getSendTimeoutCount(int communicationMethod) throws TinkerforgeException {
    return this.dev.getSendTimeoutCount(communicationMethod);
}

public void setSPITFPBaudrate(char brickletPort, long baudrate) throws TinkerforgeException {
    this.dev.setSPITFPBaudrate(brickletPort, baudrate);
}

public long getSPITFPBaudrate(char brickletPort) throws TinkerforgeException {
    return this.dev.getSPITFPBaudrate(brickletPort);
}

public BrickDC.SPITFPErrorCount getSPITFPErrorCount(char brickletPort) throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount(brickletPort);
}

public void enableStatusLED() throws TinkerforgeException {
    this.dev.enableStatusLED();
}

public void disableStatusLED() throws TinkerforgeException {
    this.dev.disableStatusLED();
}

public boolean isStatusLEDEnabled() throws TinkerforgeException {
    return this.dev.isStatusLEDEnabled();
}

public BrickDC.Protocol1BrickletName getProtocol1BrickletName(char port) throws TinkerforgeException {
    return this.dev.getProtocol1BrickletName(port);
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeBrickletPlugin(char port, int offset, int[] chunk) throws TinkerforgeException {
    this.dev.writeBrickletPlugin(port, offset, chunk);
}

public int[] readBrickletPlugin(char port, int offset) throws TinkerforgeException {
    return this.dev.readBrickletPlugin(port, offset);
}

public BrickDC.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addUnderVoltageListener(BrickDC.UnderVoltageListener l) {
    this.dev.addUnderVoltageListener(l);
}

public void removeUnderVoltageListener(BrickDC.UnderVoltageListener l) {
    this.dev.removeUnderVoltageListener(l);
}

public void addEmergencyShutdownListener(BrickDC.EmergencyShutdownListener l) {
    this.dev.addEmergencyShutdownListener(l);
}

public void removeEmergencyShutdownListener(BrickDC.EmergencyShutdownListener l) {
    this.dev.removeEmergencyShutdownListener(l);
}

public void addVelocityReachedListener(BrickDC.VelocityReachedListener l) {
    this.dev.addVelocityReachedListener(l);
}

public void removeVelocityReachedListener(BrickDC.VelocityReachedListener l) {
    this.dev.removeVelocityReachedListener(l);
}

public void addCurrentVelocityListener(BrickDC.CurrentVelocityListener l) {
    this.dev.addCurrentVelocityListener(l);
}

public void removeCurrentVelocityListener(BrickDC.CurrentVelocityListener l) {
    this.dev.removeCurrentVelocityListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickDCWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickDCWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickDCConfig cfg = (BrickDCConfig) config.as(BrickDCConfig.class);
        this.addVelocityReachedListener(this.reg((velocity) -> {if(true) {triggerChannelFn.accept("BrickDCVelocityReached", transformBrickDCVelocityReachedCallback0(velocity, cfg));}}, this.dev::removeVelocityReachedListener));
		this.addEmergencyShutdownListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickDCEmergencyShutdown", transformBrickDCEmergencyShutdownCallback0(cfg));}}, this.dev::removeEmergencyShutdownListener));
		this.addUnderVoltageListener(this.reg((voltage) -> {if(true) {triggerChannelFn.accept("BrickDCUnderVoltage", transformBrickDCUnderVoltageCallback0(voltage, cfg));}}, this.dev::removeUnderVoltageListener));
		this.addCurrentVelocityListener(this.reg((velocity) -> {if(true) {updateStateFn.accept("BrickDCCurrentVelocity", transformBrickDCCurrentVelocityCallback0(velocity, cfg));}}, this.dev::removeCurrentVelocityListener));
        this.setMinimumVoltage((int)(cfg.minimumVoltage.doubleValue() * 1000.0));
		if(cfg.statusLEDConfig) {
		                this.enableStatusLED();
		            } else {
		                this.disableStatusLED();
		            }
		this.setSPITFPBaudrateConfig(cfg.spitfpEnableDynamicBaudrate, cfg.spitfpMinimumDynamicBaudrate);
		this.setSPITFPBaudrate('a', cfg.spitfpBaudratePortA);
		            this.setSPITFPBaudrate('b', cfg.spitfpBaudratePortB);
		{
		
		}
		{
		
		}
		{
		
		}
		{
		BrickDCCurrentVelocityConfig channelCfg = getChannelConfigFn.apply("BrickDCCurrentVelocity").as(BrickDCCurrentVelocityConfig.class);
		this.setCurrentVelocityPeriod(channelCfg.updateInterval);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickDCConfig cfg = (BrickDCConfig) config.as(BrickDCConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickDCConfig cfg = (BrickDCConfig) config.as(BrickDCConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickDCVelocityReached");
		result.add("BrickDCEmergencyShutdown");
		result.add("BrickDCUnderVoltage");
		result.add("BrickDCCurrentVelocity");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickDCCurrentVelocity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickDCCurrentVelocity"), "Current Velocity", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickDCCurrentVelocity")).withDescription("The current velocity of the motor.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-32767)).withMaximum(BigDecimal.valueOf(32767)).withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge DC Brick").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Drives one brushed DC motor with up to 28V and 5A (peak)").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickDCVelocityReached", new ChannelTypeUID("system", "trigger")).withLabel("Velocity Reached").build(), new ChannelDefinitionBuilder("BrickDCEmergencyShutdown", new ChannelTypeUID("system", "trigger")).withLabel("Emergency Shutdown").build(), new ChannelDefinitionBuilder("BrickDCUnderVoltage", new ChannelTypeUID("system", "trigger")).withLabel("Under Voltage").build(), new ChannelDefinitionBuilder("BrickDCCurrentVelocity", new ChannelTypeUID("tinkerforge", "BrickDCCurrentVelocity")).withLabel("Current Velocity").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickdc":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("minimumVoltage", Type.DECIMAL).withDefault("6").withDescription("The minimum voltage in V, below which the Under Voltage channel is triggered. The minimum possible value that works with the DC Brick is 5V. You can use this function to detect the discharge of a battery that is used to drive the stepper motor. If you have a fixed power supply, you likely do not need this functionality. The default value is 5V.").withLabel("Minimum Voltage").withUnit("V").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.BOOLEAN).withDefault("true").withDescription("The status LED is the blue LED next to the USB connector. If enabled is is on and it flickers if data is transfered. If disabled it is always off.").withLabel("Status LED Config").build(), ConfigDescriptionParameterBuilder.create("spitfpEnableDynamicBaudrate", Type.BOOLEAN).withDefault("true").withDescription("The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is enabled, the Brick will try to adapt the baudrate for the communication between Bricks and Bricklets according to the amount of data that is transferred.<br/><br/>The baudrate will be increased exponentially if lots of data is sent/received and decreased linearly if little data is sent/received.<br/><br/>This lowers the baudrate in applications where little data is transferred (e.g. a weather station) and increases the robustness. If there is lots of data to transfer (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.<br/><br/>In cases where some data has to transferred as fast as possible every few seconds (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn the dynamic baudrate off to get the highest possible performance.<br/><br/>The maximum value of the baudrate can be set per port. If the dynamic baudrate is disabled, the maximum baudrate will be used statically.").withLabel("SPITFP Enable Dynamic Baudrate").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("spitfpMinimumDynamicBaudrate", Type.INTEGER).withDefault("400000").withDescription("See SPITFP Enable Dynamic Baudrate").withLabel("SPITFP Minimum Dynamic Baudrate").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build(), ConfigDescriptionParameterBuilder.create("spitfpBaudratePortA", Type.INTEGER).withDefault("1400000").withDescription("The baudrate for Bricklet port A.<br/><br/>If you want to increase the throughput of Bricklets you can increase the baudrate. If you get a high error count because of high interference you can decrease the baudrate.<br/><br/>If the dynamic baudrate feature is enabled, this is the maximum baudrate.<br/><br/>Regulatory testing is done with the default baudrate. If CE compatibility or similar is necessary in you applications we recommend to not change the baudrate.").withLabel("(Maximum) SPITFP Baudrate Port A").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build(), ConfigDescriptionParameterBuilder.create("spitfpBaudratePortB", Type.INTEGER).withDefault("1400000").withDescription("The baudrate for Bricklet port B.<br/><br/>If you want to increase the throughput of Bricklets you can increase the baudrate. If you get a high error count because of high interference you can decrease the baudrate.<br/><br/>If the dynamic baudrate feature is enabled, this is the maximum baudrate.<br/><br/>Regulatory testing is done with the default baudrate. If CE compatibility or similar is necessary in you applications we recommend to not change the baudrate.").withLabel("(Maximum) SPITFP Baudrate Port B").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickDCCurrentVelocity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickDCConfig cfg = (BrickDCConfig) config.as(BrickDCConfig.class);
        switch(channel) {
            case "BrickDCVelocityReached":
               return;
            case "BrickDCEmergencyShutdown":
               return;
            case "BrickDCUnderVoltage":
               return;
            case "BrickDCCurrentVelocity": {
                   BrickDCCurrentVelocityConfig channelCfg = channelConfig.as(BrickDCCurrentVelocityConfig.class);
                   {
            int value = this.getCurrentVelocity();
            if(true)
                updateStateFn.accept(channel, transformBrickDCCurrentVelocityGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickDCConfig cfg = (BrickDCConfig) config.as(BrickDCConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickDCVelocityReachedCallback0(int velocity, BrickDCConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickDCEmergencyShutdownCallback0(BrickDCConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickDCUnderVoltageCallback0(int voltage, BrickDCConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickDCCurrentVelocityCallback0(int velocity, BrickDCConfig cfg) {
        return new DecimalType(velocity);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickDCCurrentVelocityGetter0(int value, BrickDCConfig cfg) {
        return new DecimalType(value);
    }

}