/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickIMUV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickIMUV2Wrapper extends DeviceWrapper implements StandardFlashHost{
    BrickIMUV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickIMUV2.DEVICE_DISPLAY_NAME, "brickimuv2", BrickIMUV2.DEVICE_IDENTIFIER, BrickIMUV2Wrapper.class, BrickIMUV2Actions.class, "2.0.10", false);

    public BrickIMUV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickIMUV2(uid, ipcon);
    }

    
	public final static int MAGNETOMETER_RATE_2HZ = 0;
	public final static int MAGNETOMETER_RATE_6HZ = 1;
	public final static int MAGNETOMETER_RATE_8HZ = 2;
	public final static int MAGNETOMETER_RATE_10HZ = 3;
	public final static int MAGNETOMETER_RATE_15HZ = 4;
	public final static int MAGNETOMETER_RATE_20HZ = 5;
	public final static int MAGNETOMETER_RATE_25HZ = 6;
	public final static int MAGNETOMETER_RATE_30HZ = 7;
	public final static int GYROSCOPE_RANGE_2000DPS = 0;
	public final static int GYROSCOPE_RANGE_1000DPS = 1;
	public final static int GYROSCOPE_RANGE_500DPS = 2;
	public final static int GYROSCOPE_RANGE_250DPS = 3;
	public final static int GYROSCOPE_RANGE_125DPS = 4;
	public final static int GYROSCOPE_BANDWIDTH_523HZ = 0;
	public final static int GYROSCOPE_BANDWIDTH_230HZ = 1;
	public final static int GYROSCOPE_BANDWIDTH_116HZ = 2;
	public final static int GYROSCOPE_BANDWIDTH_47HZ = 3;
	public final static int GYROSCOPE_BANDWIDTH_23HZ = 4;
	public final static int GYROSCOPE_BANDWIDTH_12HZ = 5;
	public final static int GYROSCOPE_BANDWIDTH_64HZ = 6;
	public final static int GYROSCOPE_BANDWIDTH_32HZ = 7;
	public final static int ACCELEROMETER_RANGE_2G = 0;
	public final static int ACCELEROMETER_RANGE_4G = 1;
	public final static int ACCELEROMETER_RANGE_8G = 2;
	public final static int ACCELEROMETER_RANGE_16G = 3;
	public final static int ACCELEROMETER_BANDWIDTH_7_81HZ = 0;
	public final static int ACCELEROMETER_BANDWIDTH_15_63HZ = 1;
	public final static int ACCELEROMETER_BANDWIDTH_31_25HZ = 2;
	public final static int ACCELEROMETER_BANDWIDTH_62_5HZ = 3;
	public final static int ACCELEROMETER_BANDWIDTH_125HZ = 4;
	public final static int ACCELEROMETER_BANDWIDTH_250HZ = 5;
	public final static int ACCELEROMETER_BANDWIDTH_500HZ = 6;
	public final static int ACCELEROMETER_BANDWIDTH_1000HZ = 7;
	public final static int SENSOR_FUSION_OFF = 0;
	public final static int SENSOR_FUSION_ON = 1;
	public final static int SENSOR_FUSION_ON_WITHOUT_MAGNETOMETER = 2;
	public final static int SENSOR_FUSION_ON_WITHOUT_FAST_MAGNETOMETER_CALIBRATION = 3;
	public final static int COMMUNICATION_METHOD_NONE = 0;
	public final static int COMMUNICATION_METHOD_USB = 1;
	public final static int COMMUNICATION_METHOD_SPI_STACK = 2;
	public final static int COMMUNICATION_METHOD_CHIBI = 3;
	public final static int COMMUNICATION_METHOD_RS485 = 4;
	public final static int COMMUNICATION_METHOD_WIFI = 5;
	public final static int COMMUNICATION_METHOD_ETHERNET = 6;
	public final static int COMMUNICATION_METHOD_WIFI_V2 = 7;


    public BrickIMUV2.Acceleration getAcceleration() throws TinkerforgeException {
    return this.dev.getAcceleration();
}

public BrickIMUV2.MagneticField getMagneticField() throws TinkerforgeException {
    return this.dev.getMagneticField();
}

public BrickIMUV2.AngularVelocity getAngularVelocity() throws TinkerforgeException {
    return this.dev.getAngularVelocity();
}

public int getTemperature() throws TinkerforgeException {
    return this.dev.getTemperature();
}

public BrickIMUV2.Orientation getOrientation() throws TinkerforgeException {
    return this.dev.getOrientation();
}

public BrickIMUV2.LinearAcceleration getLinearAcceleration() throws TinkerforgeException {
    return this.dev.getLinearAcceleration();
}

public BrickIMUV2.GravityVector getGravityVector() throws TinkerforgeException {
    return this.dev.getGravityVector();
}

public BrickIMUV2.Quaternion getQuaternion() throws TinkerforgeException {
    return this.dev.getQuaternion();
}

public BrickIMUV2.AllData getAllData() throws TinkerforgeException {
    return this.dev.getAllData();
}

public void ledsOn() throws TinkerforgeException {
    this.dev.ledsOn();
}

public void ledsOff() throws TinkerforgeException {
    this.dev.ledsOff();
}

public boolean areLedsOn() throws TinkerforgeException {
    return this.dev.areLedsOn();
}

public boolean saveCalibration() throws TinkerforgeException {
    return this.dev.saveCalibration();
}

public void setAccelerationPeriod(long period) throws TinkerforgeException {
    this.dev.setAccelerationPeriod(period);
}

public long getAccelerationPeriod() throws TinkerforgeException {
    return this.dev.getAccelerationPeriod();
}

public void setMagneticFieldPeriod(long period) throws TinkerforgeException {
    this.dev.setMagneticFieldPeriod(period);
}

public long getMagneticFieldPeriod() throws TinkerforgeException {
    return this.dev.getMagneticFieldPeriod();
}

public void setAngularVelocityPeriod(long period) throws TinkerforgeException {
    this.dev.setAngularVelocityPeriod(period);
}

public long getAngularVelocityPeriod() throws TinkerforgeException {
    return this.dev.getAngularVelocityPeriod();
}

public void setTemperaturePeriod(long period) throws TinkerforgeException {
    this.dev.setTemperaturePeriod(period);
}

public long getTemperaturePeriod() throws TinkerforgeException {
    return this.dev.getTemperaturePeriod();
}

public void setOrientationPeriod(long period) throws TinkerforgeException {
    this.dev.setOrientationPeriod(period);
}

public long getOrientationPeriod() throws TinkerforgeException {
    return this.dev.getOrientationPeriod();
}

public void setLinearAccelerationPeriod(long period) throws TinkerforgeException {
    this.dev.setLinearAccelerationPeriod(period);
}

public long getLinearAccelerationPeriod() throws TinkerforgeException {
    return this.dev.getLinearAccelerationPeriod();
}

public void setGravityVectorPeriod(long period) throws TinkerforgeException {
    this.dev.setGravityVectorPeriod(period);
}

public long getGravityVectorPeriod() throws TinkerforgeException {
    return this.dev.getGravityVectorPeriod();
}

public void setQuaternionPeriod(long period) throws TinkerforgeException {
    this.dev.setQuaternionPeriod(period);
}

public long getQuaternionPeriod() throws TinkerforgeException {
    return this.dev.getQuaternionPeriod();
}

public void setAllDataPeriod(long period) throws TinkerforgeException {
    this.dev.setAllDataPeriod(period);
}

public long getAllDataPeriod() throws TinkerforgeException {
    return this.dev.getAllDataPeriod();
}

public void setSensorConfiguration(int magnetometerRate, int gyroscopeRange, int gyroscopeBandwidth, int accelerometerRange, int accelerometerBandwidth) throws TinkerforgeException {
    this.dev.setSensorConfiguration(magnetometerRate, gyroscopeRange, gyroscopeBandwidth, accelerometerRange, accelerometerBandwidth);
}

public BrickIMUV2.SensorConfiguration getSensorConfiguration() throws TinkerforgeException {
    return this.dev.getSensorConfiguration();
}

public void setSensorFusionMode(int mode) throws TinkerforgeException {
    this.dev.setSensorFusionMode(mode);
}

public int getSensorFusionMode() throws TinkerforgeException {
    return this.dev.getSensorFusionMode();
}

public void setSPITFPBaudrateConfig(boolean enableDynamicBaudrate, long minimumDynamicBaudrate) throws TinkerforgeException {
    this.dev.setSPITFPBaudrateConfig(enableDynamicBaudrate, minimumDynamicBaudrate);
}

public BrickIMUV2.SPITFPBaudrateConfig getSPITFPBaudrateConfig() throws TinkerforgeException {
    return this.dev.getSPITFPBaudrateConfig();
}

public long getSendTimeoutCount(int communicationMethod) throws TinkerforgeException {
    return this.dev.getSendTimeoutCount(communicationMethod);
}

public void setSPITFPBaudrate(char brickletPort, long baudrate) throws TinkerforgeException {
    this.dev.setSPITFPBaudrate(brickletPort, baudrate);
}

public long getSPITFPBaudrate(char brickletPort) throws TinkerforgeException {
    return this.dev.getSPITFPBaudrate(brickletPort);
}

public BrickIMUV2.SPITFPErrorCount getSPITFPErrorCount(char brickletPort) throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount(brickletPort);
}

public void enableStatusLED() throws TinkerforgeException {
    this.dev.enableStatusLED();
}

public void disableStatusLED() throws TinkerforgeException {
    this.dev.disableStatusLED();
}

public boolean isStatusLEDEnabled() throws TinkerforgeException {
    return this.dev.isStatusLEDEnabled();
}

public BrickIMUV2.Protocol1BrickletName getProtocol1BrickletName(char port) throws TinkerforgeException {
    return this.dev.getProtocol1BrickletName(port);
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeBrickletPlugin(char port, int offset, int[] chunk) throws TinkerforgeException {
    this.dev.writeBrickletPlugin(port, offset, chunk);
}

public int[] readBrickletPlugin(char port, int offset) throws TinkerforgeException {
    return this.dev.readBrickletPlugin(port, offset);
}

public BrickIMUV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addAccelerationListener(BrickIMUV2.AccelerationListener l) {
    this.dev.addAccelerationListener(l);
}

public void removeAccelerationListener(BrickIMUV2.AccelerationListener l) {
    this.dev.removeAccelerationListener(l);
}

public void addMagneticFieldListener(BrickIMUV2.MagneticFieldListener l) {
    this.dev.addMagneticFieldListener(l);
}

public void removeMagneticFieldListener(BrickIMUV2.MagneticFieldListener l) {
    this.dev.removeMagneticFieldListener(l);
}

public void addAngularVelocityListener(BrickIMUV2.AngularVelocityListener l) {
    this.dev.addAngularVelocityListener(l);
}

public void removeAngularVelocityListener(BrickIMUV2.AngularVelocityListener l) {
    this.dev.removeAngularVelocityListener(l);
}

public void addTemperatureListener(BrickIMUV2.TemperatureListener l) {
    this.dev.addTemperatureListener(l);
}

public void removeTemperatureListener(BrickIMUV2.TemperatureListener l) {
    this.dev.removeTemperatureListener(l);
}

public void addLinearAccelerationListener(BrickIMUV2.LinearAccelerationListener l) {
    this.dev.addLinearAccelerationListener(l);
}

public void removeLinearAccelerationListener(BrickIMUV2.LinearAccelerationListener l) {
    this.dev.removeLinearAccelerationListener(l);
}

public void addGravityVectorListener(BrickIMUV2.GravityVectorListener l) {
    this.dev.addGravityVectorListener(l);
}

public void removeGravityVectorListener(BrickIMUV2.GravityVectorListener l) {
    this.dev.removeGravityVectorListener(l);
}

public void addOrientationListener(BrickIMUV2.OrientationListener l) {
    this.dev.addOrientationListener(l);
}

public void removeOrientationListener(BrickIMUV2.OrientationListener l) {
    this.dev.removeOrientationListener(l);
}

public void addQuaternionListener(BrickIMUV2.QuaternionListener l) {
    this.dev.addQuaternionListener(l);
}

public void removeQuaternionListener(BrickIMUV2.QuaternionListener l) {
    this.dev.removeQuaternionListener(l);
}

public void addAllDataListener(BrickIMUV2.AllDataListener l) {
    this.dev.addAllDataListener(l);
}

public void removeAllDataListener(BrickIMUV2.AllDataListener l) {
    this.dev.removeAllDataListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickIMUV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickIMUV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickIMUV2Config cfg = (BrickIMUV2Config) config.as(BrickIMUV2Config.class);
        this.addAccelerationListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2AccelerationX", transformBrickIMUV2AccelerationXCallback0(x, y, z, cfg));}}, this.dev::removeAccelerationListener));
		this.addAccelerationListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2AccelerationY", transformBrickIMUV2AccelerationYCallback0(x, y, z, cfg));}}, this.dev::removeAccelerationListener));
		this.addAccelerationListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2AccelerationZ", transformBrickIMUV2AccelerationZCallback0(x, y, z, cfg));}}, this.dev::removeAccelerationListener));
		this.addMagneticFieldListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2MagneticFieldX", transformBrickIMUV2MagneticFieldXCallback0(x, y, z, cfg));}}, this.dev::removeMagneticFieldListener));
		this.addMagneticFieldListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2MagneticFieldY", transformBrickIMUV2MagneticFieldYCallback0(x, y, z, cfg));}}, this.dev::removeMagneticFieldListener));
		this.addMagneticFieldListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2MagneticFieldZ", transformBrickIMUV2MagneticFieldZCallback0(x, y, z, cfg));}}, this.dev::removeMagneticFieldListener));
		this.addAngularVelocityListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2AngularVelocityX", transformBrickIMUV2AngularVelocityXCallback0(x, y, z, cfg));}}, this.dev::removeAngularVelocityListener));
		this.addAngularVelocityListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2AngularVelocityY", transformBrickIMUV2AngularVelocityYCallback0(x, y, z, cfg));}}, this.dev::removeAngularVelocityListener));
		this.addAngularVelocityListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2AngularVelocityZ", transformBrickIMUV2AngularVelocityZCallback0(x, y, z, cfg));}}, this.dev::removeAngularVelocityListener));
		this.addOrientationListener(this.reg((heading, roll, pitch) -> {if(true) {updateStateFn.accept("BrickIMUV2OrientationHeading", transformBrickIMUV2OrientationHeadingCallback0(heading, roll, pitch, cfg));}}, this.dev::removeOrientationListener));
		this.addOrientationListener(this.reg((heading, roll, pitch) -> {if(true) {updateStateFn.accept("BrickIMUV2OrientationRoll", transformBrickIMUV2OrientationRollCallback0(heading, roll, pitch, cfg));}}, this.dev::removeOrientationListener));
		this.addOrientationListener(this.reg((heading, roll, pitch) -> {if(true) {updateStateFn.accept("BrickIMUV2OrientationPitch", transformBrickIMUV2OrientationPitchCallback0(heading, roll, pitch, cfg));}}, this.dev::removeOrientationListener));
		this.addQuaternionListener(this.reg((w, x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2QuaternionW", transformBrickIMUV2QuaternionWCallback0(w, x, y, z, cfg));}}, this.dev::removeQuaternionListener));
		this.addQuaternionListener(this.reg((w, x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2QuaternionX", transformBrickIMUV2QuaternionXCallback0(w, x, y, z, cfg));}}, this.dev::removeQuaternionListener));
		this.addQuaternionListener(this.reg((w, x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2QuaternionY", transformBrickIMUV2QuaternionYCallback0(w, x, y, z, cfg));}}, this.dev::removeQuaternionListener));
		this.addQuaternionListener(this.reg((w, x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2QuaternionZ", transformBrickIMUV2QuaternionZCallback0(w, x, y, z, cfg));}}, this.dev::removeQuaternionListener));
		this.addLinearAccelerationListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2LinearAccelerationX", transformBrickIMUV2LinearAccelerationXCallback0(x, y, z, cfg));}}, this.dev::removeLinearAccelerationListener));
		this.addLinearAccelerationListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2LinearAccelerationY", transformBrickIMUV2LinearAccelerationYCallback0(x, y, z, cfg));}}, this.dev::removeLinearAccelerationListener));
		this.addLinearAccelerationListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2LinearAccelerationZ", transformBrickIMUV2LinearAccelerationZCallback0(x, y, z, cfg));}}, this.dev::removeLinearAccelerationListener));
		this.addGravityVectorListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2GravityVectorX", transformBrickIMUV2GravityVectorXCallback0(x, y, z, cfg));}}, this.dev::removeGravityVectorListener));
		this.addGravityVectorListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2GravityVectorY", transformBrickIMUV2GravityVectorYCallback0(x, y, z, cfg));}}, this.dev::removeGravityVectorListener));
		this.addGravityVectorListener(this.reg((x, y, z) -> {if(true) {updateStateFn.accept("BrickIMUV2GravityVectorZ", transformBrickIMUV2GravityVectorZCallback0(x, y, z, cfg));}}, this.dev::removeGravityVectorListener));
		this.addTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickIMUV2Temperature", transformBrickIMUV2TemperatureCallback0(temperature, cfg));}}, this.dev::removeTemperatureListener));
        
		    this.setAccelerationPeriod(cfg.accelerationUpdateInterval);
		    this.setMagneticFieldPeriod(cfg.magneticFieldUpdateInterval);
		    this.setAngularVelocityPeriod(cfg.angularVelocityUpdateInterval);
		    this.setOrientationPeriod(cfg.orientationUpdateInterval);
		    this.setQuaternionPeriod(cfg.quaternionUpdateInterval);
		    this.setLinearAccelerationPeriod(cfg.linearAccelerationUpdateInterval);
		    this.setGravityVectorPeriod(cfg.gravityVectorUpdateInterval);
		    this.setTemperaturePeriod(cfg.temperatureUpdateInterval);
		    this.setSensorConfiguration(cfg.magnetometerRate, cfg.gyroscopeRange, cfg.gyroscopeBandwidth, cfg.accelerometerRange, cfg.accelerometerBandwidth);
		    this.setSensorFusionMode(cfg.sensorFusionMode);
		    
		if(cfg.statusLEDConfig) {
		                this.enableStatusLED();
		            } else {
		                this.disableStatusLED();
		            }
		this.setSPITFPBaudrateConfig(cfg.spitfpEnableDynamicBaudrate, cfg.spitfpMinimumDynamicBaudrate);
		this.setSPITFPBaudrate('a', cfg.spitfpBaudratePortA);
		            this.setSPITFPBaudrate('b', cfg.spitfpBaudratePortB);
		{
		BrickIMUV2AccelerationConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2AccelerationX").as(BrickIMUV2AccelerationConfig.class);
		
		}
		{
		BrickIMUV2AccelerationConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2AccelerationY").as(BrickIMUV2AccelerationConfig.class);
		
		}
		{
		BrickIMUV2AccelerationConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2AccelerationZ").as(BrickIMUV2AccelerationConfig.class);
		
		}
		{
		BrickIMUV2MagneticFieldConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2MagneticFieldX").as(BrickIMUV2MagneticFieldConfig.class);
		
		}
		{
		BrickIMUV2MagneticFieldConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2MagneticFieldY").as(BrickIMUV2MagneticFieldConfig.class);
		
		}
		{
		BrickIMUV2MagneticFieldConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2MagneticFieldZ").as(BrickIMUV2MagneticFieldConfig.class);
		
		}
		{
		BrickIMUV2AngularVelocityConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2AngularVelocityX").as(BrickIMUV2AngularVelocityConfig.class);
		
		}
		{
		BrickIMUV2AngularVelocityConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2AngularVelocityY").as(BrickIMUV2AngularVelocityConfig.class);
		
		}
		{
		BrickIMUV2AngularVelocityConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2AngularVelocityZ").as(BrickIMUV2AngularVelocityConfig.class);
		
		}
		{
		BrickIMUV2OrientationConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2OrientationHeading").as(BrickIMUV2OrientationConfig.class);
		
		}
		{
		BrickIMUV2OrientationConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2OrientationRoll").as(BrickIMUV2OrientationConfig.class);
		
		}
		{
		BrickIMUV2OrientationConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2OrientationPitch").as(BrickIMUV2OrientationConfig.class);
		
		}
		{
		BrickIMUV2QuaternionConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2QuaternionW").as(BrickIMUV2QuaternionConfig.class);
		
		}
		{
		BrickIMUV2QuaternionConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2QuaternionX").as(BrickIMUV2QuaternionConfig.class);
		
		}
		{
		BrickIMUV2QuaternionConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2QuaternionY").as(BrickIMUV2QuaternionConfig.class);
		
		}
		{
		BrickIMUV2QuaternionConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2QuaternionZ").as(BrickIMUV2QuaternionConfig.class);
		
		}
		{
		BrickIMUV2LinearAccelerationConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2LinearAccelerationX").as(BrickIMUV2LinearAccelerationConfig.class);
		
		}
		{
		BrickIMUV2LinearAccelerationConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2LinearAccelerationY").as(BrickIMUV2LinearAccelerationConfig.class);
		
		}
		{
		BrickIMUV2LinearAccelerationConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2LinearAccelerationZ").as(BrickIMUV2LinearAccelerationConfig.class);
		
		}
		{
		BrickIMUV2GravityVectorConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2GravityVectorX").as(BrickIMUV2GravityVectorConfig.class);
		
		}
		{
		BrickIMUV2GravityVectorConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2GravityVectorY").as(BrickIMUV2GravityVectorConfig.class);
		
		}
		{
		BrickIMUV2GravityVectorConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2GravityVectorZ").as(BrickIMUV2GravityVectorConfig.class);
		
		}
		{
		BrickIMUV2TemperatureConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2Temperature").as(BrickIMUV2TemperatureConfig.class);
		
		}
		{
		BrickIMUV2EnableLEDsConfig channelCfg = getChannelConfigFn.apply("BrickIMUV2EnableLEDs").as(BrickIMUV2EnableLEDsConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickIMUV2Config cfg = (BrickIMUV2Config) config.as(BrickIMUV2Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickIMUV2Config cfg = (BrickIMUV2Config) config.as(BrickIMUV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickIMUV2AccelerationX");
		result.add("BrickIMUV2AccelerationY");
		result.add("BrickIMUV2AccelerationZ");
		result.add("BrickIMUV2MagneticFieldX");
		result.add("BrickIMUV2MagneticFieldY");
		result.add("BrickIMUV2MagneticFieldZ");
		result.add("BrickIMUV2AngularVelocityX");
		result.add("BrickIMUV2AngularVelocityY");
		result.add("BrickIMUV2AngularVelocityZ");
		result.add("BrickIMUV2OrientationHeading");
		result.add("BrickIMUV2OrientationRoll");
		result.add("BrickIMUV2OrientationPitch");
		result.add("BrickIMUV2QuaternionW");
		result.add("BrickIMUV2QuaternionX");
		result.add("BrickIMUV2QuaternionY");
		result.add("BrickIMUV2QuaternionZ");
		result.add("BrickIMUV2LinearAccelerationX");
		result.add("BrickIMUV2LinearAccelerationY");
		result.add("BrickIMUV2LinearAccelerationZ");
		result.add("BrickIMUV2GravityVectorX");
		result.add("BrickIMUV2GravityVectorY");
		result.add("BrickIMUV2GravityVectorZ");
		result.add("BrickIMUV2Temperature");
		result.add("BrickIMUV2EnableLEDs");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickIMUV2Acceleration":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickIMUV2Acceleration"), "NOT USED", "Number:Acceleration").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickIMUV2Acceleration")).withDescription("The acceleration from the accelerometer for the x, y and z axis in m/s².")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickIMUV2MagneticField":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickIMUV2MagneticField"), "NOT USED", "Number:MagneticFluxDensity").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickIMUV2MagneticField")).withDescription("The calibrated magnetic field from the magnetometer for the x, y and z axis in Tesla.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.9f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickIMUV2AngularVelocity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickIMUV2AngularVelocity"), "NOT USED", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickIMUV2AngularVelocity")).withDescription("The calibrated angular velocity from the gyroscope for the x, y and z axis in °/s.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.3f").withReadOnly(true).build().toStateDescription()).build();
            case "BrickIMUV2Orientation":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickIMUV2Orientation"), "NOT USED", "Number:Angle").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickIMUV2Orientation")).withDescription("The current orientation (heading, roll, pitch) of the IMU Brick as independent Euler angles in 1/16 degree. Note that Euler angles always experience a gimbal lock. We recommend that you use quaternions instead, if you need the absolute orientation.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickIMUV2Quaternion":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickIMUV2Quaternion"), "NOT USED", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickIMUV2Quaternion")).withDescription("The current orientation (w, x, y, z) of the IMU Brick as quaternions.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.4f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickIMUV2LinearAcceleration":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickIMUV2LinearAcceleration"), "NOT USED", "Number:Acceleration").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickIMUV2LinearAcceleration")).withDescription("The linear acceleration from the accelerometer for the x, y and z axis in m/s. The linear acceleration is the acceleration in each of the three axis of the IMU Brick with the influences of gravity removed.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickIMUV2GravityVector":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickIMUV2GravityVector"), "NOT USED", "Number:Acceleration").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickIMUV2GravityVector")).withDescription("The current gravity vector of the IMU Brick for the x, y and z axis in g (1g = 9.80665m/s²). The gravity vector is the acceleration that occurs due to gravity. Influences of additional linear acceleration are removed.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickIMUV2Temperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickIMUV2Temperature"), "NOT USED", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickIMUV2Temperature")).withDescription("The temperature of the IMU Brick. The temperature is given in °C. The temperature is measured in the core of the BNO055 IC, it is not the ambient temperature.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickIMUV2EnableLEDs":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickIMUV2EnableLEDs"), "Enable LEDs", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickIMUV2EnableLEDs")).withDescription("Enable/disable the orientation and direction LEDs of the IMU Brick.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge IMU Brick 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Full fledged AHRS with 9 degrees of freedom").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickIMUV2AccelerationX", new ChannelTypeUID("tinkerforge", "BrickIMUV2Acceleration")).withLabel("Acceleration - X").build(), new ChannelDefinitionBuilder("BrickIMUV2AccelerationY", new ChannelTypeUID("tinkerforge", "BrickIMUV2Acceleration")).withLabel("Acceleration - Y").build(), new ChannelDefinitionBuilder("BrickIMUV2AccelerationZ", new ChannelTypeUID("tinkerforge", "BrickIMUV2Acceleration")).withLabel("Acceleration - Z").build(), new ChannelDefinitionBuilder("BrickIMUV2MagneticFieldX", new ChannelTypeUID("tinkerforge", "BrickIMUV2MagneticField")).withLabel("Magnetic Field - X").build(), new ChannelDefinitionBuilder("BrickIMUV2MagneticFieldY", new ChannelTypeUID("tinkerforge", "BrickIMUV2MagneticField")).withLabel("Magnetic Field - Y").build(), new ChannelDefinitionBuilder("BrickIMUV2MagneticFieldZ", new ChannelTypeUID("tinkerforge", "BrickIMUV2MagneticField")).withLabel("Magnetic Field - Z").build(), new ChannelDefinitionBuilder("BrickIMUV2AngularVelocityX", new ChannelTypeUID("tinkerforge", "BrickIMUV2AngularVelocity")).withLabel("Angular Velocity - X").build(), new ChannelDefinitionBuilder("BrickIMUV2AngularVelocityY", new ChannelTypeUID("tinkerforge", "BrickIMUV2AngularVelocity")).withLabel("Angular Velocity - Y").build(), new ChannelDefinitionBuilder("BrickIMUV2AngularVelocityZ", new ChannelTypeUID("tinkerforge", "BrickIMUV2AngularVelocity")).withLabel("Angular Velocity - Z").build(), new ChannelDefinitionBuilder("BrickIMUV2OrientationHeading", new ChannelTypeUID("tinkerforge", "BrickIMUV2Orientation")).withLabel("Orientation - Heading").build(), new ChannelDefinitionBuilder("BrickIMUV2OrientationRoll", new ChannelTypeUID("tinkerforge", "BrickIMUV2Orientation")).withLabel("Orientation - Roll").build(), new ChannelDefinitionBuilder("BrickIMUV2OrientationPitch", new ChannelTypeUID("tinkerforge", "BrickIMUV2Orientation")).withLabel("Orientation - Pitch").build(), new ChannelDefinitionBuilder("BrickIMUV2QuaternionW", new ChannelTypeUID("tinkerforge", "BrickIMUV2Quaternion")).withLabel("Quaternion - W").build(), new ChannelDefinitionBuilder("BrickIMUV2QuaternionX", new ChannelTypeUID("tinkerforge", "BrickIMUV2Quaternion")).withLabel("Quaternion - X").build(), new ChannelDefinitionBuilder("BrickIMUV2QuaternionY", new ChannelTypeUID("tinkerforge", "BrickIMUV2Quaternion")).withLabel("Quaternion - Y").build(), new ChannelDefinitionBuilder("BrickIMUV2QuaternionZ", new ChannelTypeUID("tinkerforge", "BrickIMUV2Quaternion")).withLabel("Quaternion - Z").build(), new ChannelDefinitionBuilder("BrickIMUV2LinearAccelerationX", new ChannelTypeUID("tinkerforge", "BrickIMUV2LinearAcceleration")).withLabel("Linear Acceleration - X").build(), new ChannelDefinitionBuilder("BrickIMUV2LinearAccelerationY", new ChannelTypeUID("tinkerforge", "BrickIMUV2LinearAcceleration")).withLabel("Linear Acceleration - Y").build(), new ChannelDefinitionBuilder("BrickIMUV2LinearAccelerationZ", new ChannelTypeUID("tinkerforge", "BrickIMUV2LinearAcceleration")).withLabel("Linear Acceleration - Z").build(), new ChannelDefinitionBuilder("BrickIMUV2GravityVectorX", new ChannelTypeUID("tinkerforge", "BrickIMUV2GravityVector")).withLabel("Gravity Vector - X").build(), new ChannelDefinitionBuilder("BrickIMUV2GravityVectorY", new ChannelTypeUID("tinkerforge", "BrickIMUV2GravityVector")).withLabel("Gravity Vector - Y").build(), new ChannelDefinitionBuilder("BrickIMUV2GravityVectorZ", new ChannelTypeUID("tinkerforge", "BrickIMUV2GravityVector")).withLabel("Gravity Vector - Z").build(), new ChannelDefinitionBuilder("BrickIMUV2Temperature", new ChannelTypeUID("tinkerforge", "BrickIMUV2Temperature")).withLabel("Temperature").build(), new ChannelDefinitionBuilder("BrickIMUV2EnableLEDs", new ChannelTypeUID("tinkerforge", "BrickIMUV2EnableLEDs")).withLabel("Enable LEDs").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickimuv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("magnetometerRate", Type.INTEGER).withDefault("5").withDescription("This option is auto-controlled in fusion mode.").withLabel("Magnetometer Rate").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "2Hz"), new ParameterOption("1", "6Hz"), new ParameterOption("2", "8Hz"), new ParameterOption("3", "10Hz"), new ParameterOption("4", "15Hz"), new ParameterOption("5", "20Hz"), new ParameterOption("6", "25Hz"), new ParameterOption("7", "30Hz"))).build(), ConfigDescriptionParameterBuilder.create("gyroscopeRange", Type.INTEGER).withDefault("0").withDescription("This option is auto-controlled in fusion mode.").withLabel("Gyroscope Range").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "2000°/s"), new ParameterOption("1", "1000°/s"), new ParameterOption("2", "500°/s"), new ParameterOption("3", "250°/s"), new ParameterOption("4", "125°/s"))).build(), ConfigDescriptionParameterBuilder.create("gyroscopeBandwidth", Type.INTEGER).withDefault("7").withDescription("This option is auto-controlled in fusion mode.").withLabel("Gyroscope Bandwidth").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "523Hz"), new ParameterOption("1", "230Hz"), new ParameterOption("2", "116Hz"), new ParameterOption("3", "47Hz"), new ParameterOption("4", "23Hz"), new ParameterOption("5", "12Hz"), new ParameterOption("6", "64Hz"), new ParameterOption("7", "32Hz"))).build(), ConfigDescriptionParameterBuilder.create("accelerometerRange", Type.INTEGER).withDefault("1").withDescription("This option is user selectable in all fusion modes.").withLabel("Accelerometer Range").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "±2G"), new ParameterOption("1", "±4G"), new ParameterOption("2", "±8G"), new ParameterOption("3", "±16G"))).build(), ConfigDescriptionParameterBuilder.create("accelerometerBandwidth", Type.INTEGER).withDefault("3").withDescription("This option is auto-controlled in fusion mode.").withLabel("Accelerometer Bandwidth").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "7.81Hz"), new ParameterOption("1", "15.63Hz"), new ParameterOption("2", "31.25Hz"), new ParameterOption("3", "62.5Hz"), new ParameterOption("4", "125Hz"), new ParameterOption("5", "250Hz"), new ParameterOption("6", "500Hz"), new ParameterOption("7", "1000Hz"))).build(), ConfigDescriptionParameterBuilder.create("sensorFusionMode", Type.INTEGER).withDefault("1").withDescription("If the fusion mode is turned off, the Acceleration, Magnetic Field and Angular Velocity channels return uncalibrated and uncompensated sensor data. All other sensor channels return no data.<br/><br/>Since firmware version 2.0.6 you can also use a fusion mode without magnetometer. In this mode the calculated orientation is relative (with magnetometer it is absolute with respect to the earth). However, the calculation can't be influenced by spurious magnetic fields.<br/><br/>Since firmware version 2.0.13 you can also use a fusion mode without fast magnetometer calibration. This mode is the same as the normal fusion mode, but the fast magnetometer calibration is turned off. So to find the orientation the first time will likely take longer, but small magnetic influences might not affect the automatic calibration as much.<br/><br/>By default sensor fusion is on.").withLabel("Sensor Fusion Mode").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "On Without Magnetometer"), new ParameterOption("3", "On Without Fast Magnetometer Calibration"))).build(), ConfigDescriptionParameterBuilder.create("accelerationUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the acceleration in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Acceleration Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("magneticFieldUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the magnetic field in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Magnetic Field Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("angularVelocityUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the angular velocity in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Angular Velocity Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("orientationUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the orientation as euler angles in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Orientation Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("quaternionUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the orientation as quaternion in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Quaternion Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("linearAccelerationUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the linear acceleration in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Linear Acceleration Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("gravityVectorUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the gravity vector in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Gravity Vector Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("temperatureUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the temperature in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Temperature Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.BOOLEAN).withDefault("true").withDescription("The status LED is the blue LED next to the USB connector. If enabled is is on and it flickers if data is transfered. If disabled it is always off.").withLabel("Status LED Config").build(), ConfigDescriptionParameterBuilder.create("spitfpEnableDynamicBaudrate", Type.BOOLEAN).withDefault("true").withDescription("The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is enabled, the Brick will try to adapt the baudrate for the communication between Bricks and Bricklets according to the amount of data that is transferred.<br/><br/>The baudrate will be increased exponentially if lots of data is sent/received and decreased linearly if little data is sent/received.<br/><br/>This lowers the baudrate in applications where little data is transferred (e.g. a weather station) and increases the robustness. If there is lots of data to transfer (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.<br/><br/>In cases where some data has to transferred as fast as possible every few seconds (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn the dynamic baudrate off to get the highest possible performance.<br/><br/>The maximum value of the baudrate can be set per port. If the dynamic baudrate is disabled, the maximum baudrate will be used statically.").withLabel("SPITFP Enable Dynamic Baudrate").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("spitfpMinimumDynamicBaudrate", Type.INTEGER).withDefault("400000").withDescription("See SPITFP Enable Dynamic Baudrate").withLabel("SPITFP Minimum Dynamic Baudrate").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build(), ConfigDescriptionParameterBuilder.create("spitfpBaudratePortA", Type.INTEGER).withDefault("1400000").withDescription("The baudrate for Bricklet port A.<br/><br/>If you want to increase the throughput of Bricklets you can increase the baudrate. If you get a high error count because of high interference you can decrease the baudrate.<br/><br/>If the dynamic baudrate feature is enabled, this is the maximum baudrate.<br/><br/>Regulatory testing is done with the default baudrate. If CE compatibility or similar is necessary in you applications we recommend to not change the baudrate.").withLabel("(Maximum) SPITFP Baudrate Port A").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build(), ConfigDescriptionParameterBuilder.create("spitfpBaudratePortB", Type.INTEGER).withDefault("1400000").withDescription("The baudrate for Bricklet port B.<br/><br/>If you want to increase the throughput of Bricklets you can increase the baudrate. If you get a high error count because of high interference you can decrease the baudrate.<br/><br/>If the dynamic baudrate feature is enabled, this is the maximum baudrate.<br/><br/>Regulatory testing is done with the default baudrate. If CE compatibility or similar is necessary in you applications we recommend to not change the baudrate.").withLabel("(Maximum) SPITFP Baudrate Port B").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickIMUV2Acceleration":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickIMUV2MagneticField":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickIMUV2AngularVelocity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickIMUV2Orientation":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickIMUV2Quaternion":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickIMUV2LinearAcceleration":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickIMUV2GravityVector":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickIMUV2Temperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickIMUV2EnableLEDs":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickIMUV2Config cfg = (BrickIMUV2Config) config.as(BrickIMUV2Config.class);
        switch(channel) {
            case "BrickIMUV2AccelerationX": {
                   BrickIMUV2AccelerationConfig channelCfg = channelConfig.as(BrickIMUV2AccelerationConfig.class);
                   {
            BrickIMUV2.Acceleration value = this.getAcceleration();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2AccelerationXGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2AccelerationY": {
                   BrickIMUV2AccelerationConfig channelCfg = channelConfig.as(BrickIMUV2AccelerationConfig.class);
                   {
            BrickIMUV2.Acceleration value = this.getAcceleration();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2AccelerationYGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2AccelerationZ": {
                   BrickIMUV2AccelerationConfig channelCfg = channelConfig.as(BrickIMUV2AccelerationConfig.class);
                   {
            BrickIMUV2.Acceleration value = this.getAcceleration();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2AccelerationZGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2MagneticFieldX": {
                   BrickIMUV2MagneticFieldConfig channelCfg = channelConfig.as(BrickIMUV2MagneticFieldConfig.class);
                   {
            BrickIMUV2.MagneticField value = this.getMagneticField();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2MagneticFieldXGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2MagneticFieldY": {
                   BrickIMUV2MagneticFieldConfig channelCfg = channelConfig.as(BrickIMUV2MagneticFieldConfig.class);
                   {
            BrickIMUV2.MagneticField value = this.getMagneticField();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2MagneticFieldYGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2MagneticFieldZ": {
                   BrickIMUV2MagneticFieldConfig channelCfg = channelConfig.as(BrickIMUV2MagneticFieldConfig.class);
                   {
            BrickIMUV2.MagneticField value = this.getMagneticField();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2MagneticFieldZGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2AngularVelocityX": {
                   BrickIMUV2AngularVelocityConfig channelCfg = channelConfig.as(BrickIMUV2AngularVelocityConfig.class);
                   {
            BrickIMUV2.AngularVelocity value = this.getAngularVelocity();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2AngularVelocityXGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2AngularVelocityY": {
                   BrickIMUV2AngularVelocityConfig channelCfg = channelConfig.as(BrickIMUV2AngularVelocityConfig.class);
                   {
            BrickIMUV2.AngularVelocity value = this.getAngularVelocity();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2AngularVelocityYGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2AngularVelocityZ": {
                   BrickIMUV2AngularVelocityConfig channelCfg = channelConfig.as(BrickIMUV2AngularVelocityConfig.class);
                   {
            BrickIMUV2.AngularVelocity value = this.getAngularVelocity();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2AngularVelocityZGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2OrientationHeading": {
                   BrickIMUV2OrientationConfig channelCfg = channelConfig.as(BrickIMUV2OrientationConfig.class);
                   {
            BrickIMUV2.Orientation value = this.getOrientation();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2OrientationHeadingGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2OrientationRoll": {
                   BrickIMUV2OrientationConfig channelCfg = channelConfig.as(BrickIMUV2OrientationConfig.class);
                   {
            BrickIMUV2.Orientation value = this.getOrientation();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2OrientationRollGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2OrientationPitch": {
                   BrickIMUV2OrientationConfig channelCfg = channelConfig.as(BrickIMUV2OrientationConfig.class);
                   {
            BrickIMUV2.Orientation value = this.getOrientation();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2OrientationPitchGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2QuaternionW": {
                   BrickIMUV2QuaternionConfig channelCfg = channelConfig.as(BrickIMUV2QuaternionConfig.class);
                   {
            BrickIMUV2.Quaternion value = this.getQuaternion();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2QuaternionWGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2QuaternionX": {
                   BrickIMUV2QuaternionConfig channelCfg = channelConfig.as(BrickIMUV2QuaternionConfig.class);
                   {
            BrickIMUV2.Quaternion value = this.getQuaternion();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2QuaternionXGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2QuaternionY": {
                   BrickIMUV2QuaternionConfig channelCfg = channelConfig.as(BrickIMUV2QuaternionConfig.class);
                   {
            BrickIMUV2.Quaternion value = this.getQuaternion();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2QuaternionYGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2QuaternionZ": {
                   BrickIMUV2QuaternionConfig channelCfg = channelConfig.as(BrickIMUV2QuaternionConfig.class);
                   {
            BrickIMUV2.Quaternion value = this.getQuaternion();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2QuaternionZGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2LinearAccelerationX": {
                   BrickIMUV2LinearAccelerationConfig channelCfg = channelConfig.as(BrickIMUV2LinearAccelerationConfig.class);
                   {
            BrickIMUV2.LinearAcceleration value = this.getLinearAcceleration();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2LinearAccelerationXGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2LinearAccelerationY": {
                   BrickIMUV2LinearAccelerationConfig channelCfg = channelConfig.as(BrickIMUV2LinearAccelerationConfig.class);
                   {
            BrickIMUV2.LinearAcceleration value = this.getLinearAcceleration();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2LinearAccelerationYGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2LinearAccelerationZ": {
                   BrickIMUV2LinearAccelerationConfig channelCfg = channelConfig.as(BrickIMUV2LinearAccelerationConfig.class);
                   {
            BrickIMUV2.LinearAcceleration value = this.getLinearAcceleration();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2LinearAccelerationZGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2GravityVectorX": {
                   BrickIMUV2GravityVectorConfig channelCfg = channelConfig.as(BrickIMUV2GravityVectorConfig.class);
                   {
            BrickIMUV2.GravityVector value = this.getGravityVector();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2GravityVectorXGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2GravityVectorY": {
                   BrickIMUV2GravityVectorConfig channelCfg = channelConfig.as(BrickIMUV2GravityVectorConfig.class);
                   {
            BrickIMUV2.GravityVector value = this.getGravityVector();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2GravityVectorYGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2GravityVectorZ": {
                   BrickIMUV2GravityVectorConfig channelCfg = channelConfig.as(BrickIMUV2GravityVectorConfig.class);
                   {
            BrickIMUV2.GravityVector value = this.getGravityVector();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2GravityVectorZGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2Temperature": {
                   BrickIMUV2TemperatureConfig channelCfg = channelConfig.as(BrickIMUV2TemperatureConfig.class);
                   {
            int value = this.getTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2TemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickIMUV2EnableLEDs": {
                   BrickIMUV2EnableLEDsConfig channelCfg = channelConfig.as(BrickIMUV2EnableLEDsConfig.class);
                   {
            boolean value = this.areLedsOn();
            if(true)
                updateStateFn.accept(channel, transformBrickIMUV2EnableLEDsGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickIMUV2Config cfg = (BrickIMUV2Config) config.as(BrickIMUV2Config.class);
        switch(channel) {
            case "BrickIMUV2EnableLEDs":
                if (command instanceof OnOffType) {
                    BrickIMUV2EnableLEDsConfig channelCfg = channelConfig.as(BrickIMUV2EnableLEDsConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    if(cmd == OnOffType.ON) {
    this.ledsOn();
}
                }
        
if (command instanceof OnOffType) {
                    BrickIMUV2EnableLEDsConfig channelCfg = channelConfig.as(BrickIMUV2EnableLEDsConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    if(cmd == OnOffType.OFF) {
    this.ledsOff();
}
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType, OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickIMUV2AccelerationXCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(x / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AccelerationYCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(y / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AccelerationZCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(z / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2MagneticFieldXCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(x / 16000000.0, SmartHomeUnits.TESLA);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2MagneticFieldYCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(y / 16000000.0, SmartHomeUnits.TESLA);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2MagneticFieldZCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(z / 16000000.0, SmartHomeUnits.TESLA);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AngularVelocityXCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(x / 16.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AngularVelocityYCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(y / 16.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AngularVelocityZCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(z / 16.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2OrientationHeadingCallback0(int heading, int roll, int pitch, BrickIMUV2Config cfg) {
        return new QuantityType(heading / 16.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2OrientationRollCallback0(int heading, int roll, int pitch, BrickIMUV2Config cfg) {
        return new QuantityType(roll / 16.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2OrientationPitchCallback0(int heading, int roll, int pitch, BrickIMUV2Config cfg) {
        return new QuantityType(pitch / 16.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2QuaternionWCallback0(int w, int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(w / 16383.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2QuaternionXCallback0(int w, int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(x / 16383.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2QuaternionYCallback0(int w, int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(y / 16383.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2QuaternionZCallback0(int w, int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(z / 16383.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2LinearAccelerationXCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(x / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2LinearAccelerationYCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(y / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2LinearAccelerationZCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(z / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2GravityVectorXCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(x / 980.665, SmartHomeUnits.STANDARD_GRAVITY);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2GravityVectorYCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(y / 980.665, SmartHomeUnits.STANDARD_GRAVITY);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2GravityVectorZCallback0(int x, int y, int z, BrickIMUV2Config cfg) {
        return new QuantityType(z / 980.665, SmartHomeUnits.STANDARD_GRAVITY);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2TemperatureCallback0(int temperature, BrickIMUV2Config cfg) {
        return new QuantityType(temperature, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AccelerationXGetter0(BrickIMUV2.Acceleration value, BrickIMUV2Config cfg) {
        return new QuantityType(value.x / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AccelerationYGetter0(BrickIMUV2.Acceleration value, BrickIMUV2Config cfg) {
        return new QuantityType(value.y / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AccelerationZGetter0(BrickIMUV2.Acceleration value, BrickIMUV2Config cfg) {
        return new QuantityType(value.z / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2MagneticFieldXGetter0(BrickIMUV2.MagneticField value, BrickIMUV2Config cfg) {
        return new QuantityType(value.x / 16000000.0, SmartHomeUnits.TESLA);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2MagneticFieldYGetter0(BrickIMUV2.MagneticField value, BrickIMUV2Config cfg) {
        return new QuantityType(value.y / 16000000.0, SmartHomeUnits.TESLA);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2MagneticFieldZGetter0(BrickIMUV2.MagneticField value, BrickIMUV2Config cfg) {
        return new QuantityType(value.z / 16000000.0, SmartHomeUnits.TESLA);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AngularVelocityXGetter0(BrickIMUV2.AngularVelocity value, BrickIMUV2Config cfg) {
        return new QuantityType(value.x / 16.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AngularVelocityYGetter0(BrickIMUV2.AngularVelocity value, BrickIMUV2Config cfg) {
        return new QuantityType(value.y / 16.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2AngularVelocityZGetter0(BrickIMUV2.AngularVelocity value, BrickIMUV2Config cfg) {
        return new QuantityType(value.z / 16.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2OrientationHeadingGetter0(BrickIMUV2.Orientation value, BrickIMUV2Config cfg) {
        return new QuantityType(value.heading / 16.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2OrientationRollGetter0(BrickIMUV2.Orientation value, BrickIMUV2Config cfg) {
        return new QuantityType(value.roll / 16.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2OrientationPitchGetter0(BrickIMUV2.Orientation value, BrickIMUV2Config cfg) {
        return new QuantityType(value.pitch / 16.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2QuaternionWGetter0(BrickIMUV2.Quaternion value, BrickIMUV2Config cfg) {
        return new QuantityType(value.w / 16383.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2QuaternionXGetter0(BrickIMUV2.Quaternion value, BrickIMUV2Config cfg) {
        return new QuantityType(value.x / 16383.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2QuaternionYGetter0(BrickIMUV2.Quaternion value, BrickIMUV2Config cfg) {
        return new QuantityType(value.y / 16383.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2QuaternionZGetter0(BrickIMUV2.Quaternion value, BrickIMUV2Config cfg) {
        return new QuantityType(value.z / 16383.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2LinearAccelerationXGetter0(BrickIMUV2.LinearAcceleration value, BrickIMUV2Config cfg) {
        return new QuantityType(value.x / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2LinearAccelerationYGetter0(BrickIMUV2.LinearAcceleration value, BrickIMUV2Config cfg) {
        return new QuantityType(value.y / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2LinearAccelerationZGetter0(BrickIMUV2.LinearAcceleration value, BrickIMUV2Config cfg) {
        return new QuantityType(value.z / 100.0, SmartHomeUnits.METRE_PER_SQUARE_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2GravityVectorXGetter0(BrickIMUV2.GravityVector value, BrickIMUV2Config cfg) {
        return new QuantityType(value.x / 980.665, SmartHomeUnits.STANDARD_GRAVITY);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2GravityVectorYGetter0(BrickIMUV2.GravityVector value, BrickIMUV2Config cfg) {
        return new QuantityType(value.y / 980.665, SmartHomeUnits.STANDARD_GRAVITY);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2GravityVectorZGetter0(BrickIMUV2.GravityVector value, BrickIMUV2Config cfg) {
        return new QuantityType(value.z / 980.665, SmartHomeUnits.STANDARD_GRAVITY);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2TemperatureGetter0(int value, BrickIMUV2Config cfg) {
        return new QuantityType(value, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickIMUV2EnableLEDsGetter0(boolean value, BrickIMUV2Config cfg) {
        return value? OnOffType.ON : OnOffType.OFF;
    }

}