/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickMaster;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickMasterWrapper extends DeviceWrapper implements StandardFlashHost{
    BrickMaster dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickMaster.DEVICE_DISPLAY_NAME, "brickmaster", BrickMaster.DEVICE_IDENTIFIER, BrickMasterWrapper.class, BrickMasterActions.class, "2.4.6", false);

    public BrickMasterWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickMaster(uid, ipcon);
    }

    
	public final static long EXTENSION_TYPE_CHIBI = 1L;
	public final static long EXTENSION_TYPE_RS485 = 2L;
	public final static long EXTENSION_TYPE_WIFI = 3L;
	public final static long EXTENSION_TYPE_ETHERNET = 4L;
	public final static long EXTENSION_TYPE_WIFI2 = 5L;
	public final static int CHIBI_FREQUENCY_OQPSK_868_MHZ = 0;
	public final static int CHIBI_FREQUENCY_OQPSK_915_MHZ = 1;
	public final static int CHIBI_FREQUENCY_OQPSK_780_MHZ = 2;
	public final static int CHIBI_FREQUENCY_BPSK40_915_MHZ = 3;
	public final static char RS485_PARITY_NONE = 'n';
	public final static char RS485_PARITY_EVEN = 'e';
	public final static char RS485_PARITY_ODD = 'o';
	public final static int WIFI_CONNECTION_DHCP = 0;
	public final static int WIFI_CONNECTION_STATIC_IP = 1;
	public final static int WIFI_CONNECTION_ACCESS_POINT_DHCP = 2;
	public final static int WIFI_CONNECTION_ACCESS_POINT_STATIC_IP = 3;
	public final static int WIFI_CONNECTION_AD_HOC_DHCP = 4;
	public final static int WIFI_CONNECTION_AD_HOC_STATIC_IP = 5;
	public final static int WIFI_ENCRYPTION_WPA_WPA2 = 0;
	public final static int WIFI_ENCRYPTION_WPA_ENTERPRISE = 1;
	public final static int WIFI_ENCRYPTION_WEP = 2;
	public final static int WIFI_ENCRYPTION_NO_ENCRYPTION = 3;
	public final static int WIFI_EAP_OPTION_OUTER_AUTH_EAP_FAST = 0;
	public final static int WIFI_EAP_OPTION_OUTER_AUTH_EAP_TLS = 1;
	public final static int WIFI_EAP_OPTION_OUTER_AUTH_EAP_TTLS = 2;
	public final static int WIFI_EAP_OPTION_OUTER_AUTH_EAP_PEAP = 3;
	public final static int WIFI_EAP_OPTION_INNER_AUTH_EAP_MSCHAP = 0;
	public final static int WIFI_EAP_OPTION_INNER_AUTH_EAP_GTC = 4;
	public final static int WIFI_EAP_OPTION_CERT_TYPE_CA_CERT = 0;
	public final static int WIFI_EAP_OPTION_CERT_TYPE_CLIENT_CERT = 8;
	public final static int WIFI_EAP_OPTION_CERT_TYPE_PRIVATE_KEY = 16;
	public final static int WIFI_STATE_DISASSOCIATED = 0;
	public final static int WIFI_STATE_ASSOCIATED = 1;
	public final static int WIFI_STATE_ASSOCIATING = 2;
	public final static int WIFI_STATE_ERROR = 3;
	public final static int WIFI_STATE_NOT_INITIALIZED_YET = 255;
	public final static int WIFI_POWER_MODE_FULL_SPEED = 0;
	public final static int WIFI_POWER_MODE_LOW_POWER = 1;
	public final static int WIFI_DOMAIN_CHANNEL_1TO11 = 0;
	public final static int WIFI_DOMAIN_CHANNEL_1TO13 = 1;
	public final static int WIFI_DOMAIN_CHANNEL_1TO14 = 2;
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int ETHERNET_CONNECTION_DHCP = 0;
	public final static int ETHERNET_CONNECTION_STATIC_IP = 1;
	public final static int CONNECTION_TYPE_NONE = 0;
	public final static int CONNECTION_TYPE_USB = 1;
	public final static int CONNECTION_TYPE_SPI_STACK = 2;
	public final static int CONNECTION_TYPE_CHIBI = 3;
	public final static int CONNECTION_TYPE_RS485 = 4;
	public final static int CONNECTION_TYPE_WIFI = 5;
	public final static int CONNECTION_TYPE_ETHERNET = 6;
	public final static int CONNECTION_TYPE_WIFI2 = 7;
	public final static int WIFI2_PHY_MODE_B = 0;
	public final static int WIFI2_PHY_MODE_G = 1;
	public final static int WIFI2_PHY_MODE_N = 2;
	public final static int WIFI2_CLIENT_STATUS_IDLE = 0;
	public final static int WIFI2_CLIENT_STATUS_CONNECTING = 1;
	public final static int WIFI2_CLIENT_STATUS_WRONG_PASSWORD = 2;
	public final static int WIFI2_CLIENT_STATUS_NO_AP_FOUND = 3;
	public final static int WIFI2_CLIENT_STATUS_CONNECT_FAILED = 4;
	public final static int WIFI2_CLIENT_STATUS_GOT_IP = 5;
	public final static int WIFI2_CLIENT_STATUS_UNKNOWN = 255;
	public final static int WIFI2_AP_ENCRYPTION_OPEN = 0;
	public final static int WIFI2_AP_ENCRYPTION_WEP = 1;
	public final static int WIFI2_AP_ENCRYPTION_WPA_PSK = 2;
	public final static int WIFI2_AP_ENCRYPTION_WPA2_PSK = 3;
	public final static int WIFI2_AP_ENCRYPTION_WPA_WPA2_PSK = 4;
	public final static int WIFI2_MESH_STATUS_DISABLED = 0;
	public final static int WIFI2_MESH_STATUS_WIFI_CONNECTING = 1;
	public final static int WIFI2_MESH_STATUS_GOT_IP = 2;
	public final static int WIFI2_MESH_STATUS_MESH_LOCAL = 3;
	public final static int WIFI2_MESH_STATUS_MESH_ONLINE = 4;
	public final static int WIFI2_MESH_STATUS_AP_AVAILABLE = 5;
	public final static int WIFI2_MESH_STATUS_AP_SETUP = 6;
	public final static int WIFI2_MESH_STATUS_LEAF_AVAILABLE = 7;
	public final static int COMMUNICATION_METHOD_NONE = 0;
	public final static int COMMUNICATION_METHOD_USB = 1;
	public final static int COMMUNICATION_METHOD_SPI_STACK = 2;
	public final static int COMMUNICATION_METHOD_CHIBI = 3;
	public final static int COMMUNICATION_METHOD_RS485 = 4;
	public final static int COMMUNICATION_METHOD_WIFI = 5;
	public final static int COMMUNICATION_METHOD_ETHERNET = 6;
	public final static int COMMUNICATION_METHOD_WIFI_V2 = 7;


    public int getStackVoltage() throws TinkerforgeException {
    return this.dev.getStackVoltage();
}

public int getStackCurrent() throws TinkerforgeException {
    return this.dev.getStackCurrent();
}

public void setExtensionType(int extension, long exttype) throws TinkerforgeException {
    this.dev.setExtensionType(extension, exttype);
}

public long getExtensionType(int extension) throws TinkerforgeException {
    return this.dev.getExtensionType(extension);
}

public boolean isChibiPresent() throws TinkerforgeException {
    return this.dev.isChibiPresent();
}

public void setChibiAddress(int address) throws TinkerforgeException {
    this.dev.setChibiAddress(address);
}

public int getChibiAddress() throws TinkerforgeException {
    return this.dev.getChibiAddress();
}

public void setChibiMasterAddress(int address) throws TinkerforgeException {
    this.dev.setChibiMasterAddress(address);
}

public int getChibiMasterAddress() throws TinkerforgeException {
    return this.dev.getChibiMasterAddress();
}

public void setChibiSlaveAddress(int num, int address) throws TinkerforgeException {
    this.dev.setChibiSlaveAddress(num, address);
}

public int getChibiSlaveAddress(int num) throws TinkerforgeException {
    return this.dev.getChibiSlaveAddress(num);
}

public int getChibiSignalStrength() throws TinkerforgeException {
    return this.dev.getChibiSignalStrength();
}

public BrickMaster.ChibiErrorLog getChibiErrorLog() throws TinkerforgeException {
    return this.dev.getChibiErrorLog();
}

public void setChibiFrequency(int frequency) throws TinkerforgeException {
    this.dev.setChibiFrequency(frequency);
}

public int getChibiFrequency() throws TinkerforgeException {
    return this.dev.getChibiFrequency();
}

public void setChibiChannel(int channel) throws TinkerforgeException {
    this.dev.setChibiChannel(channel);
}

public int getChibiChannel() throws TinkerforgeException {
    return this.dev.getChibiChannel();
}

public boolean isRS485Present() throws TinkerforgeException {
    return this.dev.isRS485Present();
}

public void setRS485Address(int address) throws TinkerforgeException {
    this.dev.setRS485Address(address);
}

public int getRS485Address() throws TinkerforgeException {
    return this.dev.getRS485Address();
}

public void setRS485SlaveAddress(int num, int address) throws TinkerforgeException {
    this.dev.setRS485SlaveAddress(num, address);
}

public int getRS485SlaveAddress(int num) throws TinkerforgeException {
    return this.dev.getRS485SlaveAddress(num);
}

public int getRS485ErrorLog() throws TinkerforgeException {
    return this.dev.getRS485ErrorLog();
}

public void setRS485Configuration(long speed, char parity, int stopbits) throws TinkerforgeException {
    this.dev.setRS485Configuration(speed, parity, stopbits);
}

public BrickMaster.RS485Configuration getRS485Configuration() throws TinkerforgeException {
    return this.dev.getRS485Configuration();
}

public boolean isWifiPresent() throws TinkerforgeException {
    return this.dev.isWifiPresent();
}

public void setWifiConfiguration(String ssid, int connection, int[] ip, int[] subnetMask, int[] gateway, int port) throws TinkerforgeException {
    this.dev.setWifiConfiguration(ssid, connection, ip, subnetMask, gateway, port);
}

public BrickMaster.WifiConfiguration getWifiConfiguration() throws TinkerforgeException {
    return this.dev.getWifiConfiguration();
}

public void setWifiEncryption(int encryption, String key, int keyIndex, int eapOptions, int caCertificateLength, int clientCertificateLength, int privateKeyLength) throws TinkerforgeException {
    this.dev.setWifiEncryption(encryption, key, keyIndex, eapOptions, caCertificateLength, clientCertificateLength, privateKeyLength);
}

public BrickMaster.WifiEncryption getWifiEncryption() throws TinkerforgeException {
    return this.dev.getWifiEncryption();
}

public BrickMaster.WifiStatus getWifiStatus() throws TinkerforgeException {
    return this.dev.getWifiStatus();
}

public void refreshWifiStatus() throws TinkerforgeException {
    this.dev.refreshWifiStatus();
}

public void setWifiCertificate(int index, int[] data, int dataLength) throws TinkerforgeException {
    this.dev.setWifiCertificate(index, data, dataLength);
}

public BrickMaster.WifiCertificate getWifiCertificate(int index) throws TinkerforgeException {
    return this.dev.getWifiCertificate(index);
}

public void setWifiPowerMode(int mode) throws TinkerforgeException {
    this.dev.setWifiPowerMode(mode);
}

public int getWifiPowerMode() throws TinkerforgeException {
    return this.dev.getWifiPowerMode();
}

public BrickMaster.WifiBufferInfo getWifiBufferInfo() throws TinkerforgeException {
    return this.dev.getWifiBufferInfo();
}

public void setWifiRegulatoryDomain(int domain) throws TinkerforgeException {
    this.dev.setWifiRegulatoryDomain(domain);
}

public int getWifiRegulatoryDomain() throws TinkerforgeException {
    return this.dev.getWifiRegulatoryDomain();
}

public int getUSBVoltage() throws TinkerforgeException {
    return this.dev.getUSBVoltage();
}

public void setLongWifiKey(String key) throws TinkerforgeException {
    this.dev.setLongWifiKey(key);
}

public String getLongWifiKey() throws TinkerforgeException {
    return this.dev.getLongWifiKey();
}

public void setWifiHostname(String hostname) throws TinkerforgeException {
    this.dev.setWifiHostname(hostname);
}

public String getWifiHostname() throws TinkerforgeException {
    return this.dev.getWifiHostname();
}

public void setStackCurrentCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setStackCurrentCallbackPeriod(period);
}

public long getStackCurrentCallbackPeriod() throws TinkerforgeException {
    return this.dev.getStackCurrentCallbackPeriod();
}

public void setStackVoltageCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setStackVoltageCallbackPeriod(period);
}

public long getStackVoltageCallbackPeriod() throws TinkerforgeException {
    return this.dev.getStackVoltageCallbackPeriod();
}

public void setUSBVoltageCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setUSBVoltageCallbackPeriod(period);
}

public long getUSBVoltageCallbackPeriod() throws TinkerforgeException {
    return this.dev.getUSBVoltageCallbackPeriod();
}

public void setStackCurrentCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setStackCurrentCallbackThreshold(option, min, max);
}

public BrickMaster.StackCurrentCallbackThreshold getStackCurrentCallbackThreshold() throws TinkerforgeException {
    return this.dev.getStackCurrentCallbackThreshold();
}

public void setStackVoltageCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setStackVoltageCallbackThreshold(option, min, max);
}

public BrickMaster.StackVoltageCallbackThreshold getStackVoltageCallbackThreshold() throws TinkerforgeException {
    return this.dev.getStackVoltageCallbackThreshold();
}

public void setUSBVoltageCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setUSBVoltageCallbackThreshold(option, min, max);
}

public BrickMaster.USBVoltageCallbackThreshold getUSBVoltageCallbackThreshold() throws TinkerforgeException {
    return this.dev.getUSBVoltageCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public boolean isEthernetPresent() throws TinkerforgeException {
    return this.dev.isEthernetPresent();
}

public void setEthernetConfiguration(int connection, int[] ip, int[] subnetMask, int[] gateway, int port) throws TinkerforgeException {
    this.dev.setEthernetConfiguration(connection, ip, subnetMask, gateway, port);
}

public BrickMaster.EthernetConfiguration getEthernetConfiguration() throws TinkerforgeException {
    return this.dev.getEthernetConfiguration();
}

public BrickMaster.EthernetStatus getEthernetStatus() throws TinkerforgeException {
    return this.dev.getEthernetStatus();
}

public void setEthernetHostname(String hostname) throws TinkerforgeException {
    this.dev.setEthernetHostname(hostname);
}

public void setEthernetMACAddress(int[] macAddress) throws TinkerforgeException {
    this.dev.setEthernetMACAddress(macAddress);
}

public void setEthernetWebsocketConfiguration(int sockets, int port) throws TinkerforgeException {
    this.dev.setEthernetWebsocketConfiguration(sockets, port);
}

public BrickMaster.EthernetWebsocketConfiguration getEthernetWebsocketConfiguration() throws TinkerforgeException {
    return this.dev.getEthernetWebsocketConfiguration();
}

public void setEthernetAuthenticationSecret(String secret) throws TinkerforgeException {
    this.dev.setEthernetAuthenticationSecret(secret);
}

public String getEthernetAuthenticationSecret() throws TinkerforgeException {
    return this.dev.getEthernetAuthenticationSecret();
}

public void setWifiAuthenticationSecret(String secret) throws TinkerforgeException {
    this.dev.setWifiAuthenticationSecret(secret);
}

public String getWifiAuthenticationSecret() throws TinkerforgeException {
    return this.dev.getWifiAuthenticationSecret();
}

public int getConnectionType() throws TinkerforgeException {
    return this.dev.getConnectionType();
}

public boolean isWifi2Present() throws TinkerforgeException {
    return this.dev.isWifi2Present();
}

public int startWifi2Bootloader() throws TinkerforgeException {
    return this.dev.startWifi2Bootloader();
}

public int writeWifi2SerialPort(int[] data, int length) throws TinkerforgeException {
    return this.dev.writeWifi2SerialPort(data, length);
}

public BrickMaster.ReadWifi2SerialPort readWifi2SerialPort(int length) throws TinkerforgeException {
    return this.dev.readWifi2SerialPort(length);
}

public void setWifi2AuthenticationSecret(String secret) throws TinkerforgeException {
    this.dev.setWifi2AuthenticationSecret(secret);
}

public String getWifi2AuthenticationSecret() throws TinkerforgeException {
    return this.dev.getWifi2AuthenticationSecret();
}

public void setWifi2Configuration(int port, int websocketPort, int websitePort, int phyMode, int sleepMode, int website) throws TinkerforgeException {
    this.dev.setWifi2Configuration(port, websocketPort, websitePort, phyMode, sleepMode, website);
}

public BrickMaster.Wifi2Configuration getWifi2Configuration() throws TinkerforgeException {
    return this.dev.getWifi2Configuration();
}

public BrickMaster.Wifi2Status getWifi2Status() throws TinkerforgeException {
    return this.dev.getWifi2Status();
}

public void setWifi2ClientConfiguration(boolean enable, String ssid, int[] ip, int[] subnetMask, int[] gateway, int[] macAddress, int[] bssid) throws TinkerforgeException {
    this.dev.setWifi2ClientConfiguration(enable, ssid, ip, subnetMask, gateway, macAddress, bssid);
}

public BrickMaster.Wifi2ClientConfiguration getWifi2ClientConfiguration() throws TinkerforgeException {
    return this.dev.getWifi2ClientConfiguration();
}

public void setWifi2ClientHostname(String hostname) throws TinkerforgeException {
    this.dev.setWifi2ClientHostname(hostname);
}

public String getWifi2ClientHostname() throws TinkerforgeException {
    return this.dev.getWifi2ClientHostname();
}

public void setWifi2ClientPassword(String password) throws TinkerforgeException {
    this.dev.setWifi2ClientPassword(password);
}

public String getWifi2ClientPassword() throws TinkerforgeException {
    return this.dev.getWifi2ClientPassword();
}

public void setWifi2APConfiguration(boolean enable, String ssid, int[] ip, int[] subnetMask, int[] gateway, int encryption, boolean hidden, int channel, int[] macAddress) throws TinkerforgeException {
    this.dev.setWifi2APConfiguration(enable, ssid, ip, subnetMask, gateway, encryption, hidden, channel, macAddress);
}

public BrickMaster.Wifi2APConfiguration getWifi2APConfiguration() throws TinkerforgeException {
    return this.dev.getWifi2APConfiguration();
}

public void setWifi2APPassword(String password) throws TinkerforgeException {
    this.dev.setWifi2APPassword(password);
}

public String getWifi2APPassword() throws TinkerforgeException {
    return this.dev.getWifi2APPassword();
}

public int saveWifi2Configuration() throws TinkerforgeException {
    return this.dev.saveWifi2Configuration();
}

public int[] getWifi2FirmwareVersion() throws TinkerforgeException {
    return this.dev.getWifi2FirmwareVersion();
}

public void enableWifi2StatusLED() throws TinkerforgeException {
    this.dev.enableWifi2StatusLED();
}

public void disableWifi2StatusLED() throws TinkerforgeException {
    this.dev.disableWifi2StatusLED();
}

public boolean isWifi2StatusLEDEnabled() throws TinkerforgeException {
    return this.dev.isWifi2StatusLEDEnabled();
}

public void setWifi2MeshConfiguration(boolean enable, int[] rootIP, int[] rootSubnetMask, int[] rootGateway, int[] routerBSSID, int[] groupID, String groupSSIDPrefix, int[] gatewayIP, int gatewayPort) throws TinkerforgeException {
    this.dev.setWifi2MeshConfiguration(enable, rootIP, rootSubnetMask, rootGateway, routerBSSID, groupID, groupSSIDPrefix, gatewayIP, gatewayPort);
}

public BrickMaster.Wifi2MeshConfiguration getWifi2MeshConfiguration() throws TinkerforgeException {
    return this.dev.getWifi2MeshConfiguration();
}

public void setWifi2MeshRouterSSID(String ssid) throws TinkerforgeException {
    this.dev.setWifi2MeshRouterSSID(ssid);
}

public String getWifi2MeshRouterSSID() throws TinkerforgeException {
    return this.dev.getWifi2MeshRouterSSID();
}

public void setWifi2MeshRouterPassword(String password) throws TinkerforgeException {
    this.dev.setWifi2MeshRouterPassword(password);
}

public String getWifi2MeshRouterPassword() throws TinkerforgeException {
    return this.dev.getWifi2MeshRouterPassword();
}

public BrickMaster.Wifi2MeshCommonStatus getWifi2MeshCommonStatus() throws TinkerforgeException {
    return this.dev.getWifi2MeshCommonStatus();
}

public BrickMaster.Wifi2MeshClientStatus getWifi2MeshClientStatus() throws TinkerforgeException {
    return this.dev.getWifi2MeshClientStatus();
}

public BrickMaster.Wifi2MeshAPStatus getWifi2MeshAPStatus() throws TinkerforgeException {
    return this.dev.getWifi2MeshAPStatus();
}

public void setSPITFPBaudrateConfig(boolean enableDynamicBaudrate, long minimumDynamicBaudrate) throws TinkerforgeException {
    this.dev.setSPITFPBaudrateConfig(enableDynamicBaudrate, minimumDynamicBaudrate);
}

public BrickMaster.SPITFPBaudrateConfig getSPITFPBaudrateConfig() throws TinkerforgeException {
    return this.dev.getSPITFPBaudrateConfig();
}

public long getSendTimeoutCount(int communicationMethod) throws TinkerforgeException {
    return this.dev.getSendTimeoutCount(communicationMethod);
}

public void setSPITFPBaudrate(char brickletPort, long baudrate) throws TinkerforgeException {
    this.dev.setSPITFPBaudrate(brickletPort, baudrate);
}

public long getSPITFPBaudrate(char brickletPort) throws TinkerforgeException {
    return this.dev.getSPITFPBaudrate(brickletPort);
}

public BrickMaster.SPITFPErrorCount getSPITFPErrorCount(char brickletPort) throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount(brickletPort);
}

public void enableStatusLED() throws TinkerforgeException {
    this.dev.enableStatusLED();
}

public void disableStatusLED() throws TinkerforgeException {
    this.dev.disableStatusLED();
}

public boolean isStatusLEDEnabled() throws TinkerforgeException {
    return this.dev.isStatusLEDEnabled();
}

public BrickMaster.Protocol1BrickletName getProtocol1BrickletName(char port) throws TinkerforgeException {
    return this.dev.getProtocol1BrickletName(port);
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeBrickletPlugin(char port, int offset, int[] chunk) throws TinkerforgeException {
    this.dev.writeBrickletPlugin(port, offset, chunk);
}

public int[] readBrickletPlugin(char port, int offset) throws TinkerforgeException {
    return this.dev.readBrickletPlugin(port, offset);
}

public BrickMaster.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addStackCurrentListener(BrickMaster.StackCurrentListener l) {
    this.dev.addStackCurrentListener(l);
}

public void removeStackCurrentListener(BrickMaster.StackCurrentListener l) {
    this.dev.removeStackCurrentListener(l);
}

public void addStackVoltageListener(BrickMaster.StackVoltageListener l) {
    this.dev.addStackVoltageListener(l);
}

public void removeStackVoltageListener(BrickMaster.StackVoltageListener l) {
    this.dev.removeStackVoltageListener(l);
}

public void addUSBVoltageListener(BrickMaster.USBVoltageListener l) {
    this.dev.addUSBVoltageListener(l);
}

public void removeUSBVoltageListener(BrickMaster.USBVoltageListener l) {
    this.dev.removeUSBVoltageListener(l);
}

public void addStackCurrentReachedListener(BrickMaster.StackCurrentReachedListener l) {
    this.dev.addStackCurrentReachedListener(l);
}

public void removeStackCurrentReachedListener(BrickMaster.StackCurrentReachedListener l) {
    this.dev.removeStackCurrentReachedListener(l);
}

public void addStackVoltageReachedListener(BrickMaster.StackVoltageReachedListener l) {
    this.dev.addStackVoltageReachedListener(l);
}

public void removeStackVoltageReachedListener(BrickMaster.StackVoltageReachedListener l) {
    this.dev.removeStackVoltageReachedListener(l);
}

public void addUSBVoltageReachedListener(BrickMaster.USBVoltageReachedListener l) {
    this.dev.addUSBVoltageReachedListener(l);
}

public void removeUSBVoltageReachedListener(BrickMaster.USBVoltageReachedListener l) {
    this.dev.removeUSBVoltageReachedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickMasterWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickMasterWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickMasterConfig cfg = (BrickMasterConfig) config.as(BrickMasterConfig.class);
        this.addStackVoltageListener(this.reg((voltage) -> {if(true) {updateStateFn.accept("BrickMasterStackVoltage", transformBrickMasterStackVoltageCallback0(voltage, cfg));}}, this.dev::removeStackVoltageListener));
		this.addStackCurrentListener(this.reg((current) -> {if(true) {updateStateFn.accept("BrickMasterStackCurrent", transformBrickMasterStackCurrentCallback0(current, cfg));}}, this.dev::removeStackCurrentListener));
        
		if(cfg.statusLEDConfig) {
		                this.enableStatusLED();
		            } else {
		                this.disableStatusLED();
		            }
		this.setSPITFPBaudrateConfig(cfg.spitfpEnableDynamicBaudrate, cfg.spitfpMinimumDynamicBaudrate);
		this.setSPITFPBaudrate('a', cfg.spitfpBaudratePortA);
		            this.setSPITFPBaudrate('b', cfg.spitfpBaudratePortB);
		            this.setSPITFPBaudrate('c', cfg.spitfpBaudratePortC);
		            this.setSPITFPBaudrate('d', cfg.spitfpBaudratePortD);
		{
		BrickMasterStackVoltageConfig channelCfg = getChannelConfigFn.apply("BrickMasterStackVoltage").as(BrickMasterStackVoltageConfig.class);
		this.setStackVoltageCallbackPeriod(channelCfg.updateInterval);
		this.setStackVoltageCallbackThreshold('x', 0, 0);
		}
		{
		BrickMasterStackCurrentConfig channelCfg = getChannelConfigFn.apply("BrickMasterStackCurrent").as(BrickMasterStackCurrentConfig.class);
		this.setStackCurrentCallbackPeriod(channelCfg.updateInterval);
		this.setStackCurrentCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickMasterConfig cfg = (BrickMasterConfig) config.as(BrickMasterConfig.class);
        this.setStackVoltageCallbackPeriod(0);
		this.setStackCurrentCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickMasterConfig cfg = (BrickMasterConfig) config.as(BrickMasterConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickMasterStackVoltage");
		result.add("BrickMasterStackCurrent");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickMasterStackVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickMasterStackVoltage"), "Stack Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickMasterStackVoltage")).withDescription("The stack voltage in V. The stack voltage is the voltage that is supplied via the stack, i.e. it is given by a Step-Down or Step-Up Power Supply.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickMasterStackCurrent":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickMasterStackCurrent"), "Stack Current", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickMasterStackCurrent")).withDescription("The stack current in A. The stack current is the current that is drawn via the stack, i.e. it is given by a Step-Down or Step-Up Power Supply.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Master Brick").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Basis to build stacks and has 4 Bricklet ports").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickMasterStackVoltage", new ChannelTypeUID("tinkerforge", "BrickMasterStackVoltage")).withLabel("Stack Voltage").build(), new ChannelDefinitionBuilder("BrickMasterStackCurrent", new ChannelTypeUID("tinkerforge", "BrickMasterStackCurrent")).withLabel("Stack Current").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickmaster":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.BOOLEAN).withDefault("true").withDescription("The status LED is the blue LED next to the USB connector. If enabled is is on and it flickers if data is transfered. If disabled it is always off.").withLabel("Status LED Config").build(), ConfigDescriptionParameterBuilder.create("spitfpEnableDynamicBaudrate", Type.BOOLEAN).withDefault("true").withDescription("The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is enabled, the Brick will try to adapt the baudrate for the communication between Bricks and Bricklets according to the amount of data that is transferred.<br/><br/>The baudrate will be increased exponentially if lots of data is sent/received and decreased linearly if little data is sent/received.<br/><br/>This lowers the baudrate in applications where little data is transferred (e.g. a weather station) and increases the robustness. If there is lots of data to transfer (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.<br/><br/>In cases where some data has to transferred as fast as possible every few seconds (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn the dynamic baudrate off to get the highest possible performance.<br/><br/>The maximum value of the baudrate can be set per port. If the dynamic baudrate is disabled, the maximum baudrate will be used statically.").withLabel("SPITFP Enable Dynamic Baudrate").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("spitfpMinimumDynamicBaudrate", Type.INTEGER).withDefault("400000").withDescription("See SPITFP Enable Dynamic Baudrate").withLabel("SPITFP Minimum Dynamic Baudrate").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build(), ConfigDescriptionParameterBuilder.create("spitfpBaudratePortA", Type.INTEGER).withDefault("1400000").withDescription("The baudrate for Bricklet port A.<br/><br/>If you want to increase the throughput of Bricklets you can increase the baudrate. If you get a high error count because of high interference you can decrease the baudrate.<br/><br/>If the dynamic baudrate feature is enabled, this is the maximum baudrate.<br/><br/>Regulatory testing is done with the default baudrate. If CE compatibility or similar is necessary in you applications we recommend to not change the baudrate.").withLabel("(Maximum) SPITFP Baudrate Port A").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build(), ConfigDescriptionParameterBuilder.create("spitfpBaudratePortB", Type.INTEGER).withDefault("1400000").withDescription("The baudrate for Bricklet port B.<br/><br/>If you want to increase the throughput of Bricklets you can increase the baudrate. If you get a high error count because of high interference you can decrease the baudrate.<br/><br/>If the dynamic baudrate feature is enabled, this is the maximum baudrate.<br/><br/>Regulatory testing is done with the default baudrate. If CE compatibility or similar is necessary in you applications we recommend to not change the baudrate.").withLabel("(Maximum) SPITFP Baudrate Port B").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build(), ConfigDescriptionParameterBuilder.create("spitfpBaudratePortC", Type.INTEGER).withDefault("1400000").withDescription("The baudrate for Bricklet port C.<br/><br/>If you want to increase the throughput of Bricklets you can increase the baudrate. If you get a high error count because of high interference you can decrease the baudrate.<br/><br/>If the dynamic baudrate feature is enabled, this is the maximum baudrate.<br/><br/>Regulatory testing is done with the default baudrate. If CE compatibility or similar is necessary in you applications we recommend to not change the baudrate.").withLabel("(Maximum) SPITFP Baudrate Port C").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build(), ConfigDescriptionParameterBuilder.create("spitfpBaudratePortD", Type.INTEGER).withDefault("1400000").withDescription("The baudrate for Bricklet port D.<br/><br/>If you want to increase the throughput of Bricklets you can increase the baudrate. If you get a high error count because of high interference you can decrease the baudrate.<br/><br/>If the dynamic baudrate feature is enabled, this is the maximum baudrate.<br/><br/>Regulatory testing is done with the default baudrate. If CE compatibility or similar is necessary in you applications we recommend to not change the baudrate.").withLabel("(Maximum) SPITFP Baudrate Port D").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickMasterStackVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickMasterStackCurrent":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickMasterConfig cfg = (BrickMasterConfig) config.as(BrickMasterConfig.class);
        switch(channel) {
            case "BrickMasterStackVoltage": {
                   BrickMasterStackVoltageConfig channelCfg = channelConfig.as(BrickMasterStackVoltageConfig.class);
                   {
            int value = this.getStackVoltage();
            if(true)
                updateStateFn.accept(channel, transformBrickMasterStackVoltageGetter0(value, cfg));
        }
                   return;
               }
            case "BrickMasterStackCurrent": {
                   BrickMasterStackCurrentConfig channelCfg = channelConfig.as(BrickMasterStackCurrentConfig.class);
                   {
            int value = this.getStackCurrent();
            if(true)
                updateStateFn.accept(channel, transformBrickMasterStackCurrentGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickMasterConfig cfg = (BrickMasterConfig) config.as(BrickMasterConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickMasterStackVoltageCallback0(int voltage, BrickMasterConfig cfg) {
        return new QuantityType<>(voltage / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickMasterStackCurrentCallback0(int current, BrickMasterConfig cfg) {
        return new QuantityType<>(current / 1000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickMasterStackVoltageGetter0(int value, BrickMasterConfig cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickMasterStackCurrentGetter0(int value, BrickMasterConfig cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.AMPERE);
    }

}