/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickRED;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickREDWrapper extends DeviceWrapper implements StandardFlashable{
    BrickRED dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickRED.DEVICE_DISPLAY_NAME, "brickred", BrickRED.DEVICE_IDENTIFIER, BrickREDWrapper.class, BrickREDActions.class, "2.0.0", false);

    public BrickREDWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickRED(uid, ipcon);
    }

    
	public final static int ERROR_CODE_SUCCESS = 0;
	public final static int ERROR_CODE_UNKNOWN_ERROR = 1;
	public final static int ERROR_CODE_INVALID_OPERATION = 2;
	public final static int ERROR_CODE_OPERATION_ABORTED = 3;
	public final static int ERROR_CODE_INTERNAL_ERROR = 4;
	public final static int ERROR_CODE_UNKNOWN_SESSION_ID = 5;
	public final static int ERROR_CODE_NO_FREE_SESSION_ID = 6;
	public final static int ERROR_CODE_UNKNOWN_OBJECT_ID = 7;
	public final static int ERROR_CODE_NO_FREE_OBJECT_ID = 8;
	public final static int ERROR_CODE_OBJECT_IS_LOCKED = 9;
	public final static int ERROR_CODE_NO_MORE_DATA = 10;
	public final static int ERROR_CODE_WRONG_LIST_ITEM_TYPE = 11;
	public final static int ERROR_CODE_PROGRAM_IS_PURGED = 12;
	public final static int ERROR_CODE_INVALID_PARAMETER = 128;
	public final static int ERROR_CODE_NO_FREE_MEMORY = 129;
	public final static int ERROR_CODE_NO_FREE_SPACE = 130;
	public final static int ERROR_CODE_ACCESS_DENIED = 121;
	public final static int ERROR_CODE_ALREADY_EXISTS = 132;
	public final static int ERROR_CODE_DOES_NOT_EXIST = 133;
	public final static int ERROR_CODE_INTERRUPTED = 134;
	public final static int ERROR_CODE_IS_DIRECTORY = 135;
	public final static int ERROR_CODE_NOT_A_DIRECTORY = 136;
	public final static int ERROR_CODE_WOULD_BLOCK = 137;
	public final static int ERROR_CODE_OVERFLOW = 138;
	public final static int ERROR_CODE_BAD_FILE_DESCRIPTOR = 139;
	public final static int ERROR_CODE_OUT_OF_RANGE = 140;
	public final static int ERROR_CODE_NAME_TOO_LONG = 141;
	public final static int ERROR_CODE_INVALID_SEEK = 142;
	public final static int ERROR_CODE_NOT_SUPPORTED = 143;
	public final static int ERROR_CODE_TOO_MANY_OPEN_FILES = 144;
	public final static int OBJECT_TYPE_STRING = 0;
	public final static int OBJECT_TYPE_LIST = 1;
	public final static int OBJECT_TYPE_FILE = 2;
	public final static int OBJECT_TYPE_DIRECTORY = 3;
	public final static int OBJECT_TYPE_PROCESS = 4;
	public final static int OBJECT_TYPE_PROGRAM = 5;
	public final static long FILE_FLAG_READ_ONLY = 1L;
	public final static long FILE_FLAG_WRITE_ONLY = 2L;
	public final static long FILE_FLAG_READ_WRITE = 4L;
	public final static long FILE_FLAG_APPEND = 8L;
	public final static long FILE_FLAG_CREATE = 16L;
	public final static long FILE_FLAG_EXCLUSIVE = 32L;
	public final static long FILE_FLAG_NON_BLOCKING = 64L;
	public final static long FILE_FLAG_TRUNCATE = 128L;
	public final static long FILE_FLAG_TEMPORARY = 256L;
	public final static long FILE_FLAG_REPLACE = 512L;
	public final static int FILE_PERMISSION_USER_ALL = 448;
	public final static int FILE_PERMISSION_USER_READ = 256;
	public final static int FILE_PERMISSION_USER_WRITE = 128;
	public final static int FILE_PERMISSION_USER_EXECUTE = 64;
	public final static int FILE_PERMISSION_GROUP_ALL = 56;
	public final static int FILE_PERMISSION_GROUP_READ = 32;
	public final static int FILE_PERMISSION_GROUP_WRITE = 16;
	public final static int FILE_PERMISSION_GROUP_EXECUTE = 8;
	public final static int FILE_PERMISSION_OTHERS_ALL = 7;
	public final static int FILE_PERMISSION_OTHERS_READ = 4;
	public final static int FILE_PERMISSION_OTHERS_WRITE = 2;
	public final static int FILE_PERMISSION_OTHERS_EXECUTE = 1;
	public final static long PIPE_FLAG_NON_BLOCKING_READ = 1L;
	public final static long PIPE_FLAG_NON_BLOCKING_WRITE = 2L;
	public final static int FILE_TYPE_UNKNOWN = 0;
	public final static int FILE_TYPE_REGULAR = 1;
	public final static int FILE_TYPE_DIRECTORY = 2;
	public final static int FILE_TYPE_CHARACTER = 3;
	public final static int FILE_TYPE_BLOCK = 4;
	public final static int FILE_TYPE_FIFO = 5;
	public final static int FILE_TYPE_SYMLINK = 6;
	public final static int FILE_TYPE_SOCKET = 7;
	public final static int FILE_TYPE_PIPE = 8;
	public final static int FILE_ORIGIN_BEGINNING = 0;
	public final static int FILE_ORIGIN_CURRENT = 1;
	public final static int FILE_ORIGIN_END = 2;
	public final static int FILE_EVENT_READABLE = 1;
	public final static int FILE_EVENT_WRITABLE = 2;
	public final static int DIRECTORY_ENTRY_TYPE_UNKNOWN = 0;
	public final static int DIRECTORY_ENTRY_TYPE_REGULAR = 1;
	public final static int DIRECTORY_ENTRY_TYPE_DIRECTORY = 2;
	public final static int DIRECTORY_ENTRY_TYPE_CHARACTER = 3;
	public final static int DIRECTORY_ENTRY_TYPE_BLOCK = 4;
	public final static int DIRECTORY_ENTRY_TYPE_FIFO = 5;
	public final static int DIRECTORY_ENTRY_TYPE_SYMLINK = 6;
	public final static int DIRECTORY_ENTRY_TYPE_SOCKET = 7;
	public final static long DIRECTORY_FLAG_RECURSIVE = 1L;
	public final static long DIRECTORY_FLAG_EXCLUSIVE = 2L;
	public final static int PROCESS_SIGNAL_INTERRUPT = 2;
	public final static int PROCESS_SIGNAL_QUIT = 3;
	public final static int PROCESS_SIGNAL_ABORT = 6;
	public final static int PROCESS_SIGNAL_KILL = 9;
	public final static int PROCESS_SIGNAL_USER1 = 10;
	public final static int PROCESS_SIGNAL_USER2 = 12;
	public final static int PROCESS_SIGNAL_TERMINATE = 15;
	public final static int PROCESS_SIGNAL_CONTINUE = 18;
	public final static int PROCESS_SIGNAL_STOP = 19;
	public final static int PROCESS_STATE_UNKNOWN = 0;
	public final static int PROCESS_STATE_RUNNING = 1;
	public final static int PROCESS_STATE_ERROR = 2;
	public final static int PROCESS_STATE_EXITED = 3;
	public final static int PROCESS_STATE_KILLED = 4;
	public final static int PROCESS_STATE_STOPPED = 5;
	public final static int PROGRAM_STDIO_REDIRECTION_DEV_NULL = 0;
	public final static int PROGRAM_STDIO_REDIRECTION_PIPE = 1;
	public final static int PROGRAM_STDIO_REDIRECTION_FILE = 2;
	public final static int PROGRAM_STDIO_REDIRECTION_INDIVIDUAL_LOG = 3;
	public final static int PROGRAM_STDIO_REDIRECTION_CONTINUOUS_LOG = 4;
	public final static int PROGRAM_STDIO_REDIRECTION_STDOUT = 5;
	public final static int PROGRAM_START_MODE_NEVER = 0;
	public final static int PROGRAM_START_MODE_ALWAYS = 1;
	public final static int PROGRAM_START_MODE_INTERVAL = 2;
	public final static int PROGRAM_START_MODE_CRON = 3;
	public final static int PROGRAM_SCHEDULER_STATE_STOPPED = 0;
	public final static int PROGRAM_SCHEDULER_STATE_RUNNING = 1;


    public BrickRED.CreateSession createSession(long lifetime) throws TinkerforgeException {
    return this.dev.createSession(lifetime);
}

public int expireSession(int sessionId) throws TinkerforgeException {
    return this.dev.expireSession(sessionId);
}

public void expireSessionUnchecked(int sessionId) throws TinkerforgeException {
    this.dev.expireSessionUnchecked(sessionId);
}

public int keepSessionAlive(int sessionId, long lifetime) throws TinkerforgeException {
    return this.dev.keepSessionAlive(sessionId, lifetime);
}

public int releaseObject(int objectId, int sessionId) throws TinkerforgeException {
    return this.dev.releaseObject(objectId, sessionId);
}

public void releaseObjectUnchecked(int objectId, int sessionId) throws TinkerforgeException {
    this.dev.releaseObjectUnchecked(objectId, sessionId);
}

public BrickRED.AllocateString allocateString(long lengthToReserve, String buffer, int sessionId) throws TinkerforgeException {
    return this.dev.allocateString(lengthToReserve, buffer, sessionId);
}

public int truncateString(int stringId, long length) throws TinkerforgeException {
    return this.dev.truncateString(stringId, length);
}

public BrickRED.StringLength getStringLength(int stringId) throws TinkerforgeException {
    return this.dev.getStringLength(stringId);
}

public int setStringChunk(int stringId, long offset, String buffer) throws TinkerforgeException {
    return this.dev.setStringChunk(stringId, offset, buffer);
}

public BrickRED.StringChunk getStringChunk(int stringId, long offset) throws TinkerforgeException {
    return this.dev.getStringChunk(stringId, offset);
}

public BrickRED.AllocateList allocateList(int lengthToReserve, int sessionId) throws TinkerforgeException {
    return this.dev.allocateList(lengthToReserve, sessionId);
}

public BrickRED.ListLength getListLength(int listId) throws TinkerforgeException {
    return this.dev.getListLength(listId);
}

public BrickRED.ListItem getListItem(int listId, int index, int sessionId) throws TinkerforgeException {
    return this.dev.getListItem(listId, index, sessionId);
}

public int appendToList(int listId, int itemObjectId) throws TinkerforgeException {
    return this.dev.appendToList(listId, itemObjectId);
}

public int removeFromList(int listId, int index) throws TinkerforgeException {
    return this.dev.removeFromList(listId, index);
}

public BrickRED.OpenFile openFile(int nameStringId, long flags, int permissions, long uid, long gid, int sessionId) throws TinkerforgeException {
    return this.dev.openFile(nameStringId, flags, permissions, uid, gid, sessionId);
}

public BrickRED.CreatePipe createPipe(long flags, long length, int sessionId) throws TinkerforgeException {
    return this.dev.createPipe(flags, length, sessionId);
}

public BrickRED.FileInfo getFileInfo(int fileId, int sessionId) throws TinkerforgeException {
    return this.dev.getFileInfo(fileId, sessionId);
}

public BrickRED.ReadFile readFile(int fileId, int lengthToRead) throws TinkerforgeException {
    return this.dev.readFile(fileId, lengthToRead);
}

public void readFileAsync(int fileId, long lengthToRead) throws TinkerforgeException {
    this.dev.readFileAsync(fileId, lengthToRead);
}

public int abortAsyncFileRead(int fileId) throws TinkerforgeException {
    return this.dev.abortAsyncFileRead(fileId);
}

public BrickRED.WriteFile writeFile(int fileId, int[] buffer, int lengthToWrite) throws TinkerforgeException {
    return this.dev.writeFile(fileId, buffer, lengthToWrite);
}

public void writeFileUnchecked(int fileId, int[] buffer, int lengthToWrite) throws TinkerforgeException {
    this.dev.writeFileUnchecked(fileId, buffer, lengthToWrite);
}

public void writeFileAsync(int fileId, int[] buffer, int lengthToWrite) throws TinkerforgeException {
    this.dev.writeFileAsync(fileId, buffer, lengthToWrite);
}

public BrickRED.SetFilePosition setFilePosition(int fileId, long offset, int origin) throws TinkerforgeException {
    return this.dev.setFilePosition(fileId, offset, origin);
}

public BrickRED.FilePosition getFilePosition(int fileId) throws TinkerforgeException {
    return this.dev.getFilePosition(fileId);
}

public int setFileEvents(int fileId, int events) throws TinkerforgeException {
    return this.dev.setFileEvents(fileId, events);
}

public BrickRED.FileEvents getFileEvents(int fileId) throws TinkerforgeException {
    return this.dev.getFileEvents(fileId);
}

public BrickRED.OpenDirectory openDirectory(int nameStringId, int sessionId) throws TinkerforgeException {
    return this.dev.openDirectory(nameStringId, sessionId);
}

public BrickRED.DirectoryName getDirectoryName(int directoryId, int sessionId) throws TinkerforgeException {
    return this.dev.getDirectoryName(directoryId, sessionId);
}

public BrickRED.NextDirectoryEntry getNextDirectoryEntry(int directoryId, int sessionId) throws TinkerforgeException {
    return this.dev.getNextDirectoryEntry(directoryId, sessionId);
}

public int rewindDirectory(int directoryId) throws TinkerforgeException {
    return this.dev.rewindDirectory(directoryId);
}

public int createDirectory(int nameStringId, long flags, int permissions, long uid, long gid) throws TinkerforgeException {
    return this.dev.createDirectory(nameStringId, flags, permissions, uid, gid);
}

public BrickRED.Processes getProcesses(int sessionId) throws TinkerforgeException {
    return this.dev.getProcesses(sessionId);
}

public BrickRED.SpawnProcess spawnProcess(int executableStringId, int argumentsListId, int environmentListId, int workingDirectoryStringId, long uid, long gid, int stdinFileId, int stdoutFileId, int stderrFileId, int sessionId) throws TinkerforgeException {
    return this.dev.spawnProcess(executableStringId, argumentsListId, environmentListId, workingDirectoryStringId, uid, gid, stdinFileId, stdoutFileId, stderrFileId, sessionId);
}

public int killProcess(int processId, int signal) throws TinkerforgeException {
    return this.dev.killProcess(processId, signal);
}

public BrickRED.ProcessCommand getProcessCommand(int processId, int sessionId) throws TinkerforgeException {
    return this.dev.getProcessCommand(processId, sessionId);
}

public BrickRED.ProcessIdentity getProcessIdentity(int processId) throws TinkerforgeException {
    return this.dev.getProcessIdentity(processId);
}

public BrickRED.ProcessStdio getProcessStdio(int processId, int sessionId) throws TinkerforgeException {
    return this.dev.getProcessStdio(processId, sessionId);
}

public BrickRED.ProcessState getProcessState(int processId) throws TinkerforgeException {
    return this.dev.getProcessState(processId);
}

public BrickRED.Programs getPrograms(int sessionId) throws TinkerforgeException {
    return this.dev.getPrograms(sessionId);
}

public BrickRED.DefineProgram defineProgram(int identifierStringId, int sessionId) throws TinkerforgeException {
    return this.dev.defineProgram(identifierStringId, sessionId);
}

public int purgeProgram(int programId, long cookie) throws TinkerforgeException {
    return this.dev.purgeProgram(programId, cookie);
}

public BrickRED.ProgramIdentifier getProgramIdentifier(int programId, int sessionId) throws TinkerforgeException {
    return this.dev.getProgramIdentifier(programId, sessionId);
}

public BrickRED.ProgramRootDirectory getProgramRootDirectory(int programId, int sessionId) throws TinkerforgeException {
    return this.dev.getProgramRootDirectory(programId, sessionId);
}

public int setProgramCommand(int programId, int executableStringId, int argumentsListId, int environmentListId, int workingDirectoryStringId) throws TinkerforgeException {
    return this.dev.setProgramCommand(programId, executableStringId, argumentsListId, environmentListId, workingDirectoryStringId);
}

public BrickRED.ProgramCommand getProgramCommand(int programId, int sessionId) throws TinkerforgeException {
    return this.dev.getProgramCommand(programId, sessionId);
}

public int setProgramStdioRedirection(int programId, int stdinRedirection, int stdinFileNameStringId, int stdoutRedirection, int stdoutFileNameStringId, int stderrRedirection, int stderrFileNameStringId) throws TinkerforgeException {
    return this.dev.setProgramStdioRedirection(programId, stdinRedirection, stdinFileNameStringId, stdoutRedirection, stdoutFileNameStringId, stderrRedirection, stderrFileNameStringId);
}

public BrickRED.ProgramStdioRedirection getProgramStdioRedirection(int programId, int sessionId) throws TinkerforgeException {
    return this.dev.getProgramStdioRedirection(programId, sessionId);
}

public int setProgramSchedule(int programId, int startMode, boolean continueAfterError, long startInterval, int startFieldsStringId) throws TinkerforgeException {
    return this.dev.setProgramSchedule(programId, startMode, continueAfterError, startInterval, startFieldsStringId);
}

public BrickRED.ProgramSchedule getProgramSchedule(int programId, int sessionId) throws TinkerforgeException {
    return this.dev.getProgramSchedule(programId, sessionId);
}

public BrickRED.ProgramSchedulerState getProgramSchedulerState(int programId, int sessionId) throws TinkerforgeException {
    return this.dev.getProgramSchedulerState(programId, sessionId);
}

public int continueProgramSchedule(int programId) throws TinkerforgeException {
    return this.dev.continueProgramSchedule(programId);
}

public int startProgram(int programId) throws TinkerforgeException {
    return this.dev.startProgram(programId);
}

public BrickRED.LastSpawnedProgramProcess getLastSpawnedProgramProcess(int programId, int sessionId) throws TinkerforgeException {
    return this.dev.getLastSpawnedProgramProcess(programId, sessionId);
}

public BrickRED.CustomProgramOptionNames getCustomProgramOptionNames(int programId, int sessionId) throws TinkerforgeException {
    return this.dev.getCustomProgramOptionNames(programId, sessionId);
}

public int setCustomProgramOptionValue(int programId, int nameStringId, int valueStringId) throws TinkerforgeException {
    return this.dev.setCustomProgramOptionValue(programId, nameStringId, valueStringId);
}

public BrickRED.CustomProgramOptionValue getCustomProgramOptionValue(int programId, int nameStringId, int sessionId) throws TinkerforgeException {
    return this.dev.getCustomProgramOptionValue(programId, nameStringId, sessionId);
}

public int removeCustomProgramOption(int programId, int nameStringId) throws TinkerforgeException {
    return this.dev.removeCustomProgramOption(programId, nameStringId);
}

public BrickRED.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addAsyncFileReadListener(BrickRED.AsyncFileReadListener l) {
    this.dev.addAsyncFileReadListener(l);
}

public void removeAsyncFileReadListener(BrickRED.AsyncFileReadListener l) {
    this.dev.removeAsyncFileReadListener(l);
}

public void addAsyncFileWriteListener(BrickRED.AsyncFileWriteListener l) {
    this.dev.addAsyncFileWriteListener(l);
}

public void removeAsyncFileWriteListener(BrickRED.AsyncFileWriteListener l) {
    this.dev.removeAsyncFileWriteListener(l);
}

public void addFileEventsOccurredListener(BrickRED.FileEventsOccurredListener l) {
    this.dev.addFileEventsOccurredListener(l);
}

public void removeFileEventsOccurredListener(BrickRED.FileEventsOccurredListener l) {
    this.dev.removeFileEventsOccurredListener(l);
}

public void addProcessStateChangedListener(BrickRED.ProcessStateChangedListener l) {
    this.dev.addProcessStateChangedListener(l);
}

public void removeProcessStateChangedListener(BrickRED.ProcessStateChangedListener l) {
    this.dev.removeProcessStateChangedListener(l);
}

public void addProgramSchedulerStateChangedListener(BrickRED.ProgramSchedulerStateChangedListener l) {
    this.dev.addProgramSchedulerStateChangedListener(l);
}

public void removeProgramSchedulerStateChangedListener(BrickRED.ProgramSchedulerStateChangedListener l) {
    this.dev.removeProgramSchedulerStateChangedListener(l);
}

public void addProgramProcessSpawnedListener(BrickRED.ProgramProcessSpawnedListener l) {
    this.dev.addProgramProcessSpawnedListener(l);
}

public void removeProgramProcessSpawnedListener(BrickRED.ProgramProcessSpawnedListener l) {
    this.dev.removeProgramProcessSpawnedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickREDWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickREDWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickREDConfig cfg = (BrickREDConfig) config.as(BrickREDConfig.class);
        
        
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickREDConfig cfg = (BrickREDConfig) config.as(BrickREDConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickREDConfig cfg = (BrickREDConfig) config.as(BrickREDConfig.class);
        List<String> result = new ArrayList<String>();
        
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge RED Brick").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Executes user programs and controls other Bricks/Bricklets standalone").withChannelDefinitions(Arrays.asList()).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickred":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickREDConfig cfg = (BrickREDConfig) config.as(BrickREDConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickREDConfig cfg = (BrickREDConfig) config.as(BrickREDConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    

}