/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.DecimalType;

import com.tinkerforge.BrickStepper;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickStepperWrapper extends DeviceWrapper implements StandardFlashHost{
    BrickStepper dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickStepper.DEVICE_DISPLAY_NAME, "brickstepper", BrickStepper.DEVICE_IDENTIFIER, BrickStepperWrapper.class, BrickStepperActions.class, "2.3.6", false);

    public BrickStepperWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickStepper(uid, ipcon);
    }

    
	public final static int STEP_MODE_FULL_STEP = 1;
	public final static int STEP_MODE_HALF_STEP = 2;
	public final static int STEP_MODE_QUARTER_STEP = 4;
	public final static int STEP_MODE_EIGHTH_STEP = 8;
	public final static int STATE_STOP = 1;
	public final static int STATE_ACCELERATION = 2;
	public final static int STATE_RUN = 3;
	public final static int STATE_DEACCELERATION = 4;
	public final static int STATE_DIRECTION_CHANGE_TO_FORWARD = 5;
	public final static int STATE_DIRECTION_CHANGE_TO_BACKWARD = 6;
	public final static int COMMUNICATION_METHOD_NONE = 0;
	public final static int COMMUNICATION_METHOD_USB = 1;
	public final static int COMMUNICATION_METHOD_SPI_STACK = 2;
	public final static int COMMUNICATION_METHOD_CHIBI = 3;
	public final static int COMMUNICATION_METHOD_RS485 = 4;
	public final static int COMMUNICATION_METHOD_WIFI = 5;
	public final static int COMMUNICATION_METHOD_ETHERNET = 6;
	public final static int COMMUNICATION_METHOD_WIFI_V2 = 7;


    public void setMaxVelocity(int velocity) throws TinkerforgeException {
    this.dev.setMaxVelocity(velocity);
}

public int getMaxVelocity() throws TinkerforgeException {
    return this.dev.getMaxVelocity();
}

public int getCurrentVelocity() throws TinkerforgeException {
    return this.dev.getCurrentVelocity();
}

public void setSpeedRamping(int acceleration, int deacceleration) throws TinkerforgeException {
    this.dev.setSpeedRamping(acceleration, deacceleration);
}

public BrickStepper.SpeedRamping getSpeedRamping() throws TinkerforgeException {
    return this.dev.getSpeedRamping();
}

public void fullBrake() throws TinkerforgeException {
    this.dev.fullBrake();
}

public void setCurrentPosition(int position) throws TinkerforgeException {
    this.dev.setCurrentPosition(position);
}

public int getCurrentPosition() throws TinkerforgeException {
    return this.dev.getCurrentPosition();
}

public void setTargetPosition(int position) throws TinkerforgeException {
    this.dev.setTargetPosition(position);
}

public int getTargetPosition() throws TinkerforgeException {
    return this.dev.getTargetPosition();
}

public void setSteps(int steps) throws TinkerforgeException {
    this.dev.setSteps(steps);
}

public int getSteps() throws TinkerforgeException {
    return this.dev.getSteps();
}

public int getRemainingSteps() throws TinkerforgeException {
    return this.dev.getRemainingSteps();
}

public void setStepMode(int mode) throws TinkerforgeException {
    this.dev.setStepMode(mode);
}

public int getStepMode() throws TinkerforgeException {
    return this.dev.getStepMode();
}

public void driveForward() throws TinkerforgeException {
    this.dev.driveForward();
}

public void driveBackward() throws TinkerforgeException {
    this.dev.driveBackward();
}

public void stop() throws TinkerforgeException {
    this.dev.stop();
}

public int getStackInputVoltage() throws TinkerforgeException {
    return this.dev.getStackInputVoltage();
}

public int getExternalInputVoltage() throws TinkerforgeException {
    return this.dev.getExternalInputVoltage();
}

public int getCurrentConsumption() throws TinkerforgeException {
    return this.dev.getCurrentConsumption();
}

public void setMotorCurrent(int current) throws TinkerforgeException {
    this.dev.setMotorCurrent(current);
}

public int getMotorCurrent() throws TinkerforgeException {
    return this.dev.getMotorCurrent();
}

public void enable() throws TinkerforgeException {
    this.dev.enable();
}

public void disable() throws TinkerforgeException {
    this.dev.disable();
}

public boolean isEnabled() throws TinkerforgeException {
    return this.dev.isEnabled();
}

public void setDecay(int decay) throws TinkerforgeException {
    this.dev.setDecay(decay);
}

public int getDecay() throws TinkerforgeException {
    return this.dev.getDecay();
}

public void setMinimumVoltage(int voltage) throws TinkerforgeException {
    this.dev.setMinimumVoltage(voltage);
}

public int getMinimumVoltage() throws TinkerforgeException {
    return this.dev.getMinimumVoltage();
}

public void setSyncRect(boolean syncRect) throws TinkerforgeException {
    this.dev.setSyncRect(syncRect);
}

public boolean isSyncRect() throws TinkerforgeException {
    return this.dev.isSyncRect();
}

public void setTimeBase(long timeBase) throws TinkerforgeException {
    this.dev.setTimeBase(timeBase);
}

public long getTimeBase() throws TinkerforgeException {
    return this.dev.getTimeBase();
}

public BrickStepper.AllData getAllData() throws TinkerforgeException {
    return this.dev.getAllData();
}

public void setAllDataPeriod(long period) throws TinkerforgeException {
    this.dev.setAllDataPeriod(period);
}

public long getAllDataPeriod() throws TinkerforgeException {
    return this.dev.getAllDataPeriod();
}

public void setSPITFPBaudrateConfig(boolean enableDynamicBaudrate, long minimumDynamicBaudrate) throws TinkerforgeException {
    this.dev.setSPITFPBaudrateConfig(enableDynamicBaudrate, minimumDynamicBaudrate);
}

public BrickStepper.SPITFPBaudrateConfig getSPITFPBaudrateConfig() throws TinkerforgeException {
    return this.dev.getSPITFPBaudrateConfig();
}

public long getSendTimeoutCount(int communicationMethod) throws TinkerforgeException {
    return this.dev.getSendTimeoutCount(communicationMethod);
}

public void setSPITFPBaudrate(char brickletPort, long baudrate) throws TinkerforgeException {
    this.dev.setSPITFPBaudrate(brickletPort, baudrate);
}

public long getSPITFPBaudrate(char brickletPort) throws TinkerforgeException {
    return this.dev.getSPITFPBaudrate(brickletPort);
}

public BrickStepper.SPITFPErrorCount getSPITFPErrorCount(char brickletPort) throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount(brickletPort);
}

public void enableStatusLED() throws TinkerforgeException {
    this.dev.enableStatusLED();
}

public void disableStatusLED() throws TinkerforgeException {
    this.dev.disableStatusLED();
}

public boolean isStatusLEDEnabled() throws TinkerforgeException {
    return this.dev.isStatusLEDEnabled();
}

public BrickStepper.Protocol1BrickletName getProtocol1BrickletName(char port) throws TinkerforgeException {
    return this.dev.getProtocol1BrickletName(port);
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeBrickletPlugin(char port, int offset, int[] chunk) throws TinkerforgeException {
    this.dev.writeBrickletPlugin(port, offset, chunk);
}

public int[] readBrickletPlugin(char port, int offset) throws TinkerforgeException {
    return this.dev.readBrickletPlugin(port, offset);
}

public BrickStepper.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addUnderVoltageListener(BrickStepper.UnderVoltageListener l) {
    this.dev.addUnderVoltageListener(l);
}

public void removeUnderVoltageListener(BrickStepper.UnderVoltageListener l) {
    this.dev.removeUnderVoltageListener(l);
}

public void addPositionReachedListener(BrickStepper.PositionReachedListener l) {
    this.dev.addPositionReachedListener(l);
}

public void removePositionReachedListener(BrickStepper.PositionReachedListener l) {
    this.dev.removePositionReachedListener(l);
}

public void addAllDataListener(BrickStepper.AllDataListener l) {
    this.dev.addAllDataListener(l);
}

public void removeAllDataListener(BrickStepper.AllDataListener l) {
    this.dev.removeAllDataListener(l);
}

public void addNewStateListener(BrickStepper.NewStateListener l) {
    this.dev.addNewStateListener(l);
}

public void removeNewStateListener(BrickStepper.NewStateListener l) {
    this.dev.removeNewStateListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickStepperWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickStepperWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickStepperConfig cfg = (BrickStepperConfig) config.as(BrickStepperConfig.class);
        this.addAllDataListener(this.reg((currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption) -> {if(true) {updateStateFn.accept("BrickStepperVelocity", transformBrickStepperVelocityCallback0(currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption, cfg));}}, this.dev::removeAllDataListener));
		this.addAllDataListener(this.reg((currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption) -> {if(true) {updateStateFn.accept("BrickStepperPosition", transformBrickStepperPositionCallback0(currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption, cfg));}}, this.dev::removeAllDataListener));
		this.addAllDataListener(this.reg((currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption) -> {if(true) {updateStateFn.accept("BrickStepperRemainingSteps", transformBrickStepperRemainingStepsCallback0(currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption, cfg));}}, this.dev::removeAllDataListener));
		this.addAllDataListener(this.reg((currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption) -> {if(true) {updateStateFn.accept("BrickStepperStackVoltage", transformBrickStepperStackVoltageCallback0(currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption, cfg));}}, this.dev::removeAllDataListener));
		this.addAllDataListener(this.reg((currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption) -> {if(true) {updateStateFn.accept("BrickStepperExternalVoltage", transformBrickStepperExternalVoltageCallback0(currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption, cfg));}}, this.dev::removeAllDataListener));
		this.addAllDataListener(this.reg((currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption) -> {if(true) {updateStateFn.accept("BrickStepperCurrentConsumption", transformBrickStepperCurrentConsumptionCallback0(currentVelocity, currentPosition, remainingSteps, stackVoltage, externalVoltage, currentConsumption, cfg));}}, this.dev::removeAllDataListener));
		this.addNewStateListener(this.reg((stateNew, statePrevious) -> {if(true) {updateStateFn.accept("BrickStepperState", transformBrickStepperStateCallback0(stateNew, statePrevious, cfg));}}, this.dev::removeNewStateListener));
		this.addNewStateListener(this.reg((stateNew, statePrevious) -> {if(true) {updateStateFn.accept("BrickStepperPreviousState", transformBrickStepperPreviousStateCallback0(stateNew, statePrevious, cfg));}}, this.dev::removeNewStateListener));
		this.addPositionReachedListener(this.reg((position) -> {if(true) {triggerChannelFn.accept("BrickStepperPositionReached", transformBrickStepperPositionReachedCallback0(position, cfg));}}, this.dev::removePositionReachedListener));
		this.addUnderVoltageListener(this.reg((voltage) -> {if(true) {triggerChannelFn.accept("BrickStepperUnterVoltage", transformBrickStepperUnterVoltageCallback0(voltage, cfg));}}, this.dev::removeUnderVoltageListener));
        this.setAllDataPeriod(cfg.allDataUpdateInterval);
		    this.setMinimumVoltage((int)(cfg.minimumVoltage.doubleValue() * 1000.0));
		if(cfg.statusLEDConfig) {
		                this.enableStatusLED();
		            } else {
		                this.disableStatusLED();
		            }
		this.setSPITFPBaudrateConfig(cfg.spitfpEnableDynamicBaudrate, cfg.spitfpMinimumDynamicBaudrate);
		this.setSPITFPBaudrate('a', cfg.spitfpBaudratePortA);
		            this.setSPITFPBaudrate('b', cfg.spitfpBaudratePortB);
		{
		BrickStepperVelocityConfig channelCfg = getChannelConfigFn.apply("BrickStepperVelocity").as(BrickStepperVelocityConfig.class);
		
		}
		{
		BrickStepperPositionConfig channelCfg = getChannelConfigFn.apply("BrickStepperPosition").as(BrickStepperPositionConfig.class);
		
		}
		{
		BrickStepperRemainingStepsConfig channelCfg = getChannelConfigFn.apply("BrickStepperRemainingSteps").as(BrickStepperRemainingStepsConfig.class);
		
		}
		{
		BrickStepperStackVoltageConfig channelCfg = getChannelConfigFn.apply("BrickStepperStackVoltage").as(BrickStepperStackVoltageConfig.class);
		
		}
		{
		BrickStepperExternalVoltageConfig channelCfg = getChannelConfigFn.apply("BrickStepperExternalVoltage").as(BrickStepperExternalVoltageConfig.class);
		
		}
		{
		BrickStepperCurrentConsumptionConfig channelCfg = getChannelConfigFn.apply("BrickStepperCurrentConsumption").as(BrickStepperCurrentConsumptionConfig.class);
		
		}
		{
		BrickStepperStateConfig channelCfg = getChannelConfigFn.apply("BrickStepperState").as(BrickStepperStateConfig.class);
		
		}
		{
		BrickStepperStateConfig channelCfg = getChannelConfigFn.apply("BrickStepperPreviousState").as(BrickStepperStateConfig.class);
		
		}
		{
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickStepperConfig cfg = (BrickStepperConfig) config.as(BrickStepperConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickStepperConfig cfg = (BrickStepperConfig) config.as(BrickStepperConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickStepperVelocity");
		result.add("BrickStepperPosition");
		result.add("BrickStepperRemainingSteps");
		result.add("BrickStepperStackVoltage");
		result.add("BrickStepperExternalVoltage");
		result.add("BrickStepperCurrentConsumption");
		result.add("BrickStepperState");
		result.add("BrickStepperPreviousState");
		result.add("BrickStepperPositionReached");
		result.add("BrickStepperUnterVoltage");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickStepperVelocity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickStepperVelocity"), "Velocity", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickStepperVelocity")).withDescription("The current velocity of the stepper motor in steps per second.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickStepperPosition":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickStepperPosition"), "Position", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickStepperPosition")).withDescription("The current position of the stepper motor in steps. On startup the position is 0.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickStepperRemainingSteps":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickStepperRemainingSteps"), "Remaining Steps", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickStepperRemainingSteps")).withDescription("The remaining steps of the last call of the setSteps() action.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickStepperStackVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickStepperStackVoltage"), "Stack Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickStepperStackVoltage")).withDescription("The stack input voltage in V. The stack input voltage is the voltage that is supplied via the stack, i.e. it is given by a Step-Down or Step-Up Power Supply.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickStepperExternalVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickStepperExternalVoltage"), "External Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickStepperExternalVoltage")).withDescription("The external input voltage in mV. The external input voltage is given via the black power input connector on the Stepper Brick.<br/><br/>If there is an external input voltage and a stack input voltage, the motor will be driven by the external input voltage. If there is only a stack voltage present, the motor will be driven by this voltage.<br/><br/><b>Warning: This means, if you have a high stack voltage and a low external voltage, the motor will be driven with the low external voltage. If you then remove the external connection, it will immediately be driven by the high stack voltage</b>")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickStepperCurrentConsumption":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickStepperCurrentConsumption"), "Current Consumption", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickStepperCurrentConsumption")).withDescription("The current consumption of the motor in A.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickStepperState":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickStepperState"), "State", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickStepperState")).withDescription("State of the brick: <ul><li>Stop = 1</li><li>Acceleration = 2</li><li>Run = 3</li><li>Deacceleration = 4</li><li>Direction change to forward = 5</li><li>Direction change to backward = 6</li></ul>")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Stepper Brick").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Drives one bipolar stepper motor with up to 38V and 2.5A per phase").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickStepperVelocity", new ChannelTypeUID("tinkerforge", "BrickStepperVelocity")).withLabel("Velocity").build(), new ChannelDefinitionBuilder("BrickStepperPosition", new ChannelTypeUID("tinkerforge", "BrickStepperPosition")).withLabel("Position").build(), new ChannelDefinitionBuilder("BrickStepperRemainingSteps", new ChannelTypeUID("tinkerforge", "BrickStepperRemainingSteps")).withLabel("Remaining Steps").build(), new ChannelDefinitionBuilder("BrickStepperStackVoltage", new ChannelTypeUID("tinkerforge", "BrickStepperStackVoltage")).withLabel("Stack Voltage").build(), new ChannelDefinitionBuilder("BrickStepperExternalVoltage", new ChannelTypeUID("tinkerforge", "BrickStepperExternalVoltage")).withLabel("External Voltage").build(), new ChannelDefinitionBuilder("BrickStepperCurrentConsumption", new ChannelTypeUID("tinkerforge", "BrickStepperCurrentConsumption")).withLabel("Current Consumption").build(), new ChannelDefinitionBuilder("BrickStepperState", new ChannelTypeUID("tinkerforge", "BrickStepperState")).withLabel("State").build(), new ChannelDefinitionBuilder("BrickStepperPreviousState", new ChannelTypeUID("tinkerforge", "BrickStepperState")).withLabel("Previous State").build(), new ChannelDefinitionBuilder("BrickStepperPositionReached", new ChannelTypeUID("system", "trigger")).withLabel("Position Reached").build(), new ChannelDefinitionBuilder("BrickStepperUnterVoltage", new ChannelTypeUID("system", "trigger")).withLabel("Unter Voltage").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickstepper":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("allDataUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for all data in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("All Data Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("minimumVoltage", Type.DECIMAL).withDefault("8").withDescription("The minimum voltage in V, below which the Unter Voltage channel is triggered. The minimum possible value that works with the Stepper Brick is 8V. You can use this function to detect the discharge of a battery that is used to drive the stepper motor. If you have a fixed power supply, you likely do not need this functionality. The default value is 8V.").withLabel("Minimum Voltage").withUnit("V").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.BOOLEAN).withDefault("true").withDescription("The status LED is the blue LED next to the USB connector. If enabled is is on and it flickers if data is transfered. If disabled it is always off.").withLabel("Status LED Config").build(), ConfigDescriptionParameterBuilder.create("spitfpEnableDynamicBaudrate", Type.BOOLEAN).withDefault("true").withDescription("The SPITF protocol can be used with a dynamic baudrate. If the dynamic baudrate is enabled, the Brick will try to adapt the baudrate for the communication between Bricks and Bricklets according to the amount of data that is transferred.<br/><br/>The baudrate will be increased exponentially if lots of data is sent/received and decreased linearly if little data is sent/received.<br/><br/>This lowers the baudrate in applications where little data is transferred (e.g. a weather station) and increases the robustness. If there is lots of data to transfer (e.g. Thermal Imaging Bricklet) it automatically increases the baudrate as needed.<br/><br/>In cases where some data has to transferred as fast as possible every few seconds (e.g. RS485 Bricklet with a high baudrate but small payload) you may want to turn the dynamic baudrate off to get the highest possible performance.<br/><br/>The maximum value of the baudrate can be set per port. If the dynamic baudrate is disabled, the maximum baudrate will be used statically.").withLabel("SPITFP Enable Dynamic Baudrate").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("spitfpMinimumDynamicBaudrate", Type.INTEGER).withDefault("400000").withDescription("See SPITFP Enable Dynamic Baudrate").withLabel("SPITFP Minimum Dynamic Baudrate").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build(), ConfigDescriptionParameterBuilder.create("spitfpBaudratePortA", Type.INTEGER).withDefault("1400000").withDescription("The baudrate for Bricklet port A.<br/><br/>If you want to increase the throughput of Bricklets you can increase the baudrate. If you get a high error count because of high interference you can decrease the baudrate.<br/><br/>If the dynamic baudrate feature is enabled, this is the maximum baudrate.<br/><br/>Regulatory testing is done with the default baudrate. If CE compatibility or similar is necessary in you applications we recommend to not change the baudrate.").withLabel("(Maximum) SPITFP Baudrate Port A").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build(), ConfigDescriptionParameterBuilder.create("spitfpBaudratePortB", Type.INTEGER).withDefault("1400000").withDescription("The baudrate for Bricklet port B.<br/><br/>If you want to increase the throughput of Bricklets you can increase the baudrate. If you get a high error count because of high interference you can decrease the baudrate.<br/><br/>If the dynamic baudrate feature is enabled, this is the maximum baudrate.<br/><br/>Regulatory testing is done with the default baudrate. If CE compatibility or similar is necessary in you applications we recommend to not change the baudrate.").withLabel("(Maximum) SPITFP Baudrate Port B").withAdvanced(true).withMinimum(BigDecimal.valueOf(400000)).withMaximum(BigDecimal.valueOf(2000000)).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickStepperVelocity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickStepperPosition":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickStepperRemainingSteps":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickStepperStackVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickStepperExternalVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickStepperCurrentConsumption":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickStepperState":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickStepperConfig cfg = (BrickStepperConfig) config.as(BrickStepperConfig.class);
        switch(channel) {
            case "BrickStepperVelocity": {
                   BrickStepperVelocityConfig channelCfg = channelConfig.as(BrickStepperVelocityConfig.class);
                   {
            BrickStepper.AllData value = this.getAllData();
            if(true)
                updateStateFn.accept(channel, transformBrickStepperVelocityGetter0(value, cfg));
        }
                   return;
               }
            case "BrickStepperPosition": {
                   BrickStepperPositionConfig channelCfg = channelConfig.as(BrickStepperPositionConfig.class);
                   {
            BrickStepper.AllData value = this.getAllData();
            if(true)
                updateStateFn.accept(channel, transformBrickStepperPositionGetter0(value, cfg));
        }
                   return;
               }
            case "BrickStepperRemainingSteps": {
                   BrickStepperRemainingStepsConfig channelCfg = channelConfig.as(BrickStepperRemainingStepsConfig.class);
                   {
            BrickStepper.AllData value = this.getAllData();
            if(true)
                updateStateFn.accept(channel, transformBrickStepperRemainingStepsGetter0(value, cfg));
        }
                   return;
               }
            case "BrickStepperStackVoltage": {
                   BrickStepperStackVoltageConfig channelCfg = channelConfig.as(BrickStepperStackVoltageConfig.class);
                   {
            BrickStepper.AllData value = this.getAllData();
            if(true)
                updateStateFn.accept(channel, transformBrickStepperStackVoltageGetter0(value, cfg));
        }
                   return;
               }
            case "BrickStepperExternalVoltage": {
                   BrickStepperExternalVoltageConfig channelCfg = channelConfig.as(BrickStepperExternalVoltageConfig.class);
                   {
            BrickStepper.AllData value = this.getAllData();
            if(true)
                updateStateFn.accept(channel, transformBrickStepperExternalVoltageGetter0(value, cfg));
        }
                   return;
               }
            case "BrickStepperCurrentConsumption": {
                   BrickStepperCurrentConsumptionConfig channelCfg = channelConfig.as(BrickStepperCurrentConsumptionConfig.class);
                   {
            BrickStepper.AllData value = this.getAllData();
            if(true)
                updateStateFn.accept(channel, transformBrickStepperCurrentConsumptionGetter0(value, cfg));
        }
                   return;
               }
            case "BrickStepperState":
               return;
            case "BrickStepperPreviousState":
               return;
            case "BrickStepperPositionReached":
               return;
            case "BrickStepperUnterVoltage":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickStepperConfig cfg = (BrickStepperConfig) config.as(BrickStepperConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickStepperVelocityCallback0(int currentVelocity, int currentPosition, int remainingSteps, int stackVoltage, int externalVoltage, int currentConsumption, BrickStepperConfig cfg) {
        return new DecimalType(currentVelocity);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperPositionCallback0(int currentVelocity, int currentPosition, int remainingSteps, int stackVoltage, int externalVoltage, int currentConsumption, BrickStepperConfig cfg) {
        return new DecimalType(currentPosition);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperRemainingStepsCallback0(int currentVelocity, int currentPosition, int remainingSteps, int stackVoltage, int externalVoltage, int currentConsumption, BrickStepperConfig cfg) {
        return new DecimalType(remainingSteps);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperStackVoltageCallback0(int currentVelocity, int currentPosition, int remainingSteps, int stackVoltage, int externalVoltage, int currentConsumption, BrickStepperConfig cfg) {
        return new QuantityType<>(stackVoltage/ 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperExternalVoltageCallback0(int currentVelocity, int currentPosition, int remainingSteps, int stackVoltage, int externalVoltage, int currentConsumption, BrickStepperConfig cfg) {
        return new QuantityType<>(externalVoltage/ 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperCurrentConsumptionCallback0(int currentVelocity, int currentPosition, int remainingSteps, int stackVoltage, int externalVoltage, int currentConsumption, BrickStepperConfig cfg) {
        return new QuantityType<>(currentConsumption/ 1000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperStateCallback0(int stateNew, int statePrevious, BrickStepperConfig cfg) {
        return new DecimalType(stateNew);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperPreviousStateCallback0(int stateNew, int statePrevious, BrickStepperConfig cfg) {
        return new DecimalType(statePrevious);
    }
	    private String transformBrickStepperPositionReachedCallback0(int position, BrickStepperConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickStepperUnterVoltageCallback0(int voltage, BrickStepperConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperVelocityGetter0(BrickStepper.AllData value, BrickStepperConfig cfg) {
        return new DecimalType(value.currentVelocity);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperPositionGetter0(BrickStepper.AllData value, BrickStepperConfig cfg) {
        return new DecimalType(value.currentPosition);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperRemainingStepsGetter0(BrickStepper.AllData value, BrickStepperConfig cfg) {
        return new DecimalType(value.remainingSteps);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperStackVoltageGetter0(BrickStepper.AllData value, BrickStepperConfig cfg) {
        return new QuantityType<>(value.stackVoltage/ 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperExternalVoltageGetter0(BrickStepper.AllData value, BrickStepperConfig cfg) {
        return new QuantityType<>(value.externalVoltage/ 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickStepperCurrentConsumptionGetter0(BrickStepper.AllData value, BrickStepperConfig cfg) {
        return new QuantityType<>(value.currentConsumption/ 1000.0, SmartHomeUnits.AMPERE);
    }

}