/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletAirQuality;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletAirQualityWrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletAirQuality dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletAirQuality.DEVICE_DISPLAY_NAME, "brickletairquality", BrickletAirQuality.DEVICE_IDENTIFIER, BrickletAirQualityWrapper.class, BrickletAirQualityActions.class, "2.0.3", true);

    public BrickletAirQualityWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletAirQuality(uid, ipcon);
    }

    
	public final static int ACCURACY_UNRELIABLE = 0;
	public final static int ACCURACY_LOW = 1;
	public final static int ACCURACY_MEDIUM = 2;
	public final static int ACCURACY_HIGH = 3;
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int DURATION_4_DAYS = 0;
	public final static int DURATION_28_DAYS = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public BrickletAirQuality.AllValues getAllValues() throws TinkerforgeException {
    return this.dev.getAllValues();
}

public void setTemperatureOffset(int offset) throws TinkerforgeException {
    this.dev.setTemperatureOffset(offset);
}

public int getTemperatureOffset() throws TinkerforgeException {
    return this.dev.getTemperatureOffset();
}

public void setAllValuesCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setAllValuesCallbackConfiguration(period, valueHasToChange);
}

public BrickletAirQuality.AllValuesCallbackConfiguration getAllValuesCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getAllValuesCallbackConfiguration();
}

public BrickletAirQuality.IAQIndex getIAQIndex() throws TinkerforgeException {
    return this.dev.getIAQIndex();
}

public void setIAQIndexCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setIAQIndexCallbackConfiguration(period, valueHasToChange);
}

public BrickletAirQuality.IAQIndexCallbackConfiguration getIAQIndexCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getIAQIndexCallbackConfiguration();
}

public int getTemperature() throws TinkerforgeException {
    return this.dev.getTemperature();
}

public void setTemperatureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setTemperatureCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletAirQuality.TemperatureCallbackConfiguration getTemperatureCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getTemperatureCallbackConfiguration();
}

public int getHumidity() throws TinkerforgeException {
    return this.dev.getHumidity();
}

public void setHumidityCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setHumidityCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletAirQuality.HumidityCallbackConfiguration getHumidityCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getHumidityCallbackConfiguration();
}

public int getAirPressure() throws TinkerforgeException {
    return this.dev.getAirPressure();
}

public void setAirPressureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setAirPressureCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletAirQuality.AirPressureCallbackConfiguration getAirPressureCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getAirPressureCallbackConfiguration();
}

public void removeCalibration() throws TinkerforgeException {
    this.dev.removeCalibration();
}

public void setBackgroundCalibrationDuration(int duration) throws TinkerforgeException {
    this.dev.setBackgroundCalibrationDuration(duration);
}

public int getBackgroundCalibrationDuration() throws TinkerforgeException {
    return this.dev.getBackgroundCalibrationDuration();
}

public BrickletAirQuality.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletAirQuality.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addAllValuesListener(BrickletAirQuality.AllValuesListener l) {
    this.dev.addAllValuesListener(l);
}

public void removeAllValuesListener(BrickletAirQuality.AllValuesListener l) {
    this.dev.removeAllValuesListener(l);
}

public void addIAQIndexListener(BrickletAirQuality.IAQIndexListener l) {
    this.dev.addIAQIndexListener(l);
}

public void removeIAQIndexListener(BrickletAirQuality.IAQIndexListener l) {
    this.dev.removeIAQIndexListener(l);
}

public void addTemperatureListener(BrickletAirQuality.TemperatureListener l) {
    this.dev.addTemperatureListener(l);
}

public void removeTemperatureListener(BrickletAirQuality.TemperatureListener l) {
    this.dev.removeTemperatureListener(l);
}

public void addHumidityListener(BrickletAirQuality.HumidityListener l) {
    this.dev.addHumidityListener(l);
}

public void removeHumidityListener(BrickletAirQuality.HumidityListener l) {
    this.dev.removeHumidityListener(l);
}

public void addAirPressureListener(BrickletAirQuality.AirPressureListener l) {
    this.dev.addAirPressureListener(l);
}

public void removeAirPressureListener(BrickletAirQuality.AirPressureListener l) {
    this.dev.removeAirPressureListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletAirQualityWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletAirQualityWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletAirQualityConfig cfg = (BrickletAirQualityConfig) config.as(BrickletAirQualityConfig.class);
        this.addHumidityListener(this.reg((humidity) -> {if(true) {updateStateFn.accept("BrickletAirQualityHumidity", transformBrickletAirQualityHumidityCallback0(humidity, cfg));}}, this.dev::removeHumidityListener));
		this.addTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletAirQualityTemperature", transformBrickletAirQualityTemperatureCallback0(temperature, cfg));}}, this.dev::removeTemperatureListener));
		this.addAirPressureListener(this.reg((airPressure) -> {if(true) {updateStateFn.accept("BrickletAirQualityAirPressure", transformBrickletAirQualityAirPressureCallback0(airPressure, cfg));}}, this.dev::removeAirPressureListener));
		this.addIAQIndexListener(this.reg((iaqIndex, iaqIndexAccuracy) -> {if(true) {updateStateFn.accept("BrickletAirQualityIAQIndex", transformBrickletAirQualityIAQIndexCallback0(iaqIndex, iaqIndexAccuracy, cfg));}}, this.dev::removeIAQIndexListener));
		this.addIAQIndexListener(this.reg((iaqIndex, iaqIndexAccuracy) -> {if(true) {updateStateFn.accept("BrickletAirQualityIAQIndexAccuracy", transformBrickletAirQualityIAQIndexAccuracyCallback0(iaqIndex, iaqIndexAccuracy, cfg));}}, this.dev::removeIAQIndexListener));
        this.setTemperatureOffset((int)(cfg.temperatureOffset.doubleValue() * 100.0f));
		        this.setIAQIndexCallbackConfiguration(cfg.iaqIndexUpdateInterval, true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletAirQualityHumidityConfig channelCfg = getChannelConfigFn.apply("BrickletAirQualityHumidity").as(BrickletAirQualityHumidityConfig.class);
		this.setHumidityCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletAirQualityTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletAirQualityTemperature").as(BrickletAirQualityTemperatureConfig.class);
		this.setTemperatureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletAirQualityAirPressureConfig channelCfg = getChannelConfigFn.apply("BrickletAirQualityAirPressure").as(BrickletAirQualityAirPressureConfig.class);
		this.setAirPressureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletAirQualityIAQIndexConfig channelCfg = getChannelConfigFn.apply("BrickletAirQualityIAQIndex").as(BrickletAirQualityIAQIndexConfig.class);
		
		}
		{
		BrickletAirQualityIAQIndexAccuracyConfig channelCfg = getChannelConfigFn.apply("BrickletAirQualityIAQIndexAccuracy").as(BrickletAirQualityIAQIndexAccuracyConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletAirQualityConfig cfg = (BrickletAirQualityConfig) config.as(BrickletAirQualityConfig.class);
        this.setHumidityCallbackConfiguration(0, true, 'x', 0, 0);
		this.setTemperatureCallbackConfiguration(0, true, 'x', 0, 0);
		this.setAirPressureCallbackConfiguration(0, true, 'x', 0, 0);
		this.setIAQIndexCallbackConfiguration(0, true);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletAirQualityConfig cfg = (BrickletAirQualityConfig) config.as(BrickletAirQualityConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletAirQualityHumidity");
		result.add("BrickletAirQualityTemperature");
		result.add("BrickletAirQualityAirPressure");
		result.add("BrickletAirQualityIAQIndex");
		result.add("BrickletAirQualityIAQIndexAccuracy");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletAirQualityHumidity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAirQualityHumidity"), "Humidity", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAirQualityHumidity")).withDescription("Measured relative humidity")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(100)).withPattern("%.2f %%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletAirQualityTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAirQualityTemperature"), "Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAirQualityTemperature")).withDescription("Measured temperature")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-40)).withMaximum(BigDecimal.valueOf(85)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletAirQualityAirPressure":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAirQualityAirPressure"), "Air Pressure", "Number:Pressure").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAirQualityAirPressure")).withDescription("Measured air pressure")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(300)).withMaximum(BigDecimal.valueOf(1100)).withPattern("%.5f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletAirQualityIAQIndex":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAirQualityIAQIndex"), "IAQ Index", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAirQualityIAQIndex")).withDescription("The IAQ index goes from 0 to 500. The higher the IAQ index, the greater the level of air pollution.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(500)).withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletAirQualityIAQIndexAccuracy":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAirQualityIAQIndexAccuracy"), "IAQ Index Accuracy", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAirQualityIAQIndexAccuracy")).withDescription("The Bricklet is building a database of measurements and uses this data to do an automatic background calibration and calculate an accurate IAQ index over time. It will take a few days until the IAQ index has a high reliability.<br/><br/>The IAQ accuracy is reflects the current state of the background calibration process.<br/><br/>    Accuracy 0: The Bricklet was just started and the sensor is stabilizing.<br/>    Accuracy 1: The background history is uncertain. This typically means the gas sensor data was too stable for the calibration algorithm to clearly define its references.<br/>    Accuracy 2: The Bricklet found new calibration data and is currently calibrating.<br/>    Accuracy 3: The Bricklets is calibrated successfully.<br/><br/>The effective duration of the calibration process depends on the stimuli observed by the sensor. An IAQ accuracy going back and fourth between 2 and 3 is expected, the Bricklet is recalibrating itself.<br/><br/>The Bricklet saves the current database of values and calculated coefficients every 12 hours in its internal flash memory. If the Bricklet loses power it will not take as long to receive reliable data again.<br/><br/>Starting with firmware version 2.0.3 the automatic background calibration considers 28 days of data. We recommend that you run the Bricklet for 28 full days before you consider the data as completely reliable. It is possible to reduce the calibration window to 4 days with the API.<br/><br/><br/>Note<br/><br/>The currently released firmware (2.0.4) does not save the calibration every 12 hours. We had to disable this because of a bug in the proprietary load/save mechanism that we can't fix. We will release a new firmware that has this enabled again as soon as this bug is fixed.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(500)).withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Air Quality Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures IAQ index, temperature, humidity and air pressure").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletAirQualityHumidity", new ChannelTypeUID("tinkerforge", "BrickletAirQualityHumidity")).withLabel("Humidity").build(), new ChannelDefinitionBuilder("BrickletAirQualityTemperature", new ChannelTypeUID("tinkerforge", "BrickletAirQualityTemperature")).withLabel("Temperature").build(), new ChannelDefinitionBuilder("BrickletAirQualityAirPressure", new ChannelTypeUID("tinkerforge", "BrickletAirQualityAirPressure")).withLabel("Air Pressure").build(), new ChannelDefinitionBuilder("BrickletAirQualityIAQIndex", new ChannelTypeUID("tinkerforge", "BrickletAirQualityIAQIndex")).withLabel("IAQ Index").build(), new ChannelDefinitionBuilder("BrickletAirQualityIAQIndexAccuracy", new ChannelTypeUID("tinkerforge", "BrickletAirQualityIAQIndexAccuracy")).withLabel("IAQ Index Accuracy").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletairquality":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("temperatureOffset", Type.DECIMAL).withDefault("0").withDescription("If you install this Bricklet into an enclosure and you want to measure the ambient temperature, you may have to decrease the measured temperature by some value to compensate for the error because of the heating inside of the enclosure.<br/><br/>We recommend that you leave the parts in the enclosure running for at least 24 hours such that a temperature equilibrium can be reached. After that you can measure the temperature directly outside of enclosure and set the difference as offset.<br/><br/>This temperature offset is used to calculate the relative humidity and IAQ index measurements. In case the Bricklet is installed in an enclosure, we recommend to measure and set the temperature offset to imporve the accuracy of the measurements.").withLabel("Temperature Offset").build(), ConfigDescriptionParameterBuilder.create("iaqIndexUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the IAQ index and accuracy in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("IAQ Index Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletAirQualityHumidity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletAirQualityTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletAirQualityAirPressure":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletAirQualityIAQIndex":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletAirQualityIAQIndexAccuracy":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAirQualityConfig cfg = (BrickletAirQualityConfig) config.as(BrickletAirQualityConfig.class);
        switch(channel) {
            case "BrickletAirQualityHumidity": {
                   BrickletAirQualityHumidityConfig channelCfg = channelConfig.as(BrickletAirQualityHumidityConfig.class);
                   {
            int value = this.getHumidity();
            if(true)
                updateStateFn.accept(channel, transformBrickletAirQualityHumidityGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletAirQualityTemperature": {
                   BrickletAirQualityTemperatureConfig channelCfg = channelConfig.as(BrickletAirQualityTemperatureConfig.class);
                   {
            int value = this.getTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletAirQualityTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletAirQualityAirPressure": {
                   BrickletAirQualityAirPressureConfig channelCfg = channelConfig.as(BrickletAirQualityAirPressureConfig.class);
                   {
            int value = this.getAirPressure();
            if(true)
                updateStateFn.accept(channel, transformBrickletAirQualityAirPressureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletAirQualityIAQIndex": {
                   BrickletAirQualityIAQIndexConfig channelCfg = channelConfig.as(BrickletAirQualityIAQIndexConfig.class);
                   {
            BrickletAirQuality.IAQIndex value = this.getIAQIndex();
            if(true)
                updateStateFn.accept(channel, transformBrickletAirQualityIAQIndexGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletAirQualityIAQIndexAccuracy": {
                   BrickletAirQualityIAQIndexAccuracyConfig channelCfg = channelConfig.as(BrickletAirQualityIAQIndexAccuracyConfig.class);
                   {
            BrickletAirQuality.IAQIndex value = this.getIAQIndex();
            if(true)
                updateStateFn.accept(channel, transformBrickletAirQualityIAQIndexAccuracyGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletAirQualityConfig cfg = (BrickletAirQualityConfig) config.as(BrickletAirQualityConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletAirQualityHumidityCallback0(int humidity, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(humidity / 100.0, SmartHomeUnits.PERCENT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityTemperatureCallback0(int temperature, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(temperature / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityAirPressureCallback0(int airPressure, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(airPressure / 100000.0, SmartHomeUnits.BAR);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityIAQIndexCallback0(int iaqIndex, int iaqIndexAccuracy, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(iaqIndex, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityIAQIndexAccuracyCallback0(int iaqIndex, int iaqIndexAccuracy, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(iaqIndexAccuracy, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityHumidityGetter0(int value, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(value / 100.0, SmartHomeUnits.PERCENT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityTemperatureGetter0(int value, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityAirPressureGetter0(int value, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(value / 100000.0, SmartHomeUnits.BAR);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityIAQIndexGetter0(BrickletAirQuality.IAQIndex value, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(value.iaqIndex, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAirQualityIAQIndexAccuracyGetter0(BrickletAirQuality.IAQIndex value, BrickletAirQualityConfig cfg) {
        return new QuantityType<>(value.iaqIndexAccuracy, SmartHomeUnits.ONE);
    }

}