/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletAmbientLightV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletAmbientLightV2Wrapper extends DeviceWrapper implements StandardFlashable{
    BrickletAmbientLightV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletAmbientLightV2.DEVICE_DISPLAY_NAME, "brickletambientlightv2", BrickletAmbientLightV2.DEVICE_IDENTIFIER, BrickletAmbientLightV2Wrapper.class, BrickletAmbientLightV2Actions.class, "2.0.0", false);

    public BrickletAmbientLightV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletAmbientLightV2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int ILLUMINANCE_RANGE_UNLIMITED = 6;
	public final static int ILLUMINANCE_RANGE_64000LUX = 0;
	public final static int ILLUMINANCE_RANGE_32000LUX = 1;
	public final static int ILLUMINANCE_RANGE_16000LUX = 2;
	public final static int ILLUMINANCE_RANGE_8000LUX = 3;
	public final static int ILLUMINANCE_RANGE_1300LUX = 4;
	public final static int ILLUMINANCE_RANGE_600LUX = 5;
	public final static int INTEGRATION_TIME_50MS = 0;
	public final static int INTEGRATION_TIME_100MS = 1;
	public final static int INTEGRATION_TIME_150MS = 2;
	public final static int INTEGRATION_TIME_200MS = 3;
	public final static int INTEGRATION_TIME_250MS = 4;
	public final static int INTEGRATION_TIME_300MS = 5;
	public final static int INTEGRATION_TIME_350MS = 6;
	public final static int INTEGRATION_TIME_400MS = 7;


    public long getIlluminance() throws TinkerforgeException {
    return this.dev.getIlluminance();
}

public void setIlluminanceCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setIlluminanceCallbackPeriod(period);
}

public long getIlluminanceCallbackPeriod() throws TinkerforgeException {
    return this.dev.getIlluminanceCallbackPeriod();
}

public void setIlluminanceCallbackThreshold(char option, long min, long max) throws TinkerforgeException {
    this.dev.setIlluminanceCallbackThreshold(option, min, max);
}

public BrickletAmbientLightV2.IlluminanceCallbackThreshold getIlluminanceCallbackThreshold() throws TinkerforgeException {
    return this.dev.getIlluminanceCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public void setConfiguration(int illuminanceRange, int integrationTime) throws TinkerforgeException {
    this.dev.setConfiguration(illuminanceRange, integrationTime);
}

public BrickletAmbientLightV2.Configuration getConfiguration() throws TinkerforgeException {
    return this.dev.getConfiguration();
}

public BrickletAmbientLightV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addIlluminanceListener(BrickletAmbientLightV2.IlluminanceListener l) {
    this.dev.addIlluminanceListener(l);
}

public void removeIlluminanceListener(BrickletAmbientLightV2.IlluminanceListener l) {
    this.dev.removeIlluminanceListener(l);
}

public void addIlluminanceReachedListener(BrickletAmbientLightV2.IlluminanceReachedListener l) {
    this.dev.addIlluminanceReachedListener(l);
}

public void removeIlluminanceReachedListener(BrickletAmbientLightV2.IlluminanceReachedListener l) {
    this.dev.removeIlluminanceReachedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletAmbientLightV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletAmbientLightV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletAmbientLightV2Config cfg = (BrickletAmbientLightV2Config) config.as(BrickletAmbientLightV2Config.class);
        this.addIlluminanceListener(this.reg((illuminance) -> {if(true) {updateStateFn.accept("BrickletAmbientLightV2Illuminance", transformBrickletAmbientLightV2IlluminanceCallback0(illuminance, cfg));}}, this.dev::removeIlluminanceListener));
        this.setConfiguration(cfg.illuminanceRange, cfg.integrationTime);
		{
		BrickletAmbientLightV2IlluminanceConfig channelCfg = getChannelConfigFn.apply("BrickletAmbientLightV2Illuminance").as(BrickletAmbientLightV2IlluminanceConfig.class);
		this.setIlluminanceCallbackPeriod(channelCfg.updateInterval);
		this.setIlluminanceCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletAmbientLightV2Config cfg = (BrickletAmbientLightV2Config) config.as(BrickletAmbientLightV2Config.class);
        this.setIlluminanceCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletAmbientLightV2Config cfg = (BrickletAmbientLightV2Config) config.as(BrickletAmbientLightV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletAmbientLightV2Illuminance");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletAmbientLightV2Illuminance":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAmbientLightV2Illuminance"), "Illuminance", "Number:Illuminance").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAmbientLightV2Illuminance")).withDescription("The illuminance of the ambient light sensor. The measurement range goes up to about 100000lux, but above 64000lux the precision starts to drop. An illuminance of 0lux indicates that the sensor is saturated and the configuration should be modified.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(100000)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Ambient Light Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures ambient light up to 64000lux").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletAmbientLightV2Illuminance", new ChannelTypeUID("tinkerforge", "BrickletAmbientLightV2Illuminance")).withLabel("Illuminance").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletambientlightv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("illuminanceRange", Type.INTEGER).withDefault("3").withDescription("The unlimited illuminance range allows to measure up to about 100000lux, but above 64000lux the precision starts to drop.<br/><br/>A smaller illuminance range increases the resolution of the data.<br/><br/>If the actual measure illuminance is out-of-range then the current illuminance range maximum +0.01lux is reported. For example, 800001 for the 0-8000lux range.<br/><br/>If the measurement is out-of-range or the sensor is saturated then you should configure the next higher illuminance range. If the highest range is already in use, then start to reduce the integration time.").withLabel("Illuminance Range").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("6", "Unlimited"), new ParameterOption("0", "64000Lux"), new ParameterOption("1", "32000Lux"), new ParameterOption("2", "16000Lux"), new ParameterOption("3", "8000Lux"), new ParameterOption("4", "1300Lux"), new ParameterOption("5", "600Lux"))).build(), ConfigDescriptionParameterBuilder.create("integrationTime", Type.INTEGER).withDefault("3").withDescription("A longer integration time will result in less noise on the data.<br/><br/>With a long integration time the sensor might be saturated before the measured value reaches the maximum of the selected illuminance range. In this case 0lux is reported.<br/><br/>If the measurement is out-of-range or the sensor is saturated then you should configure the next higher illuminance range. If the highest range is already in use, then start to reduce the integration time.").withLabel("Integration Time").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "50ms"), new ParameterOption("1", "100ms"), new ParameterOption("2", "150ms"), new ParameterOption("3", "200ms"), new ParameterOption("4", "250ms"), new ParameterOption("5", "300ms"), new ParameterOption("6", "350ms"), new ParameterOption("7", "400ms"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletAmbientLightV2Illuminance":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAmbientLightV2Config cfg = (BrickletAmbientLightV2Config) config.as(BrickletAmbientLightV2Config.class);
        switch(channel) {
            case "BrickletAmbientLightV2Illuminance": {
                   BrickletAmbientLightV2IlluminanceConfig channelCfg = channelConfig.as(BrickletAmbientLightV2IlluminanceConfig.class);
                   {
            long value = this.getIlluminance();
            if(true)
                updateStateFn.accept(channel, transformBrickletAmbientLightV2IlluminanceGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletAmbientLightV2Config cfg = (BrickletAmbientLightV2Config) config.as(BrickletAmbientLightV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletAmbientLightV2IlluminanceCallback0(long illuminance, BrickletAmbientLightV2Config cfg) {
        return new QuantityType<>(illuminance / 100.0, SmartHomeUnits.LUX);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAmbientLightV2IlluminanceGetter0(long value, BrickletAmbientLightV2Config cfg) {
        return new QuantityType<>(value / 100.0, SmartHomeUnits.LUX);
    }

}