/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletAnalogInV3;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletAnalogInV3Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletAnalogInV3 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletAnalogInV3.DEVICE_DISPLAY_NAME, "brickletanaloginv3", BrickletAnalogInV3.DEVICE_IDENTIFIER, BrickletAnalogInV3Wrapper.class, BrickletAnalogInV3Actions.class, "2.0.0", true);

    public BrickletAnalogInV3Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletAnalogInV3(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int OVERSAMPLING_32 = 0;
	public final static int OVERSAMPLING_64 = 1;
	public final static int OVERSAMPLING_128 = 2;
	public final static int OVERSAMPLING_256 = 3;
	public final static int OVERSAMPLING_512 = 4;
	public final static int OVERSAMPLING_1024 = 5;
	public final static int OVERSAMPLING_2048 = 6;
	public final static int OVERSAMPLING_4096 = 7;
	public final static int OVERSAMPLING_8192 = 8;
	public final static int OVERSAMPLING_16384 = 9;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getVoltage() throws TinkerforgeException {
    return this.dev.getVoltage();
}

public void setVoltageCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setVoltageCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletAnalogInV3.VoltageCallbackConfiguration getVoltageCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getVoltageCallbackConfiguration();
}

public void setOversampling(int oversampling) throws TinkerforgeException {
    this.dev.setOversampling(oversampling);
}

public int getOversampling() throws TinkerforgeException {
    return this.dev.getOversampling();
}

public void setCalibration(int offset, int multiplier, int divisor) throws TinkerforgeException {
    this.dev.setCalibration(offset, multiplier, divisor);
}

public BrickletAnalogInV3.Calibration getCalibration() throws TinkerforgeException {
    return this.dev.getCalibration();
}

public BrickletAnalogInV3.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletAnalogInV3.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addVoltageListener(BrickletAnalogInV3.VoltageListener l) {
    this.dev.addVoltageListener(l);
}

public void removeVoltageListener(BrickletAnalogInV3.VoltageListener l) {
    this.dev.removeVoltageListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletAnalogInV3Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletAnalogInV3Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletAnalogInV3Config cfg = (BrickletAnalogInV3Config) config.as(BrickletAnalogInV3Config.class);
        this.addVoltageListener(this.reg((voltage) -> {if(true) {updateStateFn.accept("BrickletAnalogInV3Voltage", transformBrickletAnalogInV3VoltageCallback0(voltage, cfg));}}, this.dev::removeVoltageListener));
        this.setOversampling(cfg.oversampling);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletAnalogInV3VoltageConfig channelCfg = getChannelConfigFn.apply("BrickletAnalogInV3Voltage").as(BrickletAnalogInV3VoltageConfig.class);
		this.setVoltageCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletAnalogInV3Config cfg = (BrickletAnalogInV3Config) config.as(BrickletAnalogInV3Config.class);
        this.setVoltageCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletAnalogInV3Config cfg = (BrickletAnalogInV3Config) config.as(BrickletAnalogInV3Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletAnalogInV3Voltage");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletAnalogInV3Voltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAnalogInV3Voltage"), "Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAnalogInV3Voltage")).withDescription("Measured voltage")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(42)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Analog In Bricklet 3.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures DC voltage between 0V and 42V").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletAnalogInV3Voltage", new ChannelTypeUID("tinkerforge", "BrickletAnalogInV3Voltage")).withLabel("Voltage").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletanaloginv3":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("oversampling", Type.INTEGER).withDefault("7").withDescription("Sets the oversampling between 32x and 16384x. The Bricklet takes one 12bit sample every 17.5µs. Thus an oversampling of 32x is equivalent to an integration time of 0.56ms and a oversampling of 16384x is equivalent to an integration time of 286ms.<br/><br/>The oversampling uses the moving average principle. A new value is always calculated once per millisecond.<br/><br/>With increased oversampling the noise decreases. With decreased oversampling the reaction time increases (changes in voltage will be measured faster).<br/><br/>The default value is 4096x.").withLabel("Oversampling").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "32x"), new ParameterOption("1", "64x"), new ParameterOption("2", "128x"), new ParameterOption("3", "256x"), new ParameterOption("4", "512x"), new ParameterOption("5", "1024x"), new ParameterOption("6", "2048x"), new ParameterOption("7", "4096x"), new ParameterOption("8", "8192x"), new ParameterOption("9", "16384x"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletAnalogInV3Voltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAnalogInV3Config cfg = (BrickletAnalogInV3Config) config.as(BrickletAnalogInV3Config.class);
        switch(channel) {
            case "BrickletAnalogInV3Voltage": {
                   BrickletAnalogInV3VoltageConfig channelCfg = channelConfig.as(BrickletAnalogInV3VoltageConfig.class);
                   {
            int value = this.getVoltage();
            if(true)
                updateStateFn.accept(channel, transformBrickletAnalogInV3VoltageGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletAnalogInV3Config cfg = (BrickletAnalogInV3Config) config.as(BrickletAnalogInV3Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletAnalogInV3VoltageCallback0(int voltage, BrickletAnalogInV3Config cfg) {
        return new QuantityType<>(voltage / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAnalogInV3VoltageGetter0(int value, BrickletAnalogInV3Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }

}