/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletAnalogIn;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletAnalogInWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletAnalogIn dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletAnalogIn.DEVICE_DISPLAY_NAME, "brickletanalogin", BrickletAnalogIn.DEVICE_IDENTIFIER, BrickletAnalogInWrapper.class, BrickletAnalogInActions.class, "2.0.3", false);

    public BrickletAnalogInWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletAnalogIn(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int RANGE_AUTOMATIC = 0;
	public final static int RANGE_UP_TO_6V = 1;
	public final static int RANGE_UP_TO_10V = 2;
	public final static int RANGE_UP_TO_36V = 3;
	public final static int RANGE_UP_TO_45V = 4;
	public final static int RANGE_UP_TO_3V = 5;


    public int getVoltage() throws TinkerforgeException {
    return this.dev.getVoltage();
}

public int getAnalogValue() throws TinkerforgeException {
    return this.dev.getAnalogValue();
}

public void setVoltageCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setVoltageCallbackPeriod(period);
}

public long getVoltageCallbackPeriod() throws TinkerforgeException {
    return this.dev.getVoltageCallbackPeriod();
}

public void setAnalogValueCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setAnalogValueCallbackPeriod(period);
}

public long getAnalogValueCallbackPeriod() throws TinkerforgeException {
    return this.dev.getAnalogValueCallbackPeriod();
}

public void setVoltageCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setVoltageCallbackThreshold(option, min, max);
}

public BrickletAnalogIn.VoltageCallbackThreshold getVoltageCallbackThreshold() throws TinkerforgeException {
    return this.dev.getVoltageCallbackThreshold();
}

public void setAnalogValueCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setAnalogValueCallbackThreshold(option, min, max);
}

public BrickletAnalogIn.AnalogValueCallbackThreshold getAnalogValueCallbackThreshold() throws TinkerforgeException {
    return this.dev.getAnalogValueCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public void setRange(int range) throws TinkerforgeException {
    this.dev.setRange(range);
}

public int getRange() throws TinkerforgeException {
    return this.dev.getRange();
}

public void setAveraging(int average) throws TinkerforgeException {
    this.dev.setAveraging(average);
}

public int getAveraging() throws TinkerforgeException {
    return this.dev.getAveraging();
}

public BrickletAnalogIn.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addVoltageListener(BrickletAnalogIn.VoltageListener l) {
    this.dev.addVoltageListener(l);
}

public void removeVoltageListener(BrickletAnalogIn.VoltageListener l) {
    this.dev.removeVoltageListener(l);
}

public void addAnalogValueListener(BrickletAnalogIn.AnalogValueListener l) {
    this.dev.addAnalogValueListener(l);
}

public void removeAnalogValueListener(BrickletAnalogIn.AnalogValueListener l) {
    this.dev.removeAnalogValueListener(l);
}

public void addVoltageReachedListener(BrickletAnalogIn.VoltageReachedListener l) {
    this.dev.addVoltageReachedListener(l);
}

public void removeVoltageReachedListener(BrickletAnalogIn.VoltageReachedListener l) {
    this.dev.removeVoltageReachedListener(l);
}

public void addAnalogValueReachedListener(BrickletAnalogIn.AnalogValueReachedListener l) {
    this.dev.addAnalogValueReachedListener(l);
}

public void removeAnalogValueReachedListener(BrickletAnalogIn.AnalogValueReachedListener l) {
    this.dev.removeAnalogValueReachedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletAnalogInWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletAnalogInWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletAnalogInConfig cfg = (BrickletAnalogInConfig) config.as(BrickletAnalogInConfig.class);
        this.addVoltageListener(this.reg((voltage) -> {if(true) {updateStateFn.accept("BrickletAnalogInVoltage", transformBrickletAnalogInVoltageCallback0(voltage, cfg));}}, this.dev::removeVoltageListener));
        this.setAveraging(cfg.averageLength);
		    this.setRange(cfg.measurementRange);
		{
		BrickletAnalogInVoltageConfig channelCfg = getChannelConfigFn.apply("BrickletAnalogInVoltage").as(BrickletAnalogInVoltageConfig.class);
		this.setVoltageCallbackPeriod(channelCfg.updateInterval);
		this.setVoltageCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletAnalogInConfig cfg = (BrickletAnalogInConfig) config.as(BrickletAnalogInConfig.class);
        this.setVoltageCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletAnalogInConfig cfg = (BrickletAnalogInConfig) config.as(BrickletAnalogInConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletAnalogInVoltage");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletAnalogInVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAnalogInVoltage"), "Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAnalogInVoltage")).withDescription("Measured voltage")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(42)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Analog In Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures DC voltage between 0V and 45V").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletAnalogInVoltage", new ChannelTypeUID("tinkerforge", "BrickletAnalogInVoltage")).withLabel("Voltage").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletanalogin":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("averageLength", Type.INTEGER).withDefault("50").withDescription("The length of a averaging for the voltage value.<br/><br/>Setting the length to 0 will turn the averaging completely off. If the averaging is off, there is more noise on the data, but the data is without delay.<br/><br/>The default value is 50.").withLabel("Average Length").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("measurementRange", Type.INTEGER).withDefault("0").withDescription("The measurement range.<br/><br/>Possible ranges are: <ul><li>Automatically switched</li><li>0V - 6.05V, ~1.48mV resolution</li><li>0V - 10.32V, ~2.52mV resolution</li><li>0V - 36.30V, ~8.86mV resolution</li><li>- 45.00V, ~11.25mV resolution</li><li>0V - 3.3V, ~0.81mV resolution</li>").withLabel("Measurement Range").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Automatic"), new ParameterOption("1", "Up To 6V"), new ParameterOption("2", "Up To 10V"), new ParameterOption("3", "Up To 36V"), new ParameterOption("4", "Up To 45V"), new ParameterOption("5", "Up To 3V"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletAnalogInVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAnalogInConfig cfg = (BrickletAnalogInConfig) config.as(BrickletAnalogInConfig.class);
        switch(channel) {
            case "BrickletAnalogInVoltage": {
                   BrickletAnalogInVoltageConfig channelCfg = channelConfig.as(BrickletAnalogInVoltageConfig.class);
                   {
            int value = this.getVoltage();
            if(true)
                updateStateFn.accept(channel, transformBrickletAnalogInVoltageGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletAnalogInConfig cfg = (BrickletAnalogInConfig) config.as(BrickletAnalogInConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletAnalogInVoltageCallback0(int voltage, BrickletAnalogInConfig cfg) {
        return new QuantityType<>(voltage / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAnalogInVoltageGetter0(int value, BrickletAnalogInConfig cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }

}