/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletAnalogOutV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletAnalogOutV2Wrapper extends DeviceWrapper implements StandardFlashable{
    BrickletAnalogOutV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletAnalogOutV2.DEVICE_DISPLAY_NAME, "brickletanalogoutv2", BrickletAnalogOutV2.DEVICE_IDENTIFIER, BrickletAnalogOutV2Wrapper.class, BrickletAnalogOutV2Actions.class, "2.0.0", false);

    public BrickletAnalogOutV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletAnalogOutV2(uid, ipcon);
    }

    


    public void setOutputVoltage(int voltage) throws TinkerforgeException {
    this.dev.setOutputVoltage(voltage);
}

public int getOutputVoltage() throws TinkerforgeException {
    return this.dev.getOutputVoltage();
}

public int getInputVoltage() throws TinkerforgeException {
    return this.dev.getInputVoltage();
}

public BrickletAnalogOutV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletAnalogOutV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletAnalogOutV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletAnalogOutV2Config cfg = (BrickletAnalogOutV2Config) config.as(BrickletAnalogOutV2Config.class);
        
        
		{
		BrickletAnalogOutV2InputVoltageConfig channelCfg = getChannelConfigFn.apply("BrickletAnalogOutV2InputVoltage").as(BrickletAnalogOutV2InputVoltageConfig.class);
		
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletAnalogOutV2InputVoltage"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		{
		BrickletAnalogOutV2OutputVoltageConfig channelCfg = getChannelConfigFn.apply("BrickletAnalogOutV2OutputVoltage").as(BrickletAnalogOutV2OutputVoltageConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletAnalogOutV2Config cfg = (BrickletAnalogOutV2Config) config.as(BrickletAnalogOutV2Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletAnalogOutV2Config cfg = (BrickletAnalogOutV2Config) config.as(BrickletAnalogOutV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletAnalogOutV2InputVoltage");
		result.add("BrickletAnalogOutV2OutputVoltage");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletAnalogOutV2InputVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAnalogOutV2InputVoltage"), "Input Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAnalogOutV2InputVoltage")).withDescription("The input voltage")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(15)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletAnalogOutV2OutputVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletAnalogOutV2OutputVoltage"), "Output Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletAnalogOutV2OutputVoltage")).withDescription("The output voltage. The possible range is 0V to 12V")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(12)).withPattern("%.3f %unit%").build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Analog Out Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Generates configurable DC voltage between 0V and 12V").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletAnalogOutV2InputVoltage", new ChannelTypeUID("tinkerforge", "BrickletAnalogOutV2InputVoltage")).withLabel("Input Voltage").build(), new ChannelDefinitionBuilder("BrickletAnalogOutV2OutputVoltage", new ChannelTypeUID("tinkerforge", "BrickletAnalogOutV2OutputVoltage")).withLabel("Output Voltage").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletanalogoutv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletAnalogOutV2InputVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletAnalogOutV2OutputVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletAnalogOutV2Config cfg = (BrickletAnalogOutV2Config) config.as(BrickletAnalogOutV2Config.class);
        switch(channel) {
            case "BrickletAnalogOutV2InputVoltage": {
                   BrickletAnalogOutV2InputVoltageConfig channelCfg = channelConfig.as(BrickletAnalogOutV2InputVoltageConfig.class);
                   {
            int value = this.getInputVoltage();
            if(true)
                updateStateFn.accept(channel, transformBrickletAnalogOutV2InputVoltageGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletAnalogOutV2OutputVoltage": {
                   BrickletAnalogOutV2OutputVoltageConfig channelCfg = channelConfig.as(BrickletAnalogOutV2OutputVoltageConfig.class);
                   {
            int value = this.getOutputVoltage();
            if(true)
                updateStateFn.accept(channel, transformBrickletAnalogOutV2OutputVoltageGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletAnalogOutV2Config cfg = (BrickletAnalogOutV2Config) config.as(BrickletAnalogOutV2Config.class);
        switch(channel) {
            case "BrickletAnalogOutV2OutputVoltage":
                if (command instanceof Number) {
                    BrickletAnalogOutV2OutputVoltageConfig channelCfg = channelConfig.as(BrickletAnalogOutV2OutputVoltageConfig.class);
                    Number cmd = (Number) command;
                    this.setOutputVoltage((int)Math.round(cmd.doubleValue() * 1000.0));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletAnalogOutV2InputVoltageGetter0(int value, BrickletAnalogOutV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletAnalogOutV2OutputVoltageGetter0(int value, BrickletAnalogOutV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }

}