/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.tinkerforge.BrickletCANV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletCANV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletCANV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletCANV2.DEVICE_DISPLAY_NAME, "brickletcanv2", BrickletCANV2.DEVICE_IDENTIFIER, BrickletCANV2Wrapper.class, BrickletCANV2Actions.class, "2.0.0", true);

    public BrickletCANV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletCANV2(uid, ipcon);
    }

    
	public final static int FRAME_TYPE_STANDARD_DATA = 0;
	public final static int FRAME_TYPE_STANDARD_REMOTE = 1;
	public final static int FRAME_TYPE_EXTENDED_DATA = 2;
	public final static int FRAME_TYPE_EXTENDED_REMOTE = 3;
	public final static int TRANSCEIVER_MODE_NORMAL = 0;
	public final static int TRANSCEIVER_MODE_LOOPBACK = 1;
	public final static int TRANSCEIVER_MODE_READ_ONLY = 2;
	public final static int FILTER_MODE_ACCEPT_ALL = 0;
	public final static int FILTER_MODE_MATCH_STANDARD_ONLY = 1;
	public final static int FILTER_MODE_MATCH_EXTENDED_ONLY = 2;
	public final static int FILTER_MODE_MATCH_STANDARD_AND_EXTENDED = 3;
	public final static int TRANSCEIVER_STATE_ACTIVE = 0;
	public final static int TRANSCEIVER_STATE_PASSIVE = 1;
	public final static int TRANSCEIVER_STATE_DISABLED = 2;
	public final static int COMMUNICATION_LED_CONFIG_OFF = 0;
	public final static int COMMUNICATION_LED_CONFIG_ON = 1;
	public final static int COMMUNICATION_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int COMMUNICATION_LED_CONFIG_SHOW_COMMUNICATION = 3;
	public final static int ERROR_LED_CONFIG_OFF = 0;
	public final static int ERROR_LED_CONFIG_ON = 1;
	public final static int ERROR_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int ERROR_LED_CONFIG_SHOW_TRANSCEIVER_STATE = 3;
	public final static int ERROR_LED_CONFIG_SHOW_ERROR = 4;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public boolean writeFrame(int frameType, long identifier, int[] data) throws TinkerforgeException {
    return this.dev.writeFrame(frameType, identifier, data);
}

public BrickletCANV2.ReadFrame readFrame() throws TinkerforgeException {
    return this.dev.readFrame();
}

public void setFrameReadCallbackConfiguration(boolean enabled) throws TinkerforgeException {
    this.dev.setFrameReadCallbackConfiguration(enabled);
}

public boolean getFrameReadCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getFrameReadCallbackConfiguration();
}

public void setTransceiverConfiguration(long baudRate, int samplePoint, int transceiverMode) throws TinkerforgeException {
    this.dev.setTransceiverConfiguration(baudRate, samplePoint, transceiverMode);
}

public BrickletCANV2.TransceiverConfiguration getTransceiverConfiguration() throws TinkerforgeException {
    return this.dev.getTransceiverConfiguration();
}

public void setQueueConfiguration(int writeBufferSize, int writeBufferTimeout, int writeBacklogSize, int[] readBufferSizes, int readBacklogSize) throws TinkerforgeException {
    this.dev.setQueueConfiguration(writeBufferSize, writeBufferTimeout, writeBacklogSize, readBufferSizes, readBacklogSize);
}

public BrickletCANV2.QueueConfiguration getQueueConfiguration() throws TinkerforgeException {
    return this.dev.getQueueConfiguration();
}

public void setReadFilterConfiguration(int bufferIndex, int filterMode, long filterMask, long filterIdentifier) throws TinkerforgeException {
    this.dev.setReadFilterConfiguration(bufferIndex, filterMode, filterMask, filterIdentifier);
}

public BrickletCANV2.ReadFilterConfiguration getReadFilterConfiguration(int bufferIndex) throws TinkerforgeException {
    return this.dev.getReadFilterConfiguration(bufferIndex);
}

public BrickletCANV2.ErrorLog getErrorLog() throws TinkerforgeException {
    return this.dev.getErrorLog();
}

public void setCommunicationLEDConfig(int config) throws TinkerforgeException {
    this.dev.setCommunicationLEDConfig(config);
}

public int getCommunicationLEDConfig() throws TinkerforgeException {
    return this.dev.getCommunicationLEDConfig();
}

public void setErrorLEDConfig(int config) throws TinkerforgeException {
    this.dev.setErrorLEDConfig(config);
}

public int getErrorLEDConfig() throws TinkerforgeException {
    return this.dev.getErrorLEDConfig();
}

public BrickletCANV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletCANV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addFrameReadListener(BrickletCANV2.FrameReadListener l) {
    this.dev.addFrameReadListener(l);
}

public void removeFrameReadListener(BrickletCANV2.FrameReadListener l) {
    this.dev.removeFrameReadListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletCANV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletCANV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletCANV2Config cfg = (BrickletCANV2Config) config.as(BrickletCANV2Config.class);
        
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletCANV2Config cfg = (BrickletCANV2Config) config.as(BrickletCANV2Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletCANV2Config cfg = (BrickletCANV2Config) config.as(BrickletCANV2Config.class);
        List<String> result = new ArrayList<String>();
        
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge CAN Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Communicates with CAN bus devices").withChannelDefinitions(Arrays.asList()).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletcanv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletCANV2Config cfg = (BrickletCANV2Config) config.as(BrickletCANV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletCANV2Config cfg = (BrickletCANV2Config) config.as(BrickletCANV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    

}