/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletCO2V2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletCO2V2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletCO2V2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletCO2V2.DEVICE_DISPLAY_NAME, "brickletco2v2", BrickletCO2V2.DEVICE_IDENTIFIER, BrickletCO2V2Wrapper.class, BrickletCO2V2Actions.class, "2.0.0", true);

    public BrickletCO2V2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletCO2V2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public BrickletCO2V2.AllValues getAllValues() throws TinkerforgeException {
    return this.dev.getAllValues();
}

public void setAirPressure(int airPressure) throws TinkerforgeException {
    this.dev.setAirPressure(airPressure);
}

public int getAirPressure() throws TinkerforgeException {
    return this.dev.getAirPressure();
}

public void setTemperatureOffset(int offset) throws TinkerforgeException {
    this.dev.setTemperatureOffset(offset);
}

public int getTemperatureOffset() throws TinkerforgeException {
    return this.dev.getTemperatureOffset();
}

public void setAllValuesCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setAllValuesCallbackConfiguration(period, valueHasToChange);
}

public BrickletCO2V2.AllValuesCallbackConfiguration getAllValuesCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getAllValuesCallbackConfiguration();
}

public int getCO2Concentration() throws TinkerforgeException {
    return this.dev.getCO2Concentration();
}

public void setCO2ConcentrationCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setCO2ConcentrationCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletCO2V2.CO2ConcentrationCallbackConfiguration getCO2ConcentrationCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getCO2ConcentrationCallbackConfiguration();
}

public int getTemperature() throws TinkerforgeException {
    return this.dev.getTemperature();
}

public void setTemperatureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setTemperatureCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletCO2V2.TemperatureCallbackConfiguration getTemperatureCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getTemperatureCallbackConfiguration();
}

public int getHumidity() throws TinkerforgeException {
    return this.dev.getHumidity();
}

public void setHumidityCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setHumidityCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletCO2V2.HumidityCallbackConfiguration getHumidityCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getHumidityCallbackConfiguration();
}

public BrickletCO2V2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletCO2V2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addAllValuesListener(BrickletCO2V2.AllValuesListener l) {
    this.dev.addAllValuesListener(l);
}

public void removeAllValuesListener(BrickletCO2V2.AllValuesListener l) {
    this.dev.removeAllValuesListener(l);
}

public void addCO2ConcentrationListener(BrickletCO2V2.CO2ConcentrationListener l) {
    this.dev.addCO2ConcentrationListener(l);
}

public void removeCO2ConcentrationListener(BrickletCO2V2.CO2ConcentrationListener l) {
    this.dev.removeCO2ConcentrationListener(l);
}

public void addTemperatureListener(BrickletCO2V2.TemperatureListener l) {
    this.dev.addTemperatureListener(l);
}

public void removeTemperatureListener(BrickletCO2V2.TemperatureListener l) {
    this.dev.removeTemperatureListener(l);
}

public void addHumidityListener(BrickletCO2V2.HumidityListener l) {
    this.dev.addHumidityListener(l);
}

public void removeHumidityListener(BrickletCO2V2.HumidityListener l) {
    this.dev.removeHumidityListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletCO2V2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletCO2V2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletCO2V2Config cfg = (BrickletCO2V2Config) config.as(BrickletCO2V2Config.class);
        this.addCO2ConcentrationListener(this.reg((co2Concentration) -> {if(true) {updateStateFn.accept("BrickletCO2V2CO2Concentration", transformBrickletCO2V2CO2ConcentrationCallback0(co2Concentration, cfg));}}, this.dev::removeCO2ConcentrationListener));
		this.addTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletCO2V2Temperature", transformBrickletCO2V2TemperatureCallback0(temperature, cfg));}}, this.dev::removeTemperatureListener));
		this.addHumidityListener(this.reg((humidity) -> {if(true) {updateStateFn.accept("BrickletCO2V2Humidity", transformBrickletCO2V2HumidityCallback0(humidity, cfg));}}, this.dev::removeHumidityListener));
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletCO2V2CO2ConcentrationConfig channelCfg = getChannelConfigFn.apply("BrickletCO2V2CO2Concentration").as(BrickletCO2V2CO2ConcentrationConfig.class);
		this.setCO2ConcentrationCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletCO2V2TemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletCO2V2Temperature").as(BrickletCO2V2TemperatureConfig.class);
		this.setTemperatureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletCO2V2HumidityConfig channelCfg = getChannelConfigFn.apply("BrickletCO2V2Humidity").as(BrickletCO2V2HumidityConfig.class);
		this.setHumidityCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletCO2V2AirPressureConfig channelCfg = getChannelConfigFn.apply("BrickletCO2V2AirPressure").as(BrickletCO2V2AirPressureConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletCO2V2Config cfg = (BrickletCO2V2Config) config.as(BrickletCO2V2Config.class);
        this.setCO2ConcentrationCallbackConfiguration(0, true, 'x', 0, 0);
		this.setTemperatureCallbackConfiguration(0, true, 'x', 0, 0);
		this.setHumidityCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletCO2V2Config cfg = (BrickletCO2V2Config) config.as(BrickletCO2V2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletCO2V2CO2Concentration");
		result.add("BrickletCO2V2Temperature");
		result.add("BrickletCO2V2Humidity");
		result.add("BrickletCO2V2AirPressure");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletCO2V2CO2Concentration":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletCO2V2CO2Concentration"), "CO2 Concentration", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletCO2V2CO2Concentration")).withDescription("The measured CO2 concentration.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletCO2V2Temperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletCO2V2Temperature"), "Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletCO2V2Temperature")).withDescription("The measured temperature.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletCO2V2Humidity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletCO2V2Humidity"), "Humidity", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletCO2V2Humidity")).withDescription("The measured humidity.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletCO2V2AirPressure":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletCO2V2AirPressure"), "Air Pressure", "Number:Pressure").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletCO2V2AirPressure")).withDescription("The CO2 concentration (among other things) depends on the ambient air pressure. To increase the accuracy of the CO2 Bricklet 2.0 you can set the current air pressure. You use the Barometer Bricklet 2.0 or the Air Quality Bricklet to get the current air pressure. The expected unit of the ambient air pressure value is bar. By default air pressure compensation is disabled. Once you set a value it will be used for compensation. You can turn the compensation off again by setting the value to 0. It is sufficient to update the value every few minutes.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.3f %unit%").build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge CO2 Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures CO2 concentration, temperature and humidity").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletCO2V2CO2Concentration", new ChannelTypeUID("tinkerforge", "BrickletCO2V2CO2Concentration")).withLabel("CO2 Concentration").build(), new ChannelDefinitionBuilder("BrickletCO2V2Temperature", new ChannelTypeUID("tinkerforge", "BrickletCO2V2Temperature")).withLabel("Temperature").build(), new ChannelDefinitionBuilder("BrickletCO2V2Humidity", new ChannelTypeUID("tinkerforge", "BrickletCO2V2Humidity")).withLabel("Humidity").build(), new ChannelDefinitionBuilder("BrickletCO2V2AirPressure", new ChannelTypeUID("tinkerforge", "BrickletCO2V2AirPressure")).withLabel("Air Pressure").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletco2v2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletCO2V2CO2Concentration":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletCO2V2Temperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletCO2V2Humidity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletCO2V2AirPressure":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletCO2V2Config cfg = (BrickletCO2V2Config) config.as(BrickletCO2V2Config.class);
        switch(channel) {
            case "BrickletCO2V2CO2Concentration": {
                   BrickletCO2V2CO2ConcentrationConfig channelCfg = channelConfig.as(BrickletCO2V2CO2ConcentrationConfig.class);
                   {
            int value = this.getCO2Concentration();
            if(true)
                updateStateFn.accept(channel, transformBrickletCO2V2CO2ConcentrationGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletCO2V2Temperature": {
                   BrickletCO2V2TemperatureConfig channelCfg = channelConfig.as(BrickletCO2V2TemperatureConfig.class);
                   {
            int value = this.getTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletCO2V2TemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletCO2V2Humidity": {
                   BrickletCO2V2HumidityConfig channelCfg = channelConfig.as(BrickletCO2V2HumidityConfig.class);
                   {
            int value = this.getHumidity();
            if(true)
                updateStateFn.accept(channel, transformBrickletCO2V2HumidityGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletCO2V2AirPressure": {
                   BrickletCO2V2AirPressureConfig channelCfg = channelConfig.as(BrickletCO2V2AirPressureConfig.class);
                   {
            int value = this.getAirPressure();
            if(true)
                updateStateFn.accept(channel, transformBrickletCO2V2AirPressureGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletCO2V2Config cfg = (BrickletCO2V2Config) config.as(BrickletCO2V2Config.class);
        switch(channel) {
            case "BrickletCO2V2AirPressure":
                if (command instanceof Number) {
                    BrickletCO2V2AirPressureConfig channelCfg = channelConfig.as(BrickletCO2V2AirPressureConfig.class);
                    Number cmd = (Number) command;
                    this.setAirPressure((int)Math.round(cmd.doubleValue() * 1000.0));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletCO2V2CO2ConcentrationCallback0(int co2Concentration, BrickletCO2V2Config cfg) {
        return new QuantityType<>(co2Concentration, SmartHomeUnits.PARTS_PER_MILLION);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCO2V2TemperatureCallback0(int temperature, BrickletCO2V2Config cfg) {
        return new QuantityType<>(temperature / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCO2V2HumidityCallback0(int humidity, BrickletCO2V2Config cfg) {
        return new QuantityType<>(humidity / 100.0, SmartHomeUnits.PERCENT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCO2V2CO2ConcentrationGetter0(int value, BrickletCO2V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.PARTS_PER_MILLION);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCO2V2TemperatureGetter0(int value, BrickletCO2V2Config cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCO2V2HumidityGetter0(int value, BrickletCO2V2Config cfg) {
        return new QuantityType<>(value / 100.0, SmartHomeUnits.PERCENT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCO2V2AirPressureGetter0(int value, BrickletCO2V2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.BAR);
    }

}