/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletCO2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletCO2Wrapper extends DeviceWrapper implements StandardFlashable{
    BrickletCO2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletCO2.DEVICE_DISPLAY_NAME, "brickletco2", BrickletCO2.DEVICE_IDENTIFIER, BrickletCO2Wrapper.class, BrickletCO2Actions.class, "2.0.0", false);

    public BrickletCO2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletCO2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';


    public int getCO2Concentration() throws TinkerforgeException {
    return this.dev.getCO2Concentration();
}

public void setCO2ConcentrationCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setCO2ConcentrationCallbackPeriod(period);
}

public long getCO2ConcentrationCallbackPeriod() throws TinkerforgeException {
    return this.dev.getCO2ConcentrationCallbackPeriod();
}

public void setCO2ConcentrationCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setCO2ConcentrationCallbackThreshold(option, min, max);
}

public BrickletCO2.CO2ConcentrationCallbackThreshold getCO2ConcentrationCallbackThreshold() throws TinkerforgeException {
    return this.dev.getCO2ConcentrationCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public BrickletCO2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addCO2ConcentrationListener(BrickletCO2.CO2ConcentrationListener l) {
    this.dev.addCO2ConcentrationListener(l);
}

public void removeCO2ConcentrationListener(BrickletCO2.CO2ConcentrationListener l) {
    this.dev.removeCO2ConcentrationListener(l);
}

public void addCO2ConcentrationReachedListener(BrickletCO2.CO2ConcentrationReachedListener l) {
    this.dev.addCO2ConcentrationReachedListener(l);
}

public void removeCO2ConcentrationReachedListener(BrickletCO2.CO2ConcentrationReachedListener l) {
    this.dev.removeCO2ConcentrationReachedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletCO2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletCO2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletCO2Config cfg = (BrickletCO2Config) config.as(BrickletCO2Config.class);
        this.addCO2ConcentrationListener(this.reg((co2Concentration) -> {if(true) {updateStateFn.accept("BrickletCO2CO2Concentration", transformBrickletCO2CO2ConcentrationCallback0(co2Concentration, cfg));}}, this.dev::removeCO2ConcentrationListener));
        
		{
		BrickletCO2CO2ConcentrationConfig channelCfg = getChannelConfigFn.apply("BrickletCO2CO2Concentration").as(BrickletCO2CO2ConcentrationConfig.class);
		this.setCO2ConcentrationCallbackPeriod(channelCfg.updateInterval);
		this.setCO2ConcentrationCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletCO2Config cfg = (BrickletCO2Config) config.as(BrickletCO2Config.class);
        this.setCO2ConcentrationCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletCO2Config cfg = (BrickletCO2Config) config.as(BrickletCO2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletCO2CO2Concentration");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletCO2CO2Concentration":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletCO2CO2Concentration"), "CO2 Concentration", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletCO2CO2Concentration")).withDescription("The measured CO2 concentration.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(10000)).withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge CO2 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures CO2 concentration in ppm").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletCO2CO2Concentration", new ChannelTypeUID("tinkerforge", "BrickletCO2CO2Concentration")).withLabel("CO2 Concentration").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletco2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletCO2CO2Concentration":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletCO2Config cfg = (BrickletCO2Config) config.as(BrickletCO2Config.class);
        switch(channel) {
            case "BrickletCO2CO2Concentration": {
                   BrickletCO2CO2ConcentrationConfig channelCfg = channelConfig.as(BrickletCO2CO2ConcentrationConfig.class);
                   {
            int value = this.getCO2Concentration();
            if(true)
                updateStateFn.accept(channel, transformBrickletCO2CO2ConcentrationGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletCO2Config cfg = (BrickletCO2Config) config.as(BrickletCO2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletCO2CO2ConcentrationCallback0(int co2Concentration, BrickletCO2Config cfg) {
        return new QuantityType<>(co2Concentration, SmartHomeUnits.PARTS_PER_MILLION);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCO2CO2ConcentrationGetter0(int value, BrickletCO2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.PARTS_PER_MILLION);
    }

}