/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.HSBType;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletColor;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletColorWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletColor dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletColor.DEVICE_DISPLAY_NAME, "brickletcolor", BrickletColor.DEVICE_IDENTIFIER, BrickletColorWrapper.class, BrickletColorActions.class, "2.0.0", false);

    public BrickletColorWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletColor(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int LIGHT_ON = 0;
	public final static int LIGHT_OFF = 1;
	public final static int GAIN_1X = 0;
	public final static int GAIN_4X = 1;
	public final static int GAIN_16X = 2;
	public final static int GAIN_60X = 3;
	public final static int INTEGRATION_TIME_2MS = 0;
	public final static int INTEGRATION_TIME_24MS = 1;
	public final static int INTEGRATION_TIME_101MS = 2;
	public final static int INTEGRATION_TIME_154MS = 3;
	public final static int INTEGRATION_TIME_700MS = 4;


    public BrickletColor.Color getColor() throws TinkerforgeException {
    return this.dev.getColor();
}

public void setColorCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setColorCallbackPeriod(period);
}

public long getColorCallbackPeriod() throws TinkerforgeException {
    return this.dev.getColorCallbackPeriod();
}

public void setColorCallbackThreshold(char option, int minR, int maxR, int minG, int maxG, int minB, int maxB, int minC, int maxC) throws TinkerforgeException {
    this.dev.setColorCallbackThreshold(option, minR, maxR, minG, maxG, minB, maxB, minC, maxC);
}

public BrickletColor.ColorCallbackThreshold getColorCallbackThreshold() throws TinkerforgeException {
    return this.dev.getColorCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public void lightOn() throws TinkerforgeException {
    this.dev.lightOn();
}

public void lightOff() throws TinkerforgeException {
    this.dev.lightOff();
}

public int isLightOn() throws TinkerforgeException {
    return this.dev.isLightOn();
}

public void setConfig(int gain, int integrationTime) throws TinkerforgeException {
    this.dev.setConfig(gain, integrationTime);
}

public BrickletColor.Config getConfig() throws TinkerforgeException {
    return this.dev.getConfig();
}

public long getIlluminance() throws TinkerforgeException {
    return this.dev.getIlluminance();
}

public int getColorTemperature() throws TinkerforgeException {
    return this.dev.getColorTemperature();
}

public void setIlluminanceCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setIlluminanceCallbackPeriod(period);
}

public long getIlluminanceCallbackPeriod() throws TinkerforgeException {
    return this.dev.getIlluminanceCallbackPeriod();
}

public void setColorTemperatureCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setColorTemperatureCallbackPeriod(period);
}

public long getColorTemperatureCallbackPeriod() throws TinkerforgeException {
    return this.dev.getColorTemperatureCallbackPeriod();
}

public BrickletColor.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addColorListener(BrickletColor.ColorListener l) {
    this.dev.addColorListener(l);
}

public void removeColorListener(BrickletColor.ColorListener l) {
    this.dev.removeColorListener(l);
}

public void addColorReachedListener(BrickletColor.ColorReachedListener l) {
    this.dev.addColorReachedListener(l);
}

public void removeColorReachedListener(BrickletColor.ColorReachedListener l) {
    this.dev.removeColorReachedListener(l);
}

public void addIlluminanceListener(BrickletColor.IlluminanceListener l) {
    this.dev.addIlluminanceListener(l);
}

public void removeIlluminanceListener(BrickletColor.IlluminanceListener l) {
    this.dev.removeIlluminanceListener(l);
}

public void addColorTemperatureListener(BrickletColor.ColorTemperatureListener l) {
    this.dev.addColorTemperatureListener(l);
}

public void removeColorTemperatureListener(BrickletColor.ColorTemperatureListener l) {
    this.dev.removeColorTemperatureListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletColorWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletColorWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletColorConfig cfg = (BrickletColorConfig) config.as(BrickletColorConfig.class);
        this.addColorListener(this.reg((r, g, b, c) -> {if(true) {updateStateFn.accept("BrickletColorColor", transformBrickletColorColorCallback0(r, g, b, c, cfg));}}, this.dev::removeColorListener));
		this.addIlluminanceListener(this.reg((illuminance) -> {if(true) {updateStateFn.accept("BrickletColorIlluminance", transformBrickletColorIlluminanceCallback0(illuminance, cfg));}}, this.dev::removeIlluminanceListener));
		this.addColorTemperatureListener(this.reg((colorTemperature) -> {if(true) {updateStateFn.accept("BrickletColorColorTemperature", transformBrickletColorColorTemperatureCallback0(colorTemperature, cfg));}}, this.dev::removeColorTemperatureListener));
        this.setConfig(cfg.gain, cfg.integrationTime);
		{
		BrickletColorColorConfig channelCfg = getChannelConfigFn.apply("BrickletColorColor").as(BrickletColorColorConfig.class);
		this.setColorCallbackPeriod(channelCfg.updateInterval);
		}
		{
		BrickletColorIlluminanceConfig channelCfg = getChannelConfigFn.apply("BrickletColorIlluminance").as(BrickletColorIlluminanceConfig.class);
		this.setIlluminanceCallbackPeriod(channelCfg.updateInterval);
		}
		{
		BrickletColorColorTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletColorColorTemperature").as(BrickletColorColorTemperatureConfig.class);
		this.setColorTemperatureCallbackPeriod(channelCfg.updateInterval);
		}
		{
		BrickletColorLightConfig channelCfg = getChannelConfigFn.apply("BrickletColorLight").as(BrickletColorLightConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletColorConfig cfg = (BrickletColorConfig) config.as(BrickletColorConfig.class);
        this.setColorCallbackPeriod(0);
		this.setIlluminanceCallbackPeriod(0);
		this.setColorTemperatureCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletColorConfig cfg = (BrickletColorConfig) config.as(BrickletColorConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletColorColor");
		result.add("BrickletColorIlluminance");
		result.add("BrickletColorColorTemperature");
		result.add("BrickletColorLight");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletColorColor":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletColorColor"), "Color", "Color").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletColorColor")).withDescription("Measured color")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletColorIlluminance":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletColorIlluminance"), "Illuminance", "Number:Illuminance").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletColorIlluminance")).withDescription("Measured illuminance. To get a correct illuminance measurement make sure that the color values themself are not saturated. The color value (R, G or B) is saturated if it is equal to the maximum value of 255. In that case you have to reduce the gain.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletColorColorTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletColorColorTemperature"), "Color Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletColorColorTemperature")).withDescription("To get a correct color temperature measurement make sure that the color values themself are not saturated. The color value (R, G or B) is saturated if it is equal to the maximum value of 255. In that case you have to reduce the gain.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletColorLight":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletColorLight"), "Enable Light", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletColorLight")).withDescription("Turns the white LED on the Bricklet on/off.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Color Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures color (RGB value), illuminance and color temperature").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletColorColor", new ChannelTypeUID("tinkerforge", "BrickletColorColor")).withLabel("Color").build(), new ChannelDefinitionBuilder("BrickletColorIlluminance", new ChannelTypeUID("tinkerforge", "BrickletColorIlluminance")).withLabel("Illuminance").build(), new ChannelDefinitionBuilder("BrickletColorColorTemperature", new ChannelTypeUID("tinkerforge", "BrickletColorColorTemperature")).withLabel("Color Temperature").build(), new ChannelDefinitionBuilder("BrickletColorLight", new ChannelTypeUID("tinkerforge", "BrickletColorLight")).withLabel("Enable Light").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletcolor":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("gain", Type.INTEGER).withDefault("3").withDescription("Increasing the gain enables the sensor to detect a color from a higher distance.").withLabel("Gain").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "1x"), new ParameterOption("1", "4x"), new ParameterOption("2", "16x"), new ParameterOption("3", "60x"))).build(), ConfigDescriptionParameterBuilder.create("integrationTime", Type.INTEGER).withDefault("3").withDescription("The integration time provides a trade-off between conversion time and accuracy. With a longer integration time the values read will be more accurate but it will take longer time to get the conversion results.").withLabel("Integration Time").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "2ms"), new ParameterOption("1", "24ms"), new ParameterOption("2", "101ms"), new ParameterOption("3", "154ms"), new ParameterOption("4", "700ms"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletColorColor":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletColorIlluminance":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletColorColorTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletColorLight":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletColorConfig cfg = (BrickletColorConfig) config.as(BrickletColorConfig.class);
        switch(channel) {
            case "BrickletColorColor": {
                   BrickletColorColorConfig channelCfg = channelConfig.as(BrickletColorColorConfig.class);
                   {
            BrickletColor.Color value = this.getColor();
            if(true)
                updateStateFn.accept(channel, transformBrickletColorColorGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletColorIlluminance": {
                   BrickletColorIlluminanceConfig channelCfg = channelConfig.as(BrickletColorIlluminanceConfig.class);
                   {
            long value = this.getIlluminance();
            if(true)
                updateStateFn.accept(channel, transformBrickletColorIlluminanceGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletColorColorTemperature": {
                   BrickletColorColorTemperatureConfig channelCfg = channelConfig.as(BrickletColorColorTemperatureConfig.class);
                   {
            int value = this.getColorTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletColorColorTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletColorLight": {
                   BrickletColorLightConfig channelCfg = channelConfig.as(BrickletColorLightConfig.class);
                   {
            int value = this.isLightOn();
            if(true)
                updateStateFn.accept(channel, transformBrickletColorLightGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletColorConfig cfg = (BrickletColorConfig) config.as(BrickletColorConfig.class);
        switch(channel) {
            case "BrickletColorLight":
                if (command instanceof OnOffType) {
                    BrickletColorLightConfig channelCfg = channelConfig.as(BrickletColorLightConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    if(cmd == OnOffType.ON) {
    this.lightOn();
}
                }
        
if (command instanceof OnOffType) {
                    BrickletColorLightConfig channelCfg = channelConfig.as(BrickletColorLightConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    if(cmd == OnOffType.OFF) {
    this.lightOff();
}
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType, OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletColorColorCallback0(int r, int g, int b, int c, BrickletColorConfig cfg) {
        return HSBType.fromRGB(r * 255 / 65535, g * 255 / 65535, b * 255 / 65535);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorIlluminanceCallback0(long illuminance, BrickletColorConfig cfg) {
        return new QuantityType<>(illuminance / cfg.gain * cfg.integrationTime / 700.0, SmartHomeUnits.LUX);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorColorTemperatureCallback0(int colorTemperature, BrickletColorConfig cfg) {
        return new QuantityType<>(colorTemperature, SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorColorGetter0(BrickletColor.Color value, BrickletColorConfig cfg) {
        return HSBType.fromRGB(value.r * 255 / 65535, value.g * 255 / 65535, value.b * 255 / 65535);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorIlluminanceGetter0(long value, BrickletColorConfig cfg) {
        return new QuantityType<>(value / cfg.gain * cfg.integrationTime / 700.0, SmartHomeUnits.LUX);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorColorTemperatureGetter0(int value, BrickletColorConfig cfg) {
        return new QuantityType<>(value, SmartHomeUnits.KELVIN);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletColorLightGetter0(int value, BrickletColorConfig cfg) {
        return value == 0 ? OnOffType.ON : OnOffType.OFF;
    }

}