/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletCompass;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletCompassWrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletCompass dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletCompass.DEVICE_DISPLAY_NAME, "brickletcompass", BrickletCompass.DEVICE_IDENTIFIER, BrickletCompassWrapper.class, BrickletCompassActions.class, "2.0.0", true);

    public BrickletCompassWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletCompass(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int DATA_RATE_100HZ = 0;
	public final static int DATA_RATE_200HZ = 1;
	public final static int DATA_RATE_400HZ = 2;
	public final static int DATA_RATE_600HZ = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getHeading() throws TinkerforgeException {
    return this.dev.getHeading();
}

public void setHeadingCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setHeadingCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletCompass.HeadingCallbackConfiguration getHeadingCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getHeadingCallbackConfiguration();
}

public BrickletCompass.MagneticFluxDensity getMagneticFluxDensity() throws TinkerforgeException {
    return this.dev.getMagneticFluxDensity();
}

public void setMagneticFluxDensityCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setMagneticFluxDensityCallbackConfiguration(period, valueHasToChange);
}

public BrickletCompass.MagneticFluxDensityCallbackConfiguration getMagneticFluxDensityCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getMagneticFluxDensityCallbackConfiguration();
}

public void setConfiguration(int dataRate, boolean backgroundCalibration) throws TinkerforgeException {
    this.dev.setConfiguration(dataRate, backgroundCalibration);
}

public BrickletCompass.Configuration getConfiguration() throws TinkerforgeException {
    return this.dev.getConfiguration();
}

public void setCalibration(int[] offset, int[] gain) throws TinkerforgeException {
    this.dev.setCalibration(offset, gain);
}

public BrickletCompass.Calibration getCalibration() throws TinkerforgeException {
    return this.dev.getCalibration();
}

public BrickletCompass.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletCompass.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addHeadingListener(BrickletCompass.HeadingListener l) {
    this.dev.addHeadingListener(l);
}

public void removeHeadingListener(BrickletCompass.HeadingListener l) {
    this.dev.removeHeadingListener(l);
}

public void addMagneticFluxDensityListener(BrickletCompass.MagneticFluxDensityListener l) {
    this.dev.addMagneticFluxDensityListener(l);
}

public void removeMagneticFluxDensityListener(BrickletCompass.MagneticFluxDensityListener l) {
    this.dev.removeMagneticFluxDensityListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletCompassWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletCompassWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletCompassConfig cfg = (BrickletCompassConfig) config.as(BrickletCompassConfig.class);
        this.addHeadingListener(this.reg((heading) -> {if(true) {updateStateFn.accept("BrickletCompassHeading", transformBrickletCompassHeadingCallback0(heading, cfg));}}, this.dev::removeHeadingListener));
        this.setConfiguration(cfg.dataRate, cfg.backgroundCalibration);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletCompassHeadingConfig channelCfg = getChannelConfigFn.apply("BrickletCompassHeading").as(BrickletCompassHeadingConfig.class);
		this.setHeadingCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletCompassConfig cfg = (BrickletCompassConfig) config.as(BrickletCompassConfig.class);
        this.setHeadingCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletCompassConfig cfg = (BrickletCompassConfig) config.as(BrickletCompassConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletCompassHeading");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletCompassHeading":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletCompassHeading"), "Heading", "Number:Angle").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletCompassHeading")).withDescription("The heading (north = 0 degree)")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(360)).withPattern("%.1f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Compass Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("3-axis compass with 10 nanotesla and 0.1° resolution").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletCompassHeading", new ChannelTypeUID("tinkerforge", "BrickletCompassHeading")).withLabel("Heading").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletcompass":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("dataRate", Type.INTEGER).withDefault("0").withDescription("The data rate that is used by the magnetometer. The lower the data rate, the lower is the noise on the data.").withLabel("Data Rate").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "100Hz"), new ParameterOption("1", "200Hz"), new ParameterOption("2", "400Hz"), new ParameterOption("3", "600Hz"))).build(), ConfigDescriptionParameterBuilder.create("backgroundCalibration", Type.BOOLEAN).withDefault("true").withDescription("If the background calibration is enabled the sensing polarity is flipped once per second to automatically calculate and remove offset that is caused by temperature changes. This polarity flipping takes about 20ms. This means that once a second you will not get new data for a period of 20ms. We highly recommend that you keep the background calibration enabled and only disable it if the 20ms off-time is a problem in you application.").withLabel("Enable Background Calibration").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletCompassHeading":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletCompassConfig cfg = (BrickletCompassConfig) config.as(BrickletCompassConfig.class);
        switch(channel) {
            case "BrickletCompassHeading": {
                   BrickletCompassHeadingConfig channelCfg = channelConfig.as(BrickletCompassHeadingConfig.class);
                   {
            int value = this.getHeading();
            if(true)
                updateStateFn.accept(channel, transformBrickletCompassHeadingGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletCompassConfig cfg = (BrickletCompassConfig) config.as(BrickletCompassConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletCompassHeadingCallback0(int heading, BrickletCompassConfig cfg) {
        return new QuantityType<>(heading / 10.0, SmartHomeUnits.DEGREE_ANGLE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCompassHeadingGetter0(int value, BrickletCompassConfig cfg) {
        return new QuantityType<>(value / 10.0, SmartHomeUnits.DEGREE_ANGLE);
    }

}