/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletCurrent25;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletCurrent25Wrapper extends DeviceWrapper implements StandardFlashable{
    BrickletCurrent25 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletCurrent25.DEVICE_DISPLAY_NAME, "brickletcurrent25", BrickletCurrent25.DEVICE_IDENTIFIER, BrickletCurrent25Wrapper.class, BrickletCurrent25Actions.class, "2.0.0", false);

    public BrickletCurrent25Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletCurrent25(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';


    public int getCurrent() throws TinkerforgeException {
    return this.dev.getCurrent();
}

public void calibrate() throws TinkerforgeException {
    this.dev.calibrate();
}

public boolean isOverCurrent() throws TinkerforgeException {
    return this.dev.isOverCurrent();
}

public int getAnalogValue() throws TinkerforgeException {
    return this.dev.getAnalogValue();
}

public void setCurrentCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setCurrentCallbackPeriod(period);
}

public long getCurrentCallbackPeriod() throws TinkerforgeException {
    return this.dev.getCurrentCallbackPeriod();
}

public void setAnalogValueCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setAnalogValueCallbackPeriod(period);
}

public long getAnalogValueCallbackPeriod() throws TinkerforgeException {
    return this.dev.getAnalogValueCallbackPeriod();
}

public void setCurrentCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setCurrentCallbackThreshold(option, min, max);
}

public BrickletCurrent25.CurrentCallbackThreshold getCurrentCallbackThreshold() throws TinkerforgeException {
    return this.dev.getCurrentCallbackThreshold();
}

public void setAnalogValueCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setAnalogValueCallbackThreshold(option, min, max);
}

public BrickletCurrent25.AnalogValueCallbackThreshold getAnalogValueCallbackThreshold() throws TinkerforgeException {
    return this.dev.getAnalogValueCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public BrickletCurrent25.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addCurrentListener(BrickletCurrent25.CurrentListener l) {
    this.dev.addCurrentListener(l);
}

public void removeCurrentListener(BrickletCurrent25.CurrentListener l) {
    this.dev.removeCurrentListener(l);
}

public void addAnalogValueListener(BrickletCurrent25.AnalogValueListener l) {
    this.dev.addAnalogValueListener(l);
}

public void removeAnalogValueListener(BrickletCurrent25.AnalogValueListener l) {
    this.dev.removeAnalogValueListener(l);
}

public void addCurrentReachedListener(BrickletCurrent25.CurrentReachedListener l) {
    this.dev.addCurrentReachedListener(l);
}

public void removeCurrentReachedListener(BrickletCurrent25.CurrentReachedListener l) {
    this.dev.removeCurrentReachedListener(l);
}

public void addAnalogValueReachedListener(BrickletCurrent25.AnalogValueReachedListener l) {
    this.dev.addAnalogValueReachedListener(l);
}

public void removeAnalogValueReachedListener(BrickletCurrent25.AnalogValueReachedListener l) {
    this.dev.removeAnalogValueReachedListener(l);
}

public void addOverCurrentListener(BrickletCurrent25.OverCurrentListener l) {
    this.dev.addOverCurrentListener(l);
}

public void removeOverCurrentListener(BrickletCurrent25.OverCurrentListener l) {
    this.dev.removeOverCurrentListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletCurrent25Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletCurrent25Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletCurrent25Config cfg = (BrickletCurrent25Config) config.as(BrickletCurrent25Config.class);
        this.addCurrentListener(this.reg((current) -> {if(true) {updateStateFn.accept("BrickletCurrent25Current", transformBrickletCurrent25CurrentCallback0(current, cfg));}}, this.dev::removeCurrentListener));
		this.addOverCurrentListener(this.reg(() -> {if(true) {updateStateFn.accept("BrickletCurrent25OverCurrent", transformBrickletCurrent25OverCurrentCallback0(cfg));}}, this.dev::removeOverCurrentListener));
        
		{
		BrickletCurrent25CurrentConfig channelCfg = getChannelConfigFn.apply("BrickletCurrent25Current").as(BrickletCurrent25CurrentConfig.class);
		this.setCurrentCallbackPeriod(channelCfg.updateInterval);
		this.setCurrentCallbackThreshold('x', 0, 0);
		}
		{
		BrickletCurrent25OverCurrentConfig channelCfg = getChannelConfigFn.apply("BrickletCurrent25OverCurrent").as(BrickletCurrent25OverCurrentConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletCurrent25Config cfg = (BrickletCurrent25Config) config.as(BrickletCurrent25Config.class);
        this.setCurrentCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletCurrent25Config cfg = (BrickletCurrent25Config) config.as(BrickletCurrent25Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletCurrent25Current");
		result.add("BrickletCurrent25OverCurrent");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletCurrent25Current":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletCurrent25Current"), "Current", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletCurrent25Current")).withDescription("The current of the sensor.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-25)).withMaximum(BigDecimal.valueOf(25)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletCurrent25OverCurrent":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletCurrent25OverCurrent"), "Over Current", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletCurrent25OverCurrent")).withDescription("Enabled if more than 25A were measured. To reset this value you have to power cycle the Bricklet.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Current25 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures AC/DC current between -25A and +25A").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletCurrent25Current", new ChannelTypeUID("tinkerforge", "BrickletCurrent25Current")).withLabel("Current").build(), new ChannelDefinitionBuilder("BrickletCurrent25OverCurrent", new ChannelTypeUID("tinkerforge", "BrickletCurrent25OverCurrent")).withLabel("Over Current").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletcurrent25":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletCurrent25Current":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletCurrent25OverCurrent":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletCurrent25Config cfg = (BrickletCurrent25Config) config.as(BrickletCurrent25Config.class);
        switch(channel) {
            case "BrickletCurrent25Current": {
                   BrickletCurrent25CurrentConfig channelCfg = channelConfig.as(BrickletCurrent25CurrentConfig.class);
                   {
            int value = this.getCurrent();
            if(true)
                updateStateFn.accept(channel, transformBrickletCurrent25CurrentGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletCurrent25OverCurrent": {
                   BrickletCurrent25OverCurrentConfig channelCfg = channelConfig.as(BrickletCurrent25OverCurrentConfig.class);
                   {
            boolean value = this.isOverCurrent();
            if(true)
                updateStateFn.accept(channel, transformBrickletCurrent25OverCurrentGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletCurrent25Config cfg = (BrickletCurrent25Config) config.as(BrickletCurrent25Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletCurrent25CurrentCallback0(int current, BrickletCurrent25Config cfg) {
        return new QuantityType<>(current / 1000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCurrent25OverCurrentCallback0(BrickletCurrent25Config cfg) {
        return OnOffType.ON;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCurrent25CurrentGetter0(int value, BrickletCurrent25Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCurrent25OverCurrentGetter0(boolean value, BrickletCurrent25Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }

}