/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.DecimalType;

import com.tinkerforge.BrickletDMX;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletDMXWrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletDMX dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletDMX.DEVICE_DISPLAY_NAME, "brickletdmx", BrickletDMX.DEVICE_IDENTIFIER, BrickletDMXWrapper.class, BrickletDMXActions.class, "2.0.0", true);

    public BrickletDMXWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletDMX(uid, ipcon);
    }

    
	public final static int DMX_MODE_MASTER = 0;
	public final static int DMX_MODE_SLAVE = 1;
	public final static int COMMUNICATION_LED_CONFIG_OFF = 0;
	public final static int COMMUNICATION_LED_CONFIG_ON = 1;
	public final static int COMMUNICATION_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int COMMUNICATION_LED_CONFIG_SHOW_COMMUNICATION = 3;
	public final static int ERROR_LED_CONFIG_OFF = 0;
	public final static int ERROR_LED_CONFIG_ON = 1;
	public final static int ERROR_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int ERROR_LED_CONFIG_SHOW_ERROR = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setDMXMode(int dmxMode) throws TinkerforgeException {
    this.dev.setDMXMode(dmxMode);
}

public int getDMXMode() throws TinkerforgeException {
    return this.dev.getDMXMode();
}

public void writeFrame(int[] frame) throws TinkerforgeException {
    this.dev.writeFrame(frame);
}

public BrickletDMX.ReadFrame readFrame() throws TinkerforgeException {
    return this.dev.readFrame();
}

public void setFrameDuration(int frameDuration) throws TinkerforgeException {
    this.dev.setFrameDuration(frameDuration);
}

public int getFrameDuration() throws TinkerforgeException {
    return this.dev.getFrameDuration();
}

public BrickletDMX.FrameErrorCount getFrameErrorCount() throws TinkerforgeException {
    return this.dev.getFrameErrorCount();
}

public void setCommunicationLEDConfig(int config) throws TinkerforgeException {
    this.dev.setCommunicationLEDConfig(config);
}

public int getCommunicationLEDConfig() throws TinkerforgeException {
    return this.dev.getCommunicationLEDConfig();
}

public void setErrorLEDConfig(int config) throws TinkerforgeException {
    this.dev.setErrorLEDConfig(config);
}

public int getErrorLEDConfig() throws TinkerforgeException {
    return this.dev.getErrorLEDConfig();
}

public void setFrameCallbackConfig(boolean frameStartedCallbackEnabled, boolean frameAvailableCallbackEnabled, boolean frameCallbackEnabled, boolean frameErrorCountCallbackEnabled) throws TinkerforgeException {
    this.dev.setFrameCallbackConfig(frameStartedCallbackEnabled, frameAvailableCallbackEnabled, frameCallbackEnabled, frameErrorCountCallbackEnabled);
}

public BrickletDMX.FrameCallbackConfig getFrameCallbackConfig() throws TinkerforgeException {
    return this.dev.getFrameCallbackConfig();
}

public BrickletDMX.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletDMX.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addFrameStartedListener(BrickletDMX.FrameStartedListener l) {
    this.dev.addFrameStartedListener(l);
}

public void removeFrameStartedListener(BrickletDMX.FrameStartedListener l) {
    this.dev.removeFrameStartedListener(l);
}

public void addFrameAvailableListener(BrickletDMX.FrameAvailableListener l) {
    this.dev.addFrameAvailableListener(l);
}

public void removeFrameAvailableListener(BrickletDMX.FrameAvailableListener l) {
    this.dev.removeFrameAvailableListener(l);
}

public void addFrameListener(BrickletDMX.FrameListener l) {
    this.dev.addFrameListener(l);
}

public void removeFrameListener(BrickletDMX.FrameListener l) {
    this.dev.removeFrameListener(l);
}

public void addFrameErrorCountListener(BrickletDMX.FrameErrorCountListener l) {
    this.dev.addFrameErrorCountListener(l);
}

public void removeFrameErrorCountListener(BrickletDMX.FrameErrorCountListener l) {
    this.dev.removeFrameErrorCountListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletDMXWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletDMXWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletDMXConfig cfg = (BrickletDMXConfig) config.as(BrickletDMXConfig.class);
        this.addFrameStartedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletDMXFrameStarted", transformBrickletDMXFrameStartedCallback0(cfg));}}, this.dev::removeFrameStartedListener));
		this.addFrameAvailableListener(this.reg((frameNumber) -> {if(true) {triggerChannelFn.accept("BrickletDMXFrameAvailable", transformBrickletDMXFrameAvailableCallback0(frameNumber, cfg));}}, this.dev::removeFrameAvailableListener));
		this.addFrameErrorCountListener(this.reg((overrunErrorCount, framingErrorCount) -> {if(true) {updateStateFn.accept("BrickletDMXOverrunErrorCount", transformBrickletDMXOverrunErrorCountCallback0(overrunErrorCount, framingErrorCount, cfg));}}, this.dev::removeFrameErrorCountListener));
		this.addFrameErrorCountListener(this.reg((overrunErrorCount, framingErrorCount) -> {if(true) {updateStateFn.accept("BrickletDMXFramingErrorCount", transformBrickletDMXFramingErrorCountCallback0(overrunErrorCount, framingErrorCount, cfg));}}, this.dev::removeFrameErrorCountListener));
        this.setDMXMode(cfg.dmxMode);
		        this.setCommunicationLEDConfig(cfg.communicationLEDConfig);
		        this.setErrorLEDConfig(cfg.errorLEDConfig);
		        this.setFrameDuration(cfg.frameDuration);
		        this.setFrameCallbackConfig(true, true, false, true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		
		}
		{
		
		}
		{
		BrickletDMXOverrunErrorCountConfig channelCfg = getChannelConfigFn.apply("BrickletDMXOverrunErrorCount").as(BrickletDMXOverrunErrorCountConfig.class);
		
		}
		{
		BrickletDMXFramingErrorCountConfig channelCfg = getChannelConfigFn.apply("BrickletDMXFramingErrorCount").as(BrickletDMXFramingErrorCountConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletDMXConfig cfg = (BrickletDMXConfig) config.as(BrickletDMXConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletDMXConfig cfg = (BrickletDMXConfig) config.as(BrickletDMXConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletDMXFrameStarted");
		result.add("BrickletDMXFrameAvailable");
		result.add("BrickletDMXOverrunErrorCount");
		result.add("BrickletDMXFramingErrorCount");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletDMXOverrunErrorCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletDMXOverrunErrorCount"), "Overrun Error Count", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletDMXOverrunErrorCount")).withDescription("The current number of overrun errors")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletDMXFramingErrorCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletDMXFramingErrorCount"), "Framing Error Count", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletDMXFramingErrorCount")).withDescription("The current number of framing errors")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge DMX Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("DMX master and slave").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletDMXFrameStarted", new ChannelTypeUID("system", "trigger")).withLabel("Frame Started").build(), new ChannelDefinitionBuilder("BrickletDMXFrameAvailable", new ChannelTypeUID("system", "trigger")).withLabel("Frame Available").build(), new ChannelDefinitionBuilder("BrickletDMXOverrunErrorCount", new ChannelTypeUID("tinkerforge", "BrickletDMXOverrunErrorCount")).withLabel("Overrun Error Count").build(), new ChannelDefinitionBuilder("BrickletDMXFramingErrorCount", new ChannelTypeUID("tinkerforge", "BrickletDMXFramingErrorCount")).withLabel("Framing Error Count").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletdmx":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("dmxMode", Type.INTEGER).withDefault("0").withDescription("Sets the DMX mode to either master or slave.").withLabel("DMX Mode").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Master"), new ParameterOption("1", "Slave"))).build(), ConfigDescriptionParameterBuilder.create("communicationLEDConfig", Type.INTEGER).withDefault("3").withDescription("By default the LED shows communication traffic, it flickers once for every 10 received data packets. You can also turn the LED permanently on/off or show a heartbeat. If the Bricklet is in bootloader mode, the LED is off.").withLabel("Communication LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Communication"))).build(), ConfigDescriptionParameterBuilder.create("errorLEDConfig", Type.INTEGER).withDefault("3").withDescription("By default the error LED turns on if there is any error (see FrameErrorCountListener callback). If you call this function with the Show-Error option again, the LED will turn off until the next error occurs. You can also turn the LED permanently on/off or show a heartbeat. If the Bricklet is in bootloader mode, the LED is off.").withLabel("Error LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Error"))).build(), ConfigDescriptionParameterBuilder.create("frameDuration", Type.INTEGER).withDefault("100").withDescription("the duration of a frame in ms. Example: If you want to achieve 20 frames per second, you should set the frame duration to 50ms (50ms * 20 = 1 second). If you always want to send a frame as fast as possible you can set this value to 0. This setting is only used in master mode.").withLabel("Frame Duration").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletDMXOverrunErrorCount":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletDMXFramingErrorCount":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletDMXConfig cfg = (BrickletDMXConfig) config.as(BrickletDMXConfig.class);
        switch(channel) {
            case "BrickletDMXFrameStarted":
               return;
            case "BrickletDMXFrameAvailable":
               return;
            case "BrickletDMXOverrunErrorCount": {
                   BrickletDMXOverrunErrorCountConfig channelCfg = channelConfig.as(BrickletDMXOverrunErrorCountConfig.class);
                   {
            BrickletDMX.FrameErrorCount value = this.getFrameErrorCount();
            if(true)
                updateStateFn.accept(channel, transformBrickletDMXOverrunErrorCountGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletDMXFramingErrorCount": {
                   BrickletDMXFramingErrorCountConfig channelCfg = channelConfig.as(BrickletDMXFramingErrorCountConfig.class);
                   {
            BrickletDMX.FrameErrorCount value = this.getFrameErrorCount();
            if(true)
                updateStateFn.accept(channel, transformBrickletDMXFramingErrorCountGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletDMXConfig cfg = (BrickletDMXConfig) config.as(BrickletDMXConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletDMXFrameStartedCallback0(BrickletDMXConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickletDMXFrameAvailableCallback0(long frameNumber, BrickletDMXConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletDMXOverrunErrorCountCallback0(long overrunErrorCount, long framingErrorCount, BrickletDMXConfig cfg) {
        return new DecimalType(overrunErrorCount);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletDMXFramingErrorCountCallback0(long overrunErrorCount, long framingErrorCount, BrickletDMXConfig cfg) {
        return new DecimalType(framingErrorCount);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletDMXOverrunErrorCountGetter0(BrickletDMX.FrameErrorCount value, BrickletDMXConfig cfg) {
        return new DecimalType(value.overrunErrorCount);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletDMXFramingErrorCountGetter0(BrickletDMX.FrameErrorCount value, BrickletDMXConfig cfg) {
        return new DecimalType(value.framingErrorCount);
    }

}