/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletDistanceIRV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletDistanceIRV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletDistanceIRV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletDistanceIRV2.DEVICE_DISPLAY_NAME, "brickletdistanceirv2", BrickletDistanceIRV2.DEVICE_IDENTIFIER, BrickletDistanceIRV2Wrapper.class, BrickletDistanceIRV2Actions.class, "2.0.0", true);

    public BrickletDistanceIRV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletDistanceIRV2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int DISTANCE_LED_CONFIG_OFF = 0;
	public final static int DISTANCE_LED_CONFIG_ON = 1;
	public final static int DISTANCE_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int DISTANCE_LED_CONFIG_SHOW_DISTANCE = 3;
	public final static int SENSOR_TYPE_2Y0A41 = 0;
	public final static int SENSOR_TYPE_2Y0A21 = 1;
	public final static int SENSOR_TYPE_2Y0A02 = 2;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getDistance() throws TinkerforgeException {
    return this.dev.getDistance();
}

public void setDistanceCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setDistanceCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletDistanceIRV2.DistanceCallbackConfiguration getDistanceCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getDistanceCallbackConfiguration();
}

public long getAnalogValue() throws TinkerforgeException {
    return this.dev.getAnalogValue();
}

public void setAnalogValueCallbackConfiguration(long period, boolean valueHasToChange, char option, long min, long max) throws TinkerforgeException {
    this.dev.setAnalogValueCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletDistanceIRV2.AnalogValueCallbackConfiguration getAnalogValueCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getAnalogValueCallbackConfiguration();
}

public void setMovingAverageConfiguration(int movingAverageLength) throws TinkerforgeException {
    this.dev.setMovingAverageConfiguration(movingAverageLength);
}

public int getMovingAverageConfiguration() throws TinkerforgeException {
    return this.dev.getMovingAverageConfiguration();
}

public void setDistanceLEDConfig(int config) throws TinkerforgeException {
    this.dev.setDistanceLEDConfig(config);
}

public int getDistanceLEDConfig() throws TinkerforgeException {
    return this.dev.getDistanceLEDConfig();
}

public void setSensorType(int sensor) throws TinkerforgeException {
    this.dev.setSensorType(sensor);
}

public int getSensorType() throws TinkerforgeException {
    return this.dev.getSensorType();
}

public BrickletDistanceIRV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletDistanceIRV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addDistanceListener(BrickletDistanceIRV2.DistanceListener l) {
    this.dev.addDistanceListener(l);
}

public void removeDistanceListener(BrickletDistanceIRV2.DistanceListener l) {
    this.dev.removeDistanceListener(l);
}

public void addAnalogValueListener(BrickletDistanceIRV2.AnalogValueListener l) {
    this.dev.addAnalogValueListener(l);
}

public void removeAnalogValueListener(BrickletDistanceIRV2.AnalogValueListener l) {
    this.dev.removeAnalogValueListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletDistanceIRV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletDistanceIRV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletDistanceIRV2Config cfg = (BrickletDistanceIRV2Config) config.as(BrickletDistanceIRV2Config.class);
        this.addDistanceListener(this.reg((distance) -> {if(true) {updateStateFn.accept("BrickletDistanceIRV2Distance", transformBrickletDistanceIRV2DistanceCallback0(distance, cfg));}}, this.dev::removeDistanceListener));
        this.setMovingAverageConfiguration(cfg.movingAverageLength);
		this.setDistanceLEDConfig(cfg.distanceLEDConfig);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletDistanceIRV2DistanceConfig channelCfg = getChannelConfigFn.apply("BrickletDistanceIRV2Distance").as(BrickletDistanceIRV2DistanceConfig.class);
		this.setDistanceCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletDistanceIRV2Config cfg = (BrickletDistanceIRV2Config) config.as(BrickletDistanceIRV2Config.class);
        this.setDistanceCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletDistanceIRV2Config cfg = (BrickletDistanceIRV2Config) config.as(BrickletDistanceIRV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletDistanceIRV2Distance");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletDistanceIRV2Distance":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletDistanceIRV2Distance"), "Distance", "Number:Length").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletDistanceIRV2Distance")).withDescription("Measured distance")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(40)).withMaximum(BigDecimal.valueOf(1500)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Distance IR Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures distance up to 150cm with infrared light").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletDistanceIRV2Distance", new ChannelTypeUID("tinkerforge", "BrickletDistanceIRV2Distance")).withLabel("Distance").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletdistanceirv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("movingAverageLength", Type.INTEGER).withDefault("25").withDescription("Sets the length of a moving averaging for the distance.<br/><br/>Setting the length to 1 will turn the averaging off. With less averaging, there is more noise on the data.<br/><br/>The range for the averaging is 1-1000.<br/><br/>New data is gathered every ~10ms. With a moving average of length 1000 the resulting averaging window has a length of approximately 10s. If you want to do long term measurements the longest moving average will give the cleanest results.<br/><br/>The default value is 25.").withLabel("Moving Average Length").withMinimum(BigDecimal.valueOf(1)).withMaximum(BigDecimal.valueOf(1000)).build(), ConfigDescriptionParameterBuilder.create("distanceLEDConfig", Type.INTEGER).withDefault("3").withDescription("Configures the distance LED to be either turned off, turned on, blink in heartbeat mode or show the distance (brighter = object is nearer).").withLabel("Distance LED Config").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Distance"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletDistanceIRV2Distance":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletDistanceIRV2Config cfg = (BrickletDistanceIRV2Config) config.as(BrickletDistanceIRV2Config.class);
        switch(channel) {
            case "BrickletDistanceIRV2Distance": {
                   BrickletDistanceIRV2DistanceConfig channelCfg = channelConfig.as(BrickletDistanceIRV2DistanceConfig.class);
                   {
            int value = this.getDistance();
            if(true)
                updateStateFn.accept(channel, transformBrickletDistanceIRV2DistanceGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletDistanceIRV2Config cfg = (BrickletDistanceIRV2Config) config.as(BrickletDistanceIRV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletDistanceIRV2DistanceCallback0(int distance, BrickletDistanceIRV2Config cfg) {
        return new QuantityType<>(distance / 1000.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletDistanceIRV2DistanceGetter0(int value, BrickletDistanceIRV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SIUnits.METRE);
    }

}