/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletDualButtonV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletDualButtonV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletDualButtonV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletDualButtonV2.DEVICE_DISPLAY_NAME, "brickletdualbuttonv2", BrickletDualButtonV2.DEVICE_IDENTIFIER, BrickletDualButtonV2Wrapper.class, BrickletDualButtonV2Actions.class, "2.0.0", true);

    public BrickletDualButtonV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletDualButtonV2(uid, ipcon);
    }

    
	public final static int LED_STATE_AUTO_TOGGLE_ON = 0;
	public final static int LED_STATE_AUTO_TOGGLE_OFF = 1;
	public final static int LED_STATE_ON = 2;
	public final static int LED_STATE_OFF = 3;
	public final static int BUTTON_STATE_PRESSED = 0;
	public final static int BUTTON_STATE_RELEASED = 1;
	public final static int LED_LEFT = 0;
	public final static int LED_RIGHT = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setLEDState(int ledL, int ledR) throws TinkerforgeException {
    this.dev.setLEDState(ledL, ledR);
}

public BrickletDualButtonV2.LEDState getLEDState() throws TinkerforgeException {
    return this.dev.getLEDState();
}

public BrickletDualButtonV2.ButtonState getButtonState() throws TinkerforgeException {
    return this.dev.getButtonState();
}

public void setSelectedLEDState(int led, int state) throws TinkerforgeException {
    this.dev.setSelectedLEDState(led, state);
}

public void setStateChangedCallbackConfiguration(boolean enabled) throws TinkerforgeException {
    this.dev.setStateChangedCallbackConfiguration(enabled);
}

public boolean getStateChangedCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getStateChangedCallbackConfiguration();
}

public BrickletDualButtonV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletDualButtonV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addStateChangedListener(BrickletDualButtonV2.StateChangedListener l) {
    this.dev.addStateChangedListener(l);
}

public void removeStateChangedListener(BrickletDualButtonV2.StateChangedListener l) {
    this.dev.removeStateChangedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletDualButtonV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletDualButtonV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletDualButtonV2Config cfg = (BrickletDualButtonV2Config) config.as(BrickletDualButtonV2Config.class);
        this.addStateChangedListener(this.reg((buttonL, buttonR, ledL, ledR) -> {if(true) {triggerChannelFn.accept("BrickletDualButtonV2LeftButton", transformBrickletDualButtonV2LeftButtonCallback0(buttonL, buttonR, ledL, ledR, cfg));}}, this.dev::removeStateChangedListener));
		this.addStateChangedListener(this.reg((buttonL, buttonR, ledL, ledR) -> {if(true) {triggerChannelFn.accept("BrickletDualButtonV2RightButton", transformBrickletDualButtonV2RightButtonCallback0(buttonL, buttonR, ledL, ledR, cfg));}}, this.dev::removeStateChangedListener));
        this.setLEDState(cfg.leftLEDState, cfg.rightLEDState);
		    this.setStateChangedCallbackConfiguration(true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		
		}
		{
		
		}
		if (cfg.leftLEDState > 1) {
		BrickletDualButtonV2LeftLEDConfig channelCfg = getChannelConfigFn.apply("BrickletDualButtonV2LeftLED").as(BrickletDualButtonV2LeftLEDConfig.class);
		
		}
		if (cfg.rightLEDState > 1) {
		BrickletDualButtonV2RightLEDConfig channelCfg = getChannelConfigFn.apply("BrickletDualButtonV2RightLED").as(BrickletDualButtonV2RightLEDConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletDualButtonV2Config cfg = (BrickletDualButtonV2Config) config.as(BrickletDualButtonV2Config.class);
        this.setStateChangedCallbackConfiguration(false);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletDualButtonV2Config cfg = (BrickletDualButtonV2Config) config.as(BrickletDualButtonV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletDualButtonV2LeftButton");
		result.add("BrickletDualButtonV2RightButton");
		if (cfg.leftLEDState > 1) {
                result.add("BrickletDualButtonV2LeftLED");
            }
		if (cfg.rightLEDState > 1) {
                result.add("BrickletDualButtonV2RightLED");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletDualButtonV2LeftLED":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletDualButtonV2LeftLED"), "Left LED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletDualButtonV2LeftLED")).withDescription("Controls the left LED.").build();
            case "BrickletDualButtonV2RightLED":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletDualButtonV2RightLED"), "Right LED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletDualButtonV2RightLED")).withDescription("Controls the right LED.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Dual Button Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Two tactile buttons with built-in blue LEDs").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletDualButtonV2LeftButton", new ChannelTypeUID("system", "rawbutton")).withLabel("Left Button").build(), new ChannelDefinitionBuilder("BrickletDualButtonV2RightButton", new ChannelTypeUID("system", "rawbutton")).withLabel("Right Button").build(), new ChannelDefinitionBuilder("BrickletDualButtonV2LeftLED", new ChannelTypeUID("tinkerforge", "BrickletDualButtonV2LeftLED")).withLabel("Left LED").build(), new ChannelDefinitionBuilder("BrickletDualButtonV2RightLED", new ChannelTypeUID("tinkerforge", "BrickletDualButtonV2RightLED")).withLabel("Right LED").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletdualbuttonv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("leftLEDState", Type.INTEGER).withDefault("1").withDescription("<ul><li>Auto Toggle - Default On: Enables auto toggle. LED initially enabled</li><li>Auto Toggle - Default Off: Enables auto toggle. LED initially disabled</li><li>Channel - Default On: Creates a control channel. LED initially enabled.</li><li>Channel - Default Off: Creates a control channel. LED initially disabled.</li></ul>").withLabel("Left LED State").withOptions(Arrays.asList(new ParameterOption("0", "Auto Toggle - Default On"), new ParameterOption("1", "Auto Toggle - Default Off"), new ParameterOption("2", "Channel - Default On"), new ParameterOption("3", "Channel - Default Off"))).build(), ConfigDescriptionParameterBuilder.create("rightLEDState", Type.INTEGER).withDefault("1").withDescription("<ul><li>Auto Toggle - Default On: Enables auto toggle. LED initially enabled</li><li>Auto Toggle - Default Off: Enables auto toggle. LED initially disabled</li><li>Channel - Default On: Creates a control channel. LED initially enabled.</li><li>Channel - Default Off: Creates a control channel. LED initially disabled.</li></ul>").withLabel("Right LED State").withOptions(Arrays.asList(new ParameterOption("0", "Auto Toggle - Default On"), new ParameterOption("1", "Auto Toggle - Default Off"), new ParameterOption("2", "Channel - Default On"), new ParameterOption("3", "Channel - Default Off"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletDualButtonV2LeftLED":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletDualButtonV2RightLED":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletDualButtonV2Config cfg = (BrickletDualButtonV2Config) config.as(BrickletDualButtonV2Config.class);
        switch(channel) {
            case "BrickletDualButtonV2LeftButton":
                   {
            BrickletDualButtonV2.ButtonState value = this.getButtonState();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletDualButtonV2LeftButtonGetter0(value, cfg));
        }
                   return;
            case "BrickletDualButtonV2RightButton":
                   {
            BrickletDualButtonV2.ButtonState value = this.getButtonState();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletDualButtonV2RightButtonGetter0(value, cfg));
        }
                   return;
            case "BrickletDualButtonV2LeftLED": {
                   BrickletDualButtonV2LeftLEDConfig channelCfg = channelConfig.as(BrickletDualButtonV2LeftLEDConfig.class);
                   {
            BrickletDualButtonV2.LEDState value = this.getLEDState();
            if(true)
                updateStateFn.accept(channel, transformBrickletDualButtonV2LeftLEDGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletDualButtonV2RightLED": {
                   BrickletDualButtonV2RightLEDConfig channelCfg = channelConfig.as(BrickletDualButtonV2RightLEDConfig.class);
                   {
            BrickletDualButtonV2.LEDState value = this.getLEDState();
            if(true)
                updateStateFn.accept(channel, transformBrickletDualButtonV2RightLEDGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletDualButtonV2Config cfg = (BrickletDualButtonV2Config) config.as(BrickletDualButtonV2Config.class);
        switch(channel) {
            case "BrickletDualButtonV2LeftLED":
                if (command instanceof OnOffType) {
                    BrickletDualButtonV2LeftLEDConfig channelCfg = channelConfig.as(BrickletDualButtonV2LeftLEDConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedLEDState(BrickletDualButtonV2.LED_LEFT, cmd == OnOffType.ON? BrickletDualButtonV2.LED_STATE_ON : BrickletDualButtonV2.LED_STATE_OFF);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletDualButtonV2RightLED":
                if (command instanceof OnOffType) {
                    BrickletDualButtonV2RightLEDConfig channelCfg = channelConfig.as(BrickletDualButtonV2RightLEDConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedLEDState(BrickletDualButtonV2.LED_RIGHT, cmd == OnOffType.ON? BrickletDualButtonV2.LED_STATE_ON : BrickletDualButtonV2.LED_STATE_OFF);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletDualButtonV2LeftButtonCallback0(int buttonL, int buttonR, int ledL, int ledR, BrickletDualButtonV2Config cfg) {
        return buttonL == BrickletDualButtonV2.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletDualButtonV2RightButtonCallback0(int buttonL, int buttonR, int ledL, int ledR, BrickletDualButtonV2Config cfg) {
        return buttonR == BrickletDualButtonV2.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletDualButtonV2LeftButtonGetter0(BrickletDualButtonV2.ButtonState value, BrickletDualButtonV2Config cfg) {
        return value.buttonL == BrickletDualButtonV2.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletDualButtonV2RightButtonGetter0(BrickletDualButtonV2.ButtonState value, BrickletDualButtonV2Config cfg) {
        return value.buttonR == BrickletDualButtonV2.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletDualButtonV2LeftLEDGetter0(BrickletDualButtonV2.LEDState value, BrickletDualButtonV2Config cfg) {
        return value.ledL == BrickletDualButtonV2.LED_STATE_ON ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletDualButtonV2RightLEDGetter0(BrickletDualButtonV2.LEDState value, BrickletDualButtonV2Config cfg) {
        return value.ledR == BrickletDualButtonV2.LED_STATE_ON ? OnOffType.ON : OnOffType.OFF;
    }

}