/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletDualButton;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletDualButtonWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletDualButton dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletDualButton.DEVICE_DISPLAY_NAME, "brickletdualbutton", BrickletDualButton.DEVICE_IDENTIFIER, BrickletDualButtonWrapper.class, BrickletDualButtonActions.class, "2.0.0", false);

    public BrickletDualButtonWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletDualButton(uid, ipcon);
    }

    
	public final static int LED_STATE_AUTO_TOGGLE_ON = 0;
	public final static int LED_STATE_AUTO_TOGGLE_OFF = 1;
	public final static int LED_STATE_ON = 2;
	public final static int LED_STATE_OFF = 3;
	public final static int BUTTON_STATE_PRESSED = 0;
	public final static int BUTTON_STATE_RELEASED = 1;
	public final static int LED_LEFT = 0;
	public final static int LED_RIGHT = 1;


    public void setLEDState(int ledL, int ledR) throws TinkerforgeException {
    this.dev.setLEDState(ledL, ledR);
}

public BrickletDualButton.LEDState getLEDState() throws TinkerforgeException {
    return this.dev.getLEDState();
}

public BrickletDualButton.ButtonState getButtonState() throws TinkerforgeException {
    return this.dev.getButtonState();
}

public void setSelectedLEDState(int led, int state) throws TinkerforgeException {
    this.dev.setSelectedLEDState(led, state);
}

public BrickletDualButton.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addStateChangedListener(BrickletDualButton.StateChangedListener l) {
    this.dev.addStateChangedListener(l);
}

public void removeStateChangedListener(BrickletDualButton.StateChangedListener l) {
    this.dev.removeStateChangedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletDualButtonWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletDualButtonWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletDualButtonConfig cfg = (BrickletDualButtonConfig) config.as(BrickletDualButtonConfig.class);
        this.addStateChangedListener(this.reg((buttonL, buttonR, ledL, ledR) -> {if(true) {triggerChannelFn.accept("BrickletDualButtonLeftButton", transformBrickletDualButtonLeftButtonCallback0(buttonL, buttonR, ledL, ledR, cfg));}}, this.dev::removeStateChangedListener));
		this.addStateChangedListener(this.reg((buttonL, buttonR, ledL, ledR) -> {if(true) {triggerChannelFn.accept("BrickletDualButtonRightButton", transformBrickletDualButtonRightButtonCallback0(buttonL, buttonR, ledL, ledR, cfg));}}, this.dev::removeStateChangedListener));
        this.setLEDState(cfg.leftLEDState, cfg.rightLEDState);
		{
		
		}
		{
		
		}
		if (cfg.leftLEDState > 1) {
		BrickletDualButtonLeftLEDConfig channelCfg = getChannelConfigFn.apply("BrickletDualButtonLeftLED").as(BrickletDualButtonLeftLEDConfig.class);
		
		}
		if (cfg.rightLEDState > 1) {
		BrickletDualButtonRightLEDConfig channelCfg = getChannelConfigFn.apply("BrickletDualButtonRightLED").as(BrickletDualButtonRightLEDConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletDualButtonConfig cfg = (BrickletDualButtonConfig) config.as(BrickletDualButtonConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletDualButtonConfig cfg = (BrickletDualButtonConfig) config.as(BrickletDualButtonConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletDualButtonLeftButton");
		result.add("BrickletDualButtonRightButton");
		if (cfg.leftLEDState > 1) {
                result.add("BrickletDualButtonLeftLED");
            }
		if (cfg.rightLEDState > 1) {
                result.add("BrickletDualButtonRightLED");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletDualButtonLeftLED":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletDualButtonLeftLED"), "Left LED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletDualButtonLeftLED")).withDescription("Controls the left LED.").build();
            case "BrickletDualButtonRightLED":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletDualButtonRightLED"), "Right LED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletDualButtonRightLED")).withDescription("Controls the right LED.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Dual Button Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Two tactile buttons with built-in blue LEDs").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletDualButtonLeftButton", new ChannelTypeUID("system", "rawbutton")).withLabel("Left Button").build(), new ChannelDefinitionBuilder("BrickletDualButtonRightButton", new ChannelTypeUID("system", "rawbutton")).withLabel("Right Button").build(), new ChannelDefinitionBuilder("BrickletDualButtonLeftLED", new ChannelTypeUID("tinkerforge", "BrickletDualButtonLeftLED")).withLabel("Left LED").build(), new ChannelDefinitionBuilder("BrickletDualButtonRightLED", new ChannelTypeUID("tinkerforge", "BrickletDualButtonRightLED")).withLabel("Right LED").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletdualbutton":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("leftLEDState", Type.INTEGER).withDefault("1").withDescription("<ul><li>Auto Toggle - Default On: Enables auto toggle. LED initially enabled</li><li>Auto Toggle - Default Off: Enables auto toggle. LED initially disabled</li><li>Channel - Default On: Creates a control channel. LED initially enabled.</li><li>Channel - Default Off: Creates a control channel. LED initially disabled.</li></ul>").withLabel("Left LED State").withOptions(Arrays.asList(new ParameterOption("0", "Auto Toggle - Default On"), new ParameterOption("1", "Auto Toggle - Default Off"), new ParameterOption("2", "Channel - Default On"), new ParameterOption("3", "Channel - Default Off"))).build(), ConfigDescriptionParameterBuilder.create("rightLEDState", Type.INTEGER).withDefault("1").withDescription("<ul><li>Auto Toggle - Default On: Enables auto toggle. LED initially enabled</li><li>Auto Toggle - Default Off: Enables auto toggle. LED initially disabled</li><li>Channel - Default On: Creates a control channel. LED initially enabled.</li><li>Channel - Default Off: Creates a control channel. LED initially disabled.</li></ul>").withLabel("Right LED State").withOptions(Arrays.asList(new ParameterOption("0", "Auto Toggle - Default On"), new ParameterOption("1", "Auto Toggle - Default Off"), new ParameterOption("2", "Channel - Default On"), new ParameterOption("3", "Channel - Default Off"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletDualButtonLeftLED":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletDualButtonRightLED":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletDualButtonConfig cfg = (BrickletDualButtonConfig) config.as(BrickletDualButtonConfig.class);
        switch(channel) {
            case "BrickletDualButtonLeftButton":
                   {
            BrickletDualButton.ButtonState value = this.getButtonState();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletDualButtonLeftButtonGetter0(value, cfg));
        }
                   return;
            case "BrickletDualButtonRightButton":
                   {
            BrickletDualButton.ButtonState value = this.getButtonState();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletDualButtonRightButtonGetter0(value, cfg));
        }
                   return;
            case "BrickletDualButtonLeftLED": {
                   BrickletDualButtonLeftLEDConfig channelCfg = channelConfig.as(BrickletDualButtonLeftLEDConfig.class);
                   {
            BrickletDualButton.LEDState value = this.getLEDState();
            if(true)
                updateStateFn.accept(channel, transformBrickletDualButtonLeftLEDGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletDualButtonRightLED": {
                   BrickletDualButtonRightLEDConfig channelCfg = channelConfig.as(BrickletDualButtonRightLEDConfig.class);
                   {
            BrickletDualButton.LEDState value = this.getLEDState();
            if(true)
                updateStateFn.accept(channel, transformBrickletDualButtonRightLEDGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletDualButtonConfig cfg = (BrickletDualButtonConfig) config.as(BrickletDualButtonConfig.class);
        switch(channel) {
            case "BrickletDualButtonLeftLED":
                if (command instanceof OnOffType) {
                    BrickletDualButtonLeftLEDConfig channelCfg = channelConfig.as(BrickletDualButtonLeftLEDConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedLEDState(BrickletDualButton.LED_LEFT, cmd == OnOffType.ON? BrickletDualButton.LED_STATE_ON : BrickletDualButton.LED_STATE_OFF);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletDualButtonRightLED":
                if (command instanceof OnOffType) {
                    BrickletDualButtonRightLEDConfig channelCfg = channelConfig.as(BrickletDualButtonRightLEDConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedLEDState(BrickletDualButton.LED_RIGHT, cmd == OnOffType.ON? BrickletDualButton.LED_STATE_ON : BrickletDualButton.LED_STATE_OFF);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletDualButtonLeftButtonCallback0(int buttonL, int buttonR, int ledL, int ledR, BrickletDualButtonConfig cfg) {
        return buttonL == BrickletDualButton.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletDualButtonRightButtonCallback0(int buttonL, int buttonR, int ledL, int ledR, BrickletDualButtonConfig cfg) {
        return buttonR == BrickletDualButton.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletDualButtonLeftButtonGetter0(BrickletDualButton.ButtonState value, BrickletDualButtonConfig cfg) {
        return value.buttonL == BrickletDualButton.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletDualButtonRightButtonGetter0(BrickletDualButton.ButtonState value, BrickletDualButtonConfig cfg) {
        return value.buttonR == BrickletDualButton.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletDualButtonLeftLEDGetter0(BrickletDualButton.LEDState value, BrickletDualButtonConfig cfg) {
        return value.ledL == BrickletDualButton.LED_STATE_ON ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletDualButtonRightLEDGetter0(BrickletDualButton.LEDState value, BrickletDualButtonConfig cfg) {
        return value.ledR == BrickletDualButton.LED_STATE_ON ? OnOffType.ON : OnOffType.OFF;
    }

}