/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;
import org.eclipse.smarthome.core.library.types.DecimalType;

import com.tinkerforge.BrickletEPaper296x128;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletEPaper296x128Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletEPaper296x128 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletEPaper296x128.DEVICE_DISPLAY_NAME, "brickletepaper296x128", BrickletEPaper296x128.DEVICE_IDENTIFIER, BrickletEPaper296x128Wrapper.class, BrickletEPaper296x128Actions.class, "2.0.0", true);

    public BrickletEPaper296x128Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletEPaper296x128(uid, ipcon);
    }

    
	public final static int DRAW_STATUS_IDLE = 0;
	public final static int DRAW_STATUS_COPYING = 1;
	public final static int DRAW_STATUS_DRAWING = 2;
	public final static int COLOR_BLACK = 0;
	public final static int COLOR_WHITE = 1;
	public final static int COLOR_RED = 2;
	public final static int COLOR_GRAY = 2;
	public final static int FONT_6X8 = 0;
	public final static int FONT_6X16 = 1;
	public final static int FONT_6X24 = 2;
	public final static int FONT_6X32 = 3;
	public final static int FONT_12X16 = 4;
	public final static int FONT_12X24 = 5;
	public final static int FONT_12X32 = 6;
	public final static int FONT_18X24 = 7;
	public final static int FONT_18X32 = 8;
	public final static int FONT_24X32 = 9;
	public final static int ORIENTATION_HORIZONTAL = 0;
	public final static int ORIENTATION_VERTICAL = 1;
	public final static int UPDATE_MODE_DEFAULT = 0;
	public final static int UPDATE_MODE_BLACK_WHITE = 1;
	public final static int UPDATE_MODE_DELTA = 2;
	public final static int DISPLAY_TYPE_BLACK_WHITE_RED = 0;
	public final static int DISPLAY_TYPE_BLACK_WHITE_GRAY = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void draw() throws TinkerforgeException {
    this.dev.draw();
}

public int getDrawStatus() throws TinkerforgeException {
    return this.dev.getDrawStatus();
}

public void writeBlackWhite(int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException {
    this.dev.writeBlackWhite(xStart, yStart, xEnd, yEnd, pixels);
}

public boolean[] readBlackWhite(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
    return this.dev.readBlackWhite(xStart, yStart, xEnd, yEnd);
}

public void writeColor(int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException {
    this.dev.writeColor(xStart, yStart, xEnd, yEnd, pixels);
}

public boolean[] readColor(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
    return this.dev.readColor(xStart, yStart, xEnd, yEnd);
}

public void fillDisplay(int color) throws TinkerforgeException {
    this.dev.fillDisplay(color);
}

public void drawText(int positionX, int positionY, int font, int color, int orientation, String text) throws TinkerforgeException {
    this.dev.drawText(positionX, positionY, font, color, orientation, text);
}

public void drawLine(int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, int color) throws TinkerforgeException {
    this.dev.drawLine(positionXStart, positionYStart, positionXEnd, positionYEnd, color);
}

public void drawBox(int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, boolean fill, int color) throws TinkerforgeException {
    this.dev.drawBox(positionXStart, positionYStart, positionXEnd, positionYEnd, fill, color);
}

public void setUpdateMode(int updateMode) throws TinkerforgeException {
    this.dev.setUpdateMode(updateMode);
}

public int getUpdateMode() throws TinkerforgeException {
    return this.dev.getUpdateMode();
}

public void setDisplayType(int displayType) throws TinkerforgeException {
    this.dev.setDisplayType(displayType);
}

public int getDisplayType() throws TinkerforgeException {
    return this.dev.getDisplayType();
}

public BrickletEPaper296x128.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletEPaper296x128.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addDrawStatusListener(BrickletEPaper296x128.DrawStatusListener l) {
    this.dev.addDrawStatusListener(l);
}

public void removeDrawStatusListener(BrickletEPaper296x128.DrawStatusListener l) {
    this.dev.removeDrawStatusListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletEPaper296x128Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletEPaper296x128Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletEPaper296x128Config cfg = (BrickletEPaper296x128Config) config.as(BrickletEPaper296x128Config.class);
        this.addDrawStatusListener(this.reg((drawStatus) -> {if(true) {updateStateFn.accept("BrickletEPaper296x128DrawStatus", transformBrickletEPaper296x128DrawStatusCallback0(drawStatus, cfg));}}, this.dev::removeDrawStatusListener));
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletEPaper296x128DrawStatusConfig channelCfg = getChannelConfigFn.apply("BrickletEPaper296x128DrawStatus").as(BrickletEPaper296x128DrawStatusConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletEPaper296x128Config cfg = (BrickletEPaper296x128Config) config.as(BrickletEPaper296x128Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletEPaper296x128Config cfg = (BrickletEPaper296x128Config) config.as(BrickletEPaper296x128Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletEPaper296x128DrawStatus");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletEPaper296x128DrawStatus":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletEPaper296x128DrawStatus"), "Draw Status", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletEPaper296x128DrawStatus")).withDescription("One of three draw statuses:<ul><li>0: Idle</li><li>1: Copying: Data is being copied from the buffer of the Bricklet to the buffer of the display.</li><li>2: Drawing: The display is updating its content (during this phase the flickering etc happens).</li></ul><br/><br/>You can write to the buffer (through one of the write or draw functions) when the status is either idle or drawing. You should not write to the buffer while it is being copied to the display. There is no double-buffering.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge E-Paper 296x128 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Three color 296x128 e-paper display").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletEPaper296x128DrawStatus", new ChannelTypeUID("tinkerforge", "BrickletEPaper296x128DrawStatus")).withLabel("Draw Status").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletepaper296x128":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletEPaper296x128DrawStatus":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletEPaper296x128Config cfg = (BrickletEPaper296x128Config) config.as(BrickletEPaper296x128Config.class);
        switch(channel) {
            case "BrickletEPaper296x128DrawStatus": {
                   BrickletEPaper296x128DrawStatusConfig channelCfg = channelConfig.as(BrickletEPaper296x128DrawStatusConfig.class);
                   {
            int value = this.getDrawStatus();
            if(true)
                updateStateFn.accept(channel, transformBrickletEPaper296x128DrawStatusGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletEPaper296x128Config cfg = (BrickletEPaper296x128Config) config.as(BrickletEPaper296x128Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletEPaper296x128DrawStatusCallback0(int drawStatus, BrickletEPaper296x128Config cfg) {
        return new DecimalType(drawStatus);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletEPaper296x128DrawStatusGetter0(int value, BrickletEPaper296x128Config cfg) {
        return new DecimalType(value);
    }

}