/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletHallEffect;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletHallEffectWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletHallEffect dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletHallEffect.DEVICE_DISPLAY_NAME, "bricklethalleffect", BrickletHallEffect.DEVICE_IDENTIFIER, BrickletHallEffectWrapper.class, BrickletHallEffectActions.class, "2.0.0", false);

    public BrickletHallEffectWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletHallEffect(uid, ipcon);
    }

    
	public final static int EDGE_TYPE_RISING = 0;
	public final static int EDGE_TYPE_FALLING = 1;
	public final static int EDGE_TYPE_BOTH = 2;


    public boolean getValue() throws TinkerforgeException {
    return this.dev.getValue();
}

public long getEdgeCount(boolean resetCounter) throws TinkerforgeException {
    return this.dev.getEdgeCount(resetCounter);
}

public void setEdgeCountConfig(int edgeType, int debounce) throws TinkerforgeException {
    this.dev.setEdgeCountConfig(edgeType, debounce);
}

public BrickletHallEffect.EdgeCountConfig getEdgeCountConfig() throws TinkerforgeException {
    return this.dev.getEdgeCountConfig();
}

public void setEdgeInterrupt(long edges) throws TinkerforgeException {
    this.dev.setEdgeInterrupt(edges);
}

public long getEdgeInterrupt() throws TinkerforgeException {
    return this.dev.getEdgeInterrupt();
}

public void setEdgeCountCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setEdgeCountCallbackPeriod(period);
}

public long getEdgeCountCallbackPeriod() throws TinkerforgeException {
    return this.dev.getEdgeCountCallbackPeriod();
}

public BrickletHallEffect.EdgeInterrupt edgeInterrupt() throws TinkerforgeException {
    return this.dev.edgeInterrupt();
}

public BrickletHallEffect.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addEdgeCountListener(BrickletHallEffect.EdgeCountListener l) {
    this.dev.addEdgeCountListener(l);
}

public void removeEdgeCountListener(BrickletHallEffect.EdgeCountListener l) {
    this.dev.removeEdgeCountListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletHallEffectWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletHallEffectWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletHallEffectConfig cfg = (BrickletHallEffectConfig) config.as(BrickletHallEffectConfig.class);
        this.addEdgeCountListener(this.reg((count, value) -> {if(true) {updateStateFn.accept("BrickletHallEffectEdgeCount", transformBrickletHallEffectEdgeCountCallback0(count, value, cfg));}}, this.dev::removeEdgeCountListener));
        
		{
		BrickletHallEffectEdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletHallEffectEdgeCount").as(BrickletHallEffectEdgeCountConfig.class);
		this.setEdgeCountConfig(cfg.edgeType, cfg.debounce);
		            this.setEdgeInterrupt(channelCfg.refreshCount);
		}
		{
		BrickletHallEffectMagneticFieldDetectedConfig channelCfg = getChannelConfigFn.apply("BrickletHallEffectMagneticFieldDetected").as(BrickletHallEffectMagneticFieldDetectedConfig.class);
		
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletHallEffectMagneticFieldDetected"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletHallEffectConfig cfg = (BrickletHallEffectConfig) config.as(BrickletHallEffectConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletHallEffectConfig cfg = (BrickletHallEffectConfig) config.as(BrickletHallEffectConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletHallEffectEdgeCount");
		result.add("BrickletHallEffectMagneticFieldDetected");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletHallEffectEdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletHallEffectEdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletHallEffectEdgeCount")).withDescription("The current value of the edge counter.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletHallEffectMagneticFieldDetected":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletHallEffectMagneticFieldDetected"), "Magnetic Field Detected", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletHallEffectMagneticFieldDetected")).withDescription("Enabled if a magnetic field of 3.5 millitesla or greater is detected.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Hall Effect Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Detects presence of magnetic field").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletHallEffectEdgeCount", new ChannelTypeUID("tinkerforge", "BrickletHallEffectEdgeCount")).withLabel("Edge Count").build(), new ChannelDefinitionBuilder("BrickletHallEffectMagneticFieldDetected", new ChannelTypeUID("tinkerforge", "BrickletHallEffectMagneticFieldDetected")).withLabel("Magnetic Field Detected").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:bricklethalleffect":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").withAdvanced(true).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletHallEffectEdgeCount":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("refreshCount", Type.INTEGER).withDefault("1").withLabel("Refresh Value Every N-th Edge.").build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count On Update").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletHallEffectMagneticFieldDetected":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletHallEffectConfig cfg = (BrickletHallEffectConfig) config.as(BrickletHallEffectConfig.class);
        switch(channel) {
            case "BrickletHallEffectEdgeCount": {
                   BrickletHallEffectEdgeCountConfig channelCfg = channelConfig.as(BrickletHallEffectEdgeCountConfig.class);
                   {
            long value = this.getEdgeCount(channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletHallEffectEdgeCountGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletHallEffectMagneticFieldDetected": {
                   BrickletHallEffectMagneticFieldDetectedConfig channelCfg = channelConfig.as(BrickletHallEffectMagneticFieldDetectedConfig.class);
                   {
            boolean value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletHallEffectMagneticFieldDetectedGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletHallEffectConfig cfg = (BrickletHallEffectConfig) config.as(BrickletHallEffectConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletHallEffectEdgeCountCallback0(long count, boolean value, BrickletHallEffectConfig cfg) {
        return new QuantityType<>(count, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletHallEffectEdgeCountGetter0(long value, BrickletHallEffectConfig cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletHallEffectMagneticFieldDetectedGetter0(boolean value, BrickletHallEffectConfig cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }

}