/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletHumidityV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletHumidityV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletHumidityV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletHumidityV2.DEVICE_DISPLAY_NAME, "bricklethumidityv2", BrickletHumidityV2.DEVICE_IDENTIFIER, BrickletHumidityV2Wrapper.class, BrickletHumidityV2Actions.class, "2.0.3", true);

    public BrickletHumidityV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletHumidityV2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int HEATER_CONFIG_DISABLED = 0;
	public final static int HEATER_CONFIG_ENABLED = 1;
	public final static int SPS_20 = 0;
	public final static int SPS_10 = 1;
	public final static int SPS_5 = 2;
	public final static int SPS_1 = 3;
	public final static int SPS_02 = 4;
	public final static int SPS_01 = 5;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getHumidity() throws TinkerforgeException {
    return this.dev.getHumidity();
}

public void setHumidityCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setHumidityCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletHumidityV2.HumidityCallbackConfiguration getHumidityCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getHumidityCallbackConfiguration();
}

public int getTemperature() throws TinkerforgeException {
    return this.dev.getTemperature();
}

public void setTemperatureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setTemperatureCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletHumidityV2.TemperatureCallbackConfiguration getTemperatureCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getTemperatureCallbackConfiguration();
}

public void setHeaterConfiguration(int heaterConfig) throws TinkerforgeException {
    this.dev.setHeaterConfiguration(heaterConfig);
}

public int getHeaterConfiguration() throws TinkerforgeException {
    return this.dev.getHeaterConfiguration();
}

public void setMovingAverageConfiguration(int movingAverageLengthHumidity, int movingAverageLengthTemperature) throws TinkerforgeException {
    this.dev.setMovingAverageConfiguration(movingAverageLengthHumidity, movingAverageLengthTemperature);
}

public BrickletHumidityV2.MovingAverageConfiguration getMovingAverageConfiguration() throws TinkerforgeException {
    return this.dev.getMovingAverageConfiguration();
}

public void setSamplesPerSecond(int sps) throws TinkerforgeException {
    this.dev.setSamplesPerSecond(sps);
}

public int getSamplesPerSecond() throws TinkerforgeException {
    return this.dev.getSamplesPerSecond();
}

public BrickletHumidityV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletHumidityV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addHumidityListener(BrickletHumidityV2.HumidityListener l) {
    this.dev.addHumidityListener(l);
}

public void removeHumidityListener(BrickletHumidityV2.HumidityListener l) {
    this.dev.removeHumidityListener(l);
}

public void addTemperatureListener(BrickletHumidityV2.TemperatureListener l) {
    this.dev.addTemperatureListener(l);
}

public void removeTemperatureListener(BrickletHumidityV2.TemperatureListener l) {
    this.dev.removeTemperatureListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletHumidityV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletHumidityV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletHumidityV2Config cfg = (BrickletHumidityV2Config) config.as(BrickletHumidityV2Config.class);
        this.addHumidityListener(this.reg((humidity) -> {if(true) {updateStateFn.accept("BrickletHumidityV2Humidity", transformBrickletHumidityV2HumidityCallback0(humidity, cfg));}}, this.dev::removeHumidityListener));
		this.addTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletHumidityV2Temperature", transformBrickletHumidityV2TemperatureCallback0(temperature, cfg));}}, this.dev::removeTemperatureListener));
        this.setSamplesPerSecond(cfg.sampleRate);
		this.setMovingAverageConfiguration(cfg.humidityMovingAverageLength, cfg.temperatureMovingAverageLength);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletHumidityV2HumidityConfig channelCfg = getChannelConfigFn.apply("BrickletHumidityV2Humidity").as(BrickletHumidityV2HumidityConfig.class);
		this.setHumidityCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletHumidityV2TemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletHumidityV2Temperature").as(BrickletHumidityV2TemperatureConfig.class);
		this.setTemperatureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletHumidityV2HeaterConfig channelCfg = getChannelConfigFn.apply("BrickletHumidityV2Heater").as(BrickletHumidityV2HeaterConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletHumidityV2Config cfg = (BrickletHumidityV2Config) config.as(BrickletHumidityV2Config.class);
        this.setHumidityCallbackConfiguration(0, true, 'x', 0, 0);
		this.setTemperatureCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletHumidityV2Config cfg = (BrickletHumidityV2Config) config.as(BrickletHumidityV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletHumidityV2Humidity");
		result.add("BrickletHumidityV2Temperature");
		result.add("BrickletHumidityV2Heater");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletHumidityV2Humidity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletHumidityV2Humidity"), "Humidity", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletHumidityV2Humidity")).withDescription("Measured relative humidity")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(100)).withPattern("%.2f %%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletHumidityV2Temperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletHumidityV2Temperature"), "Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletHumidityV2Temperature")).withDescription("Measured temperature")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-40)).withMaximum(BigDecimal.valueOf(165)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletHumidityV2Heater":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletHumidityV2Heater"), "Heater", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletHumidityV2Heater")).withDescription("Enables/disables the heater. The heater can be used to dry the sensor in extremely wet conditions.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Humidity Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures relative humidity").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletHumidityV2Humidity", new ChannelTypeUID("tinkerforge", "BrickletHumidityV2Humidity")).withLabel("Humidity").build(), new ChannelDefinitionBuilder("BrickletHumidityV2Temperature", new ChannelTypeUID("tinkerforge", "BrickletHumidityV2Temperature")).withLabel("Temperature").build(), new ChannelDefinitionBuilder("BrickletHumidityV2Heater", new ChannelTypeUID("tinkerforge", "BrickletHumidityV2Heater")).withLabel("Heater").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:bricklethumidityv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("humidityMovingAverageLength", Type.INTEGER).withDefault("5").withGroupName("average").withLabel("Humidity Moving Average Length").withMinimum(BigDecimal.valueOf(1)).withMaximum(BigDecimal.valueOf(1000)).build(), ConfigDescriptionParameterBuilder.create("temperatureMovingAverageLength", Type.INTEGER).withDefault("5").withGroupName("average").withLabel("Temperature Moving Average Length").withMinimum(BigDecimal.valueOf(1)).withMaximum(BigDecimal.valueOf(1000)).build(), ConfigDescriptionParameterBuilder.create("sampleRate", Type.INTEGER).withDefault("3").withDescription("The samples per second that are gathered by the humidity/temperature sensor HDC1080.<br/><br/>We added this function since we found out that a high measurement frequency can lead to self-heating of the sensor. Which can distort the temperature measurement.<br/><br/>If you don't need a lot of measurements, you can use the lowest available measurement frequency of 0.1 samples per second for the least amount of self-heating.").withLabel("Sample Rate").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "20 SPS"), new ParameterOption("1", "10 SPS"), new ParameterOption("2", "5 SPS"), new ParameterOption("3", "1 SPS"), new ParameterOption("4", "0.2 SPS"), new ParameterOption("5", "0.1 SPS"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"), new ConfigDescriptionParameterGroup("average", "null", true, "Averaging", "Sets the length of a moving averaging for the humidity and temperature.<br/><br/>Setting the length to 1 will turn the averaging off. With less averaging, there is more noise on the data.<br/><br/>The range for the averaging is 1-1000.<br/><br/>New data is gathered every 50ms*. With a moving average of length 1000 the resulting averaging window has a length of 50s. If you want to do long term measurements the longest moving average will give the cleanest results.<br/><br/>The default value is 5.<br/><br/>* In firmware version 2.0.3 we added the setSamplesPerSecond() function. It configures the measurement frequency. Since high frequencies can result in self-heating of th IC, changed the default value from 20 samples per second to 1. With 1 sample per second a moving average length of 1000 would result in an averaging window of 1000 seconds!"))).build();
            case "channel-type:tinkerforge:BrickletHumidityV2Humidity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletHumidityV2Temperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletHumidityV2Heater":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletHumidityV2Config cfg = (BrickletHumidityV2Config) config.as(BrickletHumidityV2Config.class);
        switch(channel) {
            case "BrickletHumidityV2Humidity": {
                   BrickletHumidityV2HumidityConfig channelCfg = channelConfig.as(BrickletHumidityV2HumidityConfig.class);
                   {
            int value = this.getHumidity();
            if(true)
                updateStateFn.accept(channel, transformBrickletHumidityV2HumidityGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletHumidityV2Temperature": {
                   BrickletHumidityV2TemperatureConfig channelCfg = channelConfig.as(BrickletHumidityV2TemperatureConfig.class);
                   {
            int value = this.getTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletHumidityV2TemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletHumidityV2Heater": {
                   BrickletHumidityV2HeaterConfig channelCfg = channelConfig.as(BrickletHumidityV2HeaterConfig.class);
                   {
            int value = this.getHeaterConfiguration();
            if(true)
                updateStateFn.accept(channel, transformBrickletHumidityV2HeaterGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletHumidityV2Config cfg = (BrickletHumidityV2Config) config.as(BrickletHumidityV2Config.class);
        switch(channel) {
            case "BrickletHumidityV2Heater":
                if (command instanceof OnOffType) {
                    BrickletHumidityV2HeaterConfig channelCfg = channelConfig.as(BrickletHumidityV2HeaterConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setHeaterConfiguration(cmd == OnOffType.ON ? BrickletHumidityV2.HEATER_CONFIG_ENABLED : BrickletHumidityV2.HEATER_CONFIG_DISABLED);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletHumidityV2HumidityCallback0(int humidity, BrickletHumidityV2Config cfg) {
        return new QuantityType<>(humidity / 100.0, SmartHomeUnits.PERCENT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletHumidityV2TemperatureCallback0(int temperature, BrickletHumidityV2Config cfg) {
        return new QuantityType<>(temperature / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletHumidityV2HumidityGetter0(int value, BrickletHumidityV2Config cfg) {
        return new QuantityType<>(value / 100.0, SmartHomeUnits.PERCENT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletHumidityV2TemperatureGetter0(int value, BrickletHumidityV2Config cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletHumidityV2HeaterGetter0(int value, BrickletHumidityV2Config cfg) {
        return value == BrickletHumidityV2.HEATER_CONFIG_ENABLED ? OnOffType.ON : OnOffType.OFF;
    }

}