/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletIO4V2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIO4V2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletIO4V2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIO4V2.DEVICE_DISPLAY_NAME, "brickletio4v2", BrickletIO4V2.DEVICE_IDENTIFIER, BrickletIO4V2Wrapper.class, BrickletIO4V2Actions.class, "2.0.0", true);

    public BrickletIO4V2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletIO4V2(uid, ipcon);
    }

    
	public final static char DIRECTION_IN = 'i';
	public final static char DIRECTION_OUT = 'o';
	public final static int EDGE_TYPE_RISING = 0;
	public final static int EDGE_TYPE_FALLING = 1;
	public final static int EDGE_TYPE_BOTH = 2;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setValue(boolean[] value) throws TinkerforgeException {
    this.dev.setValue(value);
}

public boolean[] getValue() throws TinkerforgeException {
    return this.dev.getValue();
}

public void setSelectedValue(int channel, boolean value) throws TinkerforgeException {
    this.dev.setSelectedValue(channel, value);
}

public void setConfiguration(int channel, char direction, boolean value) throws TinkerforgeException {
    this.dev.setConfiguration(channel, direction, value);
}

public BrickletIO4V2.Configuration getConfiguration(int channel) throws TinkerforgeException {
    return this.dev.getConfiguration(channel);
}

public void setInputValueCallbackConfiguration(int channel, long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setInputValueCallbackConfiguration(channel, period, valueHasToChange);
}

public BrickletIO4V2.InputValueCallbackConfiguration getInputValueCallbackConfiguration(int channel) throws TinkerforgeException {
    return this.dev.getInputValueCallbackConfiguration(channel);
}

public void setAllInputValueCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setAllInputValueCallbackConfiguration(period, valueHasToChange);
}

public BrickletIO4V2.AllInputValueCallbackConfiguration getAllInputValueCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getAllInputValueCallbackConfiguration();
}

public void setMonoflop(int channel, boolean value, long time) throws TinkerforgeException {
    this.dev.setMonoflop(channel, value, time);
}

public BrickletIO4V2.Monoflop getMonoflop(int channel) throws TinkerforgeException {
    return this.dev.getMonoflop(channel);
}

public long getEdgeCount(int channel, boolean resetCounter) throws TinkerforgeException {
    return this.dev.getEdgeCount(channel, resetCounter);
}

public void setEdgeCountConfiguration(int channel, int edgeType, int debounce) throws TinkerforgeException {
    this.dev.setEdgeCountConfiguration(channel, edgeType, debounce);
}

public BrickletIO4V2.EdgeCountConfiguration getEdgeCountConfiguration(int channel) throws TinkerforgeException {
    return this.dev.getEdgeCountConfiguration(channel);
}

public void setPWMConfiguration(int channel, long frequency, int dutyCycle) throws TinkerforgeException {
    this.dev.setPWMConfiguration(channel, frequency, dutyCycle);
}

public BrickletIO4V2.PWMConfiguration getPWMConfiguration(int channel) throws TinkerforgeException {
    return this.dev.getPWMConfiguration(channel);
}

public BrickletIO4V2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletIO4V2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addInputValueListener(BrickletIO4V2.InputValueListener l) {
    this.dev.addInputValueListener(l);
}

public void removeInputValueListener(BrickletIO4V2.InputValueListener l) {
    this.dev.removeInputValueListener(l);
}

public void addAllInputValueListener(BrickletIO4V2.AllInputValueListener l) {
    this.dev.addAllInputValueListener(l);
}

public void removeAllInputValueListener(BrickletIO4V2.AllInputValueListener l) {
    this.dev.removeAllInputValueListener(l);
}

public void addMonoflopDoneListener(BrickletIO4V2.MonoflopDoneListener l) {
    this.dev.addMonoflopDoneListener(l);
}

public void removeMonoflopDoneListener(BrickletIO4V2.MonoflopDoneListener l) {
    this.dev.removeMonoflopDoneListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIO4V2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIO4V2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletIO4V2Config cfg = (BrickletIO4V2Config) config.as(BrickletIO4V2Config.class);
        if(cfg.pinConfiguration0 > 1) {
this.addInputValueListener(this.reg((channel, changed, value) -> {if(channel == 0) {updateStateFn.accept("BrickletIO4V2InputPin0", transformBrickletIO4V2InputPin0Callback0(channel, changed, value, cfg));}}, this.dev::removeInputValueListener));}
		if(cfg.pinConfiguration1 > 1) {
this.addInputValueListener(this.reg((channel, changed, value) -> {if(channel == 1) {updateStateFn.accept("BrickletIO4V2InputPin1", transformBrickletIO4V2InputPin1Callback0(channel, changed, value, cfg));}}, this.dev::removeInputValueListener));}
		if(cfg.pinConfiguration2 > 1) {
this.addInputValueListener(this.reg((channel, changed, value) -> {if(channel == 2) {updateStateFn.accept("BrickletIO4V2InputPin2", transformBrickletIO4V2InputPin2Callback0(channel, changed, value, cfg));}}, this.dev::removeInputValueListener));}
		if(cfg.pinConfiguration3 > 1) {
this.addInputValueListener(this.reg((channel, changed, value) -> {if(channel == 3) {updateStateFn.accept("BrickletIO4V2InputPin3", transformBrickletIO4V2InputPin3Callback0(channel, changed, value, cfg));}}, this.dev::removeInputValueListener));}
		if(cfg.pinConfiguration0 <= 1) {
this.addMonoflopDoneListener(this.reg((channel, value) -> {if(channel == 0) {updateStateFn.accept("BrickletIO4V2OutputPin0", transformBrickletIO4V2OutputPin0Callback0(channel, value, cfg));}}, this.dev::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration1 <= 1) {
this.addMonoflopDoneListener(this.reg((channel, value) -> {if(channel == 1) {updateStateFn.accept("BrickletIO4V2OutputPin1", transformBrickletIO4V2OutputPin1Callback0(channel, value, cfg));}}, this.dev::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration2 <= 1) {
this.addMonoflopDoneListener(this.reg((channel, value) -> {if(channel == 2) {updateStateFn.accept("BrickletIO4V2OutputPin2", transformBrickletIO4V2OutputPin2Callback0(channel, value, cfg));}}, this.dev::removeMonoflopDoneListener));}
		if(cfg.pinConfiguration3 <= 1) {
this.addMonoflopDoneListener(this.reg((channel, value) -> {if(channel == 3) {updateStateFn.accept("BrickletIO4V2OutputPin3", transformBrickletIO4V2OutputPin3Callback0(channel, value, cfg));}}, this.dev::removeMonoflopDoneListener));}
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO4V2InputValueConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2InputPin0").as(BrickletIO4V2InputValueConfig.class);
		this.setConfiguration(0, 'i', cfg.pinConfiguration0 % 2 == 1);
		            this.setInputValueCallbackConfiguration(0, channelCfg.updateInterval, false);
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO4V2InputValueConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2InputPin1").as(BrickletIO4V2InputValueConfig.class);
		this.setConfiguration(1, 'i', cfg.pinConfiguration1 % 2 == 1);
		            this.setInputValueCallbackConfiguration(1, channelCfg.updateInterval, false);
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO4V2InputValueConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2InputPin2").as(BrickletIO4V2InputValueConfig.class);
		this.setConfiguration(2, 'i', cfg.pinConfiguration2 % 2 == 1);
		            this.setInputValueCallbackConfiguration(2, channelCfg.updateInterval, false);
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO4V2InputValueConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2InputPin3").as(BrickletIO4V2InputValueConfig.class);
		this.setConfiguration(3, 'i', cfg.pinConfiguration3 % 2 == 1);
		            this.setInputValueCallbackConfiguration(3, channelCfg.updateInterval, false);
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2OutputPin0").as(BrickletIO4V2OutputPinConfig.class);
		this.setConfiguration(0, 'o', cfg.pinConfiguration0 % 2 == 1);
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2OutputPin1").as(BrickletIO4V2OutputPinConfig.class);
		this.setConfiguration(1, 'o', cfg.pinConfiguration1 % 2 == 1);
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2OutputPin2").as(BrickletIO4V2OutputPinConfig.class);
		this.setConfiguration(2, 'o', cfg.pinConfiguration2 % 2 == 1);
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO4V2OutputPinConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2OutputPin3").as(BrickletIO4V2OutputPinConfig.class);
		this.setConfiguration(3, 'o', cfg.pinConfiguration3 % 2 == 1);
		}
		if (cfg.pinConfiguration0 <= 1) {
		BrickletIO4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2MonoflopPin0").as(BrickletIO4V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration1 <= 1) {
		BrickletIO4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2MonoflopPin1").as(BrickletIO4V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration2 <= 1) {
		BrickletIO4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2MonoflopPin2").as(BrickletIO4V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration3 <= 1) {
		BrickletIO4V2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2MonoflopPin3").as(BrickletIO4V2MonoflopConfig.class);
		
		}
		if (cfg.pinConfiguration0 > 1) {
		BrickletIO4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2EdgeCountPin0").as(BrickletIO4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(0, channelCfg.edgeType, channelCfg.debounce);
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIO4V2EdgeCountPin0"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		if (cfg.pinConfiguration1 > 1) {
		BrickletIO4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2EdgeCountPin1").as(BrickletIO4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(1, channelCfg.edgeType, channelCfg.debounce);
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIO4V2EdgeCountPin1"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		if (cfg.pinConfiguration2 > 1) {
		BrickletIO4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2EdgeCountPin2").as(BrickletIO4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(2, channelCfg.edgeType, channelCfg.debounce);
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIO4V2EdgeCountPin2"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		if (cfg.pinConfiguration3 > 1) {
		BrickletIO4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIO4V2EdgeCountPin3").as(BrickletIO4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(3, channelCfg.edgeType, channelCfg.debounce);
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIO4V2EdgeCountPin3"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletIO4V2Config cfg = (BrickletIO4V2Config) config.as(BrickletIO4V2Config.class);
        if(cfg.pinConfiguration0 > 1) {
this.setInputValueCallbackConfiguration(0, 0, false);}
		if(cfg.pinConfiguration1 > 1) {
this.setInputValueCallbackConfiguration(1, 0, false);}
		if(cfg.pinConfiguration2 > 1) {
this.setInputValueCallbackConfiguration(2, 0, false);}
		if(cfg.pinConfiguration3 > 1) {
this.setInputValueCallbackConfiguration(3, 0, false);}
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIO4V2Config cfg = (BrickletIO4V2Config) config.as(BrickletIO4V2Config.class);
        List<String> result = new ArrayList<String>();
        if (cfg.pinConfiguration0 > 1) {
                result.add("BrickletIO4V2InputPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("BrickletIO4V2InputPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("BrickletIO4V2InputPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("BrickletIO4V2InputPin3");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("BrickletIO4V2OutputPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("BrickletIO4V2OutputPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("BrickletIO4V2OutputPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("BrickletIO4V2OutputPin3");
            }
		if (cfg.pinConfiguration0 <= 1) {
                result.add("BrickletIO4V2MonoflopPin0");
            }
		if (cfg.pinConfiguration1 <= 1) {
                result.add("BrickletIO4V2MonoflopPin1");
            }
		if (cfg.pinConfiguration2 <= 1) {
                result.add("BrickletIO4V2MonoflopPin2");
            }
		if (cfg.pinConfiguration3 <= 1) {
                result.add("BrickletIO4V2MonoflopPin3");
            }
		if (cfg.pinConfiguration0 > 1) {
                result.add("BrickletIO4V2EdgeCountPin0");
            }
		if (cfg.pinConfiguration1 > 1) {
                result.add("BrickletIO4V2EdgeCountPin1");
            }
		if (cfg.pinConfiguration2 > 1) {
                result.add("BrickletIO4V2EdgeCountPin2");
            }
		if (cfg.pinConfiguration3 > 1) {
                result.add("BrickletIO4V2EdgeCountPin3");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIO4V2InputValue":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO4V2InputValue"), "Input Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO4V2InputValue")).withDescription("The logic level that is currently measured on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletIO4V2OutputPin":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO4V2OutputPin"), "Output Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO4V2OutputPin")).withDescription("The logic level that is currently set on the pin.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "BrickletIO4V2Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO4V2Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO4V2Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            case "BrickletIO4V2EdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIO4V2EdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIO4V2EdgeCount")).withDescription("The current value of the edge counter for the selected channel")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge IO-4 Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4-channel digital input/output").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIO4V2InputPin0", new ChannelTypeUID("tinkerforge", "BrickletIO4V2InputValue")).withLabel("Input Value Pin 0").build(), new ChannelDefinitionBuilder("BrickletIO4V2InputPin1", new ChannelTypeUID("tinkerforge", "BrickletIO4V2InputValue")).withLabel("Input Value Pin 1").build(), new ChannelDefinitionBuilder("BrickletIO4V2InputPin2", new ChannelTypeUID("tinkerforge", "BrickletIO4V2InputValue")).withLabel("Input Value Pin 2").build(), new ChannelDefinitionBuilder("BrickletIO4V2InputPin3", new ChannelTypeUID("tinkerforge", "BrickletIO4V2InputValue")).withLabel("Input Value Pin 3").build(), new ChannelDefinitionBuilder("BrickletIO4V2OutputPin0", new ChannelTypeUID("tinkerforge", "BrickletIO4V2OutputPin")).withLabel("Output Value Pin 0").build(), new ChannelDefinitionBuilder("BrickletIO4V2OutputPin1", new ChannelTypeUID("tinkerforge", "BrickletIO4V2OutputPin")).withLabel("Output Value Pin 1").build(), new ChannelDefinitionBuilder("BrickletIO4V2OutputPin2", new ChannelTypeUID("tinkerforge", "BrickletIO4V2OutputPin")).withLabel("Output Value Pin 2").build(), new ChannelDefinitionBuilder("BrickletIO4V2OutputPin3", new ChannelTypeUID("tinkerforge", "BrickletIO4V2OutputPin")).withLabel("Output Value Pin 3").build(), new ChannelDefinitionBuilder("BrickletIO4V2MonoflopPin0", new ChannelTypeUID("tinkerforge", "BrickletIO4V2Monoflop")).withLabel("Monoflop Pin 0").build(), new ChannelDefinitionBuilder("BrickletIO4V2MonoflopPin1", new ChannelTypeUID("tinkerforge", "BrickletIO4V2Monoflop")).withLabel("Monoflop Pin 1").build(), new ChannelDefinitionBuilder("BrickletIO4V2MonoflopPin2", new ChannelTypeUID("tinkerforge", "BrickletIO4V2Monoflop")).withLabel("Monoflop Pin 2").build(), new ChannelDefinitionBuilder("BrickletIO4V2MonoflopPin3", new ChannelTypeUID("tinkerforge", "BrickletIO4V2Monoflop")).withLabel("Monoflop Pin 3").build(), new ChannelDefinitionBuilder("BrickletIO4V2EdgeCountPin0", new ChannelTypeUID("tinkerforge", "BrickletIO4V2EdgeCount")).withLabel("Edge Count Pin 0").build(), new ChannelDefinitionBuilder("BrickletIO4V2EdgeCountPin1", new ChannelTypeUID("tinkerforge", "BrickletIO4V2EdgeCount")).withLabel("Edge Count Pin 1").build(), new ChannelDefinitionBuilder("BrickletIO4V2EdgeCountPin2", new ChannelTypeUID("tinkerforge", "BrickletIO4V2EdgeCount")).withLabel("Edge Count Pin 2").build(), new ChannelDefinitionBuilder("BrickletIO4V2EdgeCountPin3", new ChannelTypeUID("tinkerforge", "BrickletIO4V2EdgeCount")).withLabel("Edge Count Pin 3").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletio4v2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("pinConfiguration0", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 0. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 0").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration1", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 1. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 1").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration2", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 2. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 2").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("pinConfiguration3", Type.INTEGER).withDefault("3").withDescription("Configures the direction of pin 3. Inputs without pull-up will be floating if nothing is connected. Outputs can have an initial state of low or high.").withLabel("Pin Configuration 3").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("3", "Input with pull-up"), new ParameterOption("2", "Input without pull-up"), new ParameterOption("1", "Output (Initial high)"), new ParameterOption("0", "Output (Initial low)"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO4V2InputValue":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO4V2OutputPin":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO4V2Monoflop":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the pin should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").withAdvanced(true).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIO4V2EdgeCount":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count On Update").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIO4V2Config cfg = (BrickletIO4V2Config) config.as(BrickletIO4V2Config.class);
        switch(channel) {
            case "BrickletIO4V2InputPin0": {
                   BrickletIO4V2InputValueConfig channelCfg = channelConfig.as(BrickletIO4V2InputValueConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2InputPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2InputPin1": {
                   BrickletIO4V2InputValueConfig channelCfg = channelConfig.as(BrickletIO4V2InputValueConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2InputPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2InputPin2": {
                   BrickletIO4V2InputValueConfig channelCfg = channelConfig.as(BrickletIO4V2InputValueConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2InputPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2InputPin3": {
                   BrickletIO4V2InputValueConfig channelCfg = channelConfig.as(BrickletIO4V2InputValueConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2InputPin3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2OutputPin0": {
                   BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2OutputPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2OutputPin1": {
                   BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2OutputPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2OutputPin2": {
                   BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2OutputPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2OutputPin3": {
                   BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2OutputPin3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2MonoflopPin0": {
                   BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                   {
            BrickletIO4V2.Monoflop value = this.getMonoflop(0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2MonoflopPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2MonoflopPin1": {
                   BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                   {
            BrickletIO4V2.Monoflop value = this.getMonoflop(1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2MonoflopPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2MonoflopPin2": {
                   BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                   {
            BrickletIO4V2.Monoflop value = this.getMonoflop(2);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2MonoflopPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2MonoflopPin3": {
                   BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                   {
            BrickletIO4V2.Monoflop value = this.getMonoflop(3);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2MonoflopPin3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2EdgeCountPin0": {
                   BrickletIO4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4V2EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount(0, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2EdgeCountPin0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2EdgeCountPin1": {
                   BrickletIO4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4V2EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount(1, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2EdgeCountPin1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2EdgeCountPin2": {
                   BrickletIO4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4V2EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount(2, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2EdgeCountPin2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIO4V2EdgeCountPin3": {
                   BrickletIO4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIO4V2EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount(3, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIO4V2EdgeCountPin3Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIO4V2Config cfg = (BrickletIO4V2Config) config.as(BrickletIO4V2Config.class);
        switch(channel) {
            case "BrickletIO4V2OutputPin0":
                if (command instanceof OnOffType) {
                    BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(0, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO4V2OutputPin1":
                if (command instanceof OnOffType) {
                    BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(1, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO4V2OutputPin2":
                if (command instanceof OnOffType) {
                    BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(2, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO4V2OutputPin3":
                if (command instanceof OnOffType) {
                    BrickletIO4V2OutputPinConfig channelCfg = channelConfig.as(BrickletIO4V2OutputPinConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(3, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIO4V2MonoflopPin0":
                if (command instanceof StringType) {
                    BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(0, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO4V2OutputPin0", 0));
                break;
            case "BrickletIO4V2MonoflopPin1":
                if (command instanceof StringType) {
                    BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO4V2OutputPin1", 0));
                break;
            case "BrickletIO4V2MonoflopPin2":
                if (command instanceof StringType) {
                    BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(2, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO4V2OutputPin2", 0));
                break;
            case "BrickletIO4V2MonoflopPin3":
                if (command instanceof StringType) {
                    BrickletIO4V2MonoflopConfig channelCfg = channelConfig.as(BrickletIO4V2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(3, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIO4V2OutputPin3", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIO4V2InputPin0Callback0(int channel, boolean changed, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2InputPin1Callback0(int channel, boolean changed, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2InputPin2Callback0(int channel, boolean changed, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2InputPin3Callback0(int channel, boolean changed, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2OutputPin0Callback0(int channel, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2OutputPin1Callback0(int channel, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2OutputPin2Callback0(int channel, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2OutputPin3Callback0(int channel, boolean value, BrickletIO4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2InputPin0Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2InputPin1Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2InputPin2Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2InputPin3Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2OutputPin0Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2OutputPin1Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2OutputPin2Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2OutputPin3Getter0(boolean[] value, BrickletIO4V2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2MonoflopPin0Getter0(BrickletIO4V2.Monoflop value, BrickletIO4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2MonoflopPin1Getter0(BrickletIO4V2.Monoflop value, BrickletIO4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2MonoflopPin2Getter0(BrickletIO4V2.Monoflop value, BrickletIO4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2MonoflopPin3Getter0(BrickletIO4V2.Monoflop value, BrickletIO4V2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2EdgeCountPin0Getter0(long value, BrickletIO4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2EdgeCountPin1Getter0(long value, BrickletIO4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2EdgeCountPin2Getter0(long value, BrickletIO4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIO4V2EdgeCountPin3Getter0(long value, BrickletIO4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }

}