/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.DecimalType;

import com.tinkerforge.BrickletIndustrialAnalogOutV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIndustrialAnalogOutV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletIndustrialAnalogOutV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIndustrialAnalogOutV2.DEVICE_DISPLAY_NAME, "brickletindustrialanalogoutv2", BrickletIndustrialAnalogOutV2.DEVICE_IDENTIFIER, BrickletIndustrialAnalogOutV2Wrapper.class, BrickletIndustrialAnalogOutV2Actions.class, "2.0.0", true);

    public BrickletIndustrialAnalogOutV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletIndustrialAnalogOutV2(uid, ipcon);
    }

    
	public final static int VOLTAGE_RANGE_0_TO_5V = 0;
	public final static int VOLTAGE_RANGE_0_TO_10V = 1;
	public final static int CURRENT_RANGE_4_TO_20MA = 0;
	public final static int CURRENT_RANGE_0_TO_20MA = 1;
	public final static int CURRENT_RANGE_0_TO_24MA = 2;
	public final static int OUT_LED_CONFIG_OFF = 0;
	public final static int OUT_LED_CONFIG_ON = 1;
	public final static int OUT_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int OUT_LED_CONFIG_SHOW_OUT_STATUS = 3;
	public final static int OUT_LED_STATUS_CONFIG_THRESHOLD = 0;
	public final static int OUT_LED_STATUS_CONFIG_INTENSITY = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setEnabled(boolean enabled) throws TinkerforgeException {
    this.dev.setEnabled(enabled);
}

public boolean getEnabled() throws TinkerforgeException {
    return this.dev.getEnabled();
}

public void setVoltage(int voltage) throws TinkerforgeException {
    this.dev.setVoltage(voltage);
}

public int getVoltage() throws TinkerforgeException {
    return this.dev.getVoltage();
}

public void setCurrent(int current) throws TinkerforgeException {
    this.dev.setCurrent(current);
}

public int getCurrent() throws TinkerforgeException {
    return this.dev.getCurrent();
}

public void setConfiguration(int voltageRange, int currentRange) throws TinkerforgeException {
    this.dev.setConfiguration(voltageRange, currentRange);
}

public BrickletIndustrialAnalogOutV2.Configuration getConfiguration() throws TinkerforgeException {
    return this.dev.getConfiguration();
}

public void setOutLEDConfig(int config) throws TinkerforgeException {
    this.dev.setOutLEDConfig(config);
}

public int getOutLEDConfig() throws TinkerforgeException {
    return this.dev.getOutLEDConfig();
}

public void setOutLEDStatusConfig(int min, int max, int config) throws TinkerforgeException {
    this.dev.setOutLEDStatusConfig(min, max, config);
}

public BrickletIndustrialAnalogOutV2.OutLEDStatusConfig getOutLEDStatusConfig() throws TinkerforgeException {
    return this.dev.getOutLEDStatusConfig();
}

public BrickletIndustrialAnalogOutV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletIndustrialAnalogOutV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialAnalogOutV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialAnalogOutV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletIndustrialAnalogOutV2Config cfg = (BrickletIndustrialAnalogOutV2Config) config.as(BrickletIndustrialAnalogOutV2Config.class);
        
        this.setConfiguration(cfg.voltageRange, cfg.currentRange);
		this.setOutLEDConfig(cfg.outLEDConfig);
		this.setOutLEDStatusConfig((int)(cfg.outLEDStatusMinimum.doubleValue() * (cfg.controlVoltage == 1 ? 1000.0 : 1000000.0)),
		                           (int)(cfg.outLEDStatusMaximum.doubleValue() * (cfg.controlVoltage == 1 ? 1000.0 : 1000000.0)),
		                           cfg.outLEDStatusMode);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletIndustrialAnalogOutV2EnabledConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialAnalogOutV2Enabled").as(BrickletIndustrialAnalogOutV2EnabledConfig.class);
		
		}
		if (cfg.controlVoltage == 0) {
		BrickletIndustrialAnalogOutV2CurrentConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialAnalogOutV2Current").as(BrickletIndustrialAnalogOutV2CurrentConfig.class);
		
		}
		if (cfg.controlVoltage == 1) {
		BrickletIndustrialAnalogOutV2VoltageConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialAnalogOutV2Voltage").as(BrickletIndustrialAnalogOutV2VoltageConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletIndustrialAnalogOutV2Config cfg = (BrickletIndustrialAnalogOutV2Config) config.as(BrickletIndustrialAnalogOutV2Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialAnalogOutV2Config cfg = (BrickletIndustrialAnalogOutV2Config) config.as(BrickletIndustrialAnalogOutV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialAnalogOutV2Enabled");
		if (cfg.controlVoltage == 0) {
                result.add("BrickletIndustrialAnalogOutV2Current");
            }
		if (cfg.controlVoltage == 1) {
                result.add("BrickletIndustrialAnalogOutV2Voltage");
            }
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialAnalogOutV2Enabled":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutV2Enabled"), "Output Enabled", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialAnalogOutV2Enabled")).withDescription("Enables/disables the output of voltage and current.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            case "BrickletIndustrialAnalogOutV2Voltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutV2Voltage"), "Output Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialAnalogOutV2Voltage")).withDescription("The output voltage in V. The output voltage and output current are linked. Changing the output voltage also changes the output current.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(10)).withPattern("%.3f %unit%").withReadOnly(false).build().toStateDescription()).build();
            case "BrickletIndustrialAnalogOutV2Current":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutV2Current"), "Output Current", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialAnalogOutV2Current")).withDescription("The output current in A. The output current and output voltage are linked. Changing the output current also changes the output voltage.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(0.024)).withPattern("%.6f %unit%").withReadOnly(false).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Analog Out Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Generates configurable DC voltage and current, 0V to 10V and 4mA to 20mA").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialAnalogOutV2Enabled", new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutV2Enabled")).withLabel("Output Enabled").build(), new ChannelDefinitionBuilder("BrickletIndustrialAnalogOutV2Current", new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutV2Current")).withLabel("Output Current").build(), new ChannelDefinitionBuilder("BrickletIndustrialAnalogOutV2Voltage", new ChannelTypeUID("tinkerforge", "BrickletIndustrialAnalogOutV2Voltage")).withLabel("Output Voltage").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialanalogoutv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("controlVoltage", Type.INTEGER).withDefault("1").withDescription("Sets the output configuration. As the output voltage and current level depend on each other, only one can be controlled at the same time.").withLabel("Output Configuration").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Current"), new ParameterOption("1", "Voltage"))).build(), ConfigDescriptionParameterBuilder.create("voltageRange", Type.INTEGER).withDefault("1").withDescription("Configures the voltage range. The resolution will always be 12 bit. This means, that the precision is higher with a smaller range.").withLabel("Voltage Range").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "0 To 5V"), new ParameterOption("1", "0 To 10V"))).build(), ConfigDescriptionParameterBuilder.create("currentRange", Type.INTEGER).withDefault("0").withDescription("Configures the current range. The resolution will always be 12 bit. This means, that the precision is higher with a smaller range.").withLabel("Current Range").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "4 To 20mA"), new ParameterOption("1", "0 To 20mA"), new ParameterOption("2", "0 To 24mA"))).build(), ConfigDescriptionParameterBuilder.create("outLEDConfig", Type.INTEGER).withDefault("3").withDescription("You can turn the Out LED off, on or show a heartbeat. You can also set the LED to Out Status. In this mode the LED can either be turned on with a pre-defined threshold or the intensity of the LED can change with the output value (voltage or current).").withLabel("Output LED Configuration").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Out Status"))).build(), ConfigDescriptionParameterBuilder.create("outLEDStatusMode", Type.INTEGER).withDefault("1").withDescription("For each channel you can choose between threshold and intensity mode.<br/><br/>In threshold mode you can define a positive or a negative threshold.<br/>For a positive threshold set the \"min\" parameter to the threshold value in mV or<br/>µA above which the LED should turn on and set the \"max\" parameter to 0. Example:<br/>If you set a positive threshold of 5V, the LED will turn on as soon as the<br/>output value exceeds 5V and turn off again if it goes below 5V.<br/>For a negative threshold set the \"max\" parameter to the threshold value in mV or<br/>µA below which the LED should turn on and set the \"min\" parameter to 0. Example:<br/>If you set a negative threshold of 5V, the LED will turn on as soon as the<br/>output value goes below 5V and the LED will turn off when the output value<br/>exceeds 5V.<br/><br/>In intensity mode you can define a range mV or µA that is used to scale the brightness<br/>of the LED. Example with min=2V, max=8V: The LED is off at 2V and below, on at<br/>8V and above and the brightness is linearly scaled between the values 2V and 8V.<br/>If the min value is greater than the max value, the LED brightness is scaled the<br/>other way around.").withLabel("Output LED Status Mode").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Threshold"), new ParameterOption("1", "Intensity"))).build(), ConfigDescriptionParameterBuilder.create("outLEDStatusMinimum", Type.DECIMAL).withDefault("0").withDescription("See LED Status Mode for further explaination.").withLabel("Output LED Status Maximum").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(10)).build(), ConfigDescriptionParameterBuilder.create("outLEDStatusMaximum", Type.DECIMAL).withDefault("10").withDescription("See LED Status Mode for further explaination.").withLabel("Output LED Status Maximum").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(10)).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialAnalogOutV2Enabled":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialAnalogOutV2Voltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialAnalogOutV2Current":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialAnalogOutV2Config cfg = (BrickletIndustrialAnalogOutV2Config) config.as(BrickletIndustrialAnalogOutV2Config.class);
        switch(channel) {
            case "BrickletIndustrialAnalogOutV2Enabled": {
                   BrickletIndustrialAnalogOutV2EnabledConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutV2EnabledConfig.class);
                   {
            boolean value = this.getEnabled();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialAnalogOutV2EnabledGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialAnalogOutV2Current": {
                   BrickletIndustrialAnalogOutV2CurrentConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutV2CurrentConfig.class);
                   {
            int value = this.getCurrent();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialAnalogOutV2CurrentGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialAnalogOutV2Voltage": {
                   BrickletIndustrialAnalogOutV2VoltageConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutV2VoltageConfig.class);
                   {
            int value = this.getVoltage();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialAnalogOutV2VoltageGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIndustrialAnalogOutV2Config cfg = (BrickletIndustrialAnalogOutV2Config) config.as(BrickletIndustrialAnalogOutV2Config.class);
        switch(channel) {
            case "BrickletIndustrialAnalogOutV2Enabled":
                if (command instanceof OnOffType) {
                    BrickletIndustrialAnalogOutV2EnabledConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutV2EnabledConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setEnabled(cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialAnalogOutV2Current":
                if (command instanceof Number) {
                    BrickletIndustrialAnalogOutV2CurrentConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutV2CurrentConfig.class);
                    Number cmd = (Number) command;
                    this.setCurrent((int)(cmd.doubleValue() * 1000000.0));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialAnalogOutV2Voltage":
                if (command instanceof Number) {
                    BrickletIndustrialAnalogOutV2VoltageConfig channelCfg = channelConfig.as(BrickletIndustrialAnalogOutV2VoltageConfig.class);
                    Number cmd = (Number) command;
                    this.setVoltage((int)(cmd.doubleValue() * 1000.0));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialAnalogOutV2EnabledGetter0(boolean value, BrickletIndustrialAnalogOutV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialAnalogOutV2CurrentGetter0(int value, BrickletIndustrialAnalogOutV2Config cfg) {
        return new QuantityType(value / 1000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialAnalogOutV2VoltageGetter0(int value, BrickletIndustrialAnalogOutV2Config cfg) {
        return new QuantityType(value / 1000.0, SmartHomeUnits.VOLT);
    }

}