/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletIndustrialDigitalIn4V2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIndustrialDigitalIn4V2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletIndustrialDigitalIn4V2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIndustrialDigitalIn4V2.DEVICE_DISPLAY_NAME, "brickletindustrialdigitalin4v2", BrickletIndustrialDigitalIn4V2.DEVICE_IDENTIFIER, BrickletIndustrialDigitalIn4V2Wrapper.class, BrickletIndustrialDigitalIn4V2Actions.class, "2.0.0", true);

    public BrickletIndustrialDigitalIn4V2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletIndustrialDigitalIn4V2(uid, ipcon);
    }

    
	public final static int CHANNEL_0 = 0;
	public final static int CHANNEL_1 = 1;
	public final static int CHANNEL_2 = 2;
	public final static int CHANNEL_3 = 3;
	public final static int EDGE_TYPE_RISING = 0;
	public final static int EDGE_TYPE_FALLING = 1;
	public final static int EDGE_TYPE_BOTH = 2;
	public final static int CHANNEL_LED_CONFIG_OFF = 0;
	public final static int CHANNEL_LED_CONFIG_ON = 1;
	public final static int CHANNEL_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int CHANNEL_LED_CONFIG_SHOW_CHANNEL_STATUS = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public boolean[] getValue() throws TinkerforgeException {
    return this.dev.getValue();
}

public void setValueCallbackConfiguration(int channel, long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setValueCallbackConfiguration(channel, period, valueHasToChange);
}

public BrickletIndustrialDigitalIn4V2.ValueCallbackConfiguration getValueCallbackConfiguration(int channel) throws TinkerforgeException {
    return this.dev.getValueCallbackConfiguration(channel);
}

public void setAllValueCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setAllValueCallbackConfiguration(period, valueHasToChange);
}

public BrickletIndustrialDigitalIn4V2.AllValueCallbackConfiguration getAllValueCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getAllValueCallbackConfiguration();
}

public long getEdgeCount(int channel, boolean resetCounter) throws TinkerforgeException {
    return this.dev.getEdgeCount(channel, resetCounter);
}

public void setEdgeCountConfiguration(int channel, int edgeType, int debounce) throws TinkerforgeException {
    this.dev.setEdgeCountConfiguration(channel, edgeType, debounce);
}

public BrickletIndustrialDigitalIn4V2.EdgeCountConfiguration getEdgeCountConfiguration(int channel) throws TinkerforgeException {
    return this.dev.getEdgeCountConfiguration(channel);
}

public void setChannelLEDConfig(int channel, int config) throws TinkerforgeException {
    this.dev.setChannelLEDConfig(channel, config);
}

public int getChannelLEDConfig(int channel) throws TinkerforgeException {
    return this.dev.getChannelLEDConfig(channel);
}

public BrickletIndustrialDigitalIn4V2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletIndustrialDigitalIn4V2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addValueListener(BrickletIndustrialDigitalIn4V2.ValueListener l) {
    this.dev.addValueListener(l);
}

public void removeValueListener(BrickletIndustrialDigitalIn4V2.ValueListener l) {
    this.dev.removeValueListener(l);
}

public void addAllValueListener(BrickletIndustrialDigitalIn4V2.AllValueListener l) {
    this.dev.addAllValueListener(l);
}

public void removeAllValueListener(BrickletIndustrialDigitalIn4V2.AllValueListener l) {
    this.dev.removeAllValueListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialDigitalIn4V2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialDigitalIn4V2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletIndustrialDigitalIn4V2Config cfg = (BrickletIndustrialDigitalIn4V2Config) config.as(BrickletIndustrialDigitalIn4V2Config.class);
        this.addValueListener(this.reg((channel, changed, value) -> {if(channel == 0) {updateStateFn.accept("BrickletIndustrialDigitalIn4V2Input0", transformBrickletIndustrialDigitalIn4V2Input0Callback0(channel, changed, value, cfg));}}, this.dev::removeValueListener));
		this.addValueListener(this.reg((channel, changed, value) -> {if(channel == 1) {updateStateFn.accept("BrickletIndustrialDigitalIn4V2Input1", transformBrickletIndustrialDigitalIn4V2Input1Callback0(channel, changed, value, cfg));}}, this.dev::removeValueListener));
		this.addValueListener(this.reg((channel, changed, value) -> {if(channel == 2) {updateStateFn.accept("BrickletIndustrialDigitalIn4V2Input2", transformBrickletIndustrialDigitalIn4V2Input2Callback0(channel, changed, value, cfg));}}, this.dev::removeValueListener));
		this.addValueListener(this.reg((channel, changed, value) -> {if(channel == 3) {updateStateFn.accept("BrickletIndustrialDigitalIn4V2Input3", transformBrickletIndustrialDigitalIn4V2Input3Callback0(channel, changed, value, cfg));}}, this.dev::removeValueListener));
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletIndustrialDigitalIn4V2ValueConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalIn4V2Input0").as(BrickletIndustrialDigitalIn4V2ValueConfig.class);
		this.setValueCallbackConfiguration(0, channelCfg.updateInterval, true);
		this.setChannelLEDConfig(0, channelCfg.ledConfig);
		}
		{
		BrickletIndustrialDigitalIn4V2ValueConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalIn4V2Input1").as(BrickletIndustrialDigitalIn4V2ValueConfig.class);
		this.setValueCallbackConfiguration(1, channelCfg.updateInterval, true);
		this.setChannelLEDConfig(1, channelCfg.ledConfig);
		}
		{
		BrickletIndustrialDigitalIn4V2ValueConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalIn4V2Input2").as(BrickletIndustrialDigitalIn4V2ValueConfig.class);
		this.setValueCallbackConfiguration(2, channelCfg.updateInterval, true);
		this.setChannelLEDConfig(2, channelCfg.ledConfig);
		}
		{
		BrickletIndustrialDigitalIn4V2ValueConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalIn4V2Input3").as(BrickletIndustrialDigitalIn4V2ValueConfig.class);
		this.setValueCallbackConfiguration(3, channelCfg.updateInterval, true);
		this.setChannelLEDConfig(3, channelCfg.ledConfig);
		}
		{
		BrickletIndustrialDigitalIn4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalIn4V2EdgeCountInput0").as(BrickletIndustrialDigitalIn4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(0, channelCfg.edgeType, channelCfg.debounce);
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalIn4V2EdgeCountInput0"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		{
		BrickletIndustrialDigitalIn4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalIn4V2EdgeCountInput1").as(BrickletIndustrialDigitalIn4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(1, channelCfg.edgeType, channelCfg.debounce);
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalIn4V2EdgeCountInput1"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		{
		BrickletIndustrialDigitalIn4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalIn4V2EdgeCountInput2").as(BrickletIndustrialDigitalIn4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(2, channelCfg.edgeType, channelCfg.debounce);
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalIn4V2EdgeCountInput2"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		{
		BrickletIndustrialDigitalIn4V2EdgeCountConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDigitalIn4V2EdgeCountInput3").as(BrickletIndustrialDigitalIn4V2EdgeCountConfig.class);
		this.setEdgeCountConfiguration(3, channelCfg.edgeType, channelCfg.debounce);
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletIndustrialDigitalIn4V2EdgeCountInput3"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletIndustrialDigitalIn4V2Config cfg = (BrickletIndustrialDigitalIn4V2Config) config.as(BrickletIndustrialDigitalIn4V2Config.class);
        this.setValueCallbackConfiguration(0, 0, true);
		this.setValueCallbackConfiguration(1, 0, true);
		this.setValueCallbackConfiguration(2, 0, true);
		this.setValueCallbackConfiguration(3, 0, true);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialDigitalIn4V2Config cfg = (BrickletIndustrialDigitalIn4V2Config) config.as(BrickletIndustrialDigitalIn4V2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialDigitalIn4V2Input0");
		result.add("BrickletIndustrialDigitalIn4V2Input1");
		result.add("BrickletIndustrialDigitalIn4V2Input2");
		result.add("BrickletIndustrialDigitalIn4V2Input3");
		result.add("BrickletIndustrialDigitalIn4V2EdgeCountInput0");
		result.add("BrickletIndustrialDigitalIn4V2EdgeCountInput1");
		result.add("BrickletIndustrialDigitalIn4V2EdgeCountInput2");
		result.add("BrickletIndustrialDigitalIn4V2EdgeCountInput3");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialDigitalIn4V2Value":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalIn4V2Value"), "Input Value", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDigitalIn4V2Value")).withDescription("The logic level that is currently measured on the input.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletIndustrialDigitalIn4V2EdgeCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalIn4V2EdgeCount"), "Edge Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDigitalIn4V2EdgeCount")).withDescription("The current value of the edge counter for the selected channel")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Digital In 4 Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4 galvanically isolated digital inputs").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialDigitalIn4V2Input0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalIn4V2Value")).withLabel("Input Value 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalIn4V2Input1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalIn4V2Value")).withLabel("Input Value 1").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalIn4V2Input2", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalIn4V2Value")).withLabel("Input Value 2").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalIn4V2Input3", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalIn4V2Value")).withLabel("Input Value 3").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalIn4V2EdgeCountInput0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalIn4V2EdgeCount")).withLabel("Edge Count Input 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalIn4V2EdgeCountInput1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalIn4V2EdgeCount")).withLabel("Edge Count Input 1").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalIn4V2EdgeCountInput2", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalIn4V2EdgeCount")).withLabel("Edge Count Input 2").build(), new ChannelDefinitionBuilder("BrickletIndustrialDigitalIn4V2EdgeCountInput3", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDigitalIn4V2EdgeCount")).withLabel("Edge Count Input 3").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialdigitalin4v2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialDigitalIn4V2Value":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("100").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("ledConfig", Type.INTEGER).withDefault("3").withDescription("Each channel has a corresponding LED. You can turn the LED off, on or show a heartbeat. You can also set the LED to Channel Status. In this mode the LED is on if the channel is high and off otherwise.").withLabel("LED Configuration").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Channel Status"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialDigitalIn4V2EdgeCount":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("edgeType", Type.INTEGER).withDefault("0").withDescription("The edge type parameter configures if rising edges, falling edges or both are counted.").withLabel("Edge Type").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Rising"), new ParameterOption("1", "Falling"), new ParameterOption("2", "Both"))).build(), ConfigDescriptionParameterBuilder.create("debounce", Type.INTEGER).withDefault("100").withDescription("The debounce time in ms.").withLabel("Debounce Time").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("resetOnRead", Type.BOOLEAN).withDefault("false").withDescription("Enabling this will reset the edge counter after OpenHAB reads its value. Use this if you want relative edge counts per update.").withLabel("Reset Edge Count On Update").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDigitalIn4V2Config cfg = (BrickletIndustrialDigitalIn4V2Config) config.as(BrickletIndustrialDigitalIn4V2Config.class);
        switch(channel) {
            case "BrickletIndustrialDigitalIn4V2Input0": {
                   BrickletIndustrialDigitalIn4V2ValueConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4V2ValueConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalIn4V2Input0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalIn4V2Input1": {
                   BrickletIndustrialDigitalIn4V2ValueConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4V2ValueConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalIn4V2Input1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalIn4V2Input2": {
                   BrickletIndustrialDigitalIn4V2ValueConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4V2ValueConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalIn4V2Input2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalIn4V2Input3": {
                   BrickletIndustrialDigitalIn4V2ValueConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4V2ValueConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalIn4V2Input3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalIn4V2EdgeCountInput0": {
                   BrickletIndustrialDigitalIn4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4V2EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount(0, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalIn4V2EdgeCountInput0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalIn4V2EdgeCountInput1": {
                   BrickletIndustrialDigitalIn4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4V2EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount(1, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalIn4V2EdgeCountInput1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalIn4V2EdgeCountInput2": {
                   BrickletIndustrialDigitalIn4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4V2EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount(2, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalIn4V2EdgeCountInput2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDigitalIn4V2EdgeCountInput3": {
                   BrickletIndustrialDigitalIn4V2EdgeCountConfig channelCfg = channelConfig.as(BrickletIndustrialDigitalIn4V2EdgeCountConfig.class);
                   {
            long value = this.getEdgeCount(3, channelCfg.resetOnRead);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDigitalIn4V2EdgeCountInput3Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIndustrialDigitalIn4V2Config cfg = (BrickletIndustrialDigitalIn4V2Config) config.as(BrickletIndustrialDigitalIn4V2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2Input0Callback0(int channel, boolean changed, boolean value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2Input1Callback0(int channel, boolean changed, boolean value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2Input2Callback0(int channel, boolean changed, boolean value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2Input3Callback0(int channel, boolean changed, boolean value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2Input0Getter0(boolean[] value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2Input1Getter0(boolean[] value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2Input2Getter0(boolean[] value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2Input3Getter0(boolean[] value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2EdgeCountInput0Getter0(long value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2EdgeCountInput1Getter0(long value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2EdgeCountInput2Getter0(long value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDigitalIn4V2EdgeCountInput3Getter0(long value, BrickletIndustrialDigitalIn4V2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }

}