/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletIndustrialDual020mAV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIndustrialDual020mAV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletIndustrialDual020mAV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIndustrialDual020mAV2.DEVICE_DISPLAY_NAME, "brickletindustrialdual020mav2", BrickletIndustrialDual020mAV2.DEVICE_IDENTIFIER, BrickletIndustrialDual020mAV2Wrapper.class, BrickletIndustrialDual020mAV2Actions.class, "2.0.0", true);

    public BrickletIndustrialDual020mAV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletIndustrialDual020mAV2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int SAMPLE_RATE_240_SPS = 0;
	public final static int SAMPLE_RATE_60_SPS = 1;
	public final static int SAMPLE_RATE_15_SPS = 2;
	public final static int SAMPLE_RATE_4_SPS = 3;
	public final static int GAIN_1X = 0;
	public final static int GAIN_2X = 1;
	public final static int GAIN_4X = 2;
	public final static int GAIN_8X = 3;
	public final static int CHANNEL_LED_CONFIG_OFF = 0;
	public final static int CHANNEL_LED_CONFIG_ON = 1;
	public final static int CHANNEL_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int CHANNEL_LED_CONFIG_SHOW_CHANNEL_STATUS = 3;
	public final static int CHANNEL_LED_STATUS_CONFIG_THRESHOLD = 0;
	public final static int CHANNEL_LED_STATUS_CONFIG_INTENSITY = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getCurrent(int channel) throws TinkerforgeException {
    return this.dev.getCurrent(channel);
}

public void setCurrentCallbackConfiguration(int channel, long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setCurrentCallbackConfiguration(channel, period, valueHasToChange, option, min, max);
}

public BrickletIndustrialDual020mAV2.CurrentCallbackConfiguration getCurrentCallbackConfiguration(int channel) throws TinkerforgeException {
    return this.dev.getCurrentCallbackConfiguration(channel);
}

public void setSampleRate(int rate) throws TinkerforgeException {
    this.dev.setSampleRate(rate);
}

public int getSampleRate() throws TinkerforgeException {
    return this.dev.getSampleRate();
}

public void setGain(int gain) throws TinkerforgeException {
    this.dev.setGain(gain);
}

public int getGain() throws TinkerforgeException {
    return this.dev.getGain();
}

public void setChannelLEDConfig(int channel, int config) throws TinkerforgeException {
    this.dev.setChannelLEDConfig(channel, config);
}

public int getChannelLEDConfig(int channel) throws TinkerforgeException {
    return this.dev.getChannelLEDConfig(channel);
}

public void setChannelLEDStatusConfig(int channel, int min, int max, int config) throws TinkerforgeException {
    this.dev.setChannelLEDStatusConfig(channel, min, max, config);
}

public BrickletIndustrialDual020mAV2.ChannelLEDStatusConfig getChannelLEDStatusConfig(int channel) throws TinkerforgeException {
    return this.dev.getChannelLEDStatusConfig(channel);
}

public BrickletIndustrialDual020mAV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletIndustrialDual020mAV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addCurrentListener(BrickletIndustrialDual020mAV2.CurrentListener l) {
    this.dev.addCurrentListener(l);
}

public void removeCurrentListener(BrickletIndustrialDual020mAV2.CurrentListener l) {
    this.dev.removeCurrentListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialDual020mAV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialDual020mAV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletIndustrialDual020mAV2Config cfg = (BrickletIndustrialDual020mAV2Config) config.as(BrickletIndustrialDual020mAV2Config.class);
        this.addCurrentListener(this.reg((channel, current) -> {if(channel == 0) {updateStateFn.accept("BrickletIndustrialDual020mAV2CurrentSensor0", transformBrickletIndustrialDual020mAV2CurrentSensor0Callback0(channel, current, cfg));}}, this.dev::removeCurrentListener));
		this.addCurrentListener(this.reg((channel, current) -> {if(channel == 1) {updateStateFn.accept("BrickletIndustrialDual020mAV2CurrentSensor1", transformBrickletIndustrialDual020mAV2CurrentSensor1Callback0(channel, current, cfg));}}, this.dev::removeCurrentListener));
        this.setSampleRate(cfg.sampleRate);
		    this.setGain(cfg.gain);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletIndustrialDual020mAV2CurrentConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDual020mAV2CurrentSensor0").as(BrickletIndustrialDual020mAV2CurrentConfig.class);
		this.setCurrentCallbackConfiguration(0, channelCfg.updateInterval, true, 'x', 0, 0);
		            this.setChannelLEDConfig(0, channelCfg.ledConfig);
		            this.setChannelLEDStatusConfig(0, channelCfg.ledStatusMinimum, channelCfg.ledStatusMaximum, channelCfg.ledStatusMode);
		}
		{
		BrickletIndustrialDual020mAV2CurrentConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDual020mAV2CurrentSensor1").as(BrickletIndustrialDual020mAV2CurrentConfig.class);
		this.setCurrentCallbackConfiguration(1, channelCfg.updateInterval, true, 'x', 0, 0);
		            this.setChannelLEDConfig(1, channelCfg.ledConfig);
		            this.setChannelLEDStatusConfig(1, channelCfg.ledStatusMinimum, channelCfg.ledStatusMaximum, channelCfg.ledStatusMode);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletIndustrialDual020mAV2Config cfg = (BrickletIndustrialDual020mAV2Config) config.as(BrickletIndustrialDual020mAV2Config.class);
        this.setCurrentCallbackConfiguration(0, 0, true, 'x', 0, 0);
		this.setCurrentCallbackConfiguration(1, 0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialDual020mAV2Config cfg = (BrickletIndustrialDual020mAV2Config) config.as(BrickletIndustrialDual020mAV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialDual020mAV2CurrentSensor0");
		result.add("BrickletIndustrialDual020mAV2CurrentSensor1");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialDual020mAV2Current":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mAV2Current"), "NOT USED", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDual020mAV2Current")).withDescription("Measured current between 0 and 0.022505322A (22.5mA)")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(0.022505322)).withPattern("%.6f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Dual 0-20mA Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures two DC currents between 0mA and 20mA (IEC 60381-1)").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialDual020mAV2CurrentSensor0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mAV2Current")).withLabel("Current Sensor 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialDual020mAV2CurrentSensor1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDual020mAV2Current")).withLabel("Current Sensor 1").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialdual020mav2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("sampleRate", Type.INTEGER).withDefault("3").withDescription("The sample rate to either 240, 60, 15 or 4 samples per second. The resolution for the rates is 12, 14, 16 and 18 bit respectively.").withLabel("Sample Rate").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "240 SPS"), new ParameterOption("1", "60 SPS"), new ParameterOption("2", "15 SPS"), new ParameterOption("3", "4 SPS"))).build(), ConfigDescriptionParameterBuilder.create("gain", Type.INTEGER).withDefault("0").withDescription("The gain between 1x and 8x. If you want to measure a very small current, you can increase the gain to get some more resolution.<br/><br/>Example: If you measure 0.5mA with a gain of 8x the return value will be 4mA.").withLabel("Gain").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "1x"), new ParameterOption("1", "2x"), new ParameterOption("2", "4x"), new ParameterOption("3", "8x"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletIndustrialDual020mAV2Current":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("ledConfig", Type.INTEGER).withDefault("3").withDescription("Each channel has a corresponding LED. You can turn the LED off, on or show a heartbeat. You can also set the LED to Show Channel Status. In this mode the LED can either be turned on with a pre-defined threshold or the intensity of the LED can change with the measured value.").withLabel("LED Configuration").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Channel Status"))).build(), ConfigDescriptionParameterBuilder.create("ledStatusMode", Type.INTEGER).withDefault("1").withDescription("For each channel you can choose between threshold and intensity mode.<br/><br/>In threshold mode you can define a positive or a negative threshold.<br/>For a positive threshold set the \"min\" parameter to the threshold value in nA<br/>above which the LED should turn on and set the \"max\" parameter to 0. Example:<br/>If you set a positive threshold of 10mA, the LED will turn on as soon as the<br/>current exceeds 10mA and turn off again if it goes below 10mA.<br/>For a negative threshold set the \"max\" parameter to the threshold value in nA<br/>below which the LED should turn on and set the \"min\" parameter to 0. Example:<br/>If you set a negative threshold of 10mA, the LED will turn on as soon as the<br/>current goes below 10mA and the LED will turn off when the current exceeds 10mA.<br/><br/>In intensity mode you can define a range in nA that is used to scale the brightness<br/>of the LED. Example with min=4mA and max=20mA: The LED is off at 4mA and below,<br/>on at 20mA and above and the brightness is linearly scaled between the values<br/>4mA and 20mA. If the min value is greater than the max value, the LED brightness<br/>is scaled the other way around.").withLabel("LED Status Mode").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Threshold"), new ParameterOption("1", "Intensity"))).build(), ConfigDescriptionParameterBuilder.create("ledStatusMinimum", Type.INTEGER).withDefault("0").withDescription("See LED Status Mode for further explaination.").withLabel("LED Status Maximum").withUnit("V").withMinimum(BigDecimal.valueOf(-35)).withMaximum(BigDecimal.valueOf(35)).build(), ConfigDescriptionParameterBuilder.create("ledStatusMaximum", Type.INTEGER).withDefault("10").withDescription("See LED Status Mode for further explaination.").withLabel("LED Status Maximum").withUnit("V").withMinimum(BigDecimal.valueOf(-35)).withMaximum(BigDecimal.valueOf(35)).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDual020mAV2Config cfg = (BrickletIndustrialDual020mAV2Config) config.as(BrickletIndustrialDual020mAV2Config.class);
        switch(channel) {
            case "BrickletIndustrialDual020mAV2CurrentSensor0": {
                   BrickletIndustrialDual020mAV2CurrentConfig channelCfg = channelConfig.as(BrickletIndustrialDual020mAV2CurrentConfig.class);
                   {
            int value = this.getCurrent(0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDual020mAV2CurrentSensor0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDual020mAV2CurrentSensor1": {
                   BrickletIndustrialDual020mAV2CurrentConfig channelCfg = channelConfig.as(BrickletIndustrialDual020mAV2CurrentConfig.class);
                   {
            int value = this.getCurrent(1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDual020mAV2CurrentSensor1Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIndustrialDual020mAV2Config cfg = (BrickletIndustrialDual020mAV2Config) config.as(BrickletIndustrialDual020mAV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mAV2CurrentSensor0Callback0(int channel, int current, BrickletIndustrialDual020mAV2Config cfg) {
        return new QuantityType<>(current / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mAV2CurrentSensor1Callback0(int channel, int current, BrickletIndustrialDual020mAV2Config cfg) {
        return new QuantityType<>(current / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mAV2CurrentSensor0Getter0(int value, BrickletIndustrialDual020mAV2Config cfg) {
        return new QuantityType<>(value / 1000000000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDual020mAV2CurrentSensor1Getter0(int value, BrickletIndustrialDual020mAV2Config cfg) {
        return new QuantityType<>(value / 1000000000.0, SmartHomeUnits.AMPERE);
    }

}