/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletIndustrialDualAnalogIn;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIndustrialDualAnalogInWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletIndustrialDualAnalogIn dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIndustrialDualAnalogIn.DEVICE_DISPLAY_NAME, "brickletindustrialdualanalogin", BrickletIndustrialDualAnalogIn.DEVICE_IDENTIFIER, BrickletIndustrialDualAnalogInWrapper.class, BrickletIndustrialDualAnalogInActions.class, "2.0.0", false);

    public BrickletIndustrialDualAnalogInWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletIndustrialDualAnalogIn(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int SAMPLE_RATE_976_SPS = 0;
	public final static int SAMPLE_RATE_488_SPS = 1;
	public final static int SAMPLE_RATE_244_SPS = 2;
	public final static int SAMPLE_RATE_122_SPS = 3;
	public final static int SAMPLE_RATE_61_SPS = 4;
	public final static int SAMPLE_RATE_4_SPS = 5;
	public final static int SAMPLE_RATE_2_SPS = 6;
	public final static int SAMPLE_RATE_1_SPS = 7;


    public int getVoltage(int channel) throws TinkerforgeException {
    return this.dev.getVoltage(channel);
}

public void setVoltageCallbackPeriod(int channel, long period) throws TinkerforgeException {
    this.dev.setVoltageCallbackPeriod(channel, period);
}

public long getVoltageCallbackPeriod(int channel) throws TinkerforgeException {
    return this.dev.getVoltageCallbackPeriod(channel);
}

public void setVoltageCallbackThreshold(int channel, char option, int min, int max) throws TinkerforgeException {
    this.dev.setVoltageCallbackThreshold(channel, option, min, max);
}

public BrickletIndustrialDualAnalogIn.VoltageCallbackThreshold getVoltageCallbackThreshold(int channel) throws TinkerforgeException {
    return this.dev.getVoltageCallbackThreshold(channel);
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public void setSampleRate(int rate) throws TinkerforgeException {
    this.dev.setSampleRate(rate);
}

public int getSampleRate() throws TinkerforgeException {
    return this.dev.getSampleRate();
}

public void setCalibration(int[] offset, int[] gain) throws TinkerforgeException {
    this.dev.setCalibration(offset, gain);
}

public BrickletIndustrialDualAnalogIn.Calibration getCalibration() throws TinkerforgeException {
    return this.dev.getCalibration();
}

public int[] getADCValues() throws TinkerforgeException {
    return this.dev.getADCValues();
}

public BrickletIndustrialDualAnalogIn.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addVoltageListener(BrickletIndustrialDualAnalogIn.VoltageListener l) {
    this.dev.addVoltageListener(l);
}

public void removeVoltageListener(BrickletIndustrialDualAnalogIn.VoltageListener l) {
    this.dev.removeVoltageListener(l);
}

public void addVoltageReachedListener(BrickletIndustrialDualAnalogIn.VoltageReachedListener l) {
    this.dev.addVoltageReachedListener(l);
}

public void removeVoltageReachedListener(BrickletIndustrialDualAnalogIn.VoltageReachedListener l) {
    this.dev.removeVoltageReachedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialDualAnalogInWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialDualAnalogInWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletIndustrialDualAnalogInConfig cfg = (BrickletIndustrialDualAnalogInConfig) config.as(BrickletIndustrialDualAnalogInConfig.class);
        this.addVoltageListener(this.reg((channel, voltage) -> {if(channel == 0) {updateStateFn.accept("BrickletIndustrialDualAnalogInVoltageChannel0", transformBrickletIndustrialDualAnalogInVoltageChannel0Callback0(channel, voltage, cfg));}}, this.dev::removeVoltageListener));
		this.addVoltageListener(this.reg((channel, voltage) -> {if(channel == 1) {updateStateFn.accept("BrickletIndustrialDualAnalogInVoltageChannel1", transformBrickletIndustrialDualAnalogInVoltageChannel1Callback0(channel, voltage, cfg));}}, this.dev::removeVoltageListener));
        this.setSampleRate(cfg.sampleRate);
		{
		BrickletIndustrialDualAnalogInVoltageConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDualAnalogInVoltageChannel0").as(BrickletIndustrialDualAnalogInVoltageConfig.class);
		this.setVoltageCallbackPeriod(0, channelCfg.updateInterval);
		}
		{
		BrickletIndustrialDualAnalogInVoltageConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDualAnalogInVoltageChannel1").as(BrickletIndustrialDualAnalogInVoltageConfig.class);
		this.setVoltageCallbackPeriod(1, channelCfg.updateInterval);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletIndustrialDualAnalogInConfig cfg = (BrickletIndustrialDualAnalogInConfig) config.as(BrickletIndustrialDualAnalogInConfig.class);
        this.setVoltageCallbackPeriod(0, 0);
		this.setVoltageCallbackPeriod(1, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialDualAnalogInConfig cfg = (BrickletIndustrialDualAnalogInConfig) config.as(BrickletIndustrialDualAnalogInConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialDualAnalogInVoltageChannel0");
		result.add("BrickletIndustrialDualAnalogInVoltageChannel1");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialDualAnalogInVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDualAnalogInVoltage"), "NOT USED", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDualAnalogInVoltage")).withDescription("Measured voltage between -35 and 35 V")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-35)).withMaximum(BigDecimal.valueOf(35)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Dual Analog In Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures two DC voltages between -35V and +35V with 24bit resolution each").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialDualAnalogInVoltageChannel0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDualAnalogInVoltage")).withLabel("Voltage Channel 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialDualAnalogInVoltageChannel1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDualAnalogInVoltage")).withLabel("Voltage Channel 1").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialdualanalogin":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("sampleRate", Type.INTEGER).withDefault("6").withDescription("The voltage measurement sample rate. Decreasing the sample rate will also decrease the noise on the data.").withLabel("Sample Rate").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "976 SPS"), new ParameterOption("1", "488 SPS"), new ParameterOption("2", "244 SPS"), new ParameterOption("3", "122 SPS"), new ParameterOption("4", "61 SPS"), new ParameterOption("5", "4 SPS"), new ParameterOption("6", "2 SPS"), new ParameterOption("7", "1 SPS"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletIndustrialDualAnalogInVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDualAnalogInConfig cfg = (BrickletIndustrialDualAnalogInConfig) config.as(BrickletIndustrialDualAnalogInConfig.class);
        switch(channel) {
            case "BrickletIndustrialDualAnalogInVoltageChannel0": {
                   BrickletIndustrialDualAnalogInVoltageConfig channelCfg = channelConfig.as(BrickletIndustrialDualAnalogInVoltageConfig.class);
                   {
            int value = this.getVoltage(0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDualAnalogInVoltageChannel0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDualAnalogInVoltageChannel1": {
                   BrickletIndustrialDualAnalogInVoltageConfig channelCfg = channelConfig.as(BrickletIndustrialDualAnalogInVoltageConfig.class);
                   {
            int value = this.getVoltage(1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDualAnalogInVoltageChannel1Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletIndustrialDualAnalogInConfig cfg = (BrickletIndustrialDualAnalogInConfig) config.as(BrickletIndustrialDualAnalogInConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDualAnalogInVoltageChannel0Callback0(int channel, int voltage, BrickletIndustrialDualAnalogInConfig cfg) {
        return new QuantityType<>(voltage / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDualAnalogInVoltageChannel1Callback0(int channel, int voltage, BrickletIndustrialDualAnalogInConfig cfg) {
        return new QuantityType<>(voltage / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDualAnalogInVoltageChannel0Getter0(int value, BrickletIndustrialDualAnalogInConfig cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDualAnalogInVoltageChannel1Getter0(int value, BrickletIndustrialDualAnalogInConfig cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }

}