/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletIndustrialDualRelay;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIndustrialDualRelayWrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletIndustrialDualRelay dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIndustrialDualRelay.DEVICE_DISPLAY_NAME, "brickletindustrialdualrelay", BrickletIndustrialDualRelay.DEVICE_IDENTIFIER, BrickletIndustrialDualRelayWrapper.class, BrickletIndustrialDualRelayActions.class, "2.0.0", true);

    public BrickletIndustrialDualRelayWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletIndustrialDualRelay(uid, ipcon);
    }

    
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setValue(boolean channel0, boolean channel1) throws TinkerforgeException {
    this.dev.setValue(channel0, channel1);
}

public BrickletIndustrialDualRelay.Value getValue() throws TinkerforgeException {
    return this.dev.getValue();
}

public void setMonoflop(int channel, boolean value, long time) throws TinkerforgeException {
    this.dev.setMonoflop(channel, value, time);
}

public BrickletIndustrialDualRelay.Monoflop getMonoflop(int channel) throws TinkerforgeException {
    return this.dev.getMonoflop(channel);
}

public void setSelectedValue(int channel, boolean value) throws TinkerforgeException {
    this.dev.setSelectedValue(channel, value);
}

public BrickletIndustrialDualRelay.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletIndustrialDualRelay.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addMonoflopDoneListener(BrickletIndustrialDualRelay.MonoflopDoneListener l) {
    this.dev.addMonoflopDoneListener(l);
}

public void removeMonoflopDoneListener(BrickletIndustrialDualRelay.MonoflopDoneListener l) {
    this.dev.removeMonoflopDoneListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialDualRelayWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialDualRelayWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletIndustrialDualRelayConfig cfg = (BrickletIndustrialDualRelayConfig) config.as(BrickletIndustrialDualRelayConfig.class);
        this.addMonoflopDoneListener(this.reg((channel, value) -> {if(channel == 0) {updateStateFn.accept("BrickletIndustrialDualRelayRelay0", transformBrickletIndustrialDualRelayRelay0Callback0(channel, value, cfg));}}, this.dev::removeMonoflopDoneListener));
		this.addMonoflopDoneListener(this.reg((channel, value) -> {if(channel == 1) {updateStateFn.accept("BrickletIndustrialDualRelayRelay1", transformBrickletIndustrialDualRelayRelay1Callback0(channel, value, cfg));}}, this.dev::removeMonoflopDoneListener));
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletIndustrialDualRelayRelayConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDualRelayRelay0").as(BrickletIndustrialDualRelayRelayConfig.class);
		
		}
		{
		BrickletIndustrialDualRelayRelayConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDualRelayRelay1").as(BrickletIndustrialDualRelayRelayConfig.class);
		
		}
		{
		BrickletIndustrialDualRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDualRelayMonofloprelay0").as(BrickletIndustrialDualRelayMonoflopConfig.class);
		
		}
		{
		BrickletIndustrialDualRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialDualRelayMonofloprelay1").as(BrickletIndustrialDualRelayMonoflopConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletIndustrialDualRelayConfig cfg = (BrickletIndustrialDualRelayConfig) config.as(BrickletIndustrialDualRelayConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialDualRelayConfig cfg = (BrickletIndustrialDualRelayConfig) config.as(BrickletIndustrialDualRelayConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialDualRelayRelay0");
		result.add("BrickletIndustrialDualRelayRelay1");
		result.add("BrickletIndustrialDualRelayMonofloprelay0");
		result.add("BrickletIndustrialDualRelayMonofloprelay1");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialDualRelayRelay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDualRelayRelay"), "NOT USED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDualRelayRelay")).withDescription("NOT USED").build();
            case "BrickletIndustrialDualRelayMonoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialDualRelayMonoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialDualRelayMonoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Dual Relay Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Two relays to switch AC/DC devices").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialDualRelayRelay0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDualRelayRelay")).withLabel("Relay 0").withDescription("Switches Relay 0. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialDualRelayRelay1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDualRelayRelay")).withLabel("Relay 1").withDescription("Switches Relay 1. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialDualRelayMonofloprelay0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDualRelayMonoflop")).withLabel("Monoflop Relay 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialDualRelayMonofloprelay1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialDualRelayMonoflop")).withLabel("Monoflop Relay 1").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialdualrelay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletIndustrialDualRelayRelay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialDualRelayMonoflop":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the relay should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").withAdvanced(true).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialDualRelayConfig cfg = (BrickletIndustrialDualRelayConfig) config.as(BrickletIndustrialDualRelayConfig.class);
        switch(channel) {
            case "BrickletIndustrialDualRelayRelay0": {
                   BrickletIndustrialDualRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialDualRelayRelayConfig.class);
                   {
            BrickletIndustrialDualRelay.Value value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDualRelayRelay0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDualRelayRelay1": {
                   BrickletIndustrialDualRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialDualRelayRelayConfig.class);
                   {
            BrickletIndustrialDualRelay.Value value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDualRelayRelay1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDualRelayMonofloprelay0": {
                   BrickletIndustrialDualRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDualRelayMonoflopConfig.class);
                   {
            BrickletIndustrialDualRelay.Monoflop value = this.getMonoflop(0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDualRelayMonofloprelay0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialDualRelayMonofloprelay1": {
                   BrickletIndustrialDualRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDualRelayMonoflopConfig.class);
                   {
            BrickletIndustrialDualRelay.Monoflop value = this.getMonoflop(1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialDualRelayMonofloprelay1Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIndustrialDualRelayConfig cfg = (BrickletIndustrialDualRelayConfig) config.as(BrickletIndustrialDualRelayConfig.class);
        switch(channel) {
            case "BrickletIndustrialDualRelayRelay0":
                if (command instanceof OnOffType) {
                    BrickletIndustrialDualRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialDualRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(0, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialDualRelayRelay1":
                if (command instanceof OnOffType) {
                    BrickletIndustrialDualRelayRelayConfig channelCfg = channelConfig.as(BrickletIndustrialDualRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(1, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialDualRelayMonofloprelay0":
                if (command instanceof StringType) {
                    BrickletIndustrialDualRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDualRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(0, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialDualRelayRelay0", 0));
                break;
            case "BrickletIndustrialDualRelayMonofloprelay1":
                if (command instanceof StringType) {
                    BrickletIndustrialDualRelayMonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialDualRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialDualRelayRelay1", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDualRelayRelay0Callback0(int channel, boolean value, BrickletIndustrialDualRelayConfig cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDualRelayRelay1Callback0(int channel, boolean value, BrickletIndustrialDualRelayConfig cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDualRelayRelay0Getter0(BrickletIndustrialDualRelay.Value value, BrickletIndustrialDualRelayConfig cfg) {
        return value.channel0 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDualRelayRelay1Getter0(BrickletIndustrialDualRelay.Value value, BrickletIndustrialDualRelayConfig cfg) {
        return value.channel1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDualRelayMonofloprelay0Getter0(BrickletIndustrialDualRelay.Monoflop value, BrickletIndustrialDualRelayConfig cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialDualRelayMonofloprelay1Getter0(BrickletIndustrialDualRelay.Monoflop value, BrickletIndustrialDualRelayConfig cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }

}