/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletIndustrialQuadRelayV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletIndustrialQuadRelayV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletIndustrialQuadRelayV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletIndustrialQuadRelayV2.DEVICE_DISPLAY_NAME, "brickletindustrialquadrelayv2", BrickletIndustrialQuadRelayV2.DEVICE_IDENTIFIER, BrickletIndustrialQuadRelayV2Wrapper.class, BrickletIndustrialQuadRelayV2Actions.class, "2.0.0", true);

    public BrickletIndustrialQuadRelayV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletIndustrialQuadRelayV2(uid, ipcon);
    }

    
	public final static int CHANNEL_LED_CONFIG_OFF = 0;
	public final static int CHANNEL_LED_CONFIG_ON = 1;
	public final static int CHANNEL_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int CHANNEL_LED_CONFIG_SHOW_CHANNEL_STATUS = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setValue(boolean[] value) throws TinkerforgeException {
    this.dev.setValue(value);
}

public boolean[] getValue() throws TinkerforgeException {
    return this.dev.getValue();
}

public void setMonoflop(int channel, boolean value, long time) throws TinkerforgeException {
    this.dev.setMonoflop(channel, value, time);
}

public BrickletIndustrialQuadRelayV2.Monoflop getMonoflop(int channel) throws TinkerforgeException {
    return this.dev.getMonoflop(channel);
}

public void setSelectedValue(int channel, boolean value) throws TinkerforgeException {
    this.dev.setSelectedValue(channel, value);
}

public void setChannelLEDConfig(int channel, int config) throws TinkerforgeException {
    this.dev.setChannelLEDConfig(channel, config);
}

public int getChannelLEDConfig(int channel) throws TinkerforgeException {
    return this.dev.getChannelLEDConfig(channel);
}

public BrickletIndustrialQuadRelayV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletIndustrialQuadRelayV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addMonoflopDoneListener(BrickletIndustrialQuadRelayV2.MonoflopDoneListener l) {
    this.dev.addMonoflopDoneListener(l);
}

public void removeMonoflopDoneListener(BrickletIndustrialQuadRelayV2.MonoflopDoneListener l) {
    this.dev.removeMonoflopDoneListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialQuadRelayV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialQuadRelayV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletIndustrialQuadRelayV2Config cfg = (BrickletIndustrialQuadRelayV2Config) config.as(BrickletIndustrialQuadRelayV2Config.class);
        this.addMonoflopDoneListener(this.reg((channel, value) -> {if(channel == 0) {updateStateFn.accept("BrickletIndustrialQuadRelayV2Relay0", transformBrickletIndustrialQuadRelayV2Relay0Callback0(channel, value, cfg));}}, this.dev::removeMonoflopDoneListener));
		this.addMonoflopDoneListener(this.reg((channel, value) -> {if(channel == 1) {updateStateFn.accept("BrickletIndustrialQuadRelayV2Relay1", transformBrickletIndustrialQuadRelayV2Relay1Callback0(channel, value, cfg));}}, this.dev::removeMonoflopDoneListener));
		this.addMonoflopDoneListener(this.reg((channel, value) -> {if(channel == 2) {updateStateFn.accept("BrickletIndustrialQuadRelayV2Relay2", transformBrickletIndustrialQuadRelayV2Relay2Callback0(channel, value, cfg));}}, this.dev::removeMonoflopDoneListener));
		this.addMonoflopDoneListener(this.reg((channel, value) -> {if(channel == 3) {updateStateFn.accept("BrickletIndustrialQuadRelayV2Relay3", transformBrickletIndustrialQuadRelayV2Relay3Callback0(channel, value, cfg));}}, this.dev::removeMonoflopDoneListener));
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletIndustrialQuadRelayV2RelayConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayV2Relay0").as(BrickletIndustrialQuadRelayV2RelayConfig.class);
		this.setChannelLEDConfig(0, channelCfg.channelLEDConfig);
		}
		{
		BrickletIndustrialQuadRelayV2RelayConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayV2Relay1").as(BrickletIndustrialQuadRelayV2RelayConfig.class);
		this.setChannelLEDConfig(1, channelCfg.channelLEDConfig);
		}
		{
		BrickletIndustrialQuadRelayV2RelayConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayV2Relay2").as(BrickletIndustrialQuadRelayV2RelayConfig.class);
		this.setChannelLEDConfig(2, channelCfg.channelLEDConfig);
		}
		{
		BrickletIndustrialQuadRelayV2RelayConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayV2Relay3").as(BrickletIndustrialQuadRelayV2RelayConfig.class);
		this.setChannelLEDConfig(3, channelCfg.channelLEDConfig);
		}
		{
		BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayV2Monofloprelay0").as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayV2Monofloprelay1").as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayV2Monofloprelay2").as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
		
		}
		{
		BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayV2Monofloprelay3").as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletIndustrialQuadRelayV2Config cfg = (BrickletIndustrialQuadRelayV2Config) config.as(BrickletIndustrialQuadRelayV2Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialQuadRelayV2Config cfg = (BrickletIndustrialQuadRelayV2Config) config.as(BrickletIndustrialQuadRelayV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialQuadRelayV2Relay0");
		result.add("BrickletIndustrialQuadRelayV2Relay1");
		result.add("BrickletIndustrialQuadRelayV2Relay2");
		result.add("BrickletIndustrialQuadRelayV2Relay3");
		result.add("BrickletIndustrialQuadRelayV2Monofloprelay0");
		result.add("BrickletIndustrialQuadRelayV2Monofloprelay1");
		result.add("BrickletIndustrialQuadRelayV2Monofloprelay2");
		result.add("BrickletIndustrialQuadRelayV2Monofloprelay3");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialQuadRelayV2Relay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayV2Relay"), "NOT USED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialQuadRelayV2Relay")).withDescription("NOT USED").build();
            case "BrickletIndustrialQuadRelayV2Monoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayV2Monoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialQuadRelayV2Monoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Quad Relay Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4 galvanically isolated solid state relays").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayV2Relay0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayV2Relay")).withLabel("Relay 0").withDescription("Switches Relay 0. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayV2Relay1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayV2Relay")).withLabel("Relay 1").withDescription("Switches Relay 1. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayV2Relay2", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayV2Relay")).withLabel("Relay 2").withDescription("Switches Relay 2. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayV2Relay3", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayV2Relay")).withLabel("Relay 3").withDescription("Switches Relay 3. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayV2Monofloprelay0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayV2Monoflop")).withLabel("Monoflop Relay 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayV2Monofloprelay1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayV2Monoflop")).withLabel("Monoflop Relay 1").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayV2Monofloprelay2", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayV2Monoflop")).withLabel("Monoflop Relay 2").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayV2Monofloprelay3", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayV2Monoflop")).withLabel("Monoflop Relay 3").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialquadrelayv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletIndustrialQuadRelayV2Relay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("channelLEDConfig", Type.INTEGER).withDefault("3").withDescription("Each channel has a corresponding LED. You can turn the LED off, on or show a heartbeat. You can also set the LED to Channel Status. In this mode the LED is on if the channel is high and off otherwise.").withLabel("Channel LED Config").withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Channel Status"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialQuadRelayV2Monoflop":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the relay should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").withAdvanced(true).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialQuadRelayV2Config cfg = (BrickletIndustrialQuadRelayV2Config) config.as(BrickletIndustrialQuadRelayV2Config.class);
        switch(channel) {
            case "BrickletIndustrialQuadRelayV2Relay0": {
                   BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayV2Relay0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayV2Relay1": {
                   BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayV2Relay1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayV2Relay2": {
                   BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayV2Relay2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayV2Relay3": {
                   BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                   {
            boolean[] value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayV2Relay3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayV2Monofloprelay0": {
                   BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                   {
            BrickletIndustrialQuadRelayV2.Monoflop value = this.getMonoflop(0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayV2Monofloprelay0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayV2Monofloprelay1": {
                   BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                   {
            BrickletIndustrialQuadRelayV2.Monoflop value = this.getMonoflop(1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayV2Monofloprelay1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayV2Monofloprelay2": {
                   BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                   {
            BrickletIndustrialQuadRelayV2.Monoflop value = this.getMonoflop(2);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayV2Monofloprelay2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayV2Monofloprelay3": {
                   BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                   {
            BrickletIndustrialQuadRelayV2.Monoflop value = this.getMonoflop(3);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayV2Monofloprelay3Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIndustrialQuadRelayV2Config cfg = (BrickletIndustrialQuadRelayV2Config) config.as(BrickletIndustrialQuadRelayV2Config.class);
        switch(channel) {
            case "BrickletIndustrialQuadRelayV2Relay0":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(0, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayV2Relay1":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(1, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayV2Relay2":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(2, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayV2Relay3":
                if (command instanceof OnOffType) {
                    BrickletIndustrialQuadRelayV2RelayConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2RelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setSelectedValue(3, cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayV2Monofloprelay0":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(0, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayV2Relay0", 0));
                break;
            case "BrickletIndustrialQuadRelayV2Monofloprelay1":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayV2Relay1", 0));
                break;
            case "BrickletIndustrialQuadRelayV2Monofloprelay2":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(2, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayV2Relay2", 0));
                break;
            case "BrickletIndustrialQuadRelayV2Monofloprelay3":
                if (command instanceof StringType) {
                    BrickletIndustrialQuadRelayV2MonoflopConfig channelCfg = channelConfig.as(BrickletIndustrialQuadRelayV2MonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(3, channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayV2Relay3", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Relay0Callback0(int channel, boolean value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Relay1Callback0(int channel, boolean value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Relay2Callback0(int channel, boolean value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Relay3Callback0(int channel, boolean value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Relay0Getter0(boolean[] value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value[0] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Relay1Getter0(boolean[] value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value[1] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Relay2Getter0(boolean[] value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value[2] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Relay3Getter0(boolean[] value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value[3] ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Monofloprelay0Getter0(BrickletIndustrialQuadRelayV2.Monoflop value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Monofloprelay1Getter0(BrickletIndustrialQuadRelayV2.Monoflop value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Monofloprelay2Getter0(BrickletIndustrialQuadRelayV2.Monoflop value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayV2Monofloprelay3Getter0(BrickletIndustrialQuadRelayV2.Monoflop value, BrickletIndustrialQuadRelayV2Config cfg) {
        return value.value ? OnOffType.ON : OnOffType.OFF;
    }

}