/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;

import com.tinkerforge.BrickletJoystickV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletJoystickV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletJoystickV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletJoystickV2.DEVICE_DISPLAY_NAME, "brickletjoystickv2", BrickletJoystickV2.DEVICE_IDENTIFIER, BrickletJoystickV2Wrapper.class, BrickletJoystickV2Actions.class, "2.0.0", true);

    public BrickletJoystickV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletJoystickV2(uid, ipcon);
    }

    
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public BrickletJoystickV2.Position getPosition() throws TinkerforgeException {
    return this.dev.getPosition();
}

public boolean isPressed() throws TinkerforgeException {
    return this.dev.isPressed();
}

public void calibrate() throws TinkerforgeException {
    this.dev.calibrate();
}

public void setPositionCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setPositionCallbackConfiguration(period, valueHasToChange);
}

public BrickletJoystickV2.PositionCallbackConfiguration getPositionCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getPositionCallbackConfiguration();
}

public void setPressedCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setPressedCallbackConfiguration(period, valueHasToChange);
}

public BrickletJoystickV2.PressedCallbackConfiguration getPressedCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getPressedCallbackConfiguration();
}

public BrickletJoystickV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletJoystickV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addPositionListener(BrickletJoystickV2.PositionListener l) {
    this.dev.addPositionListener(l);
}

public void removePositionListener(BrickletJoystickV2.PositionListener l) {
    this.dev.removePositionListener(l);
}

public void addPressedListener(BrickletJoystickV2.PressedListener l) {
    this.dev.addPressedListener(l);
}

public void removePressedListener(BrickletJoystickV2.PressedListener l) {
    this.dev.removePressedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletJoystickV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletJoystickV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletJoystickV2Config cfg = (BrickletJoystickV2Config) config.as(BrickletJoystickV2Config.class);
        this.addPositionListener(this.reg((x, y) -> {if(true) {updateStateFn.accept("BrickletJoystickV2PositionX", transformBrickletJoystickV2PositionXCallback0(x, y, cfg));}}, this.dev::removePositionListener));
		this.addPositionListener(this.reg((x, y) -> {if(true) {updateStateFn.accept("BrickletJoystickV2PositionY", transformBrickletJoystickV2PositionYCallback0(x, y, cfg));}}, this.dev::removePositionListener));
		this.addPressedListener(this.reg((pressed) -> {if(true) {triggerChannelFn.accept("BrickletJoystickV2Pressed", transformBrickletJoystickV2PressedCallback0(pressed, cfg));}}, this.dev::removePressedListener));
        this.setPositionCallbackConfiguration(cfg.positionUpdateInterval, true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletJoystickV2PositionConfig channelCfg = getChannelConfigFn.apply("BrickletJoystickV2PositionX").as(BrickletJoystickV2PositionConfig.class);
		
		}
		{
		BrickletJoystickV2PositionConfig channelCfg = getChannelConfigFn.apply("BrickletJoystickV2PositionY").as(BrickletJoystickV2PositionConfig.class);
		
		}
		{
		this.setPressedCallbackConfiguration(10, true);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletJoystickV2Config cfg = (BrickletJoystickV2Config) config.as(BrickletJoystickV2Config.class);
        this.setPositionCallbackConfiguration(0, true);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletJoystickV2Config cfg = (BrickletJoystickV2Config) config.as(BrickletJoystickV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletJoystickV2PositionX");
		result.add("BrickletJoystickV2PositionY");
		result.add("BrickletJoystickV2Pressed");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletJoystickV2Position":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletJoystickV2Position"), "Position", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletJoystickV2Position")).withDescription("The position of the joystick. The value ranges between -100 and 100 for both axis. The middle position of the joystick is x=0, y=0. The returned values are averaged and calibrated.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-100)).withMaximum(BigDecimal.valueOf(100)).withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Joystick Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("2-axis joystick with push-button").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletJoystickV2PositionX", new ChannelTypeUID("tinkerforge", "BrickletJoystickV2Position")).withLabel("Position X").build(), new ChannelDefinitionBuilder("BrickletJoystickV2PositionY", new ChannelTypeUID("tinkerforge", "BrickletJoystickV2Position")).withLabel("Position Y").build(), new ChannelDefinitionBuilder("BrickletJoystickV2Pressed", new ChannelTypeUID("system", "rawbutton")).withLabel("Pressed").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletjoystickv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("positionUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for X and Y position in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Position Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletJoystickV2Position":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletJoystickV2Config cfg = (BrickletJoystickV2Config) config.as(BrickletJoystickV2Config.class);
        switch(channel) {
            case "BrickletJoystickV2PositionX": {
                   BrickletJoystickV2PositionConfig channelCfg = channelConfig.as(BrickletJoystickV2PositionConfig.class);
                   {
            BrickletJoystickV2.Position value = this.getPosition();
            if(true)
                updateStateFn.accept(channel, transformBrickletJoystickV2PositionXGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletJoystickV2PositionY": {
                   BrickletJoystickV2PositionConfig channelCfg = channelConfig.as(BrickletJoystickV2PositionConfig.class);
                   {
            BrickletJoystickV2.Position value = this.getPosition();
            if(true)
                updateStateFn.accept(channel, transformBrickletJoystickV2PositionYGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletJoystickV2Pressed":
                   {
            boolean value = this.isPressed();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletJoystickV2PressedGetter0(value, cfg));
        }
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletJoystickV2Config cfg = (BrickletJoystickV2Config) config.as(BrickletJoystickV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletJoystickV2PositionXCallback0(int x, int y, BrickletJoystickV2Config cfg) {
        return new QuantityType<>(x, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletJoystickV2PositionYCallback0(int x, int y, BrickletJoystickV2Config cfg) {
        return new QuantityType<>(y, SmartHomeUnits.ONE);
    }
	    private String transformBrickletJoystickV2PressedCallback0(boolean pressed, BrickletJoystickV2Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletJoystickV2PositionXGetter0(BrickletJoystickV2.Position value, BrickletJoystickV2Config cfg) {
        return new QuantityType<>(value.x, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletJoystickV2PositionYGetter0(BrickletJoystickV2.Position value, BrickletJoystickV2Config cfg) {
        return new QuantityType<>(value.y, SmartHomeUnits.ONE);
    }
	    private String transformBrickletJoystickV2PressedGetter0(boolean value, BrickletJoystickV2Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }

}