/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;

import com.tinkerforge.BrickletJoystick;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletJoystickWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletJoystick dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletJoystick.DEVICE_DISPLAY_NAME, "brickletjoystick", BrickletJoystick.DEVICE_IDENTIFIER, BrickletJoystickWrapper.class, BrickletJoystickActions.class, "2.0.0", false);

    public BrickletJoystickWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletJoystick(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';


    public BrickletJoystick.Position getPosition() throws TinkerforgeException {
    return this.dev.getPosition();
}

public boolean isPressed() throws TinkerforgeException {
    return this.dev.isPressed();
}

public BrickletJoystick.AnalogValue getAnalogValue() throws TinkerforgeException {
    return this.dev.getAnalogValue();
}

public void calibrate() throws TinkerforgeException {
    this.dev.calibrate();
}

public void setPositionCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setPositionCallbackPeriod(period);
}

public long getPositionCallbackPeriod() throws TinkerforgeException {
    return this.dev.getPositionCallbackPeriod();
}

public void setAnalogValueCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setAnalogValueCallbackPeriod(period);
}

public long getAnalogValueCallbackPeriod() throws TinkerforgeException {
    return this.dev.getAnalogValueCallbackPeriod();
}

public void setPositionCallbackThreshold(char option, int minX, int maxX, int minY, int maxY) throws TinkerforgeException {
    this.dev.setPositionCallbackThreshold(option, minX, maxX, minY, maxY);
}

public BrickletJoystick.PositionCallbackThreshold getPositionCallbackThreshold() throws TinkerforgeException {
    return this.dev.getPositionCallbackThreshold();
}

public void setAnalogValueCallbackThreshold(char option, int minX, int maxX, int minY, int maxY) throws TinkerforgeException {
    this.dev.setAnalogValueCallbackThreshold(option, minX, maxX, minY, maxY);
}

public BrickletJoystick.AnalogValueCallbackThreshold getAnalogValueCallbackThreshold() throws TinkerforgeException {
    return this.dev.getAnalogValueCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public BrickletJoystick.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addPositionListener(BrickletJoystick.PositionListener l) {
    this.dev.addPositionListener(l);
}

public void removePositionListener(BrickletJoystick.PositionListener l) {
    this.dev.removePositionListener(l);
}

public void addAnalogValueListener(BrickletJoystick.AnalogValueListener l) {
    this.dev.addAnalogValueListener(l);
}

public void removeAnalogValueListener(BrickletJoystick.AnalogValueListener l) {
    this.dev.removeAnalogValueListener(l);
}

public void addPositionReachedListener(BrickletJoystick.PositionReachedListener l) {
    this.dev.addPositionReachedListener(l);
}

public void removePositionReachedListener(BrickletJoystick.PositionReachedListener l) {
    this.dev.removePositionReachedListener(l);
}

public void addAnalogValueReachedListener(BrickletJoystick.AnalogValueReachedListener l) {
    this.dev.addAnalogValueReachedListener(l);
}

public void removeAnalogValueReachedListener(BrickletJoystick.AnalogValueReachedListener l) {
    this.dev.removeAnalogValueReachedListener(l);
}

public void addPressedListener(BrickletJoystick.PressedListener l) {
    this.dev.addPressedListener(l);
}

public void removePressedListener(BrickletJoystick.PressedListener l) {
    this.dev.removePressedListener(l);
}

public void addReleasedListener(BrickletJoystick.ReleasedListener l) {
    this.dev.addReleasedListener(l);
}

public void removeReleasedListener(BrickletJoystick.ReleasedListener l) {
    this.dev.removeReleasedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletJoystickWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletJoystickWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletJoystickConfig cfg = (BrickletJoystickConfig) config.as(BrickletJoystickConfig.class);
        this.addPositionListener(this.reg((x, y) -> {if(true) {updateStateFn.accept("BrickletJoystickPositionX", transformBrickletJoystickPositionXCallback0(x, y, cfg));}}, this.dev::removePositionListener));
		this.addPositionListener(this.reg((x, y) -> {if(true) {updateStateFn.accept("BrickletJoystickPositionY", transformBrickletJoystickPositionYCallback0(x, y, cfg));}}, this.dev::removePositionListener));
		this.addPressedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletJoystickPressed", transformBrickletJoystickPressedCallback0(cfg));}}, this.dev::removePressedListener));
		this.addReleasedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletJoystickPressed", transformBrickletJoystickPressedCallback1(cfg));}}, this.dev::removeReleasedListener));
        this.setPositionCallbackPeriod(cfg.positionUpdateInterval);
		{
		BrickletJoystickPositionConfig channelCfg = getChannelConfigFn.apply("BrickletJoystickPositionX").as(BrickletJoystickPositionConfig.class);
		
		}
		{
		BrickletJoystickPositionConfig channelCfg = getChannelConfigFn.apply("BrickletJoystickPositionY").as(BrickletJoystickPositionConfig.class);
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletJoystickConfig cfg = (BrickletJoystickConfig) config.as(BrickletJoystickConfig.class);
        this.setPositionCallbackPeriod(0);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletJoystickConfig cfg = (BrickletJoystickConfig) config.as(BrickletJoystickConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletJoystickPositionX");
		result.add("BrickletJoystickPositionY");
		result.add("BrickletJoystickPressed");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletJoystickPosition":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletJoystickPosition"), "Position", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletJoystickPosition")).withDescription("The position of the joystick. The value ranges between -100 and 100 for both axis. The middle position of the joystick is x=0, y=0. The returned values are averaged and calibrated.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-100)).withMaximum(BigDecimal.valueOf(100)).withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Joystick Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("2-axis joystick with push-button").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletJoystickPositionX", new ChannelTypeUID("tinkerforge", "BrickletJoystickPosition")).withLabel("Position X").build(), new ChannelDefinitionBuilder("BrickletJoystickPositionY", new ChannelTypeUID("tinkerforge", "BrickletJoystickPosition")).withLabel("Position Y").build(), new ChannelDefinitionBuilder("BrickletJoystickPressed", new ChannelTypeUID("system", "rawbutton")).withLabel("Pressed").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletjoystick":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("positionUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for X and Y position in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Position Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletJoystickPosition":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletJoystickConfig cfg = (BrickletJoystickConfig) config.as(BrickletJoystickConfig.class);
        switch(channel) {
            case "BrickletJoystickPositionX": {
                   BrickletJoystickPositionConfig channelCfg = channelConfig.as(BrickletJoystickPositionConfig.class);
                   {
            BrickletJoystick.Position value = this.getPosition();
            if(true)
                updateStateFn.accept(channel, transformBrickletJoystickPositionXGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletJoystickPositionY": {
                   BrickletJoystickPositionConfig channelCfg = channelConfig.as(BrickletJoystickPositionConfig.class);
                   {
            BrickletJoystick.Position value = this.getPosition();
            if(true)
                updateStateFn.accept(channel, transformBrickletJoystickPositionYGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletJoystickPressed":
                   {
            boolean value = this.isPressed();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletJoystickPressedGetter0(value, cfg));
        }
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletJoystickConfig cfg = (BrickletJoystickConfig) config.as(BrickletJoystickConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletJoystickPositionXCallback0(int x, int y, BrickletJoystickConfig cfg) {
        return new QuantityType<>(x, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletJoystickPositionYCallback0(int x, int y, BrickletJoystickConfig cfg) {
        return new QuantityType<>(y, SmartHomeUnits.ONE);
    }
	    private String transformBrickletJoystickPressedCallback0(BrickletJoystickConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickletJoystickPressedCallback1(BrickletJoystickConfig cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletJoystickPositionXGetter0(BrickletJoystick.Position value, BrickletJoystickConfig cfg) {
        return new QuantityType<>(value.x, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletJoystickPositionYGetter0(BrickletJoystick.Position value, BrickletJoystickConfig cfg) {
        return new QuantityType<>(value.y, SmartHomeUnits.ONE);
    }
	    private String transformBrickletJoystickPressedGetter0(boolean value, BrickletJoystickConfig cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }

}