/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;
import org.eclipse.smarthome.core.library.types.DecimalType;

import com.tinkerforge.BrickletLCD128x64;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletLCD128x64Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletLCD128x64 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletLCD128x64.DEVICE_DISPLAY_NAME, "brickletlcd128x64", BrickletLCD128x64.DEVICE_IDENTIFIER, BrickletLCD128x64Wrapper.class, BrickletLCD128x64Actions.class, "2.0.2", true);

    public BrickletLCD128x64Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletLCD128x64(uid, ipcon);
    }

    
	public final static int GESTURE_LEFT_TO_RIGHT = 0;
	public final static int GESTURE_RIGHT_TO_LEFT = 1;
	public final static int GESTURE_TOP_TO_BOTTOM = 2;
	public final static int GESTURE_BOTTOM_TO_TOP = 3;
	public final static boolean COLOR_WHITE = false;
	public final static boolean COLOR_BLACK = true;
	public final static int FONT_6X8 = 0;
	public final static int FONT_6X16 = 1;
	public final static int FONT_6X24 = 2;
	public final static int FONT_6X32 = 3;
	public final static int FONT_12X16 = 4;
	public final static int FONT_12X24 = 5;
	public final static int FONT_12X32 = 6;
	public final static int FONT_18X24 = 7;
	public final static int FONT_18X32 = 8;
	public final static int FONT_24X32 = 9;
	public final static int DIRECTION_HORIZONTAL = 0;
	public final static int DIRECTION_VERTICAL = 1;
	public final static int CHANGE_TAB_ON_CLICK = 1;
	public final static int CHANGE_TAB_ON_SWIPE = 2;
	public final static int CHANGE_TAB_ON_CLICK_AND_SWIPE = 3;
	public final static int GRAPH_TYPE_DOT = 0;
	public final static int GRAPH_TYPE_LINE = 1;
	public final static int GRAPH_TYPE_BAR = 2;
	public final static int TOUCH_LED_CONFIG_OFF = 0;
	public final static int TOUCH_LED_CONFIG_ON = 1;
	public final static int TOUCH_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int TOUCH_LED_CONFIG_SHOW_TOUCH = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void writePixels(int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException {
    this.dev.writePixels(xStart, yStart, xEnd, yEnd, pixels);
}

public boolean[] readPixels(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
    return this.dev.readPixels(xStart, yStart, xEnd, yEnd);
}

public void clearDisplay() throws TinkerforgeException {
    this.dev.clearDisplay();
}

public void setDisplayConfiguration(int contrast, int backlight, boolean invert, boolean automaticDraw) throws TinkerforgeException {
    this.dev.setDisplayConfiguration(contrast, backlight, invert, automaticDraw);
}

public BrickletLCD128x64.DisplayConfiguration getDisplayConfiguration() throws TinkerforgeException {
    return this.dev.getDisplayConfiguration();
}

public void writeLine(int line, int position, String text) throws TinkerforgeException {
    this.dev.writeLine(line, position, text);
}

public void drawBufferedFrame(boolean forceCompleteRedraw) throws TinkerforgeException {
    this.dev.drawBufferedFrame(forceCompleteRedraw);
}

public BrickletLCD128x64.TouchPosition getTouchPosition() throws TinkerforgeException {
    return this.dev.getTouchPosition();
}

public void setTouchPositionCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setTouchPositionCallbackConfiguration(period, valueHasToChange);
}

public BrickletLCD128x64.TouchPositionCallbackConfiguration getTouchPositionCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getTouchPositionCallbackConfiguration();
}

public BrickletLCD128x64.TouchGesture getTouchGesture() throws TinkerforgeException {
    return this.dev.getTouchGesture();
}

public void setTouchGestureCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setTouchGestureCallbackConfiguration(period, valueHasToChange);
}

public BrickletLCD128x64.TouchGestureCallbackConfiguration getTouchGestureCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getTouchGestureCallbackConfiguration();
}

public void drawLine(int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, boolean color) throws TinkerforgeException {
    this.dev.drawLine(positionXStart, positionYStart, positionXEnd, positionYEnd, color);
}

public void drawBox(int positionXStart, int positionYStart, int positionXEnd, int positionYEnd, boolean fill, boolean color) throws TinkerforgeException {
    this.dev.drawBox(positionXStart, positionYStart, positionXEnd, positionYEnd, fill, color);
}

public void drawText(int positionX, int positionY, int font, boolean color, String text) throws TinkerforgeException {
    this.dev.drawText(positionX, positionY, font, color, text);
}

public void setGUIButton(int index, int positionX, int positionY, int width, int height, String text) throws TinkerforgeException {
    this.dev.setGUIButton(index, positionX, positionY, width, height, text);
}

public BrickletLCD128x64.GUIButton getGUIButton(int index) throws TinkerforgeException {
    return this.dev.getGUIButton(index);
}

public void removeGUIButton(int index) throws TinkerforgeException {
    this.dev.removeGUIButton(index);
}

public void setGUIButtonPressedCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setGUIButtonPressedCallbackConfiguration(period, valueHasToChange);
}

public BrickletLCD128x64.GUIButtonPressedCallbackConfiguration getGUIButtonPressedCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getGUIButtonPressedCallbackConfiguration();
}

public boolean getGUIButtonPressed(int index) throws TinkerforgeException {
    return this.dev.getGUIButtonPressed(index);
}

public void setGUISlider(int index, int positionX, int positionY, int length, int direction, int value) throws TinkerforgeException {
    this.dev.setGUISlider(index, positionX, positionY, length, direction, value);
}

public BrickletLCD128x64.GUISlider getGUISlider(int index) throws TinkerforgeException {
    return this.dev.getGUISlider(index);
}

public void removeGUISlider(int index) throws TinkerforgeException {
    this.dev.removeGUISlider(index);
}

public void setGUISliderValueCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setGUISliderValueCallbackConfiguration(period, valueHasToChange);
}

public BrickletLCD128x64.GUISliderValueCallbackConfiguration getGUISliderValueCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getGUISliderValueCallbackConfiguration();
}

public int getGUISliderValue(int index) throws TinkerforgeException {
    return this.dev.getGUISliderValue(index);
}

public void setGUITabConfiguration(int changeTabConfig, boolean clearGUI) throws TinkerforgeException {
    this.dev.setGUITabConfiguration(changeTabConfig, clearGUI);
}

public BrickletLCD128x64.GUITabConfiguration getGUITabConfiguration() throws TinkerforgeException {
    return this.dev.getGUITabConfiguration();
}

public void setGUITabText(int index, String text) throws TinkerforgeException {
    this.dev.setGUITabText(index, text);
}

public BrickletLCD128x64.GUITabText getGUITabText(int index) throws TinkerforgeException {
    return this.dev.getGUITabText(index);
}

public void setGUITabIcon(int index, boolean[] icon) throws TinkerforgeException {
    this.dev.setGUITabIcon(index, icon);
}

public BrickletLCD128x64.GUITabIcon getGUITabIcon(int index) throws TinkerforgeException {
    return this.dev.getGUITabIcon(index);
}

public void removeGUITab(int index) throws TinkerforgeException {
    this.dev.removeGUITab(index);
}

public void setGUITabSelected(int index) throws TinkerforgeException {
    this.dev.setGUITabSelected(index);
}

public void setGUITabSelectedCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setGUITabSelectedCallbackConfiguration(period, valueHasToChange);
}

public BrickletLCD128x64.GUITabSelectedCallbackConfiguration getGUITabSelectedCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getGUITabSelectedCallbackConfiguration();
}

public int getGUITabSelected() throws TinkerforgeException {
    return this.dev.getGUITabSelected();
}

public void setGUIGraphConfiguration(int index, int graphType, int positionX, int positionY, int width, int height, String textX, String textY) throws TinkerforgeException {
    this.dev.setGUIGraphConfiguration(index, graphType, positionX, positionY, width, height, textX, textY);
}

public BrickletLCD128x64.GUIGraphConfiguration getGUIGraphConfiguration(int index) throws TinkerforgeException {
    return this.dev.getGUIGraphConfiguration(index);
}

public void setGUIGraphData(int index, int[] data) throws TinkerforgeException {
    this.dev.setGUIGraphData(index, data);
}

public int[] getGUIGraphData(int index) throws TinkerforgeException {
    return this.dev.getGUIGraphData(index);
}

public void removeGUIGraph(int index) throws TinkerforgeException {
    this.dev.removeGUIGraph(index);
}

public void removeAllGUI() throws TinkerforgeException {
    this.dev.removeAllGUI();
}

public void setTouchLEDConfig(int config) throws TinkerforgeException {
    this.dev.setTouchLEDConfig(config);
}

public int getTouchLEDConfig() throws TinkerforgeException {
    return this.dev.getTouchLEDConfig();
}

public BrickletLCD128x64.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletLCD128x64.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addTouchPositionListener(BrickletLCD128x64.TouchPositionListener l) {
    this.dev.addTouchPositionListener(l);
}

public void removeTouchPositionListener(BrickletLCD128x64.TouchPositionListener l) {
    this.dev.removeTouchPositionListener(l);
}

public void addTouchGestureListener(BrickletLCD128x64.TouchGestureListener l) {
    this.dev.addTouchGestureListener(l);
}

public void removeTouchGestureListener(BrickletLCD128x64.TouchGestureListener l) {
    this.dev.removeTouchGestureListener(l);
}

public void addGUIButtonPressedListener(BrickletLCD128x64.GUIButtonPressedListener l) {
    this.dev.addGUIButtonPressedListener(l);
}

public void removeGUIButtonPressedListener(BrickletLCD128x64.GUIButtonPressedListener l) {
    this.dev.removeGUIButtonPressedListener(l);
}

public void addGUISliderValueListener(BrickletLCD128x64.GUISliderValueListener l) {
    this.dev.addGUISliderValueListener(l);
}

public void removeGUISliderValueListener(BrickletLCD128x64.GUISliderValueListener l) {
    this.dev.removeGUISliderValueListener(l);
}

public void addGUITabSelectedListener(BrickletLCD128x64.GUITabSelectedListener l) {
    this.dev.addGUITabSelectedListener(l);
}

public void removeGUITabSelectedListener(BrickletLCD128x64.GUITabSelectedListener l) {
    this.dev.removeGUITabSelectedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletLCD128x64Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletLCD128x64Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletLCD128x64Config cfg = (BrickletLCD128x64Config) config.as(BrickletLCD128x64Config.class);
        this.addTouchPositionListener(this.reg((pressure, x, y, age) -> {if(true) {triggerChannelFn.accept("BrickletLCD128x64TouchPosition", transformBrickletLCD128x64TouchPositionCallback0(pressure, x, y, age, cfg));}}, this.dev::removeTouchPositionListener));
		this.addTouchGestureListener(this.reg((gesture, duration, pressureMax, xStart, yStart, xEnd, yEnd, age) -> {if(true) {triggerChannelFn.accept("BrickletLCD128x64TouchGesture", transformBrickletLCD128x64TouchGestureCallback0(gesture, duration, pressureMax, xStart, yStart, xEnd, yEnd, age, cfg));}}, this.dev::removeTouchGestureListener));
		this.addGUITabSelectedListener(this.reg((index) -> {if(true) {updateStateFn.accept("BrickletLCD128x64SelectedGUITab", transformBrickletLCD128x64SelectedGUITabCallback0(index, cfg));}}, this.dev::removeGUITabSelectedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  0) {triggerChannelFn.accept("BrickletLCD128x64GUIButton0", transformBrickletLCD128x64GUIButton0Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  1) {triggerChannelFn.accept("BrickletLCD128x64GUIButton1", transformBrickletLCD128x64GUIButton1Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  2) {triggerChannelFn.accept("BrickletLCD128x64GUIButton2", transformBrickletLCD128x64GUIButton2Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  3) {triggerChannelFn.accept("BrickletLCD128x64GUIButton3", transformBrickletLCD128x64GUIButton3Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  4) {triggerChannelFn.accept("BrickletLCD128x64GUIButton4", transformBrickletLCD128x64GUIButton4Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  5) {triggerChannelFn.accept("BrickletLCD128x64GUIButton5", transformBrickletLCD128x64GUIButton5Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  6) {triggerChannelFn.accept("BrickletLCD128x64GUIButton6", transformBrickletLCD128x64GUIButton6Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  7) {triggerChannelFn.accept("BrickletLCD128x64GUIButton7", transformBrickletLCD128x64GUIButton7Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  8) {triggerChannelFn.accept("BrickletLCD128x64GUIButton8", transformBrickletLCD128x64GUIButton8Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  9) {triggerChannelFn.accept("BrickletLCD128x64GUIButton9", transformBrickletLCD128x64GUIButton9Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  10) {triggerChannelFn.accept("BrickletLCD128x64GUIButton10", transformBrickletLCD128x64GUIButton10Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUIButtonPressedListener(this.reg((index, pressed) -> {if(index ==  11) {triggerChannelFn.accept("BrickletLCD128x64GUIButton11", transformBrickletLCD128x64GUIButton11Callback0(index, pressed, cfg));}}, this.dev::removeGUIButtonPressedListener));
		this.addGUISliderValueListener(this.reg((index, value) -> {if(index ==  0) {updateStateFn.accept("BrickletLCD128x64GUISlider0", transformBrickletLCD128x64GUISlider0Callback0(index, value, cfg));}}, this.dev::removeGUISliderValueListener));
		this.addGUISliderValueListener(this.reg((index, value) -> {if(index ==  1) {updateStateFn.accept("BrickletLCD128x64GUISlider1", transformBrickletLCD128x64GUISlider1Callback0(index, value, cfg));}}, this.dev::removeGUISliderValueListener));
		this.addGUISliderValueListener(this.reg((index, value) -> {if(index ==  2) {updateStateFn.accept("BrickletLCD128x64GUISlider2", transformBrickletLCD128x64GUISlider2Callback0(index, value, cfg));}}, this.dev::removeGUISliderValueListener));
		this.addGUISliderValueListener(this.reg((index, value) -> {if(index ==  3) {updateStateFn.accept("BrickletLCD128x64GUISlider3", transformBrickletLCD128x64GUISlider3Callback0(index, value, cfg));}}, this.dev::removeGUISliderValueListener));
		this.addGUISliderValueListener(this.reg((index, value) -> {if(index ==  4) {updateStateFn.accept("BrickletLCD128x64GUISlider4", transformBrickletLCD128x64GUISlider4Callback0(index, value, cfg));}}, this.dev::removeGUISliderValueListener));
		this.addGUISliderValueListener(this.reg((index, value) -> {if(index ==  5) {updateStateFn.accept("BrickletLCD128x64GUISlider5", transformBrickletLCD128x64GUISlider5Callback0(index, value, cfg));}}, this.dev::removeGUISliderValueListener));
        this.setDisplayConfiguration(cfg.contrast, cfg.defaultBacklightIntensity, cfg.invert, cfg.automaticDraw);
		    this.setTouchLEDConfig(cfg.touchLEDConfig);
		    this.setGUIButtonPressedCallbackConfiguration(cfg.guiButtonUpdateInterval.longValue(), true);
		    this.setGUISliderValueCallbackConfiguration(cfg.guiSliderUpdateInterval.longValue(), true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletLCD128x64TextConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64Text").as(BrickletLCD128x64TextConfig.class);
		
		}
		{
		BrickletLCD128x64ClearDisplayConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64ClearDisplay").as(BrickletLCD128x64ClearDisplayConfig.class);
		
		}
		{
		BrickletLCD128x64DrawBufferedFrameConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64DrawBufferedFrame").as(BrickletLCD128x64DrawBufferedFrameConfig.class);
		
		}
		{
		BrickletLCD128x64BacklightConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64Backlight").as(BrickletLCD128x64BacklightConfig.class);
		
		}
		{
		this.setTouchPositionCallbackConfiguration(cfg.touchPositionUpdateInterval, true);
		}
		{
		this.setTouchGestureCallbackConfiguration(cfg.touchGestureUpdateInterval, true);
		}
		{
		BrickletLCD128x64GUITabSelectedConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64SelectedGUITab").as(BrickletLCD128x64GUITabSelectedConfig.class);
		this.setGUITabSelectedCallbackConfiguration(channelCfg.updateInterval.longValue(), true);
		}
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
		{
		BrickletLCD128x64GUISliderConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64GUISlider0").as(BrickletLCD128x64GUISliderConfig.class);
		
		}
		{
		BrickletLCD128x64GUISliderConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64GUISlider1").as(BrickletLCD128x64GUISliderConfig.class);
		
		}
		{
		BrickletLCD128x64GUISliderConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64GUISlider2").as(BrickletLCD128x64GUISliderConfig.class);
		
		}
		{
		BrickletLCD128x64GUISliderConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64GUISlider3").as(BrickletLCD128x64GUISliderConfig.class);
		
		}
		{
		BrickletLCD128x64GUISliderConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64GUISlider4").as(BrickletLCD128x64GUISliderConfig.class);
		
		}
		{
		BrickletLCD128x64GUISliderConfig channelCfg = getChannelConfigFn.apply("BrickletLCD128x64GUISlider5").as(BrickletLCD128x64GUISliderConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletLCD128x64Config cfg = (BrickletLCD128x64Config) config.as(BrickletLCD128x64Config.class);
        this.setTouchPositionCallbackConfiguration(0, true);
		this.setTouchGestureCallbackConfiguration(0, true);
		this.setGUITabSelectedCallbackConfiguration(0, true);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletLCD128x64Config cfg = (BrickletLCD128x64Config) config.as(BrickletLCD128x64Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletLCD128x64Text");
		result.add("BrickletLCD128x64ClearDisplay");
		result.add("BrickletLCD128x64DrawBufferedFrame");
		result.add("BrickletLCD128x64Backlight");
		result.add("BrickletLCD128x64TouchPosition");
		result.add("BrickletLCD128x64TouchGesture");
		result.add("BrickletLCD128x64SelectedGUITab");
		result.add("BrickletLCD128x64GUIButton0");
		result.add("BrickletLCD128x64GUIButton1");
		result.add("BrickletLCD128x64GUIButton2");
		result.add("BrickletLCD128x64GUIButton3");
		result.add("BrickletLCD128x64GUIButton4");
		result.add("BrickletLCD128x64GUIButton5");
		result.add("BrickletLCD128x64GUIButton6");
		result.add("BrickletLCD128x64GUIButton7");
		result.add("BrickletLCD128x64GUIButton8");
		result.add("BrickletLCD128x64GUIButton9");
		result.add("BrickletLCD128x64GUIButton10");
		result.add("BrickletLCD128x64GUIButton11");
		result.add("BrickletLCD128x64GUISlider0");
		result.add("BrickletLCD128x64GUISlider1");
		result.add("BrickletLCD128x64GUISlider2");
		result.add("BrickletLCD128x64GUISlider3");
		result.add("BrickletLCD128x64GUISlider4");
		result.add("BrickletLCD128x64GUISlider5");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletLCD128x64Text":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLCD128x64Text"), "Text", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLCD128x64Text")).withDescription("Text to display on the LCD. Command format is [line],[position],[text].<br/><br/>Additional ',' are handled as part of the text. Unicode characters are converted to the LCD character set if possible. Additionally you can use \\x[two hex digits] to use a character of the LCD character set directly.").build();
            case "BrickletLCD128x64ClearDisplay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLCD128x64ClearDisplay"), "Clear Display", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLCD128x64ClearDisplay")).withDescription("Deletes all characters from the display.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("CLEAR", "Clear")).build()).build();
            case "BrickletLCD128x64DrawBufferedFrame":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLCD128x64DrawBufferedFrame"), "Draw Buffered Frame", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLCD128x64DrawBufferedFrame")).withDescription("Draws the currently buffered frame.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("DRAW", "Draw")).build()).build();
            case "BrickletLCD128x64Backlight":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLCD128x64Backlight"), "Backlight", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLCD128x64Backlight")).withDescription("The backlight intensity value from 0 to 100.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(100)).build().toStateDescription()).build();
            case "BrickletLCD128x64GUITabSelected":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLCD128x64GUITabSelected"), "Selected GUI Tab", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLCD128x64GUITabSelected")).withDescription("Returns the index of the currently selected tab. If there are not tabs, the returned index is -1.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-1)).withMaximum(BigDecimal.valueOf(10)).build().toStateDescription()).build();
            case "BrickletLCD128x64GUISlider":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLCD128x64GUISlider"), "GUI Slider", "Number").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLCD128x64GUISlider")).withDescription("The current slider value for the given index.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(120)).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge LCD 128x64 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("7.1cm (2.8\") display with 128x64 pixel and touch screen").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletLCD128x64Text", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64Text")).withLabel("Text").build(), new ChannelDefinitionBuilder("BrickletLCD128x64ClearDisplay", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64ClearDisplay")).withLabel("Clear Display").build(), new ChannelDefinitionBuilder("BrickletLCD128x64DrawBufferedFrame", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64DrawBufferedFrame")).withLabel("Draw Buffered Frame").build(), new ChannelDefinitionBuilder("BrickletLCD128x64Backlight", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64Backlight")).withLabel("Backlight").build(), new ChannelDefinitionBuilder("BrickletLCD128x64TouchPosition", new ChannelTypeUID("system", "trigger")).withLabel("Touch Position").build(), new ChannelDefinitionBuilder("BrickletLCD128x64TouchGesture", new ChannelTypeUID("system", "trigger")).withLabel("Touch Gesture").build(), new ChannelDefinitionBuilder("BrickletLCD128x64SelectedGUITab", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64GUITabSelected")).withLabel("Selected GUI Tab").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton0", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 0").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton1", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 1").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton2", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 2").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton3", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 3").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton4", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 4").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton5", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 5").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton6", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 6").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton7", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 7").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton8", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 8").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton9", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 9").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton10", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 10").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUIButton11", new ChannelTypeUID("system", "rawbutton")).withLabel("GUI Button 11").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUISlider0", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64GUISlider")).withLabel("GUI Slider 0").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUISlider1", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64GUISlider")).withLabel("GUI Slider 1").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUISlider2", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64GUISlider")).withLabel("GUI Slider 2").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUISlider3", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64GUISlider")).withLabel("GUI Slider 3").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUISlider4", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64GUISlider")).withLabel("GUI Slider 4").build(), new ChannelDefinitionBuilder("BrickletLCD128x64GUISlider5", new ChannelTypeUID("tinkerforge", "BrickletLCD128x64GUISlider")).withLabel("GUI Slider 5").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletlcd128x64":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("contrast", Type.INTEGER).withDefault("14").withDescription("Sets the contrast of the display (0-63).").withLabel("Contrast").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(63)).build(), ConfigDescriptionParameterBuilder.create("defaultBacklightIntensity", Type.INTEGER).withDefault("100").withDescription("Sets the default backlight intensity of the display (0-100).").withLabel("Default Backlight Intensity").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(100)).build(), ConfigDescriptionParameterBuilder.create("invert", Type.BOOLEAN).withDefault("false").withDescription("Inverts the color (black/white) of the display.").withLabel("Invert").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("automaticDraw", Type.BOOLEAN).withDefault("true").withDescription("If automatic draw is enabled, the display is automatically updated when writing text or clearing the display. If it is disabled, the changes are written into an internal buffer and only shown on the display after triggering the Draw Buffered Frame channel.").withLabel("Automatic Draw").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("touchLEDConfig", Type.INTEGER).withDefault("3").withDescription("The touch LED configuration. By default the LED is on if the LCD is touched.<br/>You can also turn the LED permanently on/off or show a heartbeat.<br/>If the Bricklet is in bootloader mode, the LED is off.").withLabel("Touch LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Touch"))).build(), ConfigDescriptionParameterBuilder.create("guiButtonUpdateInterval", Type.INTEGER).withDefault("100").withDescription("Specifies the update interval for the GUI buttons in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("GUI Button Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("guiSliderUpdateInterval", Type.INTEGER).withDefault("100").withDescription("Specifies the update interval for the GUI sliders in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("GUI Slider Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("touchPositionUpdateInterval", Type.INTEGER).withDefault("100").withDescription("Specifies the update interval for touch positions in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Touch Position Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("touchGestureUpdateInterval", Type.INTEGER).withDefault("100").withDescription("Specifies the update interval for touch gestures in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Touch Gesture Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletLCD128x64Text":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletLCD128x64ClearDisplay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletLCD128x64DrawBufferedFrame":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletLCD128x64Backlight":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletLCD128x64GUITabSelected":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletLCD128x64GUISlider":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLCD128x64Config cfg = (BrickletLCD128x64Config) config.as(BrickletLCD128x64Config.class);
        switch(channel) {
            case "BrickletLCD128x64Text":
               return;
            case "BrickletLCD128x64ClearDisplay":
               return;
            case "BrickletLCD128x64DrawBufferedFrame":
               return;
            case "BrickletLCD128x64Backlight": {
                   BrickletLCD128x64BacklightConfig channelCfg = channelConfig.as(BrickletLCD128x64BacklightConfig.class);
                   {
            BrickletLCD128x64.DisplayConfiguration value = this.getDisplayConfiguration();
            if(true)
                updateStateFn.accept(channel, transformBrickletLCD128x64BacklightGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletLCD128x64TouchPosition":
                   {
            BrickletLCD128x64.TouchPosition value = this.getTouchPosition();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64TouchPositionGetter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64TouchGesture":
                   {
            BrickletLCD128x64.TouchGesture value = this.getTouchGesture();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64TouchGestureGetter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64SelectedGUITab": {
                   BrickletLCD128x64GUITabSelectedConfig channelCfg = channelConfig.as(BrickletLCD128x64GUITabSelectedConfig.class);
                   {
            int value = this.getGUITabSelected();
            if(true)
                updateStateFn.accept(channel, transformBrickletLCD128x64SelectedGUITabGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletLCD128x64GUIButton0":
                   {
            boolean value = this.getGUIButtonPressed(0);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton0Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton1":
                   {
            boolean value = this.getGUIButtonPressed(1);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton1Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton2":
                   {
            boolean value = this.getGUIButtonPressed(2);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton2Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton3":
                   {
            boolean value = this.getGUIButtonPressed(3);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton3Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton4":
                   {
            boolean value = this.getGUIButtonPressed(4);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton4Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton5":
                   {
            boolean value = this.getGUIButtonPressed(5);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton5Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton6":
                   {
            boolean value = this.getGUIButtonPressed(6);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton6Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton7":
                   {
            boolean value = this.getGUIButtonPressed(7);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton7Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton8":
                   {
            boolean value = this.getGUIButtonPressed(8);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton8Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton9":
                   {
            boolean value = this.getGUIButtonPressed(9);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton9Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton10":
                   {
            boolean value = this.getGUIButtonPressed(10);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton10Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUIButton11":
                   {
            boolean value = this.getGUIButtonPressed(11);
            if(true)
                triggerChannelFn.accept(channel, transformBrickletLCD128x64GUIButton11Getter0(value, cfg));
        }
                   return;
            case "BrickletLCD128x64GUISlider0": {
                   BrickletLCD128x64GUISliderConfig channelCfg = channelConfig.as(BrickletLCD128x64GUISliderConfig.class);
                   {
            int value = this.getGUISliderValue(0);
            if(true)
                updateStateFn.accept(channel, transformBrickletLCD128x64GUISlider0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletLCD128x64GUISlider1": {
                   BrickletLCD128x64GUISliderConfig channelCfg = channelConfig.as(BrickletLCD128x64GUISliderConfig.class);
                   {
            int value = this.getGUISliderValue(1);
            if(true)
                updateStateFn.accept(channel, transformBrickletLCD128x64GUISlider1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletLCD128x64GUISlider2": {
                   BrickletLCD128x64GUISliderConfig channelCfg = channelConfig.as(BrickletLCD128x64GUISliderConfig.class);
                   {
            int value = this.getGUISliderValue(2);
            if(true)
                updateStateFn.accept(channel, transformBrickletLCD128x64GUISlider2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletLCD128x64GUISlider3": {
                   BrickletLCD128x64GUISliderConfig channelCfg = channelConfig.as(BrickletLCD128x64GUISliderConfig.class);
                   {
            int value = this.getGUISliderValue(3);
            if(true)
                updateStateFn.accept(channel, transformBrickletLCD128x64GUISlider3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletLCD128x64GUISlider4": {
                   BrickletLCD128x64GUISliderConfig channelCfg = channelConfig.as(BrickletLCD128x64GUISliderConfig.class);
                   {
            int value = this.getGUISliderValue(4);
            if(true)
                updateStateFn.accept(channel, transformBrickletLCD128x64GUISlider4Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletLCD128x64GUISlider5": {
                   BrickletLCD128x64GUISliderConfig channelCfg = channelConfig.as(BrickletLCD128x64GUISliderConfig.class);
                   {
            int value = this.getGUISliderValue(5);
            if(true)
                updateStateFn.accept(channel, transformBrickletLCD128x64GUISlider5Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletLCD128x64Config cfg = (BrickletLCD128x64Config) config.as(BrickletLCD128x64Config.class);
        switch(channel) {
            case "BrickletLCD128x64Text":
                if (command instanceof StringType) {
                    BrickletLCD128x64TextConfig channelCfg = channelConfig.as(BrickletLCD128x64TextConfig.class);
                    StringType cmd = (StringType) command;
                    this.writeLine(Helper.parseDisplayCommandLine(cmd.toString(), logger), Helper.parseDisplayCommandPosition(cmd.toString(), logger), Helper.parseDisplayCommandText(cmd.toString(), logger, false));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletLCD128x64ClearDisplay":
                if (command instanceof StringType) {
                    BrickletLCD128x64ClearDisplayConfig channelCfg = channelConfig.as(BrickletLCD128x64ClearDisplayConfig.class);
                    StringType cmd = (StringType) command;
                    this.clearDisplay();
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletLCD128x64DrawBufferedFrame":
                if (command instanceof StringType) {
                    BrickletLCD128x64DrawBufferedFrameConfig channelCfg = channelConfig.as(BrickletLCD128x64DrawBufferedFrameConfig.class);
                    StringType cmd = (StringType) command;
                    this.drawBufferedFrame(true);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletLCD128x64Backlight":
                if (command instanceof Number) {
                    BrickletLCD128x64BacklightConfig channelCfg = channelConfig.as(BrickletLCD128x64BacklightConfig.class);
                    Number cmd = (Number) command;
                    this.setDisplayConfiguration(cfg.contrast, cmd.intValue(), cfg.invert, cfg.automaticDraw);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletLCD128x64SelectedGUITab":
                if (command instanceof Number) {
                    BrickletLCD128x64GUITabSelectedConfig channelCfg = channelConfig.as(BrickletLCD128x64GUITabSelectedConfig.class);
                    Number cmd = (Number) command;
                    this.setGUITabSelected(cmd.intValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletLCD128x64TouchPositionCallback0(int pressure, int x, int y, long age, BrickletLCD128x64Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickletLCD128x64TouchGestureCallback0(int gesture, long duration, int pressureMax, int xStart, int yStart, int xEnd, int yEnd, long age, BrickletLCD128x64Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64SelectedGUITabCallback0(int index, BrickletLCD128x64Config cfg) {
        return new DecimalType(index);
    }
	    private String transformBrickletLCD128x64GUIButton0Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton1Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton2Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton3Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton4Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton5Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton6Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton7Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton8Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton9Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton10Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton11Callback0(int index, boolean pressed, BrickletLCD128x64Config cfg) {
        return pressed ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider0Callback0(int index, int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider1Callback0(int index, int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider2Callback0(int index, int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider3Callback0(int index, int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider4Callback0(int index, int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider5Callback0(int index, int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64BacklightGetter0(BrickletLCD128x64.DisplayConfiguration value, BrickletLCD128x64Config cfg) {
        return new QuantityType<>(value.backlight, SmartHomeUnits.ONE);
    }
	    private String transformBrickletLCD128x64TouchPositionGetter0(BrickletLCD128x64.TouchPosition value, BrickletLCD128x64Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickletLCD128x64TouchGestureGetter0(BrickletLCD128x64.TouchGesture value, BrickletLCD128x64Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64SelectedGUITabGetter0(int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private String transformBrickletLCD128x64GUIButton0Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton1Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton2Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton3Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton4Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton5Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton6Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton7Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton8Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton9Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton10Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private String transformBrickletLCD128x64GUIButton11Getter0(boolean value, BrickletLCD128x64Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider0Getter0(int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider1Getter0(int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider2Getter0(int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider3Getter0(int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider4Getter0(int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLCD128x64GUISlider5Getter0(int value, BrickletLCD128x64Config cfg) {
        return new DecimalType(value);
    }

}