/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletLaserRangeFinderV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletLaserRangeFinderV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletLaserRangeFinderV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletLaserRangeFinderV2.DEVICE_DISPLAY_NAME, "brickletlaserrangefinderv2", BrickletLaserRangeFinderV2.DEVICE_IDENTIFIER, BrickletLaserRangeFinderV2Wrapper.class, BrickletLaserRangeFinderV2Actions.class, "2.0.0", true);

    public BrickletLaserRangeFinderV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletLaserRangeFinderV2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int DISTANCE_LED_CONFIG_OFF = 0;
	public final static int DISTANCE_LED_CONFIG_ON = 1;
	public final static int DISTANCE_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int DISTANCE_LED_CONFIG_SHOW_DISTANCE = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getDistance() throws TinkerforgeException {
    return this.dev.getDistance();
}

public void setDistanceCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setDistanceCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletLaserRangeFinderV2.DistanceCallbackConfiguration getDistanceCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getDistanceCallbackConfiguration();
}

public int getVelocity() throws TinkerforgeException {
    return this.dev.getVelocity();
}

public void setVelocityCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setVelocityCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletLaserRangeFinderV2.VelocityCallbackConfiguration getVelocityCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getVelocityCallbackConfiguration();
}

public void setEnable(boolean enable) throws TinkerforgeException {
    this.dev.setEnable(enable);
}

public boolean getEnable() throws TinkerforgeException {
    return this.dev.getEnable();
}

public void setConfiguration(int acquisitionCount, boolean enableQuickTermination, int thresholdValue, int measurementFrequency) throws TinkerforgeException {
    this.dev.setConfiguration(acquisitionCount, enableQuickTermination, thresholdValue, measurementFrequency);
}

public BrickletLaserRangeFinderV2.Configuration getConfiguration() throws TinkerforgeException {
    return this.dev.getConfiguration();
}

public void setMovingAverage(int distanceAverageLength, int velocityAverageLength) throws TinkerforgeException {
    this.dev.setMovingAverage(distanceAverageLength, velocityAverageLength);
}

public BrickletLaserRangeFinderV2.MovingAverage getMovingAverage() throws TinkerforgeException {
    return this.dev.getMovingAverage();
}

public void setOffsetCalibration(int offset) throws TinkerforgeException {
    this.dev.setOffsetCalibration(offset);
}

public int getOffsetCalibration() throws TinkerforgeException {
    return this.dev.getOffsetCalibration();
}

public void setDistanceLEDConfig(int config) throws TinkerforgeException {
    this.dev.setDistanceLEDConfig(config);
}

public int getDistanceLEDConfig() throws TinkerforgeException {
    return this.dev.getDistanceLEDConfig();
}

public BrickletLaserRangeFinderV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletLaserRangeFinderV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addDistanceListener(BrickletLaserRangeFinderV2.DistanceListener l) {
    this.dev.addDistanceListener(l);
}

public void removeDistanceListener(BrickletLaserRangeFinderV2.DistanceListener l) {
    this.dev.removeDistanceListener(l);
}

public void addVelocityListener(BrickletLaserRangeFinderV2.VelocityListener l) {
    this.dev.addVelocityListener(l);
}

public void removeVelocityListener(BrickletLaserRangeFinderV2.VelocityListener l) {
    this.dev.removeVelocityListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletLaserRangeFinderV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletLaserRangeFinderV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletLaserRangeFinderV2Config cfg = (BrickletLaserRangeFinderV2Config) config.as(BrickletLaserRangeFinderV2Config.class);
        this.addDistanceListener(this.reg((distance) -> {if(true) {updateStateFn.accept("BrickletLaserRangeFinderV2Distance", transformBrickletLaserRangeFinderV2DistanceCallback0(distance, cfg));}}, this.dev::removeDistanceListener));
		this.addVelocityListener(this.reg((velocity) -> {if(true) {updateStateFn.accept("BrickletLaserRangeFinderV2Velocity", transformBrickletLaserRangeFinderV2VelocityCallback0(velocity, cfg));}}, this.dev::removeVelocityListener));
        
		    this.setConfiguration(cfg.acquisitionCount, cfg.enableQuickTermination, cfg.thresholdValue, cfg.enableFixedMeasurementFrequency ? cfg.measurementFrequency : 0);
		    this.setMovingAverage(cfg.distanceMovingAverageLength, cfg.velocityMovingAverageLength);
		    this.setDistanceLEDConfig(cfg.distanceLEDConfig);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletLaserRangeFinderV2DistanceConfig channelCfg = getChannelConfigFn.apply("BrickletLaserRangeFinderV2Distance").as(BrickletLaserRangeFinderV2DistanceConfig.class);
		this.setDistanceCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletLaserRangeFinderV2VelocityConfig channelCfg = getChannelConfigFn.apply("BrickletLaserRangeFinderV2Velocity").as(BrickletLaserRangeFinderV2VelocityConfig.class);
		this.setVelocityCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletLaserRangeFinderV2EnableLaserConfig channelCfg = getChannelConfigFn.apply("BrickletLaserRangeFinderV2EnableLaser").as(BrickletLaserRangeFinderV2EnableLaserConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletLaserRangeFinderV2Config cfg = (BrickletLaserRangeFinderV2Config) config.as(BrickletLaserRangeFinderV2Config.class);
        this.setDistanceCallbackConfiguration(0, true, 'x', 0, 0);
		this.setVelocityCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletLaserRangeFinderV2Config cfg = (BrickletLaserRangeFinderV2Config) config.as(BrickletLaserRangeFinderV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletLaserRangeFinderV2Distance");
		result.add("BrickletLaserRangeFinderV2Velocity");
		result.add("BrickletLaserRangeFinderV2EnableLaser");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletLaserRangeFinderV2Distance":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLaserRangeFinderV2Distance"), "Distance", "Number:Length").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLaserRangeFinderV2Distance")).withDescription("The measured distance. Sensor hardware version 1 cannot measure distance and velocity at the same time. Therefore, the distance mode has to be enabled. Sensor hardware version 3 can measure distance and velocity at the same time. Also the laser has to be enabled.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(40)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletLaserRangeFinderV2Velocity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLaserRangeFinderV2Velocity"), "Velocity", "Number:Speed").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLaserRangeFinderV2Velocity")).withDescription("The measured velocity. Sensor hardware version 1 cannot measure distance and velocity at the same time. Therefore, the velocity mode has to be enabled. Sensor hardware version 3 can measure distance and velocity at the same time, but the velocity measurement only produces stables results if a fixed measurement rateis configured. Also the laser has to be enabled.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-128)).withMaximum(BigDecimal.valueOf(127)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletLaserRangeFinderV2EnableLaser":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLaserRangeFinderV2EnableLaser"), "Enable Laser", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLaserRangeFinderV2EnableLaser")).withDescription("Activates the laser of the LIDAR.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Laser Range Finder Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures distance up to 40m with laser light").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletLaserRangeFinderV2Distance", new ChannelTypeUID("tinkerforge", "BrickletLaserRangeFinderV2Distance")).withLabel("Distance").build(), new ChannelDefinitionBuilder("BrickletLaserRangeFinderV2Velocity", new ChannelTypeUID("tinkerforge", "BrickletLaserRangeFinderV2Velocity")).withLabel("Velocity").build(), new ChannelDefinitionBuilder("BrickletLaserRangeFinderV2EnableLaser", new ChannelTypeUID("tinkerforge", "BrickletLaserRangeFinderV2EnableLaser")).withLabel("Enable Laser").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletlaserrangefinderv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("distanceMovingAverageLength", Type.INTEGER).withDefault("10").withGroupName("average").withLabel("Distance Moving Average Length").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(255)).build(), ConfigDescriptionParameterBuilder.create("velocityMovingAverageLength", Type.INTEGER).withDefault("10").withGroupName("average").withLabel("Velocity Moving Average Length").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(255)).build(), ConfigDescriptionParameterBuilder.create("acquisitionCount", Type.INTEGER).withDefault("128").withDescription("The Acquisition Count defines the number of times the Laser Range Finder Bricklet will integrate acquisitions to find a correlation record peak. With a higher count, the Bricklet can measure longer distances. With a lower count, the rate increases. This setting will be ignored if you have a LIDAR-Lite sensor with hardware version 1.").withGroupName("sensor").withLabel("Acquisition Count").withMinimum(BigDecimal.valueOf(1)).withMaximum(BigDecimal.valueOf(255)).build(), ConfigDescriptionParameterBuilder.create("enableQuickTermination", Type.BOOLEAN).withDefault("false").withDescription("If you enable Quick Termination, the distance measurement will be terminated early if a high peak was already detected. This means that a higher measurement rate can be achieved and long distances can be measured at the same time. However, the chance of false-positive distance measurements increases. This setting will be ignored if you have a LIDAR-Lite sensor with hardware version 1.").withGroupName("sensor").withLabel("Enable Quick Termination").build(), ConfigDescriptionParameterBuilder.create("thresholdValue", Type.INTEGER).withDefault("0").withDescription("Normally the distance is calculated with a detection algorithm that uses peak value, signal strength and noise. You can however also define a fixed Threshold Value. Set this to a low value if you want to measure the distance to something that has very little reflection (e.g. glass) and set it to a high value if you want to measure the distance to something with a very high reflection (e.g. mirror). Set this to 0 to use the default algorithm. This setting will be ignored if you have a LIDAR-Lite sensor with hardware version 1.").withGroupName("sensor").withLabel("Threshold Value").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(255)).build(), ConfigDescriptionParameterBuilder.create("enableFixedMeasurementFrequency", Type.BOOLEAN).withDefault("false").withDescription("For a stable velocity measurement you should set a fixed measurement frequency. See Measurement Frequency for details. This setting will be ignored if you have a LIDAR-Lite sensor with hardware version 1.").withGroupName("sensor").withLabel("Enable Fixed Measurement Frequency").build(), ConfigDescriptionParameterBuilder.create("measurementFrequency", Type.INTEGER).withDefault("10").withDescription("Set the Measurement Frequency in Hz to force a fixed measurement rate. If set to 0, the Laser Range Finder Bricklet will use the optimal frequency according to the other configurations and the actual measured distance. Since the rate is not fixed in this case, the velocity measurement is not stable. For a stable velocity measurement you should set a fixed measurement frequency. The lower the frequency, the higher is the resolution of the calculated velocity. The allowed values are 10Hz-500Hz. This setting will be ignored if you have a LIDAR-Lite sensor with hardware version 1.").withGroupName("sensor").withLabel("Measurement Frequency").withMinimum(BigDecimal.valueOf(10)).withMaximum(BigDecimal.valueOf(500)).build(), ConfigDescriptionParameterBuilder.create("distanceLEDConfig", Type.INTEGER).withDefault("3").withDescription("Configures the distance LED to be either turned off, turned on, blink in heartbeat mode or show the distance (brighter = object is nearer).").withLabel("Distance LED Config").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Distance"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"), new ConfigDescriptionParameterGroup("average", "null", true, "Averaging", "Sets the different averaging parameters. It is possible to set the length of a normal averaging for the temperature and pressure, as well as an additional length of a moving average for the pressure. The moving average is calculated from the normal averages. There is no moving average for the temperature.<br/><br/>The maximum length for the pressure average is 10, for the temperature average is 255 and for the moving average is 25.<br/><br/>Setting the all three parameters to 0 will turn the averaging completely off. If the averaging is off, there is lots of noise on the data, but the data is without delay. Thus we recommend to turn the averaging off if the Barometer Bricklet data is to be used for sensor fusion with other sensors.<br/><br/>The default values are 10 for the normal averages and 25 for the moving average."), new ConfigDescriptionParameterGroup("sensor3", "null", false, "Sensor Version 3", "Configuration for LIDAR-Lite sensors with hardware version 3"))).build();
            case "channel-type:tinkerforge:BrickletLaserRangeFinderV2Distance":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletLaserRangeFinderV2Velocity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletLaserRangeFinderV2EnableLaser":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLaserRangeFinderV2Config cfg = (BrickletLaserRangeFinderV2Config) config.as(BrickletLaserRangeFinderV2Config.class);
        switch(channel) {
            case "BrickletLaserRangeFinderV2Distance": {
                   BrickletLaserRangeFinderV2DistanceConfig channelCfg = channelConfig.as(BrickletLaserRangeFinderV2DistanceConfig.class);
                   {
            int value = this.getDistance();
            if(true)
                updateStateFn.accept(channel, transformBrickletLaserRangeFinderV2DistanceGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletLaserRangeFinderV2Velocity": {
                   BrickletLaserRangeFinderV2VelocityConfig channelCfg = channelConfig.as(BrickletLaserRangeFinderV2VelocityConfig.class);
                   {
            int value = this.getVelocity();
            if(true)
                updateStateFn.accept(channel, transformBrickletLaserRangeFinderV2VelocityGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletLaserRangeFinderV2EnableLaser": {
                   BrickletLaserRangeFinderV2EnableLaserConfig channelCfg = channelConfig.as(BrickletLaserRangeFinderV2EnableLaserConfig.class);
                   {
            boolean value = this.getEnable();
            if(true)
                updateStateFn.accept(channel, transformBrickletLaserRangeFinderV2EnableLaserGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletLaserRangeFinderV2Config cfg = (BrickletLaserRangeFinderV2Config) config.as(BrickletLaserRangeFinderV2Config.class);
        switch(channel) {
            case "BrickletLaserRangeFinderV2EnableLaser":
                if (command instanceof OnOffType) {
                    BrickletLaserRangeFinderV2EnableLaserConfig channelCfg = channelConfig.as(BrickletLaserRangeFinderV2EnableLaserConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setEnable(cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletLaserRangeFinderV2DistanceCallback0(int distance, BrickletLaserRangeFinderV2Config cfg) {
        return new QuantityType<>(distance / 100.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLaserRangeFinderV2VelocityCallback0(int velocity, BrickletLaserRangeFinderV2Config cfg) {
        return new QuantityType<>(velocity / 100.0, SmartHomeUnits.METRE_PER_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLaserRangeFinderV2DistanceGetter0(int value, BrickletLaserRangeFinderV2Config cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.METRE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLaserRangeFinderV2VelocityGetter0(int value, BrickletLaserRangeFinderV2Config cfg) {
        return new QuantityType<>(value / 100.0, SmartHomeUnits.METRE_PER_SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLaserRangeFinderV2EnableLaserGetter0(boolean value, BrickletLaserRangeFinderV2Config cfg) {
        return value? OnOffType.ON : OnOffType.OFF;
    }

}