/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletLine;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletLineWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletLine dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletLine.DEVICE_DISPLAY_NAME, "brickletline", BrickletLine.DEVICE_IDENTIFIER, BrickletLineWrapper.class, BrickletLineActions.class, "2.0.0", false);

    public BrickletLineWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletLine(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';


    public int getReflectivity() throws TinkerforgeException {
    return this.dev.getReflectivity();
}

public void setReflectivityCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setReflectivityCallbackPeriod(period);
}

public long getReflectivityCallbackPeriod() throws TinkerforgeException {
    return this.dev.getReflectivityCallbackPeriod();
}

public void setReflectivityCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setReflectivityCallbackThreshold(option, min, max);
}

public BrickletLine.ReflectivityCallbackThreshold getReflectivityCallbackThreshold() throws TinkerforgeException {
    return this.dev.getReflectivityCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public BrickletLine.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addReflectivityListener(BrickletLine.ReflectivityListener l) {
    this.dev.addReflectivityListener(l);
}

public void removeReflectivityListener(BrickletLine.ReflectivityListener l) {
    this.dev.removeReflectivityListener(l);
}

public void addReflectivityReachedListener(BrickletLine.ReflectivityReachedListener l) {
    this.dev.addReflectivityReachedListener(l);
}

public void removeReflectivityReachedListener(BrickletLine.ReflectivityReachedListener l) {
    this.dev.removeReflectivityReachedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletLineWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletLineWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletLineConfig cfg = (BrickletLineConfig) config.as(BrickletLineConfig.class);
        this.addReflectivityListener(this.reg((reflectivity) -> {if(true) {updateStateFn.accept("BrickletLineReflectivity", transformBrickletLineReflectivityCallback0(reflectivity, cfg));}}, this.dev::removeReflectivityListener));
        
		{
		BrickletLineReflectivityConfig channelCfg = getChannelConfigFn.apply("BrickletLineReflectivity").as(BrickletLineReflectivityConfig.class);
		this.setReflectivityCallbackPeriod(channelCfg.updateInterval);
		this.setReflectivityCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletLineConfig cfg = (BrickletLineConfig) config.as(BrickletLineConfig.class);
        this.setReflectivityCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletLineConfig cfg = (BrickletLineConfig) config.as(BrickletLineConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletLineReflectivity");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletLineReflectivity":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLineReflectivity"), "Reflectivity", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLineReflectivity")).withDescription("The currently measured reflectivity. The reflectivity is a value between 0 (not reflective) and 4095 (very reflective).<br/><br/>Usually black has a low reflectivity while white has a high reflectivity.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4095)).withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Line Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures reflectivity of a surface").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletLineReflectivity", new ChannelTypeUID("tinkerforge", "BrickletLineReflectivity")).withLabel("Reflectivity").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletline":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletLineReflectivity":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLineConfig cfg = (BrickletLineConfig) config.as(BrickletLineConfig.class);
        switch(channel) {
            case "BrickletLineReflectivity": {
                   BrickletLineReflectivityConfig channelCfg = channelConfig.as(BrickletLineReflectivityConfig.class);
                   {
            int value = this.getReflectivity();
            if(true)
                updateStateFn.accept(channel, transformBrickletLineReflectivityGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletLineConfig cfg = (BrickletLineConfig) config.as(BrickletLineConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletLineReflectivityCallback0(int reflectivity, BrickletLineConfig cfg) {
        return new QuantityType<>(reflectivity, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLineReflectivityGetter0(int value, BrickletLineConfig cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }

}