/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletLinearPoti;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletLinearPotiWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletLinearPoti dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletLinearPoti.DEVICE_DISPLAY_NAME, "brickletlinearpoti", BrickletLinearPoti.DEVICE_IDENTIFIER, BrickletLinearPotiWrapper.class, BrickletLinearPotiActions.class, "2.0.0", false);

    public BrickletLinearPotiWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletLinearPoti(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';


    public int getPosition() throws TinkerforgeException {
    return this.dev.getPosition();
}

public int getAnalogValue() throws TinkerforgeException {
    return this.dev.getAnalogValue();
}

public void setPositionCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setPositionCallbackPeriod(period);
}

public long getPositionCallbackPeriod() throws TinkerforgeException {
    return this.dev.getPositionCallbackPeriod();
}

public void setAnalogValueCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setAnalogValueCallbackPeriod(period);
}

public long getAnalogValueCallbackPeriod() throws TinkerforgeException {
    return this.dev.getAnalogValueCallbackPeriod();
}

public void setPositionCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setPositionCallbackThreshold(option, min, max);
}

public BrickletLinearPoti.PositionCallbackThreshold getPositionCallbackThreshold() throws TinkerforgeException {
    return this.dev.getPositionCallbackThreshold();
}

public void setAnalogValueCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setAnalogValueCallbackThreshold(option, min, max);
}

public BrickletLinearPoti.AnalogValueCallbackThreshold getAnalogValueCallbackThreshold() throws TinkerforgeException {
    return this.dev.getAnalogValueCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public BrickletLinearPoti.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addPositionListener(BrickletLinearPoti.PositionListener l) {
    this.dev.addPositionListener(l);
}

public void removePositionListener(BrickletLinearPoti.PositionListener l) {
    this.dev.removePositionListener(l);
}

public void addAnalogValueListener(BrickletLinearPoti.AnalogValueListener l) {
    this.dev.addAnalogValueListener(l);
}

public void removeAnalogValueListener(BrickletLinearPoti.AnalogValueListener l) {
    this.dev.removeAnalogValueListener(l);
}

public void addPositionReachedListener(BrickletLinearPoti.PositionReachedListener l) {
    this.dev.addPositionReachedListener(l);
}

public void removePositionReachedListener(BrickletLinearPoti.PositionReachedListener l) {
    this.dev.removePositionReachedListener(l);
}

public void addAnalogValueReachedListener(BrickletLinearPoti.AnalogValueReachedListener l) {
    this.dev.addAnalogValueReachedListener(l);
}

public void removeAnalogValueReachedListener(BrickletLinearPoti.AnalogValueReachedListener l) {
    this.dev.removeAnalogValueReachedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletLinearPotiWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletLinearPotiWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletLinearPotiConfig cfg = (BrickletLinearPotiConfig) config.as(BrickletLinearPotiConfig.class);
        this.addPositionListener(this.reg((position) -> {if(true) {updateStateFn.accept("BrickletLinearPotiPosition", transformBrickletLinearPotiPositionCallback0(position, cfg));}}, this.dev::removePositionListener));
        
		{
		BrickletLinearPotiPositionConfig channelCfg = getChannelConfigFn.apply("BrickletLinearPotiPosition").as(BrickletLinearPotiPositionConfig.class);
		this.setPositionCallbackPeriod(channelCfg.updateInterval);
		this.setPositionCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletLinearPotiConfig cfg = (BrickletLinearPotiConfig) config.as(BrickletLinearPotiConfig.class);
        this.setPositionCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletLinearPotiConfig cfg = (BrickletLinearPotiConfig) config.as(BrickletLinearPotiConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletLinearPotiPosition");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletLinearPotiPosition":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletLinearPotiPosition"), "Position", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletLinearPotiPosition")).withDescription("The position of the linear potentiometer. The value is between 0 (slider down) and 100 (slider up).")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(100)).withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Linear Poti Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("59mm linear potentiometer").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletLinearPotiPosition", new ChannelTypeUID("tinkerforge", "BrickletLinearPotiPosition")).withLabel("Position").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletlinearpoti":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletLinearPotiPosition":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletLinearPotiConfig cfg = (BrickletLinearPotiConfig) config.as(BrickletLinearPotiConfig.class);
        switch(channel) {
            case "BrickletLinearPotiPosition": {
                   BrickletLinearPotiPositionConfig channelCfg = channelConfig.as(BrickletLinearPotiPositionConfig.class);
                   {
            int value = this.getPosition();
            if(true)
                updateStateFn.accept(channel, transformBrickletLinearPotiPositionGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletLinearPotiConfig cfg = (BrickletLinearPotiConfig) config.as(BrickletLinearPotiConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletLinearPotiPositionCallback0(int position, BrickletLinearPotiConfig cfg) {
        return new QuantityType<>(position, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletLinearPotiPositionGetter0(int value, BrickletLinearPotiConfig cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }

}