/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletMotionDetectorV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletMotionDetectorV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletMotionDetectorV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletMotionDetectorV2.DEVICE_DISPLAY_NAME, "brickletmotiondetectorv2", BrickletMotionDetectorV2.DEVICE_IDENTIFIER, BrickletMotionDetectorV2Wrapper.class, BrickletMotionDetectorV2Actions.class, "2.0.0", true);

    public BrickletMotionDetectorV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletMotionDetectorV2(uid, ipcon);
    }

    
	public final static int MOTION_NOT_DETECTED = 0;
	public final static int MOTION_DETECTED = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getMotionDetected() throws TinkerforgeException {
    return this.dev.getMotionDetected();
}

public void setSensitivity(int sensitivity) throws TinkerforgeException {
    this.dev.setSensitivity(sensitivity);
}

public int getSensitivity() throws TinkerforgeException {
    return this.dev.getSensitivity();
}

public void setIndicator(int topLeft, int topRight, int bottom) throws TinkerforgeException {
    this.dev.setIndicator(topLeft, topRight, bottom);
}

public BrickletMotionDetectorV2.Indicator getIndicator() throws TinkerforgeException {
    return this.dev.getIndicator();
}

public BrickletMotionDetectorV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletMotionDetectorV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addMotionDetectedListener(BrickletMotionDetectorV2.MotionDetectedListener l) {
    this.dev.addMotionDetectedListener(l);
}

public void removeMotionDetectedListener(BrickletMotionDetectorV2.MotionDetectedListener l) {
    this.dev.removeMotionDetectedListener(l);
}

public void addDetectionCycleEndedListener(BrickletMotionDetectorV2.DetectionCycleEndedListener l) {
    this.dev.addDetectionCycleEndedListener(l);
}

public void removeDetectionCycleEndedListener(BrickletMotionDetectorV2.DetectionCycleEndedListener l) {
    this.dev.removeDetectionCycleEndedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletMotionDetectorV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletMotionDetectorV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletMotionDetectorV2Config cfg = (BrickletMotionDetectorV2Config) config.as(BrickletMotionDetectorV2Config.class);
        this.addMotionDetectedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletMotionDetectorV2MotionDetected", transformBrickletMotionDetectorV2MotionDetectedCallback0(cfg));}}, this.dev::removeMotionDetectedListener));
		this.addDetectionCycleEndedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletMotionDetectorV2DetectionCycleEnded", transformBrickletMotionDetectorV2DetectionCycleEndedCallback0(cfg));}}, this.dev::removeDetectionCycleEndedListener));
        this.setSensitivity(cfg.sensitivity);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		
		}
		{
		
		}
		{
		BrickletMotionDetectorV2IndicatorConfig channelCfg = getChannelConfigFn.apply("BrickletMotionDetectorV2TopLeftIndicator").as(BrickletMotionDetectorV2IndicatorConfig.class);
		
		}
		{
		BrickletMotionDetectorV2IndicatorConfig channelCfg = getChannelConfigFn.apply("BrickletMotionDetectorV2TopRightIndicator").as(BrickletMotionDetectorV2IndicatorConfig.class);
		
		}
		{
		BrickletMotionDetectorV2IndicatorConfig channelCfg = getChannelConfigFn.apply("BrickletMotionDetectorV2BottomIndicator").as(BrickletMotionDetectorV2IndicatorConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletMotionDetectorV2Config cfg = (BrickletMotionDetectorV2Config) config.as(BrickletMotionDetectorV2Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletMotionDetectorV2Config cfg = (BrickletMotionDetectorV2Config) config.as(BrickletMotionDetectorV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletMotionDetectorV2MotionDetected");
		result.add("BrickletMotionDetectorV2DetectionCycleEnded");
		result.add("BrickletMotionDetectorV2TopLeftIndicator");
		result.add("BrickletMotionDetectorV2TopRightIndicator");
		result.add("BrickletMotionDetectorV2BottomIndicator");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletMotionDetectorV2Indicator":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletMotionDetectorV2Indicator"), "NOT USED", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletMotionDetectorV2Indicator")).withDescription("Sets one of the blue backlight LEDs of the fresnel lens. A value of 0 turns the LED off and a value of 255 turns the LED to full brightness.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(255)).withPattern("%d").build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Motion Detector Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Passive infrared (PIR) motion sensor with 12m range and dimmable backlight").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletMotionDetectorV2MotionDetected", new ChannelTypeUID("system", "trigger")).withLabel("Motion Detected").withDescription("This channel is triggered after a motion was detected.").build(), new ChannelDefinitionBuilder("BrickletMotionDetectorV2DetectionCycleEnded", new ChannelTypeUID("system", "trigger")).withLabel("Detection Cycle Ended").withDescription("This channel is triggered when the detection cycle ended. A new motion can be detected again after approximately 2 seconds.").build(), new ChannelDefinitionBuilder("BrickletMotionDetectorV2TopLeftIndicator", new ChannelTypeUID("tinkerforge", "BrickletMotionDetectorV2Indicator")).withLabel("Top Left Indicator").build(), new ChannelDefinitionBuilder("BrickletMotionDetectorV2TopRightIndicator", new ChannelTypeUID("tinkerforge", "BrickletMotionDetectorV2Indicator")).withLabel("Top Right Indicator").build(), new ChannelDefinitionBuilder("BrickletMotionDetectorV2BottomIndicator", new ChannelTypeUID("tinkerforge", "BrickletMotionDetectorV2Indicator")).withLabel("Bottom Indicator").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletmotiondetectorv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("sensitivity", Type.INTEGER).withDefault("50").withDescription("The sensitivity of the PIR sensor. The range is 0-100. At full sensitivity (100), the Bricklet can detect motion in a range of approximately 12m.<br/><br/>The actual range depends on many things in the environment (e.g. reflections) and the size of the object to be detected. While a big person might be detected in a range of 10m a cat may only be detected at 2m distance with the same setting. So you will have to find a good sensitivity for your application by trial and error.").withLabel("Sensitivity").withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(100)).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletMotionDetectorV2Indicator":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletMotionDetectorV2Config cfg = (BrickletMotionDetectorV2Config) config.as(BrickletMotionDetectorV2Config.class);
        switch(channel) {
            case "BrickletMotionDetectorV2MotionDetected":
                   {
            int value = this.getMotionDetected();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletMotionDetectorV2MotionDetectedGetter0(value, cfg));
        }
                   return;
            case "BrickletMotionDetectorV2DetectionCycleEnded":
                   {
            int value = this.getMotionDetected();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletMotionDetectorV2DetectionCycleEndedGetter0(value, cfg));
        }
                   return;
            case "BrickletMotionDetectorV2TopLeftIndicator": {
                   BrickletMotionDetectorV2IndicatorConfig channelCfg = channelConfig.as(BrickletMotionDetectorV2IndicatorConfig.class);
                   {
            BrickletMotionDetectorV2.Indicator value = this.getIndicator();
            if(true)
                updateStateFn.accept(channel, transformBrickletMotionDetectorV2TopLeftIndicatorGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletMotionDetectorV2TopRightIndicator": {
                   BrickletMotionDetectorV2IndicatorConfig channelCfg = channelConfig.as(BrickletMotionDetectorV2IndicatorConfig.class);
                   {
            BrickletMotionDetectorV2.Indicator value = this.getIndicator();
            if(true)
                updateStateFn.accept(channel, transformBrickletMotionDetectorV2TopRightIndicatorGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletMotionDetectorV2BottomIndicator": {
                   BrickletMotionDetectorV2IndicatorConfig channelCfg = channelConfig.as(BrickletMotionDetectorV2IndicatorConfig.class);
                   {
            BrickletMotionDetectorV2.Indicator value = this.getIndicator();
            if(true)
                updateStateFn.accept(channel, transformBrickletMotionDetectorV2BottomIndicatorGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletMotionDetectorV2Config cfg = (BrickletMotionDetectorV2Config) config.as(BrickletMotionDetectorV2Config.class);
        switch(channel) {
            case "BrickletMotionDetectorV2TopLeftIndicator":
                if (command instanceof Number) {
                    BrickletMotionDetectorV2IndicatorConfig channelCfg = channelConfig.as(BrickletMotionDetectorV2IndicatorConfig.class);
                    Number cmd = (Number) command;
                    this.setIndicator(cmd.intValue(), this.getIndicator().topRight, this.getIndicator().bottom);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletMotionDetectorV2TopRightIndicator":
                if (command instanceof Number) {
                    BrickletMotionDetectorV2IndicatorConfig channelCfg = channelConfig.as(BrickletMotionDetectorV2IndicatorConfig.class);
                    Number cmd = (Number) command;
                    this.setIndicator(this.getIndicator().topLeft, cmd.intValue(), this.getIndicator().bottom);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletMotionDetectorV2BottomIndicator":
                if (command instanceof Number) {
                    BrickletMotionDetectorV2IndicatorConfig channelCfg = channelConfig.as(BrickletMotionDetectorV2IndicatorConfig.class);
                    Number cmd = (Number) command;
                    this.setIndicator(this.getIndicator().topLeft, this.getIndicator().topRight, cmd.intValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of Number.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletMotionDetectorV2MotionDetectedCallback0(BrickletMotionDetectorV2Config cfg) {
        return "";
    }
	    private String transformBrickletMotionDetectorV2DetectionCycleEndedCallback0(BrickletMotionDetectorV2Config cfg) {
        return "";
    }
	    private String transformBrickletMotionDetectorV2MotionDetectedGetter0(int value, BrickletMotionDetectorV2Config cfg) {
        return "";
    }
	    private String transformBrickletMotionDetectorV2DetectionCycleEndedGetter0(int value, BrickletMotionDetectorV2Config cfg) {
        return "";
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMotionDetectorV2TopLeftIndicatorGetter0(BrickletMotionDetectorV2.Indicator value, BrickletMotionDetectorV2Config cfg) {
        return new QuantityType(value.topLeft, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMotionDetectorV2TopRightIndicatorGetter0(BrickletMotionDetectorV2.Indicator value, BrickletMotionDetectorV2Config cfg) {
        return new QuantityType(value.topRight, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletMotionDetectorV2BottomIndicatorGetter0(BrickletMotionDetectorV2.Indicator value, BrickletMotionDetectorV2Config cfg) {
        return new QuantityType(value.bottom, SmartHomeUnits.ONE);
    }

}