/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletMotionDetector;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletMotionDetectorWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletMotionDetector dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletMotionDetector.DEVICE_DISPLAY_NAME, "brickletmotiondetector", BrickletMotionDetector.DEVICE_IDENTIFIER, BrickletMotionDetectorWrapper.class, BrickletMotionDetectorActions.class, "2.0.0", false);

    public BrickletMotionDetectorWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletMotionDetector(uid, ipcon);
    }

    
	public final static int MOTION_NOT_DETECTED = 0;
	public final static int MOTION_DETECTED = 1;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 2;


    public int getMotionDetected() throws TinkerforgeException {
    return this.dev.getMotionDetected();
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public BrickletMotionDetector.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addMotionDetectedListener(BrickletMotionDetector.MotionDetectedListener l) {
    this.dev.addMotionDetectedListener(l);
}

public void removeMotionDetectedListener(BrickletMotionDetector.MotionDetectedListener l) {
    this.dev.removeMotionDetectedListener(l);
}

public void addDetectionCycleEndedListener(BrickletMotionDetector.DetectionCycleEndedListener l) {
    this.dev.addDetectionCycleEndedListener(l);
}

public void removeDetectionCycleEndedListener(BrickletMotionDetector.DetectionCycleEndedListener l) {
    this.dev.removeDetectionCycleEndedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletMotionDetectorWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletMotionDetectorWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletMotionDetectorConfig cfg = (BrickletMotionDetectorConfig) config.as(BrickletMotionDetectorConfig.class);
        this.addMotionDetectedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletMotionDetectorMotionDetected", transformBrickletMotionDetectorMotionDetectedCallback0(cfg));}}, this.dev::removeMotionDetectedListener));
		this.addDetectionCycleEndedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletMotionDetectorDetectionCycleEnded", transformBrickletMotionDetectorDetectionCycleEndedCallback0(cfg));}}, this.dev::removeDetectionCycleEndedListener));
        
		{
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletMotionDetectorConfig cfg = (BrickletMotionDetectorConfig) config.as(BrickletMotionDetectorConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletMotionDetectorConfig cfg = (BrickletMotionDetectorConfig) config.as(BrickletMotionDetectorConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletMotionDetectorMotionDetected");
		result.add("BrickletMotionDetectorDetectionCycleEnded");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Motion Detector Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Passive infrared (PIR) motion sensor with 7m range").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletMotionDetectorMotionDetected", new ChannelTypeUID("system", "trigger")).withLabel("Motion Detected").withDescription("This channel is triggered after a motion was detected.").build(), new ChannelDefinitionBuilder("BrickletMotionDetectorDetectionCycleEnded", new ChannelTypeUID("system", "trigger")).withLabel("Detection Cycle Ended").withDescription("This channel is triggered when the detection cycle ended. A new motion can be detected again after approximately 2 seconds.").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletmotiondetector":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletMotionDetectorConfig cfg = (BrickletMotionDetectorConfig) config.as(BrickletMotionDetectorConfig.class);
        switch(channel) {
            case "BrickletMotionDetectorMotionDetected":
                   {
            int value = this.getMotionDetected();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletMotionDetectorMotionDetectedGetter0(value, cfg));
        }
                   return;
            case "BrickletMotionDetectorDetectionCycleEnded":
                   {
            int value = this.getMotionDetected();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletMotionDetectorDetectionCycleEndedGetter0(value, cfg));
        }
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletMotionDetectorConfig cfg = (BrickletMotionDetectorConfig) config.as(BrickletMotionDetectorConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletMotionDetectorMotionDetectedCallback0(BrickletMotionDetectorConfig cfg) {
        return "";
    }
	    private String transformBrickletMotionDetectorDetectionCycleEndedCallback0(BrickletMotionDetectorConfig cfg) {
        return "";
    }
	    private String transformBrickletMotionDetectorMotionDetectedGetter0(int value, BrickletMotionDetectorConfig cfg) {
        return "";
    }
	    private String transformBrickletMotionDetectorDetectionCycleEndedGetter0(int value, BrickletMotionDetectorConfig cfg) {
        return "";
    }

}