/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.tinkerforge.BrickletNFCRFID;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletNFCRFIDWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletNFCRFID dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletNFCRFID.DEVICE_DISPLAY_NAME, "brickletnfcrfid", BrickletNFCRFID.DEVICE_IDENTIFIER, BrickletNFCRFIDWrapper.class, BrickletNFCRFIDActions.class, "2.0.0", false);

    public BrickletNFCRFIDWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletNFCRFID(uid, ipcon);
    }

    
	public final static int TAG_TYPE_MIFARE_CLASSIC = 0;
	public final static int TAG_TYPE_TYPE1 = 1;
	public final static int TAG_TYPE_TYPE2 = 2;
	public final static int STATE_INITIALIZATION = 0;
	public final static int STATE_IDLE = 128;
	public final static int STATE_ERROR = 192;
	public final static int STATE_REQUEST_TAG_ID = 2;
	public final static int STATE_REQUEST_TAG_ID_READY = 130;
	public final static int STATE_REQUEST_TAG_ID_ERROR = 194;
	public final static int STATE_AUTHENTICATING_MIFARE_CLASSIC_PAGE = 3;
	public final static int STATE_AUTHENTICATING_MIFARE_CLASSIC_PAGE_READY = 131;
	public final static int STATE_AUTHENTICATING_MIFARE_CLASSIC_PAGE_ERROR = 195;
	public final static int STATE_WRITE_PAGE = 4;
	public final static int STATE_WRITE_PAGE_READY = 132;
	public final static int STATE_WRITE_PAGE_ERROR = 196;
	public final static int STATE_REQUEST_PAGE = 5;
	public final static int STATE_REQUEST_PAGE_READY = 133;
	public final static int STATE_REQUEST_PAGE_ERROR = 197;
	public final static int KEY_A = 0;
	public final static int KEY_B = 1;


    public void requestTagID(int tagType) throws TinkerforgeException {
    this.dev.requestTagID(tagType);
}

public BrickletNFCRFID.TagID getTagID() throws TinkerforgeException {
    return this.dev.getTagID();
}

public BrickletNFCRFID.State getState() throws TinkerforgeException {
    return this.dev.getState();
}

public void authenticateMifareClassicPage(int page, int keyNumber, int[] key) throws TinkerforgeException {
    this.dev.authenticateMifareClassicPage(page, keyNumber, key);
}

public void writePage(int page, int[] data) throws TinkerforgeException {
    this.dev.writePage(page, data);
}

public void requestPage(int page) throws TinkerforgeException {
    this.dev.requestPage(page);
}

public int[] getPage() throws TinkerforgeException {
    return this.dev.getPage();
}

public BrickletNFCRFID.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addStateChangedListener(BrickletNFCRFID.StateChangedListener l) {
    this.dev.addStateChangedListener(l);
}

public void removeStateChangedListener(BrickletNFCRFID.StateChangedListener l) {
    this.dev.removeStateChangedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletNFCRFIDWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletNFCRFIDWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletNFCRFIDConfig cfg = (BrickletNFCRFIDConfig) config.as(BrickletNFCRFIDConfig.class);
        
        
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletNFCRFIDConfig cfg = (BrickletNFCRFIDConfig) config.as(BrickletNFCRFIDConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletNFCRFIDConfig cfg = (BrickletNFCRFIDConfig) config.as(BrickletNFCRFIDConfig.class);
        List<String> result = new ArrayList<String>();
        
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge NFC/RFID Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Reads and writes NFC and RFID tags").withChannelDefinitions(Arrays.asList()).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletnfcrfid":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletNFCRFIDConfig cfg = (BrickletNFCRFIDConfig) config.as(BrickletNFCRFIDConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletNFCRFIDConfig cfg = (BrickletNFCRFIDConfig) config.as(BrickletNFCRFIDConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    

}