/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.tinkerforge.BrickletNFC;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletNFCWrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletNFC dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletNFC.DEVICE_DISPLAY_NAME, "brickletnfc", BrickletNFC.DEVICE_IDENTIFIER, BrickletNFCWrapper.class, BrickletNFCActions.class, "2.0.0", true);

    public BrickletNFCWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletNFC(uid, ipcon);
    }

    
	public final static int MODE_OFF = 0;
	public final static int MODE_CARDEMU = 1;
	public final static int MODE_P2P = 2;
	public final static int MODE_READER = 3;
	public final static int TAG_TYPE_MIFARE_CLASSIC = 0;
	public final static int TAG_TYPE_TYPE1 = 1;
	public final static int TAG_TYPE_TYPE2 = 2;
	public final static int TAG_TYPE_TYPE3 = 3;
	public final static int TAG_TYPE_TYPE4 = 4;
	public final static int READER_STATE_INITIALIZATION = 0;
	public final static int READER_STATE_IDLE = 128;
	public final static int READER_STATE_ERROR = 192;
	public final static int READER_STATE_REQUEST_TAG_ID = 2;
	public final static int READER_STATE_REQUEST_TAG_ID_READY = 130;
	public final static int READER_STATE_REQUEST_TAG_ID_ERROR = 194;
	public final static int READER_STATE_AUTHENTICATE_MIFARE_CLASSIC_PAGE = 3;
	public final static int READER_STATE_AUTHENTICATE_MIFARE_CLASSIC_PAGE_READY = 131;
	public final static int READER_STATE_AUTHENTICATE_MIFARE_CLASSIC_PAGE_ERROR = 195;
	public final static int READER_STATE_WRITE_PAGE = 4;
	public final static int READER_STATE_WRITE_PAGE_READY = 132;
	public final static int READER_STATE_WRITE_PAGE_ERROR = 196;
	public final static int READER_STATE_REQUEST_PAGE = 5;
	public final static int READER_STATE_REQUEST_PAGE_READY = 133;
	public final static int READER_STATE_REQUEST_PAGE_ERROR = 197;
	public final static int READER_STATE_WRITE_NDEF = 6;
	public final static int READER_STATE_WRITE_NDEF_READY = 134;
	public final static int READER_STATE_WRITE_NDEF_ERROR = 198;
	public final static int READER_STATE_REQUEST_NDEF = 7;
	public final static int READER_STATE_REQUEST_NDEF_READY = 135;
	public final static int READER_STATE_REQUEST_NDEF_ERROR = 199;
	public final static int KEY_A = 0;
	public final static int KEY_B = 1;
	public final static int READER_WRITE_TYPE4_CAPABILITY_CONTAINER = 3;
	public final static int READER_WRITE_TYPE4_NDEF = 4;
	public final static int READER_REQUEST_TYPE4_CAPABILITY_CONTAINER = 3;
	public final static int READER_REQUEST_TYPE4_NDEF = 4;
	public final static int CARDEMU_STATE_INITIALIZATION = 0;
	public final static int CARDEMU_STATE_IDLE = 128;
	public final static int CARDEMU_STATE_ERROR = 192;
	public final static int CARDEMU_STATE_DISCOVER = 2;
	public final static int CARDEMU_STATE_DISCOVER_READY = 130;
	public final static int CARDEMU_STATE_DISCOVER_ERROR = 194;
	public final static int CARDEMU_STATE_TRANSFER_NDEF = 3;
	public final static int CARDEMU_STATE_TRANSFER_NDEF_READY = 131;
	public final static int CARDEMU_STATE_TRANSFER_NDEF_ERROR = 195;
	public final static int CARDEMU_TRANSFER_ABORT = 0;
	public final static int CARDEMU_TRANSFER_WRITE = 1;
	public final static int P2P_STATE_INITIALIZATION = 0;
	public final static int P2P_STATE_IDLE = 128;
	public final static int P2P_STATE_ERROR = 192;
	public final static int P2P_STATE_DISCOVER = 2;
	public final static int P2P_STATE_DISCOVER_READY = 130;
	public final static int P2P_STATE_DISCOVER_ERROR = 194;
	public final static int P2P_STATE_TRANSFER_NDEF = 3;
	public final static int P2P_STATE_TRANSFER_NDEF_READY = 131;
	public final static int P2P_STATE_TRANSFER_NDEF_ERROR = 195;
	public final static int P2P_TRANSFER_ABORT = 0;
	public final static int P2P_TRANSFER_WRITE = 1;
	public final static int P2P_TRANSFER_READ = 2;
	public final static int DETECTION_LED_CONFIG_OFF = 0;
	public final static int DETECTION_LED_CONFIG_ON = 1;
	public final static int DETECTION_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int DETECTION_LED_CONFIG_SHOW_DETECTION = 3;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setMode(int mode) throws TinkerforgeException {
    this.dev.setMode(mode);
}

public int getMode() throws TinkerforgeException {
    return this.dev.getMode();
}

public void readerRequestTagID() throws TinkerforgeException {
    this.dev.readerRequestTagID();
}

public BrickletNFC.ReaderGetTagID readerGetTagID() throws TinkerforgeException {
    return this.dev.readerGetTagID();
}

public BrickletNFC.ReaderGetState readerGetState() throws TinkerforgeException {
    return this.dev.readerGetState();
}

public void readerWriteNDEF(int[] ndef) throws TinkerforgeException {
    this.dev.readerWriteNDEF(ndef);
}

public void readerRequestNDEF() throws TinkerforgeException {
    this.dev.readerRequestNDEF();
}

public int[] readerReadNDEF() throws TinkerforgeException {
    return this.dev.readerReadNDEF();
}

public void readerAuthenticateMifareClassicPage(int page, int keyNumber, int[] key) throws TinkerforgeException {
    this.dev.readerAuthenticateMifareClassicPage(page, keyNumber, key);
}

public void readerWritePage(int page, int[] data) throws TinkerforgeException {
    this.dev.readerWritePage(page, data);
}

public void readerRequestPage(int page, int length) throws TinkerforgeException {
    this.dev.readerRequestPage(page, length);
}

public int[] readerReadPage() throws TinkerforgeException {
    return this.dev.readerReadPage();
}

public BrickletNFC.CardemuGetState cardemuGetState() throws TinkerforgeException {
    return this.dev.cardemuGetState();
}

public void cardemuStartDiscovery() throws TinkerforgeException {
    this.dev.cardemuStartDiscovery();
}

public void cardemuWriteNDEF(int[] ndef) throws TinkerforgeException {
    this.dev.cardemuWriteNDEF(ndef);
}

public void cardemuStartTransfer(int transfer) throws TinkerforgeException {
    this.dev.cardemuStartTransfer(transfer);
}

public BrickletNFC.P2PGetState p2pGetState() throws TinkerforgeException {
    return this.dev.p2pGetState();
}

public void p2pStartDiscovery() throws TinkerforgeException {
    this.dev.p2pStartDiscovery();
}

public void p2pWriteNDEF(int[] ndef) throws TinkerforgeException {
    this.dev.p2pWriteNDEF(ndef);
}

public void p2pStartTransfer(int transfer) throws TinkerforgeException {
    this.dev.p2pStartTransfer(transfer);
}

public int[] p2pReadNDEF() throws TinkerforgeException {
    return this.dev.p2pReadNDEF();
}

public void setDetectionLEDConfig(int config) throws TinkerforgeException {
    this.dev.setDetectionLEDConfig(config);
}

public int getDetectionLEDConfig() throws TinkerforgeException {
    return this.dev.getDetectionLEDConfig();
}

public void setMaximumTimeout(int timeout) throws TinkerforgeException {
    this.dev.setMaximumTimeout(timeout);
}

public int getMaximumTimeout() throws TinkerforgeException {
    return this.dev.getMaximumTimeout();
}

public BrickletNFC.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletNFC.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addReaderStateChangedListener(BrickletNFC.ReaderStateChangedListener l) {
    this.dev.addReaderStateChangedListener(l);
}

public void removeReaderStateChangedListener(BrickletNFC.ReaderStateChangedListener l) {
    this.dev.removeReaderStateChangedListener(l);
}

public void addCardemuStateChangedListener(BrickletNFC.CardemuStateChangedListener l) {
    this.dev.addCardemuStateChangedListener(l);
}

public void removeCardemuStateChangedListener(BrickletNFC.CardemuStateChangedListener l) {
    this.dev.removeCardemuStateChangedListener(l);
}

public void addP2PStateChangedListener(BrickletNFC.P2PStateChangedListener l) {
    this.dev.addP2PStateChangedListener(l);
}

public void removeP2PStateChangedListener(BrickletNFC.P2PStateChangedListener l) {
    this.dev.removeP2PStateChangedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletNFCWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletNFCWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletNFCConfig cfg = (BrickletNFCConfig) config.as(BrickletNFCConfig.class);
        
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletNFCConfig cfg = (BrickletNFCConfig) config.as(BrickletNFCConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletNFCConfig cfg = (BrickletNFCConfig) config.as(BrickletNFCConfig.class);
        List<String> result = new ArrayList<String>();
        
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge NFC Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("NFC tag read/write, NFC P2P and Card Emulation").withChannelDefinitions(Arrays.asList()).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletnfc":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletNFCConfig cfg = (BrickletNFCConfig) config.as(BrickletNFCConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletNFCConfig cfg = (BrickletNFCConfig) config.as(BrickletNFCConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    

}