/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletOLED128x64V2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletOLED128x64V2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletOLED128x64V2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletOLED128x64V2.DEVICE_DISPLAY_NAME, "brickletoled128x64v2", BrickletOLED128x64V2.DEVICE_IDENTIFIER, BrickletOLED128x64V2Wrapper.class, BrickletOLED128x64V2Actions.class, "2.0.0", true);

    public BrickletOLED128x64V2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletOLED128x64V2(uid, ipcon);
    }

    
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void writePixels(int xStart, int yStart, int xEnd, int yEnd, boolean[] pixels) throws TinkerforgeException {
    this.dev.writePixels(xStart, yStart, xEnd, yEnd, pixels);
}

public boolean[] readPixels(int xStart, int yStart, int xEnd, int yEnd) throws TinkerforgeException {
    return this.dev.readPixels(xStart, yStart, xEnd, yEnd);
}

public void clearDisplay() throws TinkerforgeException {
    this.dev.clearDisplay();
}

public void setDisplayConfiguration(int contrast, boolean invert, boolean automaticDraw) throws TinkerforgeException {
    this.dev.setDisplayConfiguration(contrast, invert, automaticDraw);
}

public BrickletOLED128x64V2.DisplayConfiguration getDisplayConfiguration() throws TinkerforgeException {
    return this.dev.getDisplayConfiguration();
}

public void writeLine(int line, int position, String text) throws TinkerforgeException {
    this.dev.writeLine(line, position, text);
}

public void drawBufferedFrame(boolean forceCompleteRedraw) throws TinkerforgeException {
    this.dev.drawBufferedFrame(forceCompleteRedraw);
}

public BrickletOLED128x64V2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletOLED128x64V2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletOLED128x64V2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletOLED128x64V2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletOLED128x64V2Config cfg = (BrickletOLED128x64V2Config) config.as(BrickletOLED128x64V2Config.class);
        
        this.setDisplayConfiguration(cfg.contrast, cfg.invert, cfg.automaticDraw);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletOLED128x64V2TextConfig channelCfg = getChannelConfigFn.apply("BrickletOLED128x64V2Text").as(BrickletOLED128x64V2TextConfig.class);
		
		}
		{
		BrickletOLED128x64V2ClearDisplayConfig channelCfg = getChannelConfigFn.apply("BrickletOLED128x64V2ClearDisplay").as(BrickletOLED128x64V2ClearDisplayConfig.class);
		
		}
		{
		BrickletOLED128x64V2DrawBufferedFrameConfig channelCfg = getChannelConfigFn.apply("BrickletOLED128x64V2DrawBufferedFrame").as(BrickletOLED128x64V2DrawBufferedFrameConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletOLED128x64V2Config cfg = (BrickletOLED128x64V2Config) config.as(BrickletOLED128x64V2Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletOLED128x64V2Config cfg = (BrickletOLED128x64V2Config) config.as(BrickletOLED128x64V2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletOLED128x64V2Text");
		result.add("BrickletOLED128x64V2ClearDisplay");
		result.add("BrickletOLED128x64V2DrawBufferedFrame");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletOLED128x64V2Text":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletOLED128x64V2Text"), "Text", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletOLED128x64V2Text")).withDescription("Text to display on the LCD. Command format is [line],[position],[text].<br/><br/>Additional ',' are handled as part of the text. Unicode characters are converted to the LCD character set if possible. Additionally you can use \\x[two hex digits] to use a character of the LCD character set directly.").build();
            case "BrickletOLED128x64V2ClearDisplay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletOLED128x64V2ClearDisplay"), "Clear Display", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletOLED128x64V2ClearDisplay")).withDescription("Deletes all characters from the display.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("CLEAR", "Clear")).build()).build();
            case "BrickletOLED128x64V2DrawBufferedFrame":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletOLED128x64V2DrawBufferedFrame"), "Draw Buffered Frame", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletOLED128x64V2DrawBufferedFrame")).withDescription("Draws the currently buffered frame.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("DRAW", "Draw")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge OLED 128x64 Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("3.3cm (1.3\") OLED display with 128x64 pixels").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletOLED128x64V2Text", new ChannelTypeUID("tinkerforge", "BrickletOLED128x64V2Text")).withLabel("Text").build(), new ChannelDefinitionBuilder("BrickletOLED128x64V2ClearDisplay", new ChannelTypeUID("tinkerforge", "BrickletOLED128x64V2ClearDisplay")).withLabel("Clear Display").build(), new ChannelDefinitionBuilder("BrickletOLED128x64V2DrawBufferedFrame", new ChannelTypeUID("tinkerforge", "BrickletOLED128x64V2DrawBufferedFrame")).withLabel("Draw Buffered Frame").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletoled128x64v2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("contrast", Type.INTEGER).withDefault("143").withDescription("Sets the contrast of the display (0-255).").withLabel("Contrast").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(255)).build(), ConfigDescriptionParameterBuilder.create("invert", Type.BOOLEAN).withDefault("false").withDescription("Inverts the color (black/white) of the display.").withLabel("Invert").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("automaticDraw", Type.BOOLEAN).withDefault("true").withDescription("If automatic draw is enabled, the display is automatically updated when writing text or clearing the display. If it is disabled, the changes are written into an internal buffer and only shown on the display after triggering the Draw Buffered Frame channel.").withLabel("Automatic Draw").withAdvanced(true).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletOLED128x64V2Text":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletOLED128x64V2ClearDisplay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletOLED128x64V2DrawBufferedFrame":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletOLED128x64V2Config cfg = (BrickletOLED128x64V2Config) config.as(BrickletOLED128x64V2Config.class);
        switch(channel) {
            case "BrickletOLED128x64V2Text":
               return;
            case "BrickletOLED128x64V2ClearDisplay":
               return;
            case "BrickletOLED128x64V2DrawBufferedFrame":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletOLED128x64V2Config cfg = (BrickletOLED128x64V2Config) config.as(BrickletOLED128x64V2Config.class);
        switch(channel) {
            case "BrickletOLED128x64V2Text":
                if (command instanceof StringType) {
                    BrickletOLED128x64V2TextConfig channelCfg = channelConfig.as(BrickletOLED128x64V2TextConfig.class);
                    StringType cmd = (StringType) command;
                    this.writeLine(Helper.parseDisplayCommandLine(cmd.toString(), logger), Helper.parseDisplayCommandPosition(cmd.toString(), logger), Helper.parseDisplayCommandText(cmd.toString(), logger, false));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletOLED128x64V2ClearDisplay":
                if (command instanceof StringType) {
                    BrickletOLED128x64V2ClearDisplayConfig channelCfg = channelConfig.as(BrickletOLED128x64V2ClearDisplayConfig.class);
                    StringType cmd = (StringType) command;
                    this.clearDisplay();
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletOLED128x64V2DrawBufferedFrame":
                if (command instanceof StringType) {
                    BrickletOLED128x64V2DrawBufferedFrameConfig channelCfg = channelConfig.as(BrickletOLED128x64V2DrawBufferedFrameConfig.class);
                    StringType cmd = (StringType) command;
                    this.drawBufferedFrame(true);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    

}