/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletOLED64x48;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletOLED64x48Wrapper extends DeviceWrapper implements StandardFlashable{
    BrickletOLED64x48 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletOLED64x48.DEVICE_DISPLAY_NAME, "brickletoled64x48", BrickletOLED64x48.DEVICE_IDENTIFIER, BrickletOLED64x48Wrapper.class, BrickletOLED64x48Actions.class, "2.0.0", false);

    public BrickletOLED64x48Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletOLED64x48(uid, ipcon);
    }

    


    public void write(int[] data) throws TinkerforgeException {
    this.dev.write(data);
}

public void newWindow(int columnFrom, int columnTo, int rowFrom, int rowTo) throws TinkerforgeException {
    this.dev.newWindow(columnFrom, columnTo, rowFrom, rowTo);
}

public void clearDisplay() throws TinkerforgeException {
    this.dev.clearDisplay();
}

public void setDisplayConfiguration(int contrast, boolean invert) throws TinkerforgeException {
    this.dev.setDisplayConfiguration(contrast, invert);
}

public BrickletOLED64x48.DisplayConfiguration getDisplayConfiguration() throws TinkerforgeException {
    return this.dev.getDisplayConfiguration();
}

public void writeLine(int line, int position, String text) throws TinkerforgeException {
    this.dev.writeLine(line, position, text);
}

public BrickletOLED64x48.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletOLED64x48Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletOLED64x48Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletOLED64x48Config cfg = (BrickletOLED64x48Config) config.as(BrickletOLED64x48Config.class);
        
        this.setDisplayConfiguration(cfg.contrast, cfg.invert);
		{
		BrickletOLED64x48TextConfig channelCfg = getChannelConfigFn.apply("BrickletOLED64x48Text").as(BrickletOLED64x48TextConfig.class);
		
		}
		{
		BrickletOLED64x48ClearDisplayConfig channelCfg = getChannelConfigFn.apply("BrickletOLED64x48ClearDisplay").as(BrickletOLED64x48ClearDisplayConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletOLED64x48Config cfg = (BrickletOLED64x48Config) config.as(BrickletOLED64x48Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletOLED64x48Config cfg = (BrickletOLED64x48Config) config.as(BrickletOLED64x48Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletOLED64x48Text");
		result.add("BrickletOLED64x48ClearDisplay");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletOLED64x48Text":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletOLED64x48Text"), "Text", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletOLED64x48Text")).withDescription("Text to display on the LCD. Command format is [line],[position],[text].<br/><br/>Additional ',' are handled as part of the text. Unicode characters are converted to the LCD character set if possible. Additionally you can use \\x[two hex digits] to use a character of the LCD character set directly.").build();
            case "BrickletOLED64x48ClearDisplay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletOLED64x48ClearDisplay"), "Clear Display", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletOLED64x48ClearDisplay")).withDescription("Deletes all characters from the display.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("CLEAR", "Clear")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge OLED 64x48 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("1.68cm (0.66\") OLED display with 64x48 pixels").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletOLED64x48Text", new ChannelTypeUID("tinkerforge", "BrickletOLED64x48Text")).withLabel("Text").build(), new ChannelDefinitionBuilder("BrickletOLED64x48ClearDisplay", new ChannelTypeUID("tinkerforge", "BrickletOLED64x48ClearDisplay")).withLabel("Clear Display").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletoled64x48":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("contrast", Type.INTEGER).withDefault("143").withDescription("Sets the contrast of the display (0-255).").withLabel("Contrast").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(255)).build(), ConfigDescriptionParameterBuilder.create("invert", Type.BOOLEAN).withDefault("false").withDescription("Inverts the color (black/white) of the display.").withLabel("Invert").withAdvanced(true).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletOLED64x48Text":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletOLED64x48ClearDisplay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletOLED64x48Config cfg = (BrickletOLED64x48Config) config.as(BrickletOLED64x48Config.class);
        switch(channel) {
            case "BrickletOLED64x48Text":
               return;
            case "BrickletOLED64x48ClearDisplay":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletOLED64x48Config cfg = (BrickletOLED64x48Config) config.as(BrickletOLED64x48Config.class);
        switch(channel) {
            case "BrickletOLED64x48Text":
                if (command instanceof StringType) {
                    BrickletOLED64x48TextConfig channelCfg = channelConfig.as(BrickletOLED64x48TextConfig.class);
                    StringType cmd = (StringType) command;
                    this.writeLine(Helper.parseDisplayCommandLine(cmd.toString(), logger), Helper.parseDisplayCommandPosition(cmd.toString(), logger), Helper.parseDisplayCommandText(cmd.toString(), logger, false));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletOLED64x48ClearDisplay":
                if (command instanceof StringType) {
                    BrickletOLED64x48ClearDisplayConfig channelCfg = channelConfig.as(BrickletOLED64x48ClearDisplayConfig.class);
                    StringType cmd = (StringType) command;
                    this.clearDisplay();
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    

}