/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletOutdoorWeather;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletOutdoorWeatherWrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletOutdoorWeather dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletOutdoorWeather.DEVICE_DISPLAY_NAME, "brickletoutdoorweather", BrickletOutdoorWeather.DEVICE_IDENTIFIER, BrickletOutdoorWeatherWrapper.class, BrickletOutdoorWeatherActions.class, "2.0.0", true);

    public BrickletOutdoorWeatherWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletOutdoorWeather(uid, ipcon);
    }

    
	public final static int WIND_DIRECTION_N = 0;
	public final static int WIND_DIRECTION_NNE = 1;
	public final static int WIND_DIRECTION_NE = 2;
	public final static int WIND_DIRECTION_ENE = 3;
	public final static int WIND_DIRECTION_E = 4;
	public final static int WIND_DIRECTION_ESE = 5;
	public final static int WIND_DIRECTION_SE = 6;
	public final static int WIND_DIRECTION_SSE = 7;
	public final static int WIND_DIRECTION_S = 8;
	public final static int WIND_DIRECTION_SSW = 9;
	public final static int WIND_DIRECTION_SW = 10;
	public final static int WIND_DIRECTION_WSW = 11;
	public final static int WIND_DIRECTION_W = 12;
	public final static int WIND_DIRECTION_WNW = 13;
	public final static int WIND_DIRECTION_NW = 14;
	public final static int WIND_DIRECTION_NNW = 15;
	public final static int WIND_DIRECTION_ERROR = 255;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int[] getStationIdentifiers() throws TinkerforgeException {
    return this.dev.getStationIdentifiers();
}

public int[] getSensorIdentifiers() throws TinkerforgeException {
    return this.dev.getSensorIdentifiers();
}

public BrickletOutdoorWeather.StationData getStationData(int identifier) throws TinkerforgeException {
    return this.dev.getStationData(identifier);
}

public BrickletOutdoorWeather.SensorData getSensorData(int identifier) throws TinkerforgeException {
    return this.dev.getSensorData(identifier);
}

public void setStationCallbackConfiguration(boolean enableCallback) throws TinkerforgeException {
    this.dev.setStationCallbackConfiguration(enableCallback);
}

public boolean getStationCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getStationCallbackConfiguration();
}

public void setSensorCallbackConfiguration(boolean enableCallback) throws TinkerforgeException {
    this.dev.setSensorCallbackConfiguration(enableCallback);
}

public boolean getSensorCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getSensorCallbackConfiguration();
}

public BrickletOutdoorWeather.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletOutdoorWeather.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addStationDataListener(BrickletOutdoorWeather.StationDataListener l) {
    this.dev.addStationDataListener(l);
}

public void removeStationDataListener(BrickletOutdoorWeather.StationDataListener l) {
    this.dev.removeStationDataListener(l);
}

public void addSensorDataListener(BrickletOutdoorWeather.SensorDataListener l) {
    this.dev.addSensorDataListener(l);
}

public void removeSensorDataListener(BrickletOutdoorWeather.SensorDataListener l) {
    this.dev.removeSensorDataListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletOutdoorWeatherWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletOutdoorWeatherWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletOutdoorWeatherConfig cfg = (BrickletOutdoorWeatherConfig) config.as(BrickletOutdoorWeatherConfig.class);
        
        
		    this.setStationCallbackConfiguration(true);
		    this.setSensorCallbackConfiguration(true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletOutdoorWeatherSensorIdentifiersConfig channelCfg = getChannelConfigFn.apply("BrickletOutdoorWeatherSensorIdentifiers").as(BrickletOutdoorWeatherSensorIdentifiersConfig.class);
		
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletOutdoorWeatherSensorIdentifiers"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
		{
		BrickletOutdoorWeatherStationIdentifiersConfig channelCfg = getChannelConfigFn.apply("BrickletOutdoorWeatherStationIdentifiers").as(BrickletOutdoorWeatherStationIdentifiersConfig.class);
		
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletOutdoorWeatherStationIdentifiers"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletOutdoorWeatherConfig cfg = (BrickletOutdoorWeatherConfig) config.as(BrickletOutdoorWeatherConfig.class);
        this.setStationCallbackConfiguration(false);
		    this.setSensorCallbackConfiguration(false);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletOutdoorWeatherConfig cfg = (BrickletOutdoorWeatherConfig) config.as(BrickletOutdoorWeatherConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletOutdoorWeatherSensorIdentifiers");
		result.add("BrickletOutdoorWeatherStationIdentifiers");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletOutdoorWeatherSensorIdentifiers":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletOutdoorWeatherSensorIdentifiers"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletOutdoorWeatherSensorIdentifiers")).withDescription("NOT USED").build();
            case "BrickletOutdoorWeatherStationIdentifiers":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletOutdoorWeatherStationIdentifiers"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletOutdoorWeatherStationIdentifiers")).withDescription("NOT USED").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Outdoor Weather Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("433MHz receiver for outdoor weather station").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletOutdoorWeatherSensorIdentifiers", new ChannelTypeUID("tinkerforge", "BrickletOutdoorWeatherSensorIdentifiers")).withLabel("Sensor Identifiers").withDescription("The identifiers (number between 0 and 255) of all sensors that have been seen since the startup of the Bricklet.<br/><br/>Each sensor gives itself a random identifier on first startup.<br/><br/>Since firmware version 2.0.2 a sensor is removed from the list if no data was received for 12 hours.").build(), new ChannelDefinitionBuilder("BrickletOutdoorWeatherStationIdentifiers", new ChannelTypeUID("tinkerforge", "BrickletOutdoorWeatherStationIdentifiers")).withLabel("Station Identifiers").withDescription("The identifiers (number between 0 and 255) of all stations that have been seen since the startup of the Bricklet.<br/><br/>Each station gives itself a random identifier on first startup.<br/><br/>Since firmware version 2.0.2 a station is removed from the list if no data was received for 12 hours.").build())).withProperties(props).buildBridge();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletoutdoorweather":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletOutdoorWeatherSensorIdentifiers":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletOutdoorWeatherStationIdentifiers":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletOutdoorWeatherConfig cfg = (BrickletOutdoorWeatherConfig) config.as(BrickletOutdoorWeatherConfig.class);
        switch(channel) {
            case "BrickletOutdoorWeatherSensorIdentifiers": {
                   BrickletOutdoorWeatherSensorIdentifiersConfig channelCfg = channelConfig.as(BrickletOutdoorWeatherSensorIdentifiersConfig.class);
                   {
            int[] value = this.getSensorIdentifiers();
            if(true)
                updateStateFn.accept(channel, transformBrickletOutdoorWeatherSensorIdentifiersGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletOutdoorWeatherStationIdentifiers": {
                   BrickletOutdoorWeatherStationIdentifiersConfig channelCfg = channelConfig.as(BrickletOutdoorWeatherStationIdentifiersConfig.class);
                   {
            int[] value = this.getStationIdentifiers();
            if(true)
                updateStateFn.accept(channel, transformBrickletOutdoorWeatherStationIdentifiersGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletOutdoorWeatherConfig cfg = (BrickletOutdoorWeatherConfig) config.as(BrickletOutdoorWeatherConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletOutdoorWeatherSensorIdentifiersGetter0(int[] value, BrickletOutdoorWeatherConfig cfg) {
        return new StringType(Arrays.stream(value).mapToObj(String::valueOf).reduce((l, r) -> l + ", " + r).orElse(""));
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletOutdoorWeatherStationIdentifiersGetter0(int[] value, BrickletOutdoorWeatherConfig cfg) {
        return new StringType(Arrays.stream(value).mapToObj(String::valueOf).reduce((l, r) -> l + ", " + r).orElse(""));
    }

}