/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletPTCV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletPTCV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletPTCV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletPTCV2.DEVICE_DISPLAY_NAME, "brickletptcv2", BrickletPTCV2.DEVICE_IDENTIFIER, BrickletPTCV2Wrapper.class, BrickletPTCV2Actions.class, "2.0.0", true);

    public BrickletPTCV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletPTCV2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int FILTER_OPTION_50HZ = 0;
	public final static int FILTER_OPTION_60HZ = 1;
	public final static int WIRE_MODE_2 = 2;
	public final static int WIRE_MODE_3 = 3;
	public final static int WIRE_MODE_4 = 4;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getTemperature() throws TinkerforgeException {
    return this.dev.getTemperature();
}

public void setTemperatureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setTemperatureCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletPTCV2.TemperatureCallbackConfiguration getTemperatureCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getTemperatureCallbackConfiguration();
}

public int getResistance() throws TinkerforgeException {
    return this.dev.getResistance();
}

public void setResistanceCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setResistanceCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletPTCV2.ResistanceCallbackConfiguration getResistanceCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getResistanceCallbackConfiguration();
}

public void setNoiseRejectionFilter(int filter) throws TinkerforgeException {
    this.dev.setNoiseRejectionFilter(filter);
}

public int getNoiseRejectionFilter() throws TinkerforgeException {
    return this.dev.getNoiseRejectionFilter();
}

public boolean isSensorConnected() throws TinkerforgeException {
    return this.dev.isSensorConnected();
}

public void setWireMode(int mode) throws TinkerforgeException {
    this.dev.setWireMode(mode);
}

public int getWireMode() throws TinkerforgeException {
    return this.dev.getWireMode();
}

public void setMovingAverageConfiguration(int movingAverageLengthResistance, int movingAverageLengthTemperature) throws TinkerforgeException {
    this.dev.setMovingAverageConfiguration(movingAverageLengthResistance, movingAverageLengthTemperature);
}

public BrickletPTCV2.MovingAverageConfiguration getMovingAverageConfiguration() throws TinkerforgeException {
    return this.dev.getMovingAverageConfiguration();
}

public void setSensorConnectedCallbackConfiguration(boolean enabled) throws TinkerforgeException {
    this.dev.setSensorConnectedCallbackConfiguration(enabled);
}

public boolean getSensorConnectedCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getSensorConnectedCallbackConfiguration();
}

public BrickletPTCV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletPTCV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addTemperatureListener(BrickletPTCV2.TemperatureListener l) {
    this.dev.addTemperatureListener(l);
}

public void removeTemperatureListener(BrickletPTCV2.TemperatureListener l) {
    this.dev.removeTemperatureListener(l);
}

public void addResistanceListener(BrickletPTCV2.ResistanceListener l) {
    this.dev.addResistanceListener(l);
}

public void removeResistanceListener(BrickletPTCV2.ResistanceListener l) {
    this.dev.removeResistanceListener(l);
}

public void addSensorConnectedListener(BrickletPTCV2.SensorConnectedListener l) {
    this.dev.addSensorConnectedListener(l);
}

public void removeSensorConnectedListener(BrickletPTCV2.SensorConnectedListener l) {
    this.dev.removeSensorConnectedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletPTCV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletPTCV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletPTCV2Config cfg = (BrickletPTCV2Config) config.as(BrickletPTCV2Config.class);
        this.addTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletPTCV2Temperature", transformBrickletPTCV2TemperatureCallback0(temperature, cfg));}}, this.dev::removeTemperatureListener));
        this.setWireMode(cfg.wireMode);
		this.setMovingAverageConfiguration(1, cfg.temperatureMovingAverageLength);
		this.setNoiseRejectionFilter(cfg.noiseRejectionFilterFrequency);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletPTCV2TemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletPTCV2Temperature").as(BrickletPTCV2TemperatureConfig.class);
		this.setTemperatureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletPTCV2SensorConnectedConfig channelCfg = getChannelConfigFn.apply("BrickletPTCV2SensorConnected").as(BrickletPTCV2SensorConnectedConfig.class);
		
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletPTCV2SensorConnected"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletPTCV2Config cfg = (BrickletPTCV2Config) config.as(BrickletPTCV2Config.class);
        this.setTemperatureCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletPTCV2Config cfg = (BrickletPTCV2Config) config.as(BrickletPTCV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletPTCV2Temperature");
		result.add("BrickletPTCV2SensorConnected");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletPTCV2Temperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletPTCV2Temperature"), "Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletPTCV2Temperature")).withDescription("Temperature of the connected sensor")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-246)).withMaximum(BigDecimal.valueOf(849)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletPTCV2SensorConnected":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletPTCV2SensorConnected"), "Sensor Connected", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletPTCV2SensorConnected")).withDescription("Indicates if the sensor is connected correctly. If this is disabled, there is either no Pt100 or Pt1000 sensor connected, the sensor is connected incorrectly or the sensor itself is faulty.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge PTC Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Reads temperatures from Pt100 und Pt1000 sensors").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletPTCV2Temperature", new ChannelTypeUID("tinkerforge", "BrickletPTCV2Temperature")).withLabel("Temperature").build(), new ChannelDefinitionBuilder("BrickletPTCV2SensorConnected", new ChannelTypeUID("tinkerforge", "BrickletPTCV2SensorConnected")).withLabel("Sensor Connected").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletptcv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("wireMode", Type.INTEGER).withDefault("2").withDescription("The wire mode of the sensor. Possible values are 2, 3 and 4 which correspond to 2-, 3- and 4-wire sensors. The value has to match the jumper configuration on the Bricklet.").withLabel("Wire Mode").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("2", "2-wire"), new ParameterOption("3", "3-wire"), new ParameterOption("4", "4-wire"))).build(), ConfigDescriptionParameterBuilder.create("temperatureMovingAverageLength", Type.INTEGER).withDefault("40").withDescription("Setting the length to 1 will turn the averaging off. With less averaging, there is more noise on the data.\n\nNew data is gathered every 20ms. With a moving average of length 1000 the resulting averaging window has a length of 20s. If you want to do long term measurements the longest moving average will give the cleanest results.").withLabel("Temperature Moving Average Length").withMinimum(BigDecimal.valueOf(1)).withMaximum(BigDecimal.valueOf(1000)).build(), ConfigDescriptionParameterBuilder.create("noiseRejectionFilterFrequency", Type.INTEGER).withDefault("0").withDescription("Sets the noise rejection filter to either 50 Hz or 60 Hz. Noise from 50 Hz or 60 Hz power sources (including harmonics of the AC power’s fundamental frequency) is attenuated by 82dB").withLabel("Noise Rejection Filter Frequency").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "50 Hz"), new ParameterOption("1", "60 Hz"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletPTCV2Temperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletPTCV2SensorConnected":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletPTCV2Config cfg = (BrickletPTCV2Config) config.as(BrickletPTCV2Config.class);
        switch(channel) {
            case "BrickletPTCV2Temperature": {
                   BrickletPTCV2TemperatureConfig channelCfg = channelConfig.as(BrickletPTCV2TemperatureConfig.class);
                   {
            int value = this.getTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletPTCV2TemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletPTCV2SensorConnected": {
                   BrickletPTCV2SensorConnectedConfig channelCfg = channelConfig.as(BrickletPTCV2SensorConnectedConfig.class);
                   {
            boolean value = this.isSensorConnected();
            if(true)
                updateStateFn.accept(channel, transformBrickletPTCV2SensorConnectedGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletPTCV2Config cfg = (BrickletPTCV2Config) config.as(BrickletPTCV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletPTCV2TemperatureCallback0(int temperature, BrickletPTCV2Config cfg) {
        return new QuantityType<>(temperature / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletPTCV2TemperatureGetter0(int value, BrickletPTCV2Config cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletPTCV2SensorConnectedGetter0(boolean value, BrickletPTCV2Config cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }

}