/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletPTC;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletPTCWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletPTC dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletPTC.DEVICE_DISPLAY_NAME, "brickletptc", BrickletPTC.DEVICE_IDENTIFIER, BrickletPTCWrapper.class, BrickletPTCActions.class, "2.0.0", false);

    public BrickletPTCWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletPTC(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int FILTER_OPTION_50HZ = 0;
	public final static int FILTER_OPTION_60HZ = 1;
	public final static int WIRE_MODE_2 = 2;
	public final static int WIRE_MODE_3 = 3;
	public final static int WIRE_MODE_4 = 4;


    public int getTemperature() throws TinkerforgeException {
    return this.dev.getTemperature();
}

public int getResistance() throws TinkerforgeException {
    return this.dev.getResistance();
}

public void setTemperatureCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setTemperatureCallbackPeriod(period);
}

public long getTemperatureCallbackPeriod() throws TinkerforgeException {
    return this.dev.getTemperatureCallbackPeriod();
}

public void setResistanceCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setResistanceCallbackPeriod(period);
}

public long getResistanceCallbackPeriod() throws TinkerforgeException {
    return this.dev.getResistanceCallbackPeriod();
}

public void setTemperatureCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setTemperatureCallbackThreshold(option, min, max);
}

public BrickletPTC.TemperatureCallbackThreshold getTemperatureCallbackThreshold() throws TinkerforgeException {
    return this.dev.getTemperatureCallbackThreshold();
}

public void setResistanceCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setResistanceCallbackThreshold(option, min, max);
}

public BrickletPTC.ResistanceCallbackThreshold getResistanceCallbackThreshold() throws TinkerforgeException {
    return this.dev.getResistanceCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public void setNoiseRejectionFilter(int filter) throws TinkerforgeException {
    this.dev.setNoiseRejectionFilter(filter);
}

public int getNoiseRejectionFilter() throws TinkerforgeException {
    return this.dev.getNoiseRejectionFilter();
}

public boolean isSensorConnected() throws TinkerforgeException {
    return this.dev.isSensorConnected();
}

public void setWireMode(int mode) throws TinkerforgeException {
    this.dev.setWireMode(mode);
}

public int getWireMode() throws TinkerforgeException {
    return this.dev.getWireMode();
}

public void setSensorConnectedCallbackConfiguration(boolean enabled) throws TinkerforgeException {
    this.dev.setSensorConnectedCallbackConfiguration(enabled);
}

public boolean getSensorConnectedCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getSensorConnectedCallbackConfiguration();
}

public BrickletPTC.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addTemperatureListener(BrickletPTC.TemperatureListener l) {
    this.dev.addTemperatureListener(l);
}

public void removeTemperatureListener(BrickletPTC.TemperatureListener l) {
    this.dev.removeTemperatureListener(l);
}

public void addTemperatureReachedListener(BrickletPTC.TemperatureReachedListener l) {
    this.dev.addTemperatureReachedListener(l);
}

public void removeTemperatureReachedListener(BrickletPTC.TemperatureReachedListener l) {
    this.dev.removeTemperatureReachedListener(l);
}

public void addResistanceListener(BrickletPTC.ResistanceListener l) {
    this.dev.addResistanceListener(l);
}

public void removeResistanceListener(BrickletPTC.ResistanceListener l) {
    this.dev.removeResistanceListener(l);
}

public void addResistanceReachedListener(BrickletPTC.ResistanceReachedListener l) {
    this.dev.addResistanceReachedListener(l);
}

public void removeResistanceReachedListener(BrickletPTC.ResistanceReachedListener l) {
    this.dev.removeResistanceReachedListener(l);
}

public void addSensorConnectedListener(BrickletPTC.SensorConnectedListener l) {
    this.dev.addSensorConnectedListener(l);
}

public void removeSensorConnectedListener(BrickletPTC.SensorConnectedListener l) {
    this.dev.removeSensorConnectedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletPTCWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletPTCWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletPTCConfig cfg = (BrickletPTCConfig) config.as(BrickletPTCConfig.class);
        this.addTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletPTCTemperature", transformBrickletPTCTemperatureCallback0(temperature, cfg));}}, this.dev::removeTemperatureListener));
        this.setWireMode(cfg.wireMode);
		this.setNoiseRejectionFilter(cfg.noiseRejectionFilterFrequency);
		{
		BrickletPTCTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletPTCTemperature").as(BrickletPTCTemperatureConfig.class);
		this.setTemperatureCallbackPeriod(channelCfg.updateInterval);
		this.setTemperatureCallbackThreshold('x', 0, 0);
		}
		{
		BrickletPTCSensorConnectedConfig channelCfg = getChannelConfigFn.apply("BrickletPTCSensorConnected").as(BrickletPTCSensorConnectedConfig.class);
		
		if(channelCfg.updateInterval > 0) {
    this.manualChannelUpdates.add(scheduler.scheduleWithFixedDelay(() -> handler.handleCommand(new ChannelUID(handler.getThing().getUID(), "BrickletPTCSensorConnected"), RefreshType.REFRESH), channelCfg.updateInterval, channelCfg.updateInterval, TimeUnit.MILLISECONDS));
}
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletPTCConfig cfg = (BrickletPTCConfig) config.as(BrickletPTCConfig.class);
        this.setTemperatureCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletPTCConfig cfg = (BrickletPTCConfig) config.as(BrickletPTCConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletPTCTemperature");
		result.add("BrickletPTCSensorConnected");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletPTCTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletPTCTemperature"), "Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletPTCTemperature")).withDescription("Temperature of the connected sensor")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-246)).withMaximum(BigDecimal.valueOf(849)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletPTCSensorConnected":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletPTCSensorConnected"), "Sensor Connected", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletPTCSensorConnected")).withDescription("Indicates if the sensor is connected correctly. If this is disabled, there is either no Pt100 or Pt1000 sensor connected, the sensor is connected incorrectly or the sensor itself is faulty.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge PTC Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Reads temperatures from Pt100 und Pt1000 sensors").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletPTCTemperature", new ChannelTypeUID("tinkerforge", "BrickletPTCTemperature")).withLabel("Temperature").build(), new ChannelDefinitionBuilder("BrickletPTCSensorConnected", new ChannelTypeUID("tinkerforge", "BrickletPTCSensorConnected")).withLabel("Sensor Connected").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletptc":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("wireMode", Type.INTEGER).withDefault("2").withDescription("The wire mode of the sensor. Possible values are 2, 3 and 4 which correspond to 2-, 3- and 4-wire sensors. The value has to match the jumper configuration on the Bricklet.").withLabel("Wire Mode").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("2", "2-wire"), new ParameterOption("3", "3-wire"), new ParameterOption("4", "4-wire"))).build(), ConfigDescriptionParameterBuilder.create("noiseRejectionFilterFrequency", Type.INTEGER).withDefault("0").withDescription("Sets the noise rejection filter to either 50 Hz or 60 Hz. Noise from 50 Hz or 60 Hz power sources (including harmonics of the AC power’s fundamental frequency) is attenuated by 82dB").withLabel("Noise Rejection Filter Frequency").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "50 Hz"), new ParameterOption("1", "60 Hz"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletPTCTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletPTCSensorConnected":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletPTCConfig cfg = (BrickletPTCConfig) config.as(BrickletPTCConfig.class);
        switch(channel) {
            case "BrickletPTCTemperature": {
                   BrickletPTCTemperatureConfig channelCfg = channelConfig.as(BrickletPTCTemperatureConfig.class);
                   {
            int value = this.getTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletPTCTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletPTCSensorConnected": {
                   BrickletPTCSensorConnectedConfig channelCfg = channelConfig.as(BrickletPTCSensorConnectedConfig.class);
                   {
            boolean value = this.isSensorConnected();
            if(true)
                updateStateFn.accept(channel, transformBrickletPTCSensorConnectedGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletPTCConfig cfg = (BrickletPTCConfig) config.as(BrickletPTCConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletPTCTemperatureCallback0(int temperature, BrickletPTCConfig cfg) {
        return new QuantityType<>(temperature / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletPTCTemperatureGetter0(int value, BrickletPTCConfig cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletPTCSensorConnectedGetter0(boolean value, BrickletPTCConfig cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }

}