/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.DecimalType;

import com.tinkerforge.BrickletPiezoSpeaker;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletPiezoSpeakerWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletPiezoSpeaker dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletPiezoSpeaker.DEVICE_DISPLAY_NAME, "brickletpiezospeaker", BrickletPiezoSpeaker.DEVICE_IDENTIFIER, BrickletPiezoSpeakerWrapper.class, BrickletPiezoSpeakerActions.class, "2.0.0", false);

    public BrickletPiezoSpeakerWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletPiezoSpeaker(uid, ipcon);
    }

    
	public final static long BEEP_DURATION_OFF = 0L;
	public final static long BEEP_DURATION_INFINITE = 4294967295L;


    public void beep(long duration, int frequency) throws TinkerforgeException {
    this.dev.beep(duration, frequency);
}

public void morseCode(String morse, int frequency) throws TinkerforgeException {
    this.dev.morseCode(morse, frequency);
}

public boolean calibrate() throws TinkerforgeException {
    return this.dev.calibrate();
}

public BrickletPiezoSpeaker.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addBeepFinishedListener(BrickletPiezoSpeaker.BeepFinishedListener l) {
    this.dev.addBeepFinishedListener(l);
}

public void removeBeepFinishedListener(BrickletPiezoSpeaker.BeepFinishedListener l) {
    this.dev.removeBeepFinishedListener(l);
}

public void addMorseCodeFinishedListener(BrickletPiezoSpeaker.MorseCodeFinishedListener l) {
    this.dev.addMorseCodeFinishedListener(l);
}

public void removeMorseCodeFinishedListener(BrickletPiezoSpeaker.MorseCodeFinishedListener l) {
    this.dev.removeMorseCodeFinishedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletPiezoSpeakerWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletPiezoSpeakerWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletPiezoSpeakerConfig cfg = (BrickletPiezoSpeakerConfig) config.as(BrickletPiezoSpeakerConfig.class);
        this.addBeepFinishedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletPiezoSpeakerBeepFinished", transformBrickletPiezoSpeakerBeepFinishedCallback0(cfg));}}, this.dev::removeBeepFinishedListener));
		this.addMorseCodeFinishedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletPiezoSpeakerMorseCodeFinished", transformBrickletPiezoSpeakerMorseCodeFinishedCallback0(cfg));}}, this.dev::removeMorseCodeFinishedListener));
        
		{
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletPiezoSpeakerConfig cfg = (BrickletPiezoSpeakerConfig) config.as(BrickletPiezoSpeakerConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletPiezoSpeakerConfig cfg = (BrickletPiezoSpeakerConfig) config.as(BrickletPiezoSpeakerConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletPiezoSpeakerBeepFinished");
		result.add("BrickletPiezoSpeakerMorseCodeFinished");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Piezo Speaker Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Creates beep with configurable frequency").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletPiezoSpeakerBeepFinished", new ChannelTypeUID("system", "trigger")).withLabel("Beep Finished").withDescription("This channel is triggered if a beep set by the beep action is finished.").build(), new ChannelDefinitionBuilder("BrickletPiezoSpeakerMorseCodeFinished", new ChannelTypeUID("system", "trigger")).withLabel("Morse Code Finished").withDescription("This channel is triggered if the playback of the morse code set by the morseCode action is finished.").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletpiezospeaker":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletPiezoSpeakerConfig cfg = (BrickletPiezoSpeakerConfig) config.as(BrickletPiezoSpeakerConfig.class);
        switch(channel) {
            case "BrickletPiezoSpeakerBeepFinished":
               return;
            case "BrickletPiezoSpeakerMorseCodeFinished":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletPiezoSpeakerConfig cfg = (BrickletPiezoSpeakerConfig) config.as(BrickletPiezoSpeakerConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletPiezoSpeakerBeepFinishedCallback0(BrickletPiezoSpeakerConfig cfg) {
        return "";
    }
	    private String transformBrickletPiezoSpeakerMorseCodeFinishedCallback0(BrickletPiezoSpeakerConfig cfg) {
        return "";
    }

}