/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.HSBType;
import org.eclipse.smarthome.core.library.types.PercentType;

import com.tinkerforge.BrickletRGBLEDButton;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletRGBLEDButtonWrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletRGBLEDButton dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletRGBLEDButton.DEVICE_DISPLAY_NAME, "brickletrgbledbutton", BrickletRGBLEDButton.DEVICE_IDENTIFIER, BrickletRGBLEDButtonWrapper.class, BrickletRGBLEDButtonActions.class, "2.0.0", true);

    public BrickletRGBLEDButtonWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletRGBLEDButton(uid, ipcon);
    }

    
	public final static int BUTTON_STATE_PRESSED = 0;
	public final static int BUTTON_STATE_RELEASED = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setColor(int red, int green, int blue) throws TinkerforgeException {
    this.dev.setColor(red, green, blue);
}

public BrickletRGBLEDButton.Color getColor() throws TinkerforgeException {
    return this.dev.getColor();
}

public int getButtonState() throws TinkerforgeException {
    return this.dev.getButtonState();
}

public void setColorCalibration(int red, int green, int blue) throws TinkerforgeException {
    this.dev.setColorCalibration(red, green, blue);
}

public BrickletRGBLEDButton.ColorCalibration getColorCalibration() throws TinkerforgeException {
    return this.dev.getColorCalibration();
}

public BrickletRGBLEDButton.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletRGBLEDButton.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addButtonStateChangedListener(BrickletRGBLEDButton.ButtonStateChangedListener l) {
    this.dev.addButtonStateChangedListener(l);
}

public void removeButtonStateChangedListener(BrickletRGBLEDButton.ButtonStateChangedListener l) {
    this.dev.removeButtonStateChangedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletRGBLEDButtonWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRGBLEDButtonWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletRGBLEDButtonConfig cfg = (BrickletRGBLEDButtonConfig) config.as(BrickletRGBLEDButtonConfig.class);
        this.addButtonStateChangedListener(this.reg((state) -> {if(true) {triggerChannelFn.accept("BrickletRGBLEDButtonButton", transformBrickletRGBLEDButtonButtonCallback0(state, cfg));}}, this.dev::removeButtonStateChangedListener));
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletRGBLEDButtonColorConfig channelCfg = getChannelConfigFn.apply("BrickletRGBLEDButtonColor").as(BrickletRGBLEDButtonColorConfig.class);
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletRGBLEDButtonConfig cfg = (BrickletRGBLEDButtonConfig) config.as(BrickletRGBLEDButtonConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRGBLEDButtonConfig cfg = (BrickletRGBLEDButtonConfig) config.as(BrickletRGBLEDButtonConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletRGBLEDButtonColor");
		result.add("BrickletRGBLEDButtonButton");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletRGBLEDButtonColor":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletRGBLEDButtonColor"), "LED Color", "Color").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletRGBLEDButtonColor")).withDescription("The color of the LED.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge RGB LED Button Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Push button with built-in RGB LED").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletRGBLEDButtonColor", new ChannelTypeUID("tinkerforge", "BrickletRGBLEDButtonColor")).withLabel("LED Color").build(), new ChannelDefinitionBuilder("BrickletRGBLEDButtonButton", new ChannelTypeUID("system", "rawbutton")).withLabel("Button").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletrgbledbutton":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletRGBLEDButtonColor":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRGBLEDButtonConfig cfg = (BrickletRGBLEDButtonConfig) config.as(BrickletRGBLEDButtonConfig.class);
        switch(channel) {
            case "BrickletRGBLEDButtonColor": {
                   BrickletRGBLEDButtonColorConfig channelCfg = channelConfig.as(BrickletRGBLEDButtonColorConfig.class);
                   {
            BrickletRGBLEDButton.Color value = this.getColor();
            if(true)
                updateStateFn.accept(channel, transformBrickletRGBLEDButtonColorGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletRGBLEDButtonButton":
                   {
            int value = this.getButtonState();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletRGBLEDButtonButtonGetter0(value, cfg));
        }
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRGBLEDButtonConfig cfg = (BrickletRGBLEDButtonConfig) config.as(BrickletRGBLEDButtonConfig.class);
        switch(channel) {
            case "BrickletRGBLEDButtonColor":
                if (command instanceof HSBType) {
                    BrickletRGBLEDButtonColorConfig channelCfg = channelConfig.as(BrickletRGBLEDButtonColorConfig.class);
                    HSBType cmd = (HSBType) command;
                    this.setColor((int)(cmd.getRed().doubleValue() * 255.0 / 100.0), (int)(cmd.getGreen().doubleValue() * 255.0 / 100.0), (int)(cmd.getBlue().doubleValue() * 255.0 / 100.0));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of HSBType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletRGBLEDButtonButtonCallback0(int state, BrickletRGBLEDButtonConfig cfg) {
        return state == BrickletRGBLEDButton.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletRGBLEDButtonColorGetter0(BrickletRGBLEDButton.Color value, BrickletRGBLEDButtonConfig cfg) {
        return HSBType.fromRGB(value.red, value.green, value.blue);
    }
	    private String transformBrickletRGBLEDButtonButtonGetter0(int value, BrickletRGBLEDButtonConfig cfg) {
        return value == BrickletRGBLEDButton.BUTTON_STATE_PRESSED ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }

}