/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletRGBLEDMatrix;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletRGBLEDMatrixWrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletRGBLEDMatrix dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletRGBLEDMatrix.DEVICE_DISPLAY_NAME, "brickletrgbledmatrix", BrickletRGBLEDMatrix.DEVICE_IDENTIFIER, BrickletRGBLEDMatrixWrapper.class, BrickletRGBLEDMatrixActions.class, "2.0.0", true);

    public BrickletRGBLEDMatrixWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletRGBLEDMatrix(uid, ipcon);
    }

    
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setRed(int[] red) throws TinkerforgeException {
    this.dev.setRed(red);
}

public int[] getRed() throws TinkerforgeException {
    return this.dev.getRed();
}

public void setGreen(int[] green) throws TinkerforgeException {
    this.dev.setGreen(green);
}

public int[] getGreen() throws TinkerforgeException {
    return this.dev.getGreen();
}

public void setBlue(int[] blue) throws TinkerforgeException {
    this.dev.setBlue(blue);
}

public int[] getBlue() throws TinkerforgeException {
    return this.dev.getBlue();
}

public void setFrameDuration(int frameDuration) throws TinkerforgeException {
    this.dev.setFrameDuration(frameDuration);
}

public int getFrameDuration() throws TinkerforgeException {
    return this.dev.getFrameDuration();
}

public void drawFrame() throws TinkerforgeException {
    this.dev.drawFrame();
}

public int getSupplyVoltage() throws TinkerforgeException {
    return this.dev.getSupplyVoltage();
}

public BrickletRGBLEDMatrix.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletRGBLEDMatrix.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addFrameStartedListener(BrickletRGBLEDMatrix.FrameStartedListener l) {
    this.dev.addFrameStartedListener(l);
}

public void removeFrameStartedListener(BrickletRGBLEDMatrix.FrameStartedListener l) {
    this.dev.removeFrameStartedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletRGBLEDMatrixWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRGBLEDMatrixWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletRGBLEDMatrixConfig cfg = (BrickletRGBLEDMatrixConfig) config.as(BrickletRGBLEDMatrixConfig.class);
        this.addFrameStartedListener(this.reg((frameNumber) -> {if(true) {triggerChannelFn.accept("BrickletRGBLEDMatrixFrameStarted", transformBrickletRGBLEDMatrixFrameStartedCallback0(frameNumber, cfg));}}, this.dev::removeFrameStartedListener));
        this.setFrameDuration(cfg.frameDuration);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		
		}
		{
		BrickletRGBLEDMatrixLEDValuesConfig channelCfg = getChannelConfigFn.apply("BrickletRGBLEDMatrixLEDValues").as(BrickletRGBLEDMatrixLEDValuesConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletRGBLEDMatrixConfig cfg = (BrickletRGBLEDMatrixConfig) config.as(BrickletRGBLEDMatrixConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRGBLEDMatrixConfig cfg = (BrickletRGBLEDMatrixConfig) config.as(BrickletRGBLEDMatrixConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletRGBLEDMatrixFrameStarted");
		result.add("BrickletRGBLEDMatrixLEDValues");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletRGBLEDMatrixLEDValues":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletRGBLEDMatrixLEDValues"), "LED Values", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletRGBLEDMatrixLEDValues")).withDescription("The RGB(W) values for the LEDs.<br/><br/>Command format is a ','-separated list of integers. The first integer is the index of the first LED to set, additional integers are the values to set. Values are between 0 (off) and 255 (on). If the channel mapping has 3 colors, you need to give the data in the sequence R,G,B,R,G,B,R,G,B,... if the channel mapping has 4 colors you need to give data in the sequence R,G,B,W,R,G,B,W,R,G,B,W...<br/><br/>The data is double buffered and the colors will be transfered to the LEDs when the next frame duration ends. You can set at most 2048 RGB values or 1536 RGBW values.<br/><br/> For example sending 2,255,0,0,0,255,0,0,0,255 will set the LED 2 to red, LED 3 to green and LED 4 to blue.").build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge RGB LED Matrix Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("RGB LED Matrix with 8x8 pixel").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletRGBLEDMatrixFrameStarted", new ChannelTypeUID("system", "trigger")).withLabel("Frame Started").build(), new ChannelDefinitionBuilder("BrickletRGBLEDMatrixLEDValues", new ChannelTypeUID("tinkerforge", "BrickletRGBLEDMatrixLEDValues")).withLabel("LED Values").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletrgbledmatrix":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("frameDuration", Type.INTEGER).withDefault("0").withDescription("The frame duration in milliseconds. This configures how fast the Frame Started Channel will trigger. 0 disables the callback.").withLabel("Frame Duration").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletRGBLEDMatrixLEDValues":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRGBLEDMatrixConfig cfg = (BrickletRGBLEDMatrixConfig) config.as(BrickletRGBLEDMatrixConfig.class);
        switch(channel) {
            case "BrickletRGBLEDMatrixFrameStarted":
               return;
            case "BrickletRGBLEDMatrixLEDValues":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRGBLEDMatrixConfig cfg = (BrickletRGBLEDMatrixConfig) config.as(BrickletRGBLEDMatrixConfig.class);
        switch(channel) {
            case "BrickletRGBLEDMatrixLEDValues":
                if (command instanceof StringType) {
                    BrickletRGBLEDMatrixLEDValuesConfig channelCfg = channelConfig.as(BrickletRGBLEDMatrixLEDValuesConfig.class);
                    StringType cmd = (StringType) command;
                    this.setRed(Helper.parseLEDMatrixValues(cmd.toString(), 0, logger));
                }
        
if (command instanceof StringType) {
                    BrickletRGBLEDMatrixLEDValuesConfig channelCfg = channelConfig.as(BrickletRGBLEDMatrixLEDValuesConfig.class);
                    StringType cmd = (StringType) command;
                    this.setGreen(Helper.parseLEDMatrixValues(cmd.toString(), 1, logger));
                }
        
if (command instanceof StringType) {
                    BrickletRGBLEDMatrixLEDValuesConfig channelCfg = channelConfig.as(BrickletRGBLEDMatrixLEDValuesConfig.class);
                    StringType cmd = (StringType) command;
                    this.setBlue(Helper.parseLEDMatrixValues(cmd.toString(), 2, logger));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType, StringType, StringType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletRGBLEDMatrixFrameStartedCallback0(long frameNumber, BrickletRGBLEDMatrixConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }

}