/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.tinkerforge.BrickletRS232V2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletRS232V2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletRS232V2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletRS232V2.DEVICE_DISPLAY_NAME, "brickletrs232v2", BrickletRS232V2.DEVICE_IDENTIFIER, BrickletRS232V2Wrapper.class, BrickletRS232V2Actions.class, "2.0.0", true);

    public BrickletRS232V2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletRS232V2(uid, ipcon);
    }

    
	public final static int PARITY_NONE = 0;
	public final static int PARITY_ODD = 1;
	public final static int PARITY_EVEN = 2;
	public final static int STOPBITS_1 = 1;
	public final static int STOPBITS_2 = 2;
	public final static int WORDLENGTH_5 = 5;
	public final static int WORDLENGTH_6 = 6;
	public final static int WORDLENGTH_7 = 7;
	public final static int WORDLENGTH_8 = 8;
	public final static int FLOWCONTROL_OFF = 0;
	public final static int FLOWCONTROL_SOFTWARE = 1;
	public final static int FLOWCONTROL_HARDWARE = 2;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int write(char[] message) throws TinkerforgeException {
    return this.dev.write(message);
}

public char[] read(int length) throws TinkerforgeException {
    return this.dev.read(length);
}

public void enableReadCallback() throws TinkerforgeException {
    this.dev.enableReadCallback();
}

public void disableReadCallback() throws TinkerforgeException {
    this.dev.disableReadCallback();
}

public boolean isReadCallbackEnabled() throws TinkerforgeException {
    return this.dev.isReadCallbackEnabled();
}

public void setConfiguration(long baudrate, int parity, int stopbits, int wordlength, int flowcontrol) throws TinkerforgeException {
    this.dev.setConfiguration(baudrate, parity, stopbits, wordlength, flowcontrol);
}

public BrickletRS232V2.Configuration getConfiguration() throws TinkerforgeException {
    return this.dev.getConfiguration();
}

public void setBufferConfig(int sendBufferSize, int receiveBufferSize) throws TinkerforgeException {
    this.dev.setBufferConfig(sendBufferSize, receiveBufferSize);
}

public BrickletRS232V2.BufferConfig getBufferConfig() throws TinkerforgeException {
    return this.dev.getBufferConfig();
}

public BrickletRS232V2.BufferStatus getBufferStatus() throws TinkerforgeException {
    return this.dev.getBufferStatus();
}

public BrickletRS232V2.ErrorCount getErrorCount() throws TinkerforgeException {
    return this.dev.getErrorCount();
}

public BrickletRS232V2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletRS232V2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addReadListener(BrickletRS232V2.ReadListener l) {
    this.dev.addReadListener(l);
}

public void removeReadListener(BrickletRS232V2.ReadListener l) {
    this.dev.removeReadListener(l);
}

public void addErrorCountListener(BrickletRS232V2.ErrorCountListener l) {
    this.dev.addErrorCountListener(l);
}

public void removeErrorCountListener(BrickletRS232V2.ErrorCountListener l) {
    this.dev.removeErrorCountListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletRS232V2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRS232V2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletRS232V2Config cfg = (BrickletRS232V2Config) config.as(BrickletRS232V2Config.class);
        
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletRS232V2Config cfg = (BrickletRS232V2Config) config.as(BrickletRS232V2Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRS232V2Config cfg = (BrickletRS232V2Config) config.as(BrickletRS232V2Config.class);
        List<String> result = new ArrayList<String>();
        
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge RS232 Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Communicates with RS232 devices").withChannelDefinitions(Arrays.asList()).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletrs232v2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRS232V2Config cfg = (BrickletRS232V2Config) config.as(BrickletRS232V2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRS232V2Config cfg = (BrickletRS232V2Config) config.as(BrickletRS232V2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    

}