/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.tinkerforge.BrickletRS232;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletRS232Wrapper extends DeviceWrapper implements StandardFlashable{
    BrickletRS232 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletRS232.DEVICE_DISPLAY_NAME, "brickletrs232", BrickletRS232.DEVICE_IDENTIFIER, BrickletRS232Wrapper.class, BrickletRS232Actions.class, "2.0.0", false);

    public BrickletRS232Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletRS232(uid, ipcon);
    }

    
	public final static int BAUDRATE_300 = 0;
	public final static int BAUDRATE_600 = 1;
	public final static int BAUDRATE_1200 = 2;
	public final static int BAUDRATE_2400 = 3;
	public final static int BAUDRATE_4800 = 4;
	public final static int BAUDRATE_9600 = 5;
	public final static int BAUDRATE_14400 = 6;
	public final static int BAUDRATE_19200 = 7;
	public final static int BAUDRATE_28800 = 8;
	public final static int BAUDRATE_38400 = 9;
	public final static int BAUDRATE_57600 = 10;
	public final static int BAUDRATE_115200 = 11;
	public final static int BAUDRATE_230400 = 12;
	public final static int PARITY_NONE = 0;
	public final static int PARITY_ODD = 1;
	public final static int PARITY_EVEN = 2;
	public final static int PARITY_FORCED_PARITY_1 = 3;
	public final static int PARITY_FORCED_PARITY_0 = 4;
	public final static int STOPBITS_1 = 1;
	public final static int STOPBITS_2 = 2;
	public final static int WORDLENGTH_5 = 5;
	public final static int WORDLENGTH_6 = 6;
	public final static int WORDLENGTH_7 = 7;
	public final static int WORDLENGTH_8 = 8;
	public final static int HARDWARE_FLOWCONTROL_OFF = 0;
	public final static int HARDWARE_FLOWCONTROL_ON = 1;
	public final static int SOFTWARE_FLOWCONTROL_OFF = 0;
	public final static int SOFTWARE_FLOWCONTROL_ON = 1;
	public final static int ERROR_OVERRUN = 1;
	public final static int ERROR_PARITY = 2;
	public final static int ERROR_FRAMING = 4;


    public int write(char[] message, int length) throws TinkerforgeException {
    return this.dev.write(message, length);
}

public BrickletRS232.Read read() throws TinkerforgeException {
    return this.dev.read();
}

public void enableReadCallback() throws TinkerforgeException {
    this.dev.enableReadCallback();
}

public void disableReadCallback() throws TinkerforgeException {
    this.dev.disableReadCallback();
}

public boolean isReadCallbackEnabled() throws TinkerforgeException {
    return this.dev.isReadCallbackEnabled();
}

public void setConfiguration(int baudrate, int parity, int stopbits, int wordlength, int hardwareFlowcontrol, int softwareFlowcontrol) throws TinkerforgeException {
    this.dev.setConfiguration(baudrate, parity, stopbits, wordlength, hardwareFlowcontrol, softwareFlowcontrol);
}

public BrickletRS232.Configuration getConfiguration() throws TinkerforgeException {
    return this.dev.getConfiguration();
}

public void setBreakCondition(int breakTime) throws TinkerforgeException {
    this.dev.setBreakCondition(breakTime);
}

public BrickletRS232.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addReadListener(BrickletRS232.ReadListener l) {
    this.dev.addReadListener(l);
}

public void removeReadListener(BrickletRS232.ReadListener l) {
    this.dev.removeReadListener(l);
}

public void addErrorListener(BrickletRS232.ErrorListener l) {
    this.dev.addErrorListener(l);
}

public void removeErrorListener(BrickletRS232.ErrorListener l) {
    this.dev.removeErrorListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletRS232Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRS232Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletRS232Config cfg = (BrickletRS232Config) config.as(BrickletRS232Config.class);
        
        
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletRS232Config cfg = (BrickletRS232Config) config.as(BrickletRS232Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRS232Config cfg = (BrickletRS232Config) config.as(BrickletRS232Config.class);
        List<String> result = new ArrayList<String>();
        
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge RS232 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Communicates with RS232 devices").withChannelDefinitions(Arrays.asList()).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletrs232":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRS232Config cfg = (BrickletRS232Config) config.as(BrickletRS232Config.class);
        switch(channel) {
            
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRS232Config cfg = (BrickletRS232Config) config.as(BrickletRS232Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    

}