/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.tinkerforge.BrickletRS485;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletRS485Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletRS485 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletRS485.DEVICE_DISPLAY_NAME, "brickletrs485", BrickletRS485.DEVICE_IDENTIFIER, BrickletRS485Wrapper.class, BrickletRS485Actions.class, "2.0.0", true);

    public BrickletRS485Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletRS485(uid, ipcon);
    }

    
	public final static int PARITY_NONE = 0;
	public final static int PARITY_ODD = 1;
	public final static int PARITY_EVEN = 2;
	public final static int STOPBITS_1 = 1;
	public final static int STOPBITS_2 = 2;
	public final static int WORDLENGTH_5 = 5;
	public final static int WORDLENGTH_6 = 6;
	public final static int WORDLENGTH_7 = 7;
	public final static int WORDLENGTH_8 = 8;
	public final static int DUPLEX_HALF = 0;
	public final static int DUPLEX_FULL = 1;
	public final static int MODE_RS485 = 0;
	public final static int MODE_MODBUS_MASTER_RTU = 1;
	public final static int MODE_MODBUS_SLAVE_RTU = 2;
	public final static int COMMUNICATION_LED_CONFIG_OFF = 0;
	public final static int COMMUNICATION_LED_CONFIG_ON = 1;
	public final static int COMMUNICATION_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int COMMUNICATION_LED_CONFIG_SHOW_COMMUNICATION = 3;
	public final static int ERROR_LED_CONFIG_OFF = 0;
	public final static int ERROR_LED_CONFIG_ON = 1;
	public final static int ERROR_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int ERROR_LED_CONFIG_SHOW_ERROR = 3;
	public final static int EXCEPTION_CODE_TIMEOUT = -1;
	public final static int EXCEPTION_CODE_SUCCESS = 0;
	public final static int EXCEPTION_CODE_ILLEGAL_FUNCTION = 1;
	public final static int EXCEPTION_CODE_ILLEGAL_DATA_ADDRESS = 2;
	public final static int EXCEPTION_CODE_ILLEGAL_DATA_VALUE = 3;
	public final static int EXCEPTION_CODE_SLAVE_DEVICE_FAILURE = 4;
	public final static int EXCEPTION_CODE_ACKNOWLEDGE = 5;
	public final static int EXCEPTION_CODE_SLAVE_DEVICE_BUSY = 6;
	public final static int EXCEPTION_CODE_MEMORY_PARITY_ERROR = 8;
	public final static int EXCEPTION_CODE_GATEWAY_PATH_UNAVAILABLE = 10;
	public final static int EXCEPTION_CODE_GATEWAY_TARGET_DEVICE_FAILED_TO_RESPOND = 11;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int write(char[] message) throws TinkerforgeException {
    return this.dev.write(message);
}

public char[] read(int length) throws TinkerforgeException {
    return this.dev.read(length);
}

public void enableReadCallback() throws TinkerforgeException {
    this.dev.enableReadCallback();
}

public void disableReadCallback() throws TinkerforgeException {
    this.dev.disableReadCallback();
}

public boolean isReadCallbackEnabled() throws TinkerforgeException {
    return this.dev.isReadCallbackEnabled();
}

public void setRS485Configuration(long baudrate, int parity, int stopbits, int wordlength, int duplex) throws TinkerforgeException {
    this.dev.setRS485Configuration(baudrate, parity, stopbits, wordlength, duplex);
}

public BrickletRS485.RS485Configuration getRS485Configuration() throws TinkerforgeException {
    return this.dev.getRS485Configuration();
}

public void setModbusConfiguration(int slaveAddress, long masterRequestTimeout) throws TinkerforgeException {
    this.dev.setModbusConfiguration(slaveAddress, masterRequestTimeout);
}

public BrickletRS485.ModbusConfiguration getModbusConfiguration() throws TinkerforgeException {
    return this.dev.getModbusConfiguration();
}

public void setMode(int mode) throws TinkerforgeException {
    this.dev.setMode(mode);
}

public int getMode() throws TinkerforgeException {
    return this.dev.getMode();
}

public void setCommunicationLEDConfig(int config) throws TinkerforgeException {
    this.dev.setCommunicationLEDConfig(config);
}

public int getCommunicationLEDConfig() throws TinkerforgeException {
    return this.dev.getCommunicationLEDConfig();
}

public void setErrorLEDConfig(int config) throws TinkerforgeException {
    this.dev.setErrorLEDConfig(config);
}

public int getErrorLEDConfig() throws TinkerforgeException {
    return this.dev.getErrorLEDConfig();
}

public void setBufferConfig(int sendBufferSize, int receiveBufferSize) throws TinkerforgeException {
    this.dev.setBufferConfig(sendBufferSize, receiveBufferSize);
}

public BrickletRS485.BufferConfig getBufferConfig() throws TinkerforgeException {
    return this.dev.getBufferConfig();
}

public BrickletRS485.BufferStatus getBufferStatus() throws TinkerforgeException {
    return this.dev.getBufferStatus();
}

public void enableErrorCountCallback() throws TinkerforgeException {
    this.dev.enableErrorCountCallback();
}

public void disableErrorCountCallback() throws TinkerforgeException {
    this.dev.disableErrorCountCallback();
}

public boolean isErrorCountCallbackEnabled() throws TinkerforgeException {
    return this.dev.isErrorCountCallbackEnabled();
}

public BrickletRS485.ErrorCount getErrorCount() throws TinkerforgeException {
    return this.dev.getErrorCount();
}

public BrickletRS485.ModbusCommonErrorCount getModbusCommonErrorCount() throws TinkerforgeException {
    return this.dev.getModbusCommonErrorCount();
}

public void modbusSlaveReportException(int requestID, int exceptionCode) throws TinkerforgeException {
    this.dev.modbusSlaveReportException(requestID, exceptionCode);
}

public void modbusSlaveAnswerReadCoilsRequest(int requestID, boolean[] coils) throws TinkerforgeException {
    this.dev.modbusSlaveAnswerReadCoilsRequest(requestID, coils);
}

public int modbusMasterReadCoils(int slaveAddress, long startingAddress, int count) throws TinkerforgeException {
    return this.dev.modbusMasterReadCoils(slaveAddress, startingAddress, count);
}

public void modbusSlaveAnswerReadHoldingRegistersRequest(int requestID, int[] holdingRegisters) throws TinkerforgeException {
    this.dev.modbusSlaveAnswerReadHoldingRegistersRequest(requestID, holdingRegisters);
}

public int modbusMasterReadHoldingRegisters(int slaveAddress, long startingAddress, int count) throws TinkerforgeException {
    return this.dev.modbusMasterReadHoldingRegisters(slaveAddress, startingAddress, count);
}

public void modbusSlaveAnswerWriteSingleCoilRequest(int requestID) throws TinkerforgeException {
    this.dev.modbusSlaveAnswerWriteSingleCoilRequest(requestID);
}

public int modbusMasterWriteSingleCoil(int slaveAddress, long coilAddress, boolean coilValue) throws TinkerforgeException {
    return this.dev.modbusMasterWriteSingleCoil(slaveAddress, coilAddress, coilValue);
}

public void modbusSlaveAnswerWriteSingleRegisterRequest(int requestID) throws TinkerforgeException {
    this.dev.modbusSlaveAnswerWriteSingleRegisterRequest(requestID);
}

public int modbusMasterWriteSingleRegister(int slaveAddress, long registerAddress, int registerValue) throws TinkerforgeException {
    return this.dev.modbusMasterWriteSingleRegister(slaveAddress, registerAddress, registerValue);
}

public void modbusSlaveAnswerWriteMultipleCoilsRequest(int requestID) throws TinkerforgeException {
    this.dev.modbusSlaveAnswerWriteMultipleCoilsRequest(requestID);
}

public int modbusMasterWriteMultipleCoils(int slaveAddress, long startingAddress, boolean[] coils) throws TinkerforgeException {
    return this.dev.modbusMasterWriteMultipleCoils(slaveAddress, startingAddress, coils);
}

public void modbusSlaveAnswerWriteMultipleRegistersRequest(int requestID) throws TinkerforgeException {
    this.dev.modbusSlaveAnswerWriteMultipleRegistersRequest(requestID);
}

public int modbusMasterWriteMultipleRegisters(int slaveAddress, long startingAddress, int[] registers) throws TinkerforgeException {
    return this.dev.modbusMasterWriteMultipleRegisters(slaveAddress, startingAddress, registers);
}

public void modbusSlaveAnswerReadDiscreteInputsRequest(int requestID, boolean[] discreteInputs) throws TinkerforgeException {
    this.dev.modbusSlaveAnswerReadDiscreteInputsRequest(requestID, discreteInputs);
}

public int modbusMasterReadDiscreteInputs(int slaveAddress, long startingAddress, int count) throws TinkerforgeException {
    return this.dev.modbusMasterReadDiscreteInputs(slaveAddress, startingAddress, count);
}

public void modbusSlaveAnswerReadInputRegistersRequest(int requestID, int[] inputRegisters) throws TinkerforgeException {
    this.dev.modbusSlaveAnswerReadInputRegistersRequest(requestID, inputRegisters);
}

public int modbusMasterReadInputRegisters(int slaveAddress, long startingAddress, int count) throws TinkerforgeException {
    return this.dev.modbusMasterReadInputRegisters(slaveAddress, startingAddress, count);
}

public BrickletRS485.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletRS485.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addReadListener(BrickletRS485.ReadListener l) {
    this.dev.addReadListener(l);
}

public void removeReadListener(BrickletRS485.ReadListener l) {
    this.dev.removeReadListener(l);
}

public void addErrorCountListener(BrickletRS485.ErrorCountListener l) {
    this.dev.addErrorCountListener(l);
}

public void removeErrorCountListener(BrickletRS485.ErrorCountListener l) {
    this.dev.removeErrorCountListener(l);
}

public void addModbusSlaveReadCoilsRequestListener(BrickletRS485.ModbusSlaveReadCoilsRequestListener l) {
    this.dev.addModbusSlaveReadCoilsRequestListener(l);
}

public void removeModbusSlaveReadCoilsRequestListener(BrickletRS485.ModbusSlaveReadCoilsRequestListener l) {
    this.dev.removeModbusSlaveReadCoilsRequestListener(l);
}

public void addModbusMasterReadCoilsResponseListener(BrickletRS485.ModbusMasterReadCoilsResponseListener l) {
    this.dev.addModbusMasterReadCoilsResponseListener(l);
}

public void removeModbusMasterReadCoilsResponseListener(BrickletRS485.ModbusMasterReadCoilsResponseListener l) {
    this.dev.removeModbusMasterReadCoilsResponseListener(l);
}

public void addModbusSlaveReadHoldingRegistersRequestListener(BrickletRS485.ModbusSlaveReadHoldingRegistersRequestListener l) {
    this.dev.addModbusSlaveReadHoldingRegistersRequestListener(l);
}

public void removeModbusSlaveReadHoldingRegistersRequestListener(BrickletRS485.ModbusSlaveReadHoldingRegistersRequestListener l) {
    this.dev.removeModbusSlaveReadHoldingRegistersRequestListener(l);
}

public void addModbusMasterReadHoldingRegistersResponseListener(BrickletRS485.ModbusMasterReadHoldingRegistersResponseListener l) {
    this.dev.addModbusMasterReadHoldingRegistersResponseListener(l);
}

public void removeModbusMasterReadHoldingRegistersResponseListener(BrickletRS485.ModbusMasterReadHoldingRegistersResponseListener l) {
    this.dev.removeModbusMasterReadHoldingRegistersResponseListener(l);
}

public void addModbusSlaveWriteSingleCoilRequestListener(BrickletRS485.ModbusSlaveWriteSingleCoilRequestListener l) {
    this.dev.addModbusSlaveWriteSingleCoilRequestListener(l);
}

public void removeModbusSlaveWriteSingleCoilRequestListener(BrickletRS485.ModbusSlaveWriteSingleCoilRequestListener l) {
    this.dev.removeModbusSlaveWriteSingleCoilRequestListener(l);
}

public void addModbusMasterWriteSingleCoilResponseListener(BrickletRS485.ModbusMasterWriteSingleCoilResponseListener l) {
    this.dev.addModbusMasterWriteSingleCoilResponseListener(l);
}

public void removeModbusMasterWriteSingleCoilResponseListener(BrickletRS485.ModbusMasterWriteSingleCoilResponseListener l) {
    this.dev.removeModbusMasterWriteSingleCoilResponseListener(l);
}

public void addModbusSlaveWriteSingleRegisterRequestListener(BrickletRS485.ModbusSlaveWriteSingleRegisterRequestListener l) {
    this.dev.addModbusSlaveWriteSingleRegisterRequestListener(l);
}

public void removeModbusSlaveWriteSingleRegisterRequestListener(BrickletRS485.ModbusSlaveWriteSingleRegisterRequestListener l) {
    this.dev.removeModbusSlaveWriteSingleRegisterRequestListener(l);
}

public void addModbusMasterWriteSingleRegisterResponseListener(BrickletRS485.ModbusMasterWriteSingleRegisterResponseListener l) {
    this.dev.addModbusMasterWriteSingleRegisterResponseListener(l);
}

public void removeModbusMasterWriteSingleRegisterResponseListener(BrickletRS485.ModbusMasterWriteSingleRegisterResponseListener l) {
    this.dev.removeModbusMasterWriteSingleRegisterResponseListener(l);
}

public void addModbusSlaveWriteMultipleCoilsRequestListener(BrickletRS485.ModbusSlaveWriteMultipleCoilsRequestListener l) {
    this.dev.addModbusSlaveWriteMultipleCoilsRequestListener(l);
}

public void removeModbusSlaveWriteMultipleCoilsRequestListener(BrickletRS485.ModbusSlaveWriteMultipleCoilsRequestListener l) {
    this.dev.removeModbusSlaveWriteMultipleCoilsRequestListener(l);
}

public void addModbusMasterWriteMultipleCoilsResponseListener(BrickletRS485.ModbusMasterWriteMultipleCoilsResponseListener l) {
    this.dev.addModbusMasterWriteMultipleCoilsResponseListener(l);
}

public void removeModbusMasterWriteMultipleCoilsResponseListener(BrickletRS485.ModbusMasterWriteMultipleCoilsResponseListener l) {
    this.dev.removeModbusMasterWriteMultipleCoilsResponseListener(l);
}

public void addModbusSlaveWriteMultipleRegistersRequestListener(BrickletRS485.ModbusSlaveWriteMultipleRegistersRequestListener l) {
    this.dev.addModbusSlaveWriteMultipleRegistersRequestListener(l);
}

public void removeModbusSlaveWriteMultipleRegistersRequestListener(BrickletRS485.ModbusSlaveWriteMultipleRegistersRequestListener l) {
    this.dev.removeModbusSlaveWriteMultipleRegistersRequestListener(l);
}

public void addModbusMasterWriteMultipleRegistersResponseListener(BrickletRS485.ModbusMasterWriteMultipleRegistersResponseListener l) {
    this.dev.addModbusMasterWriteMultipleRegistersResponseListener(l);
}

public void removeModbusMasterWriteMultipleRegistersResponseListener(BrickletRS485.ModbusMasterWriteMultipleRegistersResponseListener l) {
    this.dev.removeModbusMasterWriteMultipleRegistersResponseListener(l);
}

public void addModbusSlaveReadDiscreteInputsRequestListener(BrickletRS485.ModbusSlaveReadDiscreteInputsRequestListener l) {
    this.dev.addModbusSlaveReadDiscreteInputsRequestListener(l);
}

public void removeModbusSlaveReadDiscreteInputsRequestListener(BrickletRS485.ModbusSlaveReadDiscreteInputsRequestListener l) {
    this.dev.removeModbusSlaveReadDiscreteInputsRequestListener(l);
}

public void addModbusMasterReadDiscreteInputsResponseListener(BrickletRS485.ModbusMasterReadDiscreteInputsResponseListener l) {
    this.dev.addModbusMasterReadDiscreteInputsResponseListener(l);
}

public void removeModbusMasterReadDiscreteInputsResponseListener(BrickletRS485.ModbusMasterReadDiscreteInputsResponseListener l) {
    this.dev.removeModbusMasterReadDiscreteInputsResponseListener(l);
}

public void addModbusSlaveReadInputRegistersRequestListener(BrickletRS485.ModbusSlaveReadInputRegistersRequestListener l) {
    this.dev.addModbusSlaveReadInputRegistersRequestListener(l);
}

public void removeModbusSlaveReadInputRegistersRequestListener(BrickletRS485.ModbusSlaveReadInputRegistersRequestListener l) {
    this.dev.removeModbusSlaveReadInputRegistersRequestListener(l);
}

public void addModbusMasterReadInputRegistersResponseListener(BrickletRS485.ModbusMasterReadInputRegistersResponseListener l) {
    this.dev.addModbusMasterReadInputRegistersResponseListener(l);
}

public void removeModbusMasterReadInputRegistersResponseListener(BrickletRS485.ModbusMasterReadInputRegistersResponseListener l) {
    this.dev.removeModbusMasterReadInputRegistersResponseListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletRS485Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRS485Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletRS485Config cfg = (BrickletRS485Config) config.as(BrickletRS485Config.class);
        
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletRS485Config cfg = (BrickletRS485Config) config.as(BrickletRS485Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRS485Config cfg = (BrickletRS485Config) config.as(BrickletRS485Config.class);
        List<String> result = new ArrayList<String>();
        
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge RS485 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Communicates with RS485/Modbus devices with full- or half-duplex").withChannelDefinitions(Arrays.asList()).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletrs485":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRS485Config cfg = (BrickletRS485Config) config.as(BrickletRS485Config.class);
        switch(channel) {
            
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRS485Config cfg = (BrickletRS485Config) config.as(BrickletRS485Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

    

}