/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import java.time.ZonedDateTime;
import java.time.ZoneId;
import org.eclipse.smarthome.core.library.types.DateTimeType;

import com.tinkerforge.BrickletRealTimeClockV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletRealTimeClockV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletRealTimeClockV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletRealTimeClockV2.DEVICE_DISPLAY_NAME, "brickletrealtimeclockv2", BrickletRealTimeClockV2.DEVICE_IDENTIFIER, BrickletRealTimeClockV2Wrapper.class, BrickletRealTimeClockV2Actions.class, "2.0.0", true);

    public BrickletRealTimeClockV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletRealTimeClockV2(uid, ipcon);
    }

    
	public final static int WEEKDAY_MONDAY = 1;
	public final static int WEEKDAY_TUESDAY = 2;
	public final static int WEEKDAY_WEDNESDAY = 3;
	public final static int WEEKDAY_THURSDAY = 4;
	public final static int WEEKDAY_FRIDAY = 5;
	public final static int WEEKDAY_SATURDAY = 6;
	public final static int WEEKDAY_SUNDAY = 7;
	public final static int ALARM_MATCH_DISABLED = -1;
	public final static int ALARM_INTERVAL_DISABLED = -1;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setDateTime(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday) throws TinkerforgeException {
    this.dev.setDateTime(year, month, day, hour, minute, second, centisecond, weekday);
}

public BrickletRealTimeClockV2.DateTime getDateTime() throws TinkerforgeException {
    return this.dev.getDateTime();
}

public long getTimestamp() throws TinkerforgeException {
    return this.dev.getTimestamp();
}

public void setOffset(int offset) throws TinkerforgeException {
    this.dev.setOffset(offset);
}

public int getOffset() throws TinkerforgeException {
    return this.dev.getOffset();
}

public void setDateTimeCallbackConfiguration(long period) throws TinkerforgeException {
    this.dev.setDateTimeCallbackConfiguration(period);
}

public long getDateTimeCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getDateTimeCallbackConfiguration();
}

public void setAlarm(int month, int day, int hour, int minute, int second, int weekday, int interval) throws TinkerforgeException {
    this.dev.setAlarm(month, day, hour, minute, second, weekday, interval);
}

public BrickletRealTimeClockV2.Alarm getAlarm() throws TinkerforgeException {
    return this.dev.getAlarm();
}

public BrickletRealTimeClockV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletRealTimeClockV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addDateTimeListener(BrickletRealTimeClockV2.DateTimeListener l) {
    this.dev.addDateTimeListener(l);
}

public void removeDateTimeListener(BrickletRealTimeClockV2.DateTimeListener l) {
    this.dev.removeDateTimeListener(l);
}

public void addAlarmListener(BrickletRealTimeClockV2.AlarmListener l) {
    this.dev.addAlarmListener(l);
}

public void removeAlarmListener(BrickletRealTimeClockV2.AlarmListener l) {
    this.dev.removeAlarmListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletRealTimeClockV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRealTimeClockV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletRealTimeClockV2Config cfg = (BrickletRealTimeClockV2Config) config.as(BrickletRealTimeClockV2Config.class);
        this.addDateTimeListener(this.reg((year, month, day, hour, minute, second, centisecond, weekday, timestamp) -> {if(true) {updateStateFn.accept("BrickletRealTimeClockV2DateTime", transformBrickletRealTimeClockV2DateTimeCallback0(year, month, day, hour, minute, second, centisecond, weekday, timestamp, cfg));}}, this.dev::removeDateTimeListener));
		this.addDateTimeListener(this.reg((year, month, day, hour, minute, second, centisecond, weekday, timestamp) -> {if(true) {updateStateFn.accept("BrickletRealTimeClockV2Timestamp", transformBrickletRealTimeClockV2TimestampCallback0(year, month, day, hour, minute, second, centisecond, weekday, timestamp, cfg));}}, this.dev::removeDateTimeListener));
        this.setDateTimeCallbackConfiguration(cfg.dateTimeUpdateInterval);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletRealTimeClockV2DateTimeConfig channelCfg = getChannelConfigFn.apply("BrickletRealTimeClockV2DateTime").as(BrickletRealTimeClockV2DateTimeConfig.class);
		
		}
		{
		BrickletRealTimeClockV2TimestampConfig channelCfg = getChannelConfigFn.apply("BrickletRealTimeClockV2Timestamp").as(BrickletRealTimeClockV2TimestampConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletRealTimeClockV2Config cfg = (BrickletRealTimeClockV2Config) config.as(BrickletRealTimeClockV2Config.class);
        this.setDateTimeCallbackConfiguration(0);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRealTimeClockV2Config cfg = (BrickletRealTimeClockV2Config) config.as(BrickletRealTimeClockV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletRealTimeClockV2DateTime");
		result.add("BrickletRealTimeClockV2Timestamp");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletRealTimeClockV2DateTime":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletRealTimeClockV2DateTime"), "Date Time", "DateTime").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletRealTimeClockV2DateTime")).withDescription("The real-time clock handles leap year and inserts the 29th of February accordingly. But leap seconds are not handled. The time is stored as UTC on the clock and converted into your system's timezone when accessed by OpenHAB.").build();
            case "BrickletRealTimeClockV2Timestamp":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletRealTimeClockV2Timestamp"), "Timestamp", "Number:Time").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletRealTimeClockV2Timestamp")).withDescription("the current date and the time of the real-time clock converted to seconds. The timestamp has an effective resolution of hundredths of a second.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Real-Time Clock Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Battery-backed real-time clock").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletRealTimeClockV2DateTime", new ChannelTypeUID("tinkerforge", "BrickletRealTimeClockV2DateTime")).withLabel("Date Time").build(), new ChannelDefinitionBuilder("BrickletRealTimeClockV2Timestamp", new ChannelTypeUID("tinkerforge", "BrickletRealTimeClockV2Timestamp")).withLabel("Timestamp").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletrealtimeclockv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("dateTimeUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the date time and timestamp in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Date Time Update Interval").withUnit("ms").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletRealTimeClockV2DateTime":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletRealTimeClockV2Timestamp":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRealTimeClockV2Config cfg = (BrickletRealTimeClockV2Config) config.as(BrickletRealTimeClockV2Config.class);
        switch(channel) {
            case "BrickletRealTimeClockV2DateTime": {
                   BrickletRealTimeClockV2DateTimeConfig channelCfg = channelConfig.as(BrickletRealTimeClockV2DateTimeConfig.class);
                   {
            BrickletRealTimeClockV2.DateTime value = this.getDateTime();
            if(true)
                updateStateFn.accept(channel, transformBrickletRealTimeClockV2DateTimeGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletRealTimeClockV2Timestamp": {
                   BrickletRealTimeClockV2TimestampConfig channelCfg = channelConfig.as(BrickletRealTimeClockV2TimestampConfig.class);
                   {
            long value = this.getTimestamp();
            if(true)
                updateStateFn.accept(channel, transformBrickletRealTimeClockV2TimestampGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRealTimeClockV2Config cfg = (BrickletRealTimeClockV2Config) config.as(BrickletRealTimeClockV2Config.class);
        switch(channel) {
            case "BrickletRealTimeClockV2DateTime":
                if (command instanceof DateTimeType) {
                    BrickletRealTimeClockV2DateTimeConfig channelCfg = channelConfig.as(BrickletRealTimeClockV2DateTimeConfig.class);
                    DateTimeType cmd = (DateTimeType) command;
                    this.setDateTime(cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getYear(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getMonth().getValue(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getDayOfMonth(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getHour(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getMinute(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getSecond(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getNano() / 1000 / 1000 / 10, cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getDayOfWeek().getValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of DateTimeType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletRealTimeClockV2DateTimeCallback0(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday, long timestamp, BrickletRealTimeClockV2Config cfg) {
        return new DateTimeType(ZonedDateTime.of(year, month, day, hour, minute, second, centisecond * 10 * 1000 * 1000, ZoneId.of("UTC")).withZoneSameInstant(ZoneId.systemDefault()));
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletRealTimeClockV2TimestampCallback0(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday, long timestamp, BrickletRealTimeClockV2Config cfg) {
        return new QuantityType<>(timestamp / 1000.0, SmartHomeUnits.SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletRealTimeClockV2DateTimeGetter0(BrickletRealTimeClockV2.DateTime value, BrickletRealTimeClockV2Config cfg) {
        return new DateTimeType(ZonedDateTime.of(value.year, value.month, value.day, value.hour, value.minute, value.second, value.centisecond * 10 * 1000 * 1000, ZoneId.of("UTC")).withZoneSameInstant(ZoneId.systemDefault()));
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletRealTimeClockV2TimestampGetter0(long value, BrickletRealTimeClockV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.SECOND);
    }

}