/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import java.time.ZonedDateTime;
import java.time.ZoneId;
import org.eclipse.smarthome.core.library.types.DateTimeType;

import com.tinkerforge.BrickletRealTimeClock;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletRealTimeClockWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletRealTimeClock dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletRealTimeClock.DEVICE_DISPLAY_NAME, "brickletrealtimeclock", BrickletRealTimeClock.DEVICE_IDENTIFIER, BrickletRealTimeClockWrapper.class, BrickletRealTimeClockActions.class, "2.0.1", false);

    public BrickletRealTimeClockWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletRealTimeClock(uid, ipcon);
    }

    
	public final static int WEEKDAY_MONDAY = 1;
	public final static int WEEKDAY_TUESDAY = 2;
	public final static int WEEKDAY_WEDNESDAY = 3;
	public final static int WEEKDAY_THURSDAY = 4;
	public final static int WEEKDAY_FRIDAY = 5;
	public final static int WEEKDAY_SATURDAY = 6;
	public final static int WEEKDAY_SUNDAY = 7;
	public final static int ALARM_MATCH_DISABLED = -1;
	public final static int ALARM_INTERVAL_DISABLED = -1;


    public void setDateTime(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday) throws TinkerforgeException {
    this.dev.setDateTime(year, month, day, hour, minute, second, centisecond, weekday);
}

public BrickletRealTimeClock.DateTime getDateTime() throws TinkerforgeException {
    return this.dev.getDateTime();
}

public long getTimestamp() throws TinkerforgeException {
    return this.dev.getTimestamp();
}

public void setOffset(int offset) throws TinkerforgeException {
    this.dev.setOffset(offset);
}

public int getOffset() throws TinkerforgeException {
    return this.dev.getOffset();
}

public void setDateTimeCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setDateTimeCallbackPeriod(period);
}

public long getDateTimeCallbackPeriod() throws TinkerforgeException {
    return this.dev.getDateTimeCallbackPeriod();
}

public void setAlarm(int month, int day, int hour, int minute, int second, int weekday, int interval) throws TinkerforgeException {
    this.dev.setAlarm(month, day, hour, minute, second, weekday, interval);
}

public BrickletRealTimeClock.Alarm getAlarm() throws TinkerforgeException {
    return this.dev.getAlarm();
}

public BrickletRealTimeClock.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addDateTimeListener(BrickletRealTimeClock.DateTimeListener l) {
    this.dev.addDateTimeListener(l);
}

public void removeDateTimeListener(BrickletRealTimeClock.DateTimeListener l) {
    this.dev.removeDateTimeListener(l);
}

public void addAlarmListener(BrickletRealTimeClock.AlarmListener l) {
    this.dev.addAlarmListener(l);
}

public void removeAlarmListener(BrickletRealTimeClock.AlarmListener l) {
    this.dev.removeAlarmListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletRealTimeClockWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRealTimeClockWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletRealTimeClockConfig cfg = (BrickletRealTimeClockConfig) config.as(BrickletRealTimeClockConfig.class);
        this.addDateTimeListener(this.reg((year, month, day, hour, minute, second, centisecond, weekday, timestamp) -> {if(true) {updateStateFn.accept("BrickletRealTimeClockDateTime", transformBrickletRealTimeClockDateTimeCallback0(year, month, day, hour, minute, second, centisecond, weekday, timestamp, cfg));}}, this.dev::removeDateTimeListener));
		this.addDateTimeListener(this.reg((year, month, day, hour, minute, second, centisecond, weekday, timestamp) -> {if(true) {updateStateFn.accept("BrickletRealTimeClockTimestamp", transformBrickletRealTimeClockTimestampCallback0(year, month, day, hour, minute, second, centisecond, weekday, timestamp, cfg));}}, this.dev::removeDateTimeListener));
        this.setDateTimeCallbackPeriod(cfg.dateTimeUpdateInterval);
		{
		BrickletRealTimeClockDateTimeConfig channelCfg = getChannelConfigFn.apply("BrickletRealTimeClockDateTime").as(BrickletRealTimeClockDateTimeConfig.class);
		
		}
		{
		BrickletRealTimeClockTimestampConfig channelCfg = getChannelConfigFn.apply("BrickletRealTimeClockTimestamp").as(BrickletRealTimeClockTimestampConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletRealTimeClockConfig cfg = (BrickletRealTimeClockConfig) config.as(BrickletRealTimeClockConfig.class);
        this.setDateTimeCallbackPeriod(0);
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRealTimeClockConfig cfg = (BrickletRealTimeClockConfig) config.as(BrickletRealTimeClockConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletRealTimeClockDateTime");
		result.add("BrickletRealTimeClockTimestamp");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletRealTimeClockDateTime":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletRealTimeClockDateTime"), "Date Time", "DateTime").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletRealTimeClockDateTime")).withDescription("The real-time clock handles leap year and inserts the 29th of February accordingly. But leap seconds are not handled. The time is stored as UTC on the clock and converted into your system's timezone when accessed by OpenHAB.").build();
            case "BrickletRealTimeClockTimestamp":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletRealTimeClockTimestamp"), "Timestamp", "Number:Time").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletRealTimeClockTimestamp")).withDescription("the current date and the time of the real-time clock converted to seconds. The timestamp has an effective resolution of hundredths of a second.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Real-Time Clock Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Battery-backed real-time clock").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletRealTimeClockDateTime", new ChannelTypeUID("tinkerforge", "BrickletRealTimeClockDateTime")).withLabel("Date Time").build(), new ChannelDefinitionBuilder("BrickletRealTimeClockTimestamp", new ChannelTypeUID("tinkerforge", "BrickletRealTimeClockTimestamp")).withLabel("Timestamp").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletrealtimeclock":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("dateTimeUpdateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval for the date time and timestamp in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Date Time Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletRealTimeClockDateTime":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletRealTimeClockTimestamp":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRealTimeClockConfig cfg = (BrickletRealTimeClockConfig) config.as(BrickletRealTimeClockConfig.class);
        switch(channel) {
            case "BrickletRealTimeClockDateTime": {
                   BrickletRealTimeClockDateTimeConfig channelCfg = channelConfig.as(BrickletRealTimeClockDateTimeConfig.class);
                   {
            BrickletRealTimeClock.DateTime value = this.getDateTime();
            if(true)
                updateStateFn.accept(channel, transformBrickletRealTimeClockDateTimeGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletRealTimeClockTimestamp": {
                   BrickletRealTimeClockTimestampConfig channelCfg = channelConfig.as(BrickletRealTimeClockTimestampConfig.class);
                   {
            long value = this.getTimestamp();
            if(true)
                updateStateFn.accept(channel, transformBrickletRealTimeClockTimestampGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRealTimeClockConfig cfg = (BrickletRealTimeClockConfig) config.as(BrickletRealTimeClockConfig.class);
        switch(channel) {
            case "BrickletRealTimeClockDateTime":
                if (command instanceof DateTimeType) {
                    BrickletRealTimeClockDateTimeConfig channelCfg = channelConfig.as(BrickletRealTimeClockDateTimeConfig.class);
                    DateTimeType cmd = (DateTimeType) command;
                    this.setDateTime(cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getYear(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getMonth().getValue(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getDayOfMonth(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getHour(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getMinute(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getSecond(), cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getNano() / 1000 / 1000 / 10, cmd.getZonedDateTime().withZoneSameInstant(ZoneId.of("UTC")).getDayOfWeek().getValue());
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of DateTimeType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletRealTimeClockDateTimeCallback0(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday, long timestamp, BrickletRealTimeClockConfig cfg) {
        return new DateTimeType(ZonedDateTime.of(year, month, day, hour, minute, second, centisecond * 10 * 1000 * 1000, ZoneId.of("UTC")).withZoneSameInstant(ZoneId.systemDefault()));
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletRealTimeClockTimestampCallback0(int year, int month, int day, int hour, int minute, int second, int centisecond, int weekday, long timestamp, BrickletRealTimeClockConfig cfg) {
        return new QuantityType<>(timestamp / 1000.0, SmartHomeUnits.SECOND);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletRealTimeClockDateTimeGetter0(BrickletRealTimeClock.DateTime value, BrickletRealTimeClockConfig cfg) {
        return new DateTimeType(ZonedDateTime.of(value.year, value.month, value.day, value.hour, value.minute, value.second, value.centisecond * 10 * 1000 * 1000, ZoneId.of("UTC")).withZoneSameInstant(ZoneId.systemDefault()));
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletRealTimeClockTimestampGetter0(long value, BrickletRealTimeClockConfig cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.SECOND);
    }

}