/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.DecimalType;

import com.tinkerforge.BrickletRemoteSwitchV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletRemoteSwitchV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletRemoteSwitchV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletRemoteSwitchV2.DEVICE_DISPLAY_NAME, "brickletremoteswitchv2", BrickletRemoteSwitchV2.DEVICE_IDENTIFIER, BrickletRemoteSwitchV2Wrapper.class, BrickletRemoteSwitchV2Actions.class, "2.0.0", true);

    public BrickletRemoteSwitchV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletRemoteSwitchV2(uid, ipcon);
    }

    
	public final static int SWITCHING_STATE_READY = 0;
	public final static int SWITCHING_STATE_BUSY = 1;
	public final static int SWITCH_TO_OFF = 0;
	public final static int SWITCH_TO_ON = 1;
	public final static int REMOTE_TYPE_A = 0;
	public final static int REMOTE_TYPE_B = 1;
	public final static int REMOTE_TYPE_C = 2;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getSwitchingState() throws TinkerforgeException {
    return this.dev.getSwitchingState();
}

public void setRepeats(int repeats) throws TinkerforgeException {
    this.dev.setRepeats(repeats);
}

public int getRepeats() throws TinkerforgeException {
    return this.dev.getRepeats();
}

public void switchSocketA(int houseCode, int receiverCode, int switchTo) throws TinkerforgeException {
    this.dev.switchSocketA(houseCode, receiverCode, switchTo);
}

public void switchSocketB(long address, int unit, int switchTo) throws TinkerforgeException {
    this.dev.switchSocketB(address, unit, switchTo);
}

public void dimSocketB(long address, int unit, int dimValue) throws TinkerforgeException {
    this.dev.dimSocketB(address, unit, dimValue);
}

public void switchSocketC(char systemCode, int deviceCode, int switchTo) throws TinkerforgeException {
    this.dev.switchSocketC(systemCode, deviceCode, switchTo);
}

public void setRemoteConfiguration(int remoteType, int minimumRepeats, boolean callbackEnabled) throws TinkerforgeException {
    this.dev.setRemoteConfiguration(remoteType, minimumRepeats, callbackEnabled);
}

public BrickletRemoteSwitchV2.RemoteConfiguration getRemoteConfiguration() throws TinkerforgeException {
    return this.dev.getRemoteConfiguration();
}

public BrickletRemoteSwitchV2.RemoteStatusA getRemoteStatusA() throws TinkerforgeException {
    return this.dev.getRemoteStatusA();
}

public BrickletRemoteSwitchV2.RemoteStatusB getRemoteStatusB() throws TinkerforgeException {
    return this.dev.getRemoteStatusB();
}

public BrickletRemoteSwitchV2.RemoteStatusC getRemoteStatusC() throws TinkerforgeException {
    return this.dev.getRemoteStatusC();
}

public BrickletRemoteSwitchV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletRemoteSwitchV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addSwitchingDoneListener(BrickletRemoteSwitchV2.SwitchingDoneListener l) {
    this.dev.addSwitchingDoneListener(l);
}

public void removeSwitchingDoneListener(BrickletRemoteSwitchV2.SwitchingDoneListener l) {
    this.dev.removeSwitchingDoneListener(l);
}

public void addRemoteStatusAListener(BrickletRemoteSwitchV2.RemoteStatusAListener l) {
    this.dev.addRemoteStatusAListener(l);
}

public void removeRemoteStatusAListener(BrickletRemoteSwitchV2.RemoteStatusAListener l) {
    this.dev.removeRemoteStatusAListener(l);
}

public void addRemoteStatusBListener(BrickletRemoteSwitchV2.RemoteStatusBListener l) {
    this.dev.addRemoteStatusBListener(l);
}

public void removeRemoteStatusBListener(BrickletRemoteSwitchV2.RemoteStatusBListener l) {
    this.dev.removeRemoteStatusBListener(l);
}

public void addRemoteStatusCListener(BrickletRemoteSwitchV2.RemoteStatusCListener l) {
    this.dev.addRemoteStatusCListener(l);
}

public void removeRemoteStatusCListener(BrickletRemoteSwitchV2.RemoteStatusCListener l) {
    this.dev.removeRemoteStatusCListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletRemoteSwitchV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRemoteSwitchV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletRemoteSwitchV2Config cfg = (BrickletRemoteSwitchV2Config) config.as(BrickletRemoteSwitchV2Config.class);
        this.addSwitchingDoneListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletRemoteSwitchV2SwitchingDone", transformBrickletRemoteSwitchV2SwitchingDoneCallback0(cfg));}}, this.dev::removeSwitchingDoneListener));
		this.addRemoteStatusAListener(this.reg((houseCode, receiverCode, switchTo, repeats) -> {if(true) {triggerChannelFn.accept("BrickletRemoteSwitchV2RemoteStatusAAvailable", transformBrickletRemoteSwitchV2RemoteStatusAAvailableCallback0(houseCode, receiverCode, switchTo, repeats, cfg));}}, this.dev::removeRemoteStatusAListener));
		this.addRemoteStatusBListener(this.reg((address, unit, switchTo, dimValue, repeats) -> {if(true) {triggerChannelFn.accept("BrickletRemoteSwitchV2RemoteStatusBAvailable", transformBrickletRemoteSwitchV2RemoteStatusBAvailableCallback0(address, unit, switchTo, dimValue, repeats, cfg));}}, this.dev::removeRemoteStatusBListener));
		this.addRemoteStatusCListener(this.reg((systemCode, deviceCode, switchTo, repeats) -> {if(true) {triggerChannelFn.accept("BrickletRemoteSwitchV2RemoteStatusCAvailable", transformBrickletRemoteSwitchV2RemoteStatusCAvailableCallback0(systemCode, deviceCode, switchTo, repeats, cfg));}}, this.dev::removeRemoteStatusCListener));
        this.setRemoteConfiguration(cfg.remoteType, cfg.minimumRepeats, true);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		
		}
		{
		
		}
		{
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletRemoteSwitchV2Config cfg = (BrickletRemoteSwitchV2Config) config.as(BrickletRemoteSwitchV2Config.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRemoteSwitchV2Config cfg = (BrickletRemoteSwitchV2Config) config.as(BrickletRemoteSwitchV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletRemoteSwitchV2SwitchingDone");
		result.add("BrickletRemoteSwitchV2RemoteStatusAAvailable");
		result.add("BrickletRemoteSwitchV2RemoteStatusBAvailable");
		result.add("BrickletRemoteSwitchV2RemoteStatusCAvailable");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Remote Switch Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Controls remote mains switches and receives signals from remotes").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletRemoteSwitchV2SwitchingDone", new ChannelTypeUID("system", "trigger")).withLabel("Switching Done").withDescription("This channel is triggered whenever the switching state changes from busy to ready.").build(), new ChannelDefinitionBuilder("BrickletRemoteSwitchV2RemoteStatusAAvailable", new ChannelTypeUID("system", "trigger")).withLabel("Remote Status A Available").withDescription("This channel is triggered if at least the configured minimum of repeats of identical data packets for remote type A were received. You can get the house and receiver code, switch state and repeats with the getRemoteStatusA action.").build(), new ChannelDefinitionBuilder("BrickletRemoteSwitchV2RemoteStatusBAvailable", new ChannelTypeUID("system", "trigger")).withLabel("Remote Status B Available").withDescription("This channel is triggered if at least the configured minimum of repeats of identical data packets for remote type B were received. You can get the house and receiver code, switch state and repeats with the getRemoteStatusB action.").build(), new ChannelDefinitionBuilder("BrickletRemoteSwitchV2RemoteStatusCAvailable", new ChannelTypeUID("system", "trigger")).withLabel("Remote Status C Available").withDescription("This channel is triggered if at least the configured minimum of repeats of identical data packets for remote type C were received. You can get the house and receiver code, switch state and repeats with the getRemoteStatusC action.").build())).withProperties(props).buildBridge();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletremoteswitchv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("remoteType", Type.INTEGER).withDefault("0").withDescription("Type A, B or C depending on the type of remote you want to receive.").withLabel("Remote Type").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "A"), new ParameterOption("1", "B"), new ParameterOption("2", "C"))).build(), ConfigDescriptionParameterBuilder.create("minimumRepeats", Type.INTEGER).withDefault("2").withDescription("The minimum number of repeated data packets until the Remote Status channels trigger.").withLabel("Minimum Repeats").build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRemoteSwitchV2Config cfg = (BrickletRemoteSwitchV2Config) config.as(BrickletRemoteSwitchV2Config.class);
        switch(channel) {
            case "BrickletRemoteSwitchV2SwitchingDone":
               return;
            case "BrickletRemoteSwitchV2RemoteStatusAAvailable":
               return;
            case "BrickletRemoteSwitchV2RemoteStatusBAvailable":
               return;
            case "BrickletRemoteSwitchV2RemoteStatusCAvailable":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRemoteSwitchV2Config cfg = (BrickletRemoteSwitchV2Config) config.as(BrickletRemoteSwitchV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletRemoteSwitchV2SwitchingDoneCallback0(BrickletRemoteSwitchV2Config cfg) {
        return "";
    }
	    private String transformBrickletRemoteSwitchV2RemoteStatusAAvailableCallback0(int houseCode, int receiverCode, int switchTo, int repeats, BrickletRemoteSwitchV2Config cfg) {
        return "";
    }
	    private String transformBrickletRemoteSwitchV2RemoteStatusBAvailableCallback0(long address, int unit, int switchTo, int dimValue, int repeats, BrickletRemoteSwitchV2Config cfg) {
        return "";
    }
	    private String transformBrickletRemoteSwitchV2RemoteStatusCAvailableCallback0(char systemCode, int deviceCode, int switchTo, int repeats, BrickletRemoteSwitchV2Config cfg) {
        return "";
    }

}