/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.DecimalType;

import com.tinkerforge.BrickletRemoteSwitch;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletRemoteSwitchWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletRemoteSwitch dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletRemoteSwitch.DEVICE_DISPLAY_NAME, "brickletremoteswitch", BrickletRemoteSwitch.DEVICE_IDENTIFIER, BrickletRemoteSwitchWrapper.class, BrickletRemoteSwitchActions.class, "2.0.1", false);

    public BrickletRemoteSwitchWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletRemoteSwitch(uid, ipcon);
    }

    
	public final static int SWITCH_TO_OFF = 0;
	public final static int SWITCH_TO_ON = 1;
	public final static int SWITCHING_STATE_READY = 0;
	public final static int SWITCHING_STATE_BUSY = 1;


    public void switchSocket(int houseCode, int receiverCode, int switchTo) throws TinkerforgeException {
    this.dev.switchSocket(houseCode, receiverCode, switchTo);
}

public int getSwitchingState() throws TinkerforgeException {
    return this.dev.getSwitchingState();
}

public void setRepeats(int repeats) throws TinkerforgeException {
    this.dev.setRepeats(repeats);
}

public int getRepeats() throws TinkerforgeException {
    return this.dev.getRepeats();
}

public void switchSocketA(int houseCode, int receiverCode, int switchTo) throws TinkerforgeException {
    this.dev.switchSocketA(houseCode, receiverCode, switchTo);
}

public void switchSocketB(long address, int unit, int switchTo) throws TinkerforgeException {
    this.dev.switchSocketB(address, unit, switchTo);
}

public void dimSocketB(long address, int unit, int dimValue) throws TinkerforgeException {
    this.dev.dimSocketB(address, unit, dimValue);
}

public void switchSocketC(char systemCode, int deviceCode, int switchTo) throws TinkerforgeException {
    this.dev.switchSocketC(systemCode, deviceCode, switchTo);
}

public BrickletRemoteSwitch.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addSwitchingDoneListener(BrickletRemoteSwitch.SwitchingDoneListener l) {
    this.dev.addSwitchingDoneListener(l);
}

public void removeSwitchingDoneListener(BrickletRemoteSwitch.SwitchingDoneListener l) {
    this.dev.removeSwitchingDoneListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletRemoteSwitchWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRemoteSwitchWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletRemoteSwitchConfig cfg = (BrickletRemoteSwitchConfig) config.as(BrickletRemoteSwitchConfig.class);
        this.addSwitchingDoneListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletRemoteSwitchSwitchingDone", transformBrickletRemoteSwitchSwitchingDoneCallback0(cfg));}}, this.dev::removeSwitchingDoneListener));
        
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletRemoteSwitchConfig cfg = (BrickletRemoteSwitchConfig) config.as(BrickletRemoteSwitchConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRemoteSwitchConfig cfg = (BrickletRemoteSwitchConfig) config.as(BrickletRemoteSwitchConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletRemoteSwitchSwitchingDone");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Remote Switch Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Controls remote mains switches").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletRemoteSwitchSwitchingDone", new ChannelTypeUID("system", "trigger")).withLabel("Switching Done").withDescription("This channel is triggered whenever the switching state changes from busy to ready.").build())).withProperties(props).buildBridge();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletremoteswitch":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRemoteSwitchConfig cfg = (BrickletRemoteSwitchConfig) config.as(BrickletRemoteSwitchConfig.class);
        switch(channel) {
            case "BrickletRemoteSwitchSwitchingDone":
               return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRemoteSwitchConfig cfg = (BrickletRemoteSwitchConfig) config.as(BrickletRemoteSwitchConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private String transformBrickletRemoteSwitchSwitchingDoneCallback0(BrickletRemoteSwitchConfig cfg) {
        return "";
    }

}