/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletRotaryEncoderV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletRotaryEncoderV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletRotaryEncoderV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletRotaryEncoderV2.DEVICE_DISPLAY_NAME, "brickletrotaryencoderv2", BrickletRotaryEncoderV2.DEVICE_IDENTIFIER, BrickletRotaryEncoderV2Wrapper.class, BrickletRotaryEncoderV2Actions.class, "2.0.0", true);

    public BrickletRotaryEncoderV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletRotaryEncoderV2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getCount(boolean reset) throws TinkerforgeException {
    return this.dev.getCount(reset);
}

public void setCountCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setCountCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletRotaryEncoderV2.CountCallbackConfiguration getCountCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getCountCallbackConfiguration();
}

public boolean isPressed() throws TinkerforgeException {
    return this.dev.isPressed();
}

public BrickletRotaryEncoderV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletRotaryEncoderV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addCountListener(BrickletRotaryEncoderV2.CountListener l) {
    this.dev.addCountListener(l);
}

public void removeCountListener(BrickletRotaryEncoderV2.CountListener l) {
    this.dev.removeCountListener(l);
}

public void addPressedListener(BrickletRotaryEncoderV2.PressedListener l) {
    this.dev.addPressedListener(l);
}

public void removePressedListener(BrickletRotaryEncoderV2.PressedListener l) {
    this.dev.removePressedListener(l);
}

public void addReleasedListener(BrickletRotaryEncoderV2.ReleasedListener l) {
    this.dev.addReleasedListener(l);
}

public void removeReleasedListener(BrickletRotaryEncoderV2.ReleasedListener l) {
    this.dev.removeReleasedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletRotaryEncoderV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRotaryEncoderV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletRotaryEncoderV2Config cfg = (BrickletRotaryEncoderV2Config) config.as(BrickletRotaryEncoderV2Config.class);
        this.addCountListener(this.reg((count) -> {if(true) {updateStateFn.accept("BrickletRotaryEncoderV2Count", transformBrickletRotaryEncoderV2CountCallback0(count, cfg));}}, this.dev::removeCountListener));
		this.addPressedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletRotaryEncoderV2Pressed", transformBrickletRotaryEncoderV2PressedCallback0(cfg));}}, this.dev::removePressedListener));
		this.addReleasedListener(this.reg(() -> {if(true) {triggerChannelFn.accept("BrickletRotaryEncoderV2Pressed", transformBrickletRotaryEncoderV2PressedCallback1(cfg));}}, this.dev::removeReleasedListener));
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletRotaryEncoderV2CountConfig channelCfg = getChannelConfigFn.apply("BrickletRotaryEncoderV2Count").as(BrickletRotaryEncoderV2CountConfig.class);
		this.setCountCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletRotaryEncoderV2ResetCounterConfig channelCfg = getChannelConfigFn.apply("BrickletRotaryEncoderV2ResetCounter").as(BrickletRotaryEncoderV2ResetCounterConfig.class);
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletRotaryEncoderV2Config cfg = (BrickletRotaryEncoderV2Config) config.as(BrickletRotaryEncoderV2Config.class);
        this.setCountCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRotaryEncoderV2Config cfg = (BrickletRotaryEncoderV2Config) config.as(BrickletRotaryEncoderV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletRotaryEncoderV2Count");
		result.add("BrickletRotaryEncoderV2ResetCounter");
		result.add("BrickletRotaryEncoderV2Pressed");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletRotaryEncoderV2Count":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletRotaryEncoderV2Count"), "Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletRotaryEncoderV2Count")).withDescription("The current count of the encoder. The encoder has 24 steps per rotation. Turning the encoder to the left decrements the counter, so a negative count is possible.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletRotaryEncoderV2ResetCounter":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletRotaryEncoderV2ResetCounter"), "Reset Counter", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletRotaryEncoderV2ResetCounter")).withDescription("Resets the counter to 0.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("RESET", "Reset")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Rotary Encoder Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("360° rotary encoder with push-button").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletRotaryEncoderV2Count", new ChannelTypeUID("tinkerforge", "BrickletRotaryEncoderV2Count")).withLabel("Count").build(), new ChannelDefinitionBuilder("BrickletRotaryEncoderV2ResetCounter", new ChannelTypeUID("tinkerforge", "BrickletRotaryEncoderV2ResetCounter")).withLabel("Reset Counter").build(), new ChannelDefinitionBuilder("BrickletRotaryEncoderV2Pressed", new ChannelTypeUID("system", "rawbutton")).withLabel("Pressed").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletrotaryencoderv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletRotaryEncoderV2Count":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletRotaryEncoderV2ResetCounter":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRotaryEncoderV2Config cfg = (BrickletRotaryEncoderV2Config) config.as(BrickletRotaryEncoderV2Config.class);
        switch(channel) {
            case "BrickletRotaryEncoderV2Count": {
                   BrickletRotaryEncoderV2CountConfig channelCfg = channelConfig.as(BrickletRotaryEncoderV2CountConfig.class);
                   {
            int value = this.getCount(false);
            if(true)
                updateStateFn.accept(channel, transformBrickletRotaryEncoderV2CountGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletRotaryEncoderV2ResetCounter":
               return;
            case "BrickletRotaryEncoderV2Pressed":
                   {
            boolean value = this.isPressed();
            if(true)
                triggerChannelFn.accept(channel, transformBrickletRotaryEncoderV2PressedGetter0(value, cfg));
        }
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletRotaryEncoderV2Config cfg = (BrickletRotaryEncoderV2Config) config.as(BrickletRotaryEncoderV2Config.class);
        switch(channel) {
            case "BrickletRotaryEncoderV2ResetCounter":
                if (command instanceof StringType) {
                    BrickletRotaryEncoderV2ResetCounterConfig channelCfg = channelConfig.as(BrickletRotaryEncoderV2ResetCounterConfig.class);
                    StringType cmd = (StringType) command;
                    this.getCount(true);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletRotaryEncoderV2Count", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletRotaryEncoderV2CountCallback0(int count, BrickletRotaryEncoderV2Config cfg) {
        return new QuantityType<>(count, SmartHomeUnits.ONE);
    }
	    private String transformBrickletRotaryEncoderV2PressedCallback0(BrickletRotaryEncoderV2Config cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformBrickletRotaryEncoderV2PressedCallback1(BrickletRotaryEncoderV2Config cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletRotaryEncoderV2CountGetter0(int value, BrickletRotaryEncoderV2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private String transformBrickletRotaryEncoderV2PressedGetter0(boolean value, BrickletRotaryEncoderV2Config cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }

}