/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

import com.tinkerforge.BrickletSolidStateRelay;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletSolidStateRelayWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletSolidStateRelay dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletSolidStateRelay.DEVICE_DISPLAY_NAME, "brickletsolidstaterelay", BrickletSolidStateRelay.DEVICE_IDENTIFIER, BrickletSolidStateRelayWrapper.class, BrickletSolidStateRelayActions.class, "2.0.0", false);

    public BrickletSolidStateRelayWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletSolidStateRelay(uid, ipcon);
    }

    


    public void setState(boolean state) throws TinkerforgeException {
    this.dev.setState(state);
}

public boolean getState() throws TinkerforgeException {
    return this.dev.getState();
}

public void setMonoflop(boolean state, long time) throws TinkerforgeException {
    this.dev.setMonoflop(state, time);
}

public BrickletSolidStateRelay.Monoflop getMonoflop() throws TinkerforgeException {
    return this.dev.getMonoflop();
}

public BrickletSolidStateRelay.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addMonoflopDoneListener(BrickletSolidStateRelay.MonoflopDoneListener l) {
    this.dev.addMonoflopDoneListener(l);
}

public void removeMonoflopDoneListener(BrickletSolidStateRelay.MonoflopDoneListener l) {
    this.dev.removeMonoflopDoneListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletSolidStateRelayWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletSolidStateRelayWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletSolidStateRelayConfig cfg = (BrickletSolidStateRelayConfig) config.as(BrickletSolidStateRelayConfig.class);
        this.addMonoflopDoneListener(this.reg((state) -> {if(true) {updateStateFn.accept("BrickletSolidStateRelayRelay", transformBrickletSolidStateRelayRelayCallback0(state, cfg));}}, this.dev::removeMonoflopDoneListener));
        
		{
		BrickletSolidStateRelayRelayConfig channelCfg = getChannelConfigFn.apply("BrickletSolidStateRelayRelay").as(BrickletSolidStateRelayRelayConfig.class);
		
		}
		{
		BrickletSolidStateRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletSolidStateRelayMonofloprelay").as(BrickletSolidStateRelayMonoflopConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletSolidStateRelayConfig cfg = (BrickletSolidStateRelayConfig) config.as(BrickletSolidStateRelayConfig.class);
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletSolidStateRelayConfig cfg = (BrickletSolidStateRelayConfig) config.as(BrickletSolidStateRelayConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletSolidStateRelayRelay");
		result.add("BrickletSolidStateRelayMonofloprelay");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletSolidStateRelayRelay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletSolidStateRelayRelay"), "NOT USED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletSolidStateRelayRelay")).withDescription("NOT USED").build();
            case "BrickletSolidStateRelayMonoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletSolidStateRelayMonoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletSolidStateRelayMonoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Solid State Relay Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Controls AC and DC Solid State Relays").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletSolidStateRelayRelay", new ChannelTypeUID("tinkerforge", "BrickletSolidStateRelayRelay")).withLabel("Relay").withDescription("Switches the relay. A running monoflop timer for the relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletSolidStateRelayMonofloprelay", new ChannelTypeUID("tinkerforge", "BrickletSolidStateRelayMonoflop")).withLabel("Monoflop Relay").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletsolidstaterelay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletSolidStateRelayRelay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletSolidStateRelayMonoflop":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the relay should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").withAdvanced(true).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletSolidStateRelayConfig cfg = (BrickletSolidStateRelayConfig) config.as(BrickletSolidStateRelayConfig.class);
        switch(channel) {
            case "BrickletSolidStateRelayRelay": {
                   BrickletSolidStateRelayRelayConfig channelCfg = channelConfig.as(BrickletSolidStateRelayRelayConfig.class);
                   {
            boolean value = this.getState();
            if(true)
                updateStateFn.accept(channel, transformBrickletSolidStateRelayRelayGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletSolidStateRelayMonofloprelay": {
                   BrickletSolidStateRelayMonoflopConfig channelCfg = channelConfig.as(BrickletSolidStateRelayMonoflopConfig.class);
                   {
            BrickletSolidStateRelay.Monoflop value = this.getMonoflop();
            if(true)
                updateStateFn.accept(channel, transformBrickletSolidStateRelayMonofloprelayGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletSolidStateRelayConfig cfg = (BrickletSolidStateRelayConfig) config.as(BrickletSolidStateRelayConfig.class);
        switch(channel) {
            case "BrickletSolidStateRelayRelay":
                if (command instanceof OnOffType) {
                    BrickletSolidStateRelayRelayConfig channelCfg = channelConfig.as(BrickletSolidStateRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setState(cmd == OnOffType.ON);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletSolidStateRelayMonofloprelay":
                if (command instanceof StringType) {
                    BrickletSolidStateRelayMonoflopConfig channelCfg = channelConfig.as(BrickletSolidStateRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(channelCfg.monoflopValue.booleanValue(), channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletSolidStateRelayRelay", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletSolidStateRelayRelayCallback0(boolean state, BrickletSolidStateRelayConfig cfg) {
        return state ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletSolidStateRelayRelayGetter0(boolean value, BrickletSolidStateRelayConfig cfg) {
        return value ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletSolidStateRelayMonofloprelayGetter0(BrickletSolidStateRelay.Monoflop value, BrickletSolidStateRelayConfig cfg) {
        return value.state ? OnOffType.ON : OnOffType.OFF;
    }

}