/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletSoundPressureLevel;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletSoundPressureLevelWrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletSoundPressureLevel dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletSoundPressureLevel.DEVICE_DISPLAY_NAME, "brickletsoundpressurelevel", BrickletSoundPressureLevel.DEVICE_IDENTIFIER, BrickletSoundPressureLevelWrapper.class, BrickletSoundPressureLevelActions.class, "2.0.0", true);

    public BrickletSoundPressureLevelWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletSoundPressureLevel(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int FFT_SIZE_128 = 0;
	public final static int FFT_SIZE_256 = 1;
	public final static int FFT_SIZE_512 = 2;
	public final static int FFT_SIZE_1024 = 3;
	public final static int WEIGHTING_A = 0;
	public final static int WEIGHTING_B = 1;
	public final static int WEIGHTING_C = 2;
	public final static int WEIGHTING_D = 3;
	public final static int WEIGHTING_Z = 4;
	public final static int WEIGHTING_ITU_R_468 = 5;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getDecibel() throws TinkerforgeException {
    return this.dev.getDecibel();
}

public void setDecibelCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setDecibelCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletSoundPressureLevel.DecibelCallbackConfiguration getDecibelCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getDecibelCallbackConfiguration();
}

public int[] getSpectrum() throws TinkerforgeException {
    return this.dev.getSpectrum();
}

public void setSpectrumCallbackConfiguration(long period) throws TinkerforgeException {
    this.dev.setSpectrumCallbackConfiguration(period);
}

public long getSpectrumCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getSpectrumCallbackConfiguration();
}

public void setConfiguration(int fftSize, int weighting) throws TinkerforgeException {
    this.dev.setConfiguration(fftSize, weighting);
}

public BrickletSoundPressureLevel.Configuration getConfiguration() throws TinkerforgeException {
    return this.dev.getConfiguration();
}

public BrickletSoundPressureLevel.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletSoundPressureLevel.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addDecibelListener(BrickletSoundPressureLevel.DecibelListener l) {
    this.dev.addDecibelListener(l);
}

public void removeDecibelListener(BrickletSoundPressureLevel.DecibelListener l) {
    this.dev.removeDecibelListener(l);
}

public void addSpectrumListener(BrickletSoundPressureLevel.SpectrumListener l) {
    this.dev.addSpectrumListener(l);
}

public void removeSpectrumListener(BrickletSoundPressureLevel.SpectrumListener l) {
    this.dev.removeSpectrumListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletSoundPressureLevelWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletSoundPressureLevelWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletSoundPressureLevelConfig cfg = (BrickletSoundPressureLevelConfig) config.as(BrickletSoundPressureLevelConfig.class);
        this.addDecibelListener(this.reg((decibel) -> {if(true) {updateStateFn.accept("BrickletSoundPressureLevelDecibel", transformBrickletSoundPressureLevelDecibelCallback0(decibel, cfg));}}, this.dev::removeDecibelListener));
        
		this.setConfiguration(cfg.fftSize, cfg.weighting);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletSoundPressureLevelDecibelConfig channelCfg = getChannelConfigFn.apply("BrickletSoundPressureLevelDecibel").as(BrickletSoundPressureLevelDecibelConfig.class);
		this.setDecibelCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletSoundPressureLevelConfig cfg = (BrickletSoundPressureLevelConfig) config.as(BrickletSoundPressureLevelConfig.class);
        this.setDecibelCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletSoundPressureLevelConfig cfg = (BrickletSoundPressureLevelConfig) config.as(BrickletSoundPressureLevelConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletSoundPressureLevelDecibel");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletSoundPressureLevelDecibel":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletSoundPressureLevelDecibel"), "Sound Pressure", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletSoundPressureLevelDecibel")).withDescription("Measured Sound Pressure")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%.1f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Sound Pressure Level Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures Sound Pressure Level in dB(A/B/C/D/Z)").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletSoundPressureLevelDecibel", new ChannelTypeUID("tinkerforge", "BrickletSoundPressureLevelDecibel")).withLabel("Sound Pressure").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletsoundpressurelevel":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("fftSize", Type.INTEGER).withDefault("3").withDescription("With different FFT sizes the Bricklet has a different amount of samples per second and the size of the FFT bins changes. The higher the FFT size the more precise is the result of the dB(X) calculation.").withLabel("FFT Size").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "128"), new ParameterOption("1", "256"), new ParameterOption("2", "512"), new ParameterOption("3", "1024"))).build(), ConfigDescriptionParameterBuilder.create("weighting", Type.INTEGER).withDefault("0").withDescription("The Bricklet supports different weighting functions. dB(A/B/C/D) are the standard dB weighting curves. dB(A) is often used to measure volumes at concerts etc. dB(Z) has a flat response, no weighting is applied. ITU-R 468 is an ITU weighting standard mostly used in the UK and Europe.").withLabel("Weighting").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "dB(A)"), new ParameterOption("1", "dB(B)"), new ParameterOption("2", "dB(C)"), new ParameterOption("3", "dB(D)"), new ParameterOption("4", "dB(Z)"), new ParameterOption("5", "ITU-R 468"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletSoundPressureLevelDecibel":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletSoundPressureLevelConfig cfg = (BrickletSoundPressureLevelConfig) config.as(BrickletSoundPressureLevelConfig.class);
        switch(channel) {
            case "BrickletSoundPressureLevelDecibel": {
                   BrickletSoundPressureLevelDecibelConfig channelCfg = channelConfig.as(BrickletSoundPressureLevelDecibelConfig.class);
                   {
            int value = this.getDecibel();
            if(true)
                updateStateFn.accept(channel, transformBrickletSoundPressureLevelDecibelGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletSoundPressureLevelConfig cfg = (BrickletSoundPressureLevelConfig) config.as(BrickletSoundPressureLevelConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletSoundPressureLevelDecibelCallback0(int decibel, BrickletSoundPressureLevelConfig cfg) {
        return new QuantityType<>(decibel / 10.0, SmartHomeUnits.DECIBEL);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletSoundPressureLevelDecibelGetter0(int value, BrickletSoundPressureLevelConfig cfg) {
        return new QuantityType<>(value / 10.0, SmartHomeUnits.DECIBEL);
    }

}