/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletTemperatureIRV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletTemperatureIRV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletTemperatureIRV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletTemperatureIRV2.DEVICE_DISPLAY_NAME, "bricklettemperatureirv2", BrickletTemperatureIRV2.DEVICE_IDENTIFIER, BrickletTemperatureIRV2Wrapper.class, BrickletTemperatureIRV2Actions.class, "2.0.0", true);

    public BrickletTemperatureIRV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletTemperatureIRV2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getAmbientTemperature() throws TinkerforgeException {
    return this.dev.getAmbientTemperature();
}

public void setAmbientTemperatureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setAmbientTemperatureCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletTemperatureIRV2.AmbientTemperatureCallbackConfiguration getAmbientTemperatureCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getAmbientTemperatureCallbackConfiguration();
}

public int getObjectTemperature() throws TinkerforgeException {
    return this.dev.getObjectTemperature();
}

public void setObjectTemperatureCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setObjectTemperatureCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletTemperatureIRV2.ObjectTemperatureCallbackConfiguration getObjectTemperatureCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getObjectTemperatureCallbackConfiguration();
}

public void setEmissivity(int emissivity) throws TinkerforgeException {
    this.dev.setEmissivity(emissivity);
}

public int getEmissivity() throws TinkerforgeException {
    return this.dev.getEmissivity();
}

public BrickletTemperatureIRV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletTemperatureIRV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addAmbientTemperatureListener(BrickletTemperatureIRV2.AmbientTemperatureListener l) {
    this.dev.addAmbientTemperatureListener(l);
}

public void removeAmbientTemperatureListener(BrickletTemperatureIRV2.AmbientTemperatureListener l) {
    this.dev.removeAmbientTemperatureListener(l);
}

public void addObjectTemperatureListener(BrickletTemperatureIRV2.ObjectTemperatureListener l) {
    this.dev.addObjectTemperatureListener(l);
}

public void removeObjectTemperatureListener(BrickletTemperatureIRV2.ObjectTemperatureListener l) {
    this.dev.removeObjectTemperatureListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletTemperatureIRV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletTemperatureIRV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletTemperatureIRV2Config cfg = (BrickletTemperatureIRV2Config) config.as(BrickletTemperatureIRV2Config.class);
        this.addAmbientTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletTemperatureIRV2AmbientTemperature", transformBrickletTemperatureIRV2AmbientTemperatureCallback0(temperature, cfg));}}, this.dev::removeAmbientTemperatureListener));
		this.addObjectTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletTemperatureIRV2ObjectTemperature", transformBrickletTemperatureIRV2ObjectTemperatureCallback0(temperature, cfg));}}, this.dev::removeObjectTemperatureListener));
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletTemperatureIRV2AmbientTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletTemperatureIRV2AmbientTemperature").as(BrickletTemperatureIRV2AmbientTemperatureConfig.class);
		this.setAmbientTemperatureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletTemperatureIRV2ObjectTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletTemperatureIRV2ObjectTemperature").as(BrickletTemperatureIRV2ObjectTemperatureConfig.class);
		this.setObjectTemperatureCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletTemperatureIRV2Config cfg = (BrickletTemperatureIRV2Config) config.as(BrickletTemperatureIRV2Config.class);
        this.setAmbientTemperatureCallbackConfiguration(0, true, 'x', 0, 0);
		this.setObjectTemperatureCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletTemperatureIRV2Config cfg = (BrickletTemperatureIRV2Config) config.as(BrickletTemperatureIRV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletTemperatureIRV2AmbientTemperature");
		result.add("BrickletTemperatureIRV2ObjectTemperature");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletTemperatureIRV2AmbientTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRV2AmbientTemperature"), "Ambient Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletTemperatureIRV2AmbientTemperature")).withDescription("Measured ambient temperature")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-40)).withMaximum(BigDecimal.valueOf(125)).withPattern("%.1f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletTemperatureIRV2ObjectTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRV2ObjectTemperature"), "Object Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletTemperatureIRV2ObjectTemperature")).withDescription("Measured object temperature, i.e. the temperature of the surface of the object the sensor is aimed at. The temperature of different materials is dependent on their <a href=https://en.wikipedia.org/wiki/Emissivity>emissivity</a>.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-70)).withMaximum(BigDecimal.valueOf(380)).withPattern("%.1f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Temperature IR Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures contactless object temperature between -70°C and +380°C").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletTemperatureIRV2AmbientTemperature", new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRV2AmbientTemperature")).withLabel("Ambient Temperature").build(), new ChannelDefinitionBuilder("BrickletTemperatureIRV2ObjectTemperature", new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRV2ObjectTemperature")).withLabel("Object Temperature").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:bricklettemperatureirv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletTemperatureIRV2AmbientTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletTemperatureIRV2ObjectTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletTemperatureIRV2Config cfg = (BrickletTemperatureIRV2Config) config.as(BrickletTemperatureIRV2Config.class);
        switch(channel) {
            case "BrickletTemperatureIRV2AmbientTemperature": {
                   BrickletTemperatureIRV2AmbientTemperatureConfig channelCfg = channelConfig.as(BrickletTemperatureIRV2AmbientTemperatureConfig.class);
                   {
            int value = this.getAmbientTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletTemperatureIRV2AmbientTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletTemperatureIRV2ObjectTemperature": {
                   BrickletTemperatureIRV2ObjectTemperatureConfig channelCfg = channelConfig.as(BrickletTemperatureIRV2ObjectTemperatureConfig.class);
                   {
            int value = this.getObjectTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletTemperatureIRV2ObjectTemperatureGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletTemperatureIRV2Config cfg = (BrickletTemperatureIRV2Config) config.as(BrickletTemperatureIRV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRV2AmbientTemperatureCallback0(int temperature, BrickletTemperatureIRV2Config cfg) {
        return new QuantityType<>(temperature / 10.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRV2ObjectTemperatureCallback0(int temperature, BrickletTemperatureIRV2Config cfg) {
        return new QuantityType<>(temperature / 10.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRV2AmbientTemperatureGetter0(int value, BrickletTemperatureIRV2Config cfg) {
        return new QuantityType<>(value / 10.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRV2ObjectTemperatureGetter0(int value, BrickletTemperatureIRV2Config cfg) {
        return new QuantityType<>(value / 10.0, SIUnits.CELSIUS);
    }

}