/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletTemperatureIR;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletTemperatureIRWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletTemperatureIR dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletTemperatureIR.DEVICE_DISPLAY_NAME, "bricklettemperatureir", BrickletTemperatureIR.DEVICE_IDENTIFIER, BrickletTemperatureIRWrapper.class, BrickletTemperatureIRActions.class, "2.0.0", false);

    public BrickletTemperatureIRWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletTemperatureIR(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';


    public int getAmbientTemperature() throws TinkerforgeException {
    return this.dev.getAmbientTemperature();
}

public int getObjectTemperature() throws TinkerforgeException {
    return this.dev.getObjectTemperature();
}

public void setEmissivity(int emissivity) throws TinkerforgeException {
    this.dev.setEmissivity(emissivity);
}

public int getEmissivity() throws TinkerforgeException {
    return this.dev.getEmissivity();
}

public void setAmbientTemperatureCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setAmbientTemperatureCallbackPeriod(period);
}

public long getAmbientTemperatureCallbackPeriod() throws TinkerforgeException {
    return this.dev.getAmbientTemperatureCallbackPeriod();
}

public void setObjectTemperatureCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setObjectTemperatureCallbackPeriod(period);
}

public long getObjectTemperatureCallbackPeriod() throws TinkerforgeException {
    return this.dev.getObjectTemperatureCallbackPeriod();
}

public void setAmbientTemperatureCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setAmbientTemperatureCallbackThreshold(option, min, max);
}

public BrickletTemperatureIR.AmbientTemperatureCallbackThreshold getAmbientTemperatureCallbackThreshold() throws TinkerforgeException {
    return this.dev.getAmbientTemperatureCallbackThreshold();
}

public void setObjectTemperatureCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setObjectTemperatureCallbackThreshold(option, min, max);
}

public BrickletTemperatureIR.ObjectTemperatureCallbackThreshold getObjectTemperatureCallbackThreshold() throws TinkerforgeException {
    return this.dev.getObjectTemperatureCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public BrickletTemperatureIR.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addAmbientTemperatureListener(BrickletTemperatureIR.AmbientTemperatureListener l) {
    this.dev.addAmbientTemperatureListener(l);
}

public void removeAmbientTemperatureListener(BrickletTemperatureIR.AmbientTemperatureListener l) {
    this.dev.removeAmbientTemperatureListener(l);
}

public void addObjectTemperatureListener(BrickletTemperatureIR.ObjectTemperatureListener l) {
    this.dev.addObjectTemperatureListener(l);
}

public void removeObjectTemperatureListener(BrickletTemperatureIR.ObjectTemperatureListener l) {
    this.dev.removeObjectTemperatureListener(l);
}

public void addAmbientTemperatureReachedListener(BrickletTemperatureIR.AmbientTemperatureReachedListener l) {
    this.dev.addAmbientTemperatureReachedListener(l);
}

public void removeAmbientTemperatureReachedListener(BrickletTemperatureIR.AmbientTemperatureReachedListener l) {
    this.dev.removeAmbientTemperatureReachedListener(l);
}

public void addObjectTemperatureReachedListener(BrickletTemperatureIR.ObjectTemperatureReachedListener l) {
    this.dev.addObjectTemperatureReachedListener(l);
}

public void removeObjectTemperatureReachedListener(BrickletTemperatureIR.ObjectTemperatureReachedListener l) {
    this.dev.removeObjectTemperatureReachedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletTemperatureIRWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletTemperatureIRWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletTemperatureIRConfig cfg = (BrickletTemperatureIRConfig) config.as(BrickletTemperatureIRConfig.class);
        this.addAmbientTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletTemperatureIRAmbientTemperature", transformBrickletTemperatureIRAmbientTemperatureCallback0(temperature, cfg));}}, this.dev::removeAmbientTemperatureListener));
		this.addObjectTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletTemperatureIRObjectTemperature", transformBrickletTemperatureIRObjectTemperatureCallback0(temperature, cfg));}}, this.dev::removeObjectTemperatureListener));
        
		{
		BrickletTemperatureIRAmbientTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletTemperatureIRAmbientTemperature").as(BrickletTemperatureIRAmbientTemperatureConfig.class);
		this.setAmbientTemperatureCallbackPeriod(channelCfg.updateInterval);
		this.setAmbientTemperatureCallbackThreshold('x', 0, 0);
		}
		{
		BrickletTemperatureIRObjectTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletTemperatureIRObjectTemperature").as(BrickletTemperatureIRObjectTemperatureConfig.class);
		this.setObjectTemperatureCallbackPeriod(channelCfg.updateInterval);
		this.setObjectTemperatureCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletTemperatureIRConfig cfg = (BrickletTemperatureIRConfig) config.as(BrickletTemperatureIRConfig.class);
        this.setAmbientTemperatureCallbackPeriod(0);
		this.setObjectTemperatureCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletTemperatureIRConfig cfg = (BrickletTemperatureIRConfig) config.as(BrickletTemperatureIRConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletTemperatureIRAmbientTemperature");
		result.add("BrickletTemperatureIRObjectTemperature");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletTemperatureIRAmbientTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRAmbientTemperature"), "Ambient Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletTemperatureIRAmbientTemperature")).withDescription("Measured ambient temperature")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-40)).withMaximum(BigDecimal.valueOf(125)).withPattern("%.1f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletTemperatureIRObjectTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRObjectTemperature"), "Object Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletTemperatureIRObjectTemperature")).withDescription("Measured object temperature, i.e. the temperature of the surface of the object the sensor is aimed at. The temperature of different materials is dependent on their <a href=https://en.wikipedia.org/wiki/Emissivity>emissivity</a>.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-70)).withMaximum(BigDecimal.valueOf(380)).withPattern("%.1f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Temperature IR Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures contactless object temperature between -70°C and +380°C").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletTemperatureIRAmbientTemperature", new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRAmbientTemperature")).withLabel("Ambient Temperature").build(), new ChannelDefinitionBuilder("BrickletTemperatureIRObjectTemperature", new ChannelTypeUID("tinkerforge", "BrickletTemperatureIRObjectTemperature")).withLabel("Object Temperature").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:bricklettemperatureir":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletTemperatureIRAmbientTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletTemperatureIRObjectTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletTemperatureIRConfig cfg = (BrickletTemperatureIRConfig) config.as(BrickletTemperatureIRConfig.class);
        switch(channel) {
            case "BrickletTemperatureIRAmbientTemperature": {
                   BrickletTemperatureIRAmbientTemperatureConfig channelCfg = channelConfig.as(BrickletTemperatureIRAmbientTemperatureConfig.class);
                   {
            int value = this.getAmbientTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletTemperatureIRAmbientTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletTemperatureIRObjectTemperature": {
                   BrickletTemperatureIRObjectTemperatureConfig channelCfg = channelConfig.as(BrickletTemperatureIRObjectTemperatureConfig.class);
                   {
            int value = this.getObjectTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletTemperatureIRObjectTemperatureGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletTemperatureIRConfig cfg = (BrickletTemperatureIRConfig) config.as(BrickletTemperatureIRConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRAmbientTemperatureCallback0(int temperature, BrickletTemperatureIRConfig cfg) {
        return new QuantityType<>(temperature / 10.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRObjectTemperatureCallback0(int temperature, BrickletTemperatureIRConfig cfg) {
        return new QuantityType<>(temperature / 10.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRAmbientTemperatureGetter0(int value, BrickletTemperatureIRConfig cfg) {
        return new QuantityType<>(value / 10.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletTemperatureIRObjectTemperatureGetter0(int value, BrickletTemperatureIRConfig cfg) {
        return new QuantityType<>(value / 10.0, SIUnits.CELSIUS);
    }

}