/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletTemperature;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletTemperatureWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletTemperature dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletTemperature.DEVICE_DISPLAY_NAME, "bricklettemperature", BrickletTemperature.DEVICE_IDENTIFIER, BrickletTemperatureWrapper.class, BrickletTemperatureActions.class, "2.0.1", false);

    public BrickletTemperatureWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletTemperature(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int I2C_MODE_FAST = 0;
	public final static int I2C_MODE_SLOW = 1;


    public int getTemperature() throws TinkerforgeException {
    return this.dev.getTemperature();
}

public void setTemperatureCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setTemperatureCallbackPeriod(period);
}

public long getTemperatureCallbackPeriod() throws TinkerforgeException {
    return this.dev.getTemperatureCallbackPeriod();
}

public void setTemperatureCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setTemperatureCallbackThreshold(option, min, max);
}

public BrickletTemperature.TemperatureCallbackThreshold getTemperatureCallbackThreshold() throws TinkerforgeException {
    return this.dev.getTemperatureCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public void setI2CMode(int mode) throws TinkerforgeException {
    this.dev.setI2CMode(mode);
}

public int getI2CMode() throws TinkerforgeException {
    return this.dev.getI2CMode();
}

public BrickletTemperature.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addTemperatureListener(BrickletTemperature.TemperatureListener l) {
    this.dev.addTemperatureListener(l);
}

public void removeTemperatureListener(BrickletTemperature.TemperatureListener l) {
    this.dev.removeTemperatureListener(l);
}

public void addTemperatureReachedListener(BrickletTemperature.TemperatureReachedListener l) {
    this.dev.addTemperatureReachedListener(l);
}

public void removeTemperatureReachedListener(BrickletTemperature.TemperatureReachedListener l) {
    this.dev.removeTemperatureReachedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletTemperatureWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletTemperatureWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletTemperatureConfig cfg = (BrickletTemperatureConfig) config.as(BrickletTemperatureConfig.class);
        this.addTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletTemperatureTemperature", transformBrickletTemperatureTemperatureCallback0(temperature, cfg));}}, this.dev::removeTemperatureListener));
        this.setI2CMode(cfg.i2cMode);
		{
		BrickletTemperatureTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletTemperatureTemperature").as(BrickletTemperatureTemperatureConfig.class);
		this.setTemperatureCallbackPeriod(channelCfg.updateInterval);
		this.setTemperatureCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletTemperatureConfig cfg = (BrickletTemperatureConfig) config.as(BrickletTemperatureConfig.class);
        this.setTemperatureCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletTemperatureConfig cfg = (BrickletTemperatureConfig) config.as(BrickletTemperatureConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletTemperatureTemperature");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletTemperatureTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletTemperatureTemperature"), "Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletTemperatureTemperature")).withDescription("Measured temperature")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-25)).withMaximum(BigDecimal.valueOf(85)).withPattern("%.1f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Temperature Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures ambient temperature with 0.5°C accuracy").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletTemperatureTemperature", new ChannelTypeUID("tinkerforge", "BrickletTemperatureTemperature")).withLabel("Temperature").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:bricklettemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("i2cMode", Type.INTEGER).withDefault("0").withDescription("Sets the I2C mode. If you have problems with obvious outliers in the Temperature Bricklet measurements, they may be caused by EMI issues. In this case it may be helpful to lower the I2C speed. It is however not recommended to lower the I2C speed in applications where a high throughput needs to be achieved.").withLabel("I2C Mode").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Fast (400kHz)"), new ParameterOption("1", "Slow (100kHz)"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletTemperatureTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletTemperatureConfig cfg = (BrickletTemperatureConfig) config.as(BrickletTemperatureConfig.class);
        switch(channel) {
            case "BrickletTemperatureTemperature": {
                   BrickletTemperatureTemperatureConfig channelCfg = channelConfig.as(BrickletTemperatureTemperatureConfig.class);
                   {
            int value = this.getTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletTemperatureTemperatureGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletTemperatureConfig cfg = (BrickletTemperatureConfig) config.as(BrickletTemperatureConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletTemperatureTemperatureCallback0(int temperature, BrickletTemperatureConfig cfg) {
        return new QuantityType<>(temperature / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletTemperatureTemperatureGetter0(int value, BrickletTemperatureConfig cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.CELSIUS);
    }

}