/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.OnOffType;

import com.tinkerforge.BrickletThermocouple;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletThermocoupleWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletThermocouple dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletThermocouple.DEVICE_DISPLAY_NAME, "brickletthermocouple", BrickletThermocouple.DEVICE_IDENTIFIER, BrickletThermocoupleWrapper.class, BrickletThermocoupleActions.class, "2.0.0", false);

    public BrickletThermocoupleWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletThermocouple(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int AVERAGING_1 = 1;
	public final static int AVERAGING_2 = 2;
	public final static int AVERAGING_4 = 4;
	public final static int AVERAGING_8 = 8;
	public final static int AVERAGING_16 = 16;
	public final static int TYPE_B = 0;
	public final static int TYPE_E = 1;
	public final static int TYPE_J = 2;
	public final static int TYPE_K = 3;
	public final static int TYPE_N = 4;
	public final static int TYPE_R = 5;
	public final static int TYPE_S = 6;
	public final static int TYPE_T = 7;
	public final static int TYPE_G8 = 8;
	public final static int TYPE_G32 = 9;
	public final static int FILTER_OPTION_50HZ = 0;
	public final static int FILTER_OPTION_60HZ = 1;


    public int getTemperature() throws TinkerforgeException {
    return this.dev.getTemperature();
}

public void setTemperatureCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setTemperatureCallbackPeriod(period);
}

public long getTemperatureCallbackPeriod() throws TinkerforgeException {
    return this.dev.getTemperatureCallbackPeriod();
}

public void setTemperatureCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
    this.dev.setTemperatureCallbackThreshold(option, min, max);
}

public BrickletThermocouple.TemperatureCallbackThreshold getTemperatureCallbackThreshold() throws TinkerforgeException {
    return this.dev.getTemperatureCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public void setConfiguration(int averaging, int thermocoupleType, int filter) throws TinkerforgeException {
    this.dev.setConfiguration(averaging, thermocoupleType, filter);
}

public BrickletThermocouple.Configuration getConfiguration() throws TinkerforgeException {
    return this.dev.getConfiguration();
}

public BrickletThermocouple.ErrorState getErrorState() throws TinkerforgeException {
    return this.dev.getErrorState();
}

public BrickletThermocouple.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addTemperatureListener(BrickletThermocouple.TemperatureListener l) {
    this.dev.addTemperatureListener(l);
}

public void removeTemperatureListener(BrickletThermocouple.TemperatureListener l) {
    this.dev.removeTemperatureListener(l);
}

public void addTemperatureReachedListener(BrickletThermocouple.TemperatureReachedListener l) {
    this.dev.addTemperatureReachedListener(l);
}

public void removeTemperatureReachedListener(BrickletThermocouple.TemperatureReachedListener l) {
    this.dev.removeTemperatureReachedListener(l);
}

public void addErrorStateListener(BrickletThermocouple.ErrorStateListener l) {
    this.dev.addErrorStateListener(l);
}

public void removeErrorStateListener(BrickletThermocouple.ErrorStateListener l) {
    this.dev.removeErrorStateListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletThermocoupleWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletThermocoupleWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletThermocoupleConfig cfg = (BrickletThermocoupleConfig) config.as(BrickletThermocoupleConfig.class);
        this.addTemperatureListener(this.reg((temperature) -> {if(true) {updateStateFn.accept("BrickletThermocoupleTemperature", transformBrickletThermocoupleTemperatureCallback0(temperature, cfg));}}, this.dev::removeTemperatureListener));
		this.addErrorStateListener(this.reg((overUnder, openCircuit) -> {if(true) {updateStateFn.accept("BrickletThermocoupleOverUnderVoltage", transformBrickletThermocoupleOverUnderVoltageCallback0(overUnder, openCircuit, cfg));}}, this.dev::removeErrorStateListener));
		this.addErrorStateListener(this.reg((overUnder, openCircuit) -> {if(true) {updateStateFn.accept("BrickletThermocoupleOpenCircuit", transformBrickletThermocoupleOpenCircuitCallback0(overUnder, openCircuit, cfg));}}, this.dev::removeErrorStateListener));
        this.setConfiguration(cfg.averageLength, cfg.thermocoupleType, cfg.frequencyFilter);
		{
		BrickletThermocoupleTemperatureConfig channelCfg = getChannelConfigFn.apply("BrickletThermocoupleTemperature").as(BrickletThermocoupleTemperatureConfig.class);
		this.setTemperatureCallbackPeriod(channelCfg.updateInterval);
		this.setTemperatureCallbackThreshold('x', 0, 0);
		}
		{
		BrickletThermocoupleOverUnderVoltageConfig channelCfg = getChannelConfigFn.apply("BrickletThermocoupleOverUnderVoltage").as(BrickletThermocoupleOverUnderVoltageConfig.class);
		
		}
		{
		BrickletThermocoupleOpenCircuitConfig channelCfg = getChannelConfigFn.apply("BrickletThermocoupleOpenCircuit").as(BrickletThermocoupleOpenCircuitConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletThermocoupleConfig cfg = (BrickletThermocoupleConfig) config.as(BrickletThermocoupleConfig.class);
        this.setTemperatureCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletThermocoupleConfig cfg = (BrickletThermocoupleConfig) config.as(BrickletThermocoupleConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletThermocoupleTemperature");
		result.add("BrickletThermocoupleOverUnderVoltage");
		result.add("BrickletThermocoupleOpenCircuit");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletThermocoupleTemperature":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermocoupleTemperature"), "Temperature", "Number:Temperature").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermocoupleTemperature")).withDescription("The temperature of the thermocouple.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-210)).withMaximum(BigDecimal.valueOf(1800)).withPattern("%.2f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletThermocoupleOverUnderVoltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermocoupleOverUnderVoltage"), "Over/Under Voltage Error", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermocoupleOverUnderVoltage")).withDescription("Over/Under Voltage happens for voltages below 0V or above 3.3V. In this case it is very likely that your thermocouple is defective.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            case "BrickletThermocoupleOpenCircuit":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletThermocoupleOpenCircuit"), "Open Circuit Error", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletThermocoupleOpenCircuit")).withDescription("An Open Circuit error indicates that there is no thermocouple connected.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Thermocouple Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures temperature with thermocouples").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletThermocoupleTemperature", new ChannelTypeUID("tinkerforge", "BrickletThermocoupleTemperature")).withLabel("Temperature").build(), new ChannelDefinitionBuilder("BrickletThermocoupleOverUnderVoltage", new ChannelTypeUID("tinkerforge", "BrickletThermocoupleOverUnderVoltage")).withLabel("Over/Under Voltage").build(), new ChannelDefinitionBuilder("BrickletThermocoupleOpenCircuit", new ChannelTypeUID("tinkerforge", "BrickletThermocoupleOpenCircuit")).withLabel("Open Circuit").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletthermocouple":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("averageLength", Type.INTEGER).withDefault("16").withDescription("Available averaging sizes are 1, 2, 4, 8 and 16 samples.<br/><br/>The conversion time depends on the averaging and filter configuration, it can be calculated as follows:<ul><li>60Hz: time = 82 + (samples - 1) * 16.67</li><li>50Hz: time = 98 + (samples - 1) * 20</li></ul>").withLabel("Average Length").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("1", "1"), new ParameterOption("2", "2"), new ParameterOption("4", "4"), new ParameterOption("8", "8"), new ParameterOption("16", "16"))).build(), ConfigDescriptionParameterBuilder.create("thermocoupleType", Type.INTEGER).withDefault("3").withDescription("As thermocouple type you can use B, E, J, K, N, R, S and T. If you have a different thermocouple or a custom thermocouple you can also use G8 and G32. With these types the returned value will not be in °C/100, it will be calculated by the following formulas:<ul><li>G8: value = 8 * 1.6 * 2^17 * Vin</li><li>G32: value = 32 * 1.6 * 2^17 * Vin</li></ul>where Vin is the thermocouple input voltage.").withLabel("Thermocouple Type").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "B"), new ParameterOption("1", "E"), new ParameterOption("2", "J"), new ParameterOption("3", "K"), new ParameterOption("4", "N"), new ParameterOption("5", "R"), new ParameterOption("6", "S"), new ParameterOption("7", "T"), new ParameterOption("8", "G8"), new ParameterOption("9", "G32"))).build(), ConfigDescriptionParameterBuilder.create("frequencyFilter", Type.INTEGER).withDefault("0").withDescription("The frequency filter can be either configured to 50Hz or to 60Hz. You should configure it according to your utility frequency.").withLabel("Frequency Filter").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "50Hz"), new ParameterOption("1", "60Hz"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletThermocoupleTemperature":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletThermocoupleOverUnderVoltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletThermocoupleOpenCircuit":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletThermocoupleConfig cfg = (BrickletThermocoupleConfig) config.as(BrickletThermocoupleConfig.class);
        switch(channel) {
            case "BrickletThermocoupleTemperature": {
                   BrickletThermocoupleTemperatureConfig channelCfg = channelConfig.as(BrickletThermocoupleTemperatureConfig.class);
                   {
            int value = this.getTemperature();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermocoupleTemperatureGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermocoupleOverUnderVoltage": {
                   BrickletThermocoupleOverUnderVoltageConfig channelCfg = channelConfig.as(BrickletThermocoupleOverUnderVoltageConfig.class);
                   {
            BrickletThermocouple.ErrorState value = this.getErrorState();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermocoupleOverUnderVoltageGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletThermocoupleOpenCircuit": {
                   BrickletThermocoupleOpenCircuitConfig channelCfg = channelConfig.as(BrickletThermocoupleOpenCircuitConfig.class);
                   {
            BrickletThermocouple.ErrorState value = this.getErrorState();
            if(true)
                updateStateFn.accept(channel, transformBrickletThermocoupleOpenCircuitGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletThermocoupleConfig cfg = (BrickletThermocoupleConfig) config.as(BrickletThermocoupleConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleTemperatureCallback0(int temperature, BrickletThermocoupleConfig cfg) {
        return new QuantityType<>(temperature / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleOverUnderVoltageCallback0(boolean overUnder, boolean openCircuit, BrickletThermocoupleConfig cfg) {
        return overUnder ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleOpenCircuitCallback0(boolean overUnder, boolean openCircuit, BrickletThermocoupleConfig cfg) {
        return openCircuit ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleTemperatureGetter0(int value, BrickletThermocoupleConfig cfg) {
        return new QuantityType<>(value / 100.0, SIUnits.CELSIUS);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleOverUnderVoltageGetter0(BrickletThermocouple.ErrorState value, BrickletThermocoupleConfig cfg) {
        return value.overUnder ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletThermocoupleOpenCircuitGetter0(BrickletThermocouple.ErrorState value, BrickletThermocoupleConfig cfg) {
        return value.openCircuit ? OnOffType.ON : OnOffType.OFF;
    }

}