/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletUVLight;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletUVLightWrapper extends DeviceWrapper implements StandardFlashable{
    BrickletUVLight dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletUVLight.DEVICE_DISPLAY_NAME, "brickletuvlight", BrickletUVLight.DEVICE_IDENTIFIER, BrickletUVLightWrapper.class, BrickletUVLightActions.class, "2.0.0", false);

    public BrickletUVLightWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletUVLight(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';


    public long getUVLight() throws TinkerforgeException {
    return this.dev.getUVLight();
}

public void setUVLightCallbackPeriod(long period) throws TinkerforgeException {
    this.dev.setUVLightCallbackPeriod(period);
}

public long getUVLightCallbackPeriod() throws TinkerforgeException {
    return this.dev.getUVLightCallbackPeriod();
}

public void setUVLightCallbackThreshold(char option, long min, long max) throws TinkerforgeException {
    this.dev.setUVLightCallbackThreshold(option, min, max);
}

public BrickletUVLight.UVLightCallbackThreshold getUVLightCallbackThreshold() throws TinkerforgeException {
    return this.dev.getUVLightCallbackThreshold();
}

public void setDebouncePeriod(long debounce) throws TinkerforgeException {
    this.dev.setDebouncePeriod(debounce);
}

public long getDebouncePeriod() throws TinkerforgeException {
    return this.dev.getDebouncePeriod();
}

public BrickletUVLight.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addUVLightListener(BrickletUVLight.UVLightListener l) {
    this.dev.addUVLightListener(l);
}

public void removeUVLightListener(BrickletUVLight.UVLightListener l) {
    this.dev.removeUVLightListener(l);
}

public void addUVLightReachedListener(BrickletUVLight.UVLightReachedListener l) {
    this.dev.addUVLightReachedListener(l);
}

public void removeUVLightReachedListener(BrickletUVLight.UVLightReachedListener l) {
    this.dev.removeUVLightReachedListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletUVLightWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletUVLightWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletUVLightConfig cfg = (BrickletUVLightConfig) config.as(BrickletUVLightConfig.class);
        this.addUVLightListener(this.reg((uvLight) -> {if(true) {updateStateFn.accept("BrickletUVLightUVLight", transformBrickletUVLightUVLightCallback0(uvLight, cfg));}}, this.dev::removeUVLightListener));
        
		{
		BrickletUVLightUVLightConfig channelCfg = getChannelConfigFn.apply("BrickletUVLightUVLight").as(BrickletUVLightUVLightConfig.class);
		this.setUVLightCallbackPeriod(channelCfg.updateInterval);
		this.setUVLightCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletUVLightConfig cfg = (BrickletUVLightConfig) config.as(BrickletUVLightConfig.class);
        this.setUVLightCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletUVLightConfig cfg = (BrickletUVLightConfig) config.as(BrickletUVLightConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletUVLightUVLight");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletUVLightUVLight":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletUVLightUVLight"), "UV Index", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletUVLightUVLight")).withDescription("Measured UV Index")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(50)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge UV Light Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures UV light").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletUVLightUVLight", new ChannelTypeUID("tinkerforge", "BrickletUVLightUVLight")).withLabel("UV Index").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletuvlight":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletUVLightUVLight":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletUVLightConfig cfg = (BrickletUVLightConfig) config.as(BrickletUVLightConfig.class);
        switch(channel) {
            case "BrickletUVLightUVLight": {
                   BrickletUVLightUVLightConfig channelCfg = channelConfig.as(BrickletUVLightUVLightConfig.class);
                   {
            long value = this.getUVLight();
            if(true)
                updateStateFn.accept(channel, transformBrickletUVLightUVLightGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletUVLightConfig cfg = (BrickletUVLightConfig) config.as(BrickletUVLightConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletUVLightUVLightCallback0(long uvLight, BrickletUVLightConfig cfg) {
        return new QuantityType<>(uvLight / 250.0, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletUVLightUVLightGetter0(long value, BrickletUVLightConfig cfg) {
        return new QuantityType<>(value / 250.0, SmartHomeUnits.ONE);
    }

}