/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletVoltageCurrentV2;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletVoltageCurrentV2Wrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletVoltageCurrentV2 dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletVoltageCurrentV2.DEVICE_DISPLAY_NAME, "brickletvoltagecurrentv2", BrickletVoltageCurrentV2.DEVICE_IDENTIFIER, BrickletVoltageCurrentV2Wrapper.class, BrickletVoltageCurrentV2Actions.class, "2.0.0", true);

    public BrickletVoltageCurrentV2Wrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletVoltageCurrentV2(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int AVERAGING_1 = 0;
	public final static int AVERAGING_4 = 1;
	public final static int AVERAGING_16 = 2;
	public final static int AVERAGING_64 = 3;
	public final static int AVERAGING_128 = 4;
	public final static int AVERAGING_256 = 5;
	public final static int AVERAGING_512 = 6;
	public final static int AVERAGING_1024 = 7;
	public final static int CONVERSION_TIME_140US = 0;
	public final static int CONVERSION_TIME_204US = 1;
	public final static int CONVERSION_TIME_332US = 2;
	public final static int CONVERSION_TIME_588US = 3;
	public final static int CONVERSION_TIME_1_1MS = 4;
	public final static int CONVERSION_TIME_2_116MS = 5;
	public final static int CONVERSION_TIME_4_156MS = 6;
	public final static int CONVERSION_TIME_8_244MS = 7;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public int getCurrent() throws TinkerforgeException {
    return this.dev.getCurrent();
}

public void setCurrentCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setCurrentCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletVoltageCurrentV2.CurrentCallbackConfiguration getCurrentCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getCurrentCallbackConfiguration();
}

public int getVoltage() throws TinkerforgeException {
    return this.dev.getVoltage();
}

public void setVoltageCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setVoltageCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletVoltageCurrentV2.VoltageCallbackConfiguration getVoltageCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getVoltageCallbackConfiguration();
}

public int getPower() throws TinkerforgeException {
    return this.dev.getPower();
}

public void setPowerCallbackConfiguration(long period, boolean valueHasToChange, char option, int min, int max) throws TinkerforgeException {
    this.dev.setPowerCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletVoltageCurrentV2.PowerCallbackConfiguration getPowerCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getPowerCallbackConfiguration();
}

public void setConfiguration(int averaging, int voltageConversionTime, int currentConversionTime) throws TinkerforgeException {
    this.dev.setConfiguration(averaging, voltageConversionTime, currentConversionTime);
}

public BrickletVoltageCurrentV2.Configuration getConfiguration() throws TinkerforgeException {
    return this.dev.getConfiguration();
}

public void setCalibration(int voltageMultiplier, int voltageDivisor, int currentMultiplier, int currentDivisor) throws TinkerforgeException {
    this.dev.setCalibration(voltageMultiplier, voltageDivisor, currentMultiplier, currentDivisor);
}

public BrickletVoltageCurrentV2.Calibration getCalibration() throws TinkerforgeException {
    return this.dev.getCalibration();
}

public BrickletVoltageCurrentV2.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletVoltageCurrentV2.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addCurrentListener(BrickletVoltageCurrentV2.CurrentListener l) {
    this.dev.addCurrentListener(l);
}

public void removeCurrentListener(BrickletVoltageCurrentV2.CurrentListener l) {
    this.dev.removeCurrentListener(l);
}

public void addVoltageListener(BrickletVoltageCurrentV2.VoltageListener l) {
    this.dev.addVoltageListener(l);
}

public void removeVoltageListener(BrickletVoltageCurrentV2.VoltageListener l) {
    this.dev.removeVoltageListener(l);
}

public void addPowerListener(BrickletVoltageCurrentV2.PowerListener l) {
    this.dev.addPowerListener(l);
}

public void removePowerListener(BrickletVoltageCurrentV2.PowerListener l) {
    this.dev.removePowerListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletVoltageCurrentV2Wrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletVoltageCurrentV2Wrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletVoltageCurrentV2Config cfg = (BrickletVoltageCurrentV2Config) config.as(BrickletVoltageCurrentV2Config.class);
        this.addCurrentListener(this.reg((current) -> {if(true) {updateStateFn.accept("BrickletVoltageCurrentV2Current", transformBrickletVoltageCurrentV2CurrentCallback0(current, cfg));}}, this.dev::removeCurrentListener));
		this.addVoltageListener(this.reg((voltage) -> {if(true) {updateStateFn.accept("BrickletVoltageCurrentV2Voltage", transformBrickletVoltageCurrentV2VoltageCallback0(voltage, cfg));}}, this.dev::removeVoltageListener));
		this.addPowerListener(this.reg((power) -> {if(true) {updateStateFn.accept("BrickletVoltageCurrentV2Power", transformBrickletVoltageCurrentV2PowerCallback0(power, cfg));}}, this.dev::removePowerListener));
        this.setConfiguration(cfg.averaging, cfg.voltageConversionTime, cfg.currentConversionTime);
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletVoltageCurrentV2CurrentConfig channelCfg = getChannelConfigFn.apply("BrickletVoltageCurrentV2Current").as(BrickletVoltageCurrentV2CurrentConfig.class);
		this.setCurrentCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletVoltageCurrentV2VoltageConfig channelCfg = getChannelConfigFn.apply("BrickletVoltageCurrentV2Voltage").as(BrickletVoltageCurrentV2VoltageConfig.class);
		this.setVoltageCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
		{
		BrickletVoltageCurrentV2PowerConfig channelCfg = getChannelConfigFn.apply("BrickletVoltageCurrentV2Power").as(BrickletVoltageCurrentV2PowerConfig.class);
		this.setPowerCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletVoltageCurrentV2Config cfg = (BrickletVoltageCurrentV2Config) config.as(BrickletVoltageCurrentV2Config.class);
        this.setCurrentCallbackConfiguration(0, true, 'x', 0, 0);
		this.setVoltageCallbackConfiguration(0, true, 'x', 0, 0);
		this.setPowerCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletVoltageCurrentV2Config cfg = (BrickletVoltageCurrentV2Config) config.as(BrickletVoltageCurrentV2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletVoltageCurrentV2Current");
		result.add("BrickletVoltageCurrentV2Voltage");
		result.add("BrickletVoltageCurrentV2Power");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletVoltageCurrentV2Voltage":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentV2Voltage"), "Measured Voltage", "Number:ElectricPotential").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletVoltageCurrentV2Voltage")).withDescription("The measured voltage between 0 and 36V.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(36)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletVoltageCurrentV2Current":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentV2Current"), "Measured Current", "Number:ElectricCurrent").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletVoltageCurrentV2Current")).withDescription("The measured current between -20 and 20A.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(-20)).withMaximum(BigDecimal.valueOf(20)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            case "BrickletVoltageCurrentV2Power":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentV2Power"), "Measured Power", "Number:Power").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletVoltageCurrentV2Power")).withDescription("The measured power between 0 and 720W.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(720)).withPattern("%.3f %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Voltage/Current Bricklet 2.0").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures power, DC voltage and DC current up to 720W/36V/20A").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletVoltageCurrentV2Current", new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentV2Current")).withLabel("Measured Current").build(), new ChannelDefinitionBuilder("BrickletVoltageCurrentV2Voltage", new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentV2Voltage")).withLabel("Measured Voltage").build(), new ChannelDefinitionBuilder("BrickletVoltageCurrentV2Power", new ChannelTypeUID("tinkerforge", "BrickletVoltageCurrentV2Power")).withLabel("Measured Power").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletvoltagecurrentv2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("averaging", Type.INTEGER).withDefault("3").withDescription("Configures the number of samples to average over.").withLabel("Averaging").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "1"), new ParameterOption("1", "4"), new ParameterOption("2", "16"), new ParameterOption("3", "64"), new ParameterOption("4", "128"), new ParameterOption("5", "256"), new ParameterOption("6", "512"), new ParameterOption("7", "1024"))).build(), ConfigDescriptionParameterBuilder.create("voltageConversionTime", Type.INTEGER).withDefault("4").withDescription("Configures the voltage conversion time.").withLabel("Voltage Conversion Time").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "140µs"), new ParameterOption("1", "204µs"), new ParameterOption("2", "332µs"), new ParameterOption("3", "588µs"), new ParameterOption("4", "1.1ms"), new ParameterOption("5", "2.116ms"), new ParameterOption("6", "4.156ms"), new ParameterOption("7", "8.244ms"))).build(), ConfigDescriptionParameterBuilder.create("currentConversionTime", Type.INTEGER).withDefault("4").withDescription("Configures the current conversion time.").withLabel("Current Conversion Time").withLimitToOptions(false).withOptions(Arrays.asList(new ParameterOption("0", "140µs"), new ParameterOption("1", "204µs"), new ParameterOption("2", "332µs"), new ParameterOption("3", "588µs"), new ParameterOption("4", "1.1ms"), new ParameterOption("5", "2.116ms"), new ParameterOption("6", "4.156ms"), new ParameterOption("7", "8.244ms"))).build(), ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletVoltageCurrentV2Voltage":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletVoltageCurrentV2Current":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletVoltageCurrentV2Power":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletVoltageCurrentV2Config cfg = (BrickletVoltageCurrentV2Config) config.as(BrickletVoltageCurrentV2Config.class);
        switch(channel) {
            case "BrickletVoltageCurrentV2Current": {
                   BrickletVoltageCurrentV2CurrentConfig channelCfg = channelConfig.as(BrickletVoltageCurrentV2CurrentConfig.class);
                   {
            int value = this.getCurrent();
            if(true)
                updateStateFn.accept(channel, transformBrickletVoltageCurrentV2CurrentGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletVoltageCurrentV2Voltage": {
                   BrickletVoltageCurrentV2VoltageConfig channelCfg = channelConfig.as(BrickletVoltageCurrentV2VoltageConfig.class);
                   {
            int value = this.getVoltage();
            if(true)
                updateStateFn.accept(channel, transformBrickletVoltageCurrentV2VoltageGetter0(value, cfg));
        }
                   return;
               }
            case "BrickletVoltageCurrentV2Power": {
                   BrickletVoltageCurrentV2PowerConfig channelCfg = channelConfig.as(BrickletVoltageCurrentV2PowerConfig.class);
                   {
            int value = this.getPower();
            if(true)
                updateStateFn.accept(channel, transformBrickletVoltageCurrentV2PowerGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletVoltageCurrentV2Config cfg = (BrickletVoltageCurrentV2Config) config.as(BrickletVoltageCurrentV2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentV2CurrentCallback0(int current, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(current / 1000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentV2VoltageCallback0(int voltage, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(voltage / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentV2PowerCallback0(int power, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(power / 1000.0, SmartHomeUnits.WATT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentV2CurrentGetter0(int value, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.AMPERE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentV2VoltageGetter0(int value, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.VOLT);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletVoltageCurrentV2PowerGetter0(int value, BrickletVoltageCurrentV2Config cfg) {
        return new QuantityType<>(value / 1000.0, SmartHomeUnits.WATT);
    }

}