/* ***********************************************************
 * This file was automatically generated on 2020-02-10.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package org.eclipse.smarthome.binding.tinkerforge.internal.device;

import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ChannelUID;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.binding.BaseThingHandler;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.types.RefreshType;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

import com.tinkerforge.BrickletXMC1400Breakout;
import com.tinkerforge.IPConnection;
import com.tinkerforge.TinkerforgeException;

public class BrickletXMC1400BreakoutWrapper extends DeviceWrapper implements CoMCUFlashable{
    BrickletXMC1400Breakout dev;

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(BrickletXMC1400Breakout.DEVICE_DISPLAY_NAME, "brickletxmc1400breakout", BrickletXMC1400Breakout.DEVICE_IDENTIFIER, BrickletXMC1400BreakoutWrapper.class, BrickletXMC1400BreakoutActions.class, "2.0.0", true);

    public BrickletXMC1400BreakoutWrapper(String uid, IPConnection ipcon) {
        super();
        this.dev = new BrickletXMC1400Breakout(uid, ipcon);
    }

    
	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';
	public final static int GPIO_MODE_INPUT_TRISTATE = 0;
	public final static int GPIO_MODE_INPUT_PULL_DOWN = 1;
	public final static int GPIO_MODE_INPUT_PULL_UP = 2;
	public final static int GPIO_MODE_INPUT_SAMPLING = 3;
	public final static int GPIO_MODE_INPUT_INVERTED_TRISTATE = 4;
	public final static int GPIO_MODE_INPUT_INVERTED_PULL_DOWN = 5;
	public final static int GPIO_MODE_INPUT_INVERTED_PULL_UP = 6;
	public final static int GPIO_MODE_INPUT_INVERTED_SAMPLING = 7;
	public final static int GPIO_MODE_OUTPUT_PUSH_PULL = 8;
	public final static int GPIO_MODE_OUTPUT_OPEN_DRAIN = 9;
	public final static int GPIO_INPUT_HYSTERESIS_STANDARD = 0;
	public final static int GPIO_INPUT_HYSTERESIS_LARGE = 4;
	public final static int BOOTLOADER_MODE_BOOTLOADER = 0;
	public final static int BOOTLOADER_MODE_FIRMWARE = 1;
	public final static int BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
	public final static int BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
	public final static int BOOTLOADER_STATUS_OK = 0;
	public final static int BOOTLOADER_STATUS_INVALID_MODE = 1;
	public final static int BOOTLOADER_STATUS_NO_CHANGE = 2;
	public final static int BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
	public final static int BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
	public final static int BOOTLOADER_STATUS_CRC_MISMATCH = 5;
	public final static int STATUS_LED_CONFIG_OFF = 0;
	public final static int STATUS_LED_CONFIG_ON = 1;
	public final static int STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
	public final static int STATUS_LED_CONFIG_SHOW_STATUS = 3;


    public void setGPIOConfig(int port, int pin, int mode, int inputHysteresis, boolean outputLevel) throws TinkerforgeException {
    this.dev.setGPIOConfig(port, pin, mode, inputHysteresis, outputLevel);
}

public boolean getGPIOInput(int port, int pin) throws TinkerforgeException {
    return this.dev.getGPIOInput(port, pin);
}

public void setADCChannelConfig(int channel, boolean enable) throws TinkerforgeException {
    this.dev.setADCChannelConfig(channel, enable);
}

public boolean getADCChannelConfig(int channel) throws TinkerforgeException {
    return this.dev.getADCChannelConfig(channel);
}

public int getADCChannelValue(int channel) throws TinkerforgeException {
    return this.dev.getADCChannelValue(channel);
}

public int[] getADCValues() throws TinkerforgeException {
    return this.dev.getADCValues();
}

public void setADCValuesCallbackConfiguration(long period, boolean valueHasToChange) throws TinkerforgeException {
    this.dev.setADCValuesCallbackConfiguration(period, valueHasToChange);
}

public BrickletXMC1400Breakout.ADCValuesCallbackConfiguration getADCValuesCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getADCValuesCallbackConfiguration();
}

public long getCount() throws TinkerforgeException {
    return this.dev.getCount();
}

public void setCountCallbackConfiguration(long period, boolean valueHasToChange, char option, long min, long max) throws TinkerforgeException {
    this.dev.setCountCallbackConfiguration(period, valueHasToChange, option, min, max);
}

public BrickletXMC1400Breakout.CountCallbackConfiguration getCountCallbackConfiguration() throws TinkerforgeException {
    return this.dev.getCountCallbackConfiguration();
}

public BrickletXMC1400Breakout.SPITFPErrorCount getSPITFPErrorCount() throws TinkerforgeException {
    return this.dev.getSPITFPErrorCount();
}

public int setBootloaderMode(int mode) throws TinkerforgeException {
    return this.dev.setBootloaderMode(mode);
}

public int getBootloaderMode() throws TinkerforgeException {
    return this.dev.getBootloaderMode();
}

public void setWriteFirmwarePointer(long pointer) throws TinkerforgeException {
    this.dev.setWriteFirmwarePointer(pointer);
}

public int writeFirmware(int[] data) throws TinkerforgeException {
    return this.dev.writeFirmware(data);
}

public void setStatusLEDConfig(int config) throws TinkerforgeException {
    this.dev.setStatusLEDConfig(config);
}

public int getStatusLEDConfig() throws TinkerforgeException {
    return this.dev.getStatusLEDConfig();
}

public int getChipTemperature() throws TinkerforgeException {
    return this.dev.getChipTemperature();
}

public void reset() throws TinkerforgeException {
    this.dev.reset();
}

public void writeUID(long uid) throws TinkerforgeException {
    this.dev.writeUID(uid);
}

public long readUID() throws TinkerforgeException {
    return this.dev.readUID();
}

public BrickletXMC1400Breakout.Identity getIdentity() throws TinkerforgeException {
    return this.dev.getIdentity();
}

public void addADCValuesListener(BrickletXMC1400Breakout.ADCValuesListener l) {
    this.dev.addADCValuesListener(l);
}

public void removeADCValuesListener(BrickletXMC1400Breakout.ADCValuesListener l) {
    this.dev.removeADCValuesListener(l);
}

public void addCountListener(BrickletXMC1400Breakout.CountListener l) {
    this.dev.addCountListener(l);
}

public void removeCountListener(BrickletXMC1400Breakout.CountListener l) {
    this.dev.removeCountListener(l);
}

    
    private final Logger logger = LoggerFactory.getLogger(BrickletXMC1400BreakoutWrapper.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletXMC1400BreakoutWrapper.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn, ScheduledExecutorService scheduler, BaseThingHandler handler) throws TinkerforgeException {
        BrickletXMC1400BreakoutConfig cfg = (BrickletXMC1400BreakoutConfig) config.as(BrickletXMC1400BreakoutConfig.class);
        this.addCountListener(this.reg((count) -> {if(true) {updateStateFn.accept("BrickletXMC1400BreakoutCount", transformBrickletXMC1400BreakoutCountCallback0(count, cfg));}}, this.dev::removeCountListener));
        
		this.setStatusLEDConfig(cfg.statusLEDConfig);
		{
		BrickletXMC1400BreakoutCountConfig channelCfg = getChannelConfigFn.apply("BrickletXMC1400BreakoutCount").as(BrickletXMC1400BreakoutCountConfig.class);
		this.setCountCallbackConfiguration(channelCfg.updateInterval, true, 'x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        super.dispose(config);
        BrickletXMC1400BreakoutConfig cfg = (BrickletXMC1400BreakoutConfig) config.as(BrickletXMC1400BreakoutConfig.class);
        this.setCountCallbackConfiguration(0, true, 'x', 0, 0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletXMC1400BreakoutConfig cfg = (BrickletXMC1400BreakoutConfig) config.as(BrickletXMC1400BreakoutConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletXMC1400BreakoutCount");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletXMC1400BreakoutCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletXMC1400BreakoutCount"), "Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletXMC1400BreakoutCount")).withDescription("The value of the example count (see example.c)")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge XMC1400 Breakout Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.toString())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Breakout for Infineon XMC1400 microcontroller").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletXMC1400BreakoutCount", new ChannelTypeUID("tinkerforge", "BrickletXMC1400BreakoutCount")).withLabel("Count").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletxmc1400breakout":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("statusLEDConfig", Type.INTEGER).withDefault("3").withDescription("The status LED configuration. By default the LED shows communication traffic between Brick and Bricklet, it flickers once for every 10 received data packets.<br/><br/>You can also turn the LED permanently on/off or show a heartbeat.<br/><br/>If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.").withLabel("Status LED Config").withAdvanced(true).withLimitToOptions(true).withOptions(Arrays.asList(new ParameterOption("0", "Off"), new ParameterOption("1", "On"), new ParameterOption("2", "Show Heartbeat"), new ParameterOption("3", "Show Status"))).build())).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletXMC1400BreakoutCount":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletXMC1400BreakoutConfig cfg = (BrickletXMC1400BreakoutConfig) config.as(BrickletXMC1400BreakoutConfig.class);
        switch(channel) {
            case "BrickletXMC1400BreakoutCount": {
                   BrickletXMC1400BreakoutCountConfig channelCfg = channelConfig.as(BrickletXMC1400BreakoutCountConfig.class);
                   {
            long value = this.getCount();
            if(true)
                updateStateFn.accept(channel, transformBrickletXMC1400BreakoutCountGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletXMC1400BreakoutConfig cfg = (BrickletXMC1400BreakoutConfig) config.as(BrickletXMC1400BreakoutConfig.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletXMC1400BreakoutCountCallback0(long count, BrickletXMC1400BreakoutConfig cfg) {
        return new QuantityType<>(count, SmartHomeUnits.ONE);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletXMC1400BreakoutCountGetter0(long value, BrickletXMC1400BreakoutConfig cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }

}